<?php
/* --------------------------------------------------------------
   beezup.php 2012-10 gambio
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2012 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(ot_cod_fee.php,v 1.02 2003/02/24); www.oscommerce.com
   (C) 2001 - 2003 TheMedia, Dipl.-Ing Thomas Plnkers ; http://www.themedia.at & http://www.oscommerce.at
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: ot_cod_fee.php 1003 2005-07-10 18:58:52Z mz $)

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

class Beezup {
	public $v_partnerlink;
	public $v_export_type;
	public $v_module_name;
	public $v_module_homepage;
	public $v_module_format;
	public $v_module_export_filename;
	public $v_filename;
	public $v_keyname;
	public $v_linkname;
	public $v_delimiter;
	public $v_enclosure;
	public $v_use_variants;

	public $v_field_filename;
	public $v_field_customers_groups;
	public $v_field_currency;
	public $v_field_shipping_costs;
	public $v_field_shipping_costs_free;
	public $v_field_attributes;
	public $v_field_campaign;
	public $v_field_export;
	
	protected $_config;

	function __construct() {
		$this->_loadConfig();
		$this->formSettings();
	}
	
	protected function _loadConfig() {
		$this->_config['shipping_cost'] = (double)gm_get_conf('GM_BEEZUP_SHIPPINGCOST');
	}
	
	public function saveConfig() {
		gm_set_conf('GM_BEEZUP_SHIPPINGCOST', (double)$_POST['shipping_costs']);
	}
	
	function formSettings(){
		$this->v_partnerlink='';
		$this->v_export_type='comparison';
		$this->v_module_name='BeezUP.com';
		$this->v_module_homepage='www.beezup.de';
		$this->v_module_format='csv';
		$this->v_module_export_filename='beezup.csv';
		$this->v_filename='beezup.php';
		$this->v_keyname='BEEZUP';
		$this->v_linkname='beezup';
		$this->v_delimiter='|';
		$this->v_enclosure='';
		$this->v_use_variants = true;

		$this->v_field_filename=true;
		$this->v_field_customers_groups=true;
		$this->v_field_currency=true;
		$this->v_field_shipping_costs=false;
		$this->v_field_shipping_costs_free=false;
		$this->v_field_attributes=true;
		$this->v_field_campaign=true;
		$this->v_field_export=true;
	}

	function formAddOn() {
		$t_addOns='<tr style="vertical-align:top; background-color:#d6e6f3;">
				   <td class="dataTableContent_gm"><b>Versandkosten</b></td>
				   <td class="dataTableContent_gm">';
		$t_addOns .= '<input name="shipping_costs" type="text" value="'.$this->_config['shipping_cost'].'">';
		$t_addOns .= '</td></tr>';
		return $t_addOns;
	}

	function formatResults($p_products_array){
		$out_array = array();
		foreach($p_products_array as $key => $value) {
			if(!is_string($value)) {
				continue;
			}
			$value = strip_tags($value);
			$value = iconv('ISO-8859-15', 'UTF-8//IGNORE//TRANSLIT', $value);
			$value = strtr($value, array(
				$this->v_delimiter => '',
				"\r" => '',
				"\n" => '',
			));
			$value = html_entity_decode($value, 0, 'UTF-8');
			if($key != 'products_description') {
				$value = substr($value, 0, 250);
			}
			$out_array[$key] = $value;
		}
		$out_array['lieferkosten'] = $this->_config['shipping_cost'];
		$out_array['verfuegbarkeit'] = 'auf Lager'; // products_status == 0 wird sowieso nicht exportiert
		$catnames = explode('>', $out_array['products_categories']);
		for($i = 1; $i <= 9; $i++) {
			if(isset($catnames[$i - 1])) {
				$out_array['kat_'.$i] = trim($catnames[$i - 1]);
			}
			else {
				$out_array['kat_'.$i] = '';
			}
		}
		$out_array['refnr'] = $out_array['products_id'];
		if(isset($out_array['products_attributes_id'])) {
			$out_array['refnr'] .= '-'.$out_array['products_attributes_id'];
		}
		
		$out_array['products_quantity'] = round($out_array['products_quantity']);
		
		return($out_array);
	}

	function exportScheme(){
		$t_csv_fields_array=array();
		$t_csv_fields_array['refnr'] = 'Produktreferenznummer';
		$t_csv_fields_array['code_mpn'] = 'MPN';
		$t_csv_fields_array['products_ean'] = 'EAN/UPC';
		$t_csv_fields_array['manufacturers_name'] = 'Marke';
		$t_csv_fields_array['products_name'] = 'Produktname';
		$t_csv_fields_array['products_description'] = 'Produktbeschreibung'; // reiner Text, kein HTML
		$t_csv_fields_array['products_price'] = 'Preis inkl. MwSt.'; // Zahl (ohne Whrungssymbol)
		//$t_csv_fields_array[''] = 'UVP inkl. MwSt.'; // dito
		//$t_csv_fields_array[''] = 'Zustand'; // neu|gebraucht|instandgehalten
		//$t_csv_fields_array[''] = 'Garantie'; // Zahl in Jahren
		//$t_csv_fields_array[''] = 'Garantiedetails';
		//$t_csv_fields_array[''] = 'Oekosteuer'; // nur FR
		$t_csv_fields_array['products_link'] = 'Produkt-URL';
		$t_csv_fields_array['products_image_1'] = 'Bild-URL';
		$t_csv_fields_array['lieferkosten'] = 'Lieferkosten GER'; // gnstigste Brutto-Transportkosten DE-Binnenland
		$t_csv_fields_array['verfuegbarkeit'] = 'Verfuegbarkeit'; // auf Lager|nicht vorrtig
		$t_csv_fields_array['products_quantity'] = 'Lagerbestand'; // Anzahl
		$t_csv_fields_array['products_shippingdays'] = 'Lieferfrist'; // Lieferfrist in Tagen
		//$t_csv_fields_array[''] = 'Lieferinformationen';
		$t_csv_fields_array['kat_1'] = 'Kategorie 1'; // Kategorieebene
		$t_csv_fields_array['kat_2'] = 'Kategorie 2'; // Kategorieebene
		$t_csv_fields_array['kat_3'] = 'Kategorie 3'; // Kategorieebene
		$t_csv_fields_array['kat_4'] = 'Kategorie 4'; // Kategorieebene
		$t_csv_fields_array['kat_5'] = 'Kategorie 5'; // Kategorieebene
		$t_csv_fields_array['kat_6'] = 'Kategorie 6'; // Kategorieebene
		$t_csv_fields_array['kat_7'] = 'Kategorie 7'; // Kategorieebene
		$t_csv_fields_array['kat_8'] = 'Kategorie 8'; // Kategorieebene
		$t_csv_fields_array['kat_9'] = 'Kategorie 9'; // Kategorieebene
		//$t_csv_fields_array[''] = 'Geschlecht'; // Herren|Damen|Mdchen|Jungen|Unisex
		//$t_csv_fields_array[''] = 'Farbe';
		//$t_csv_fields_array[''] = 'Groesse';
		//$t_csv_fields_array[''] = 'Stoff';
		//$t_csv_fields_array[''] = 'Altersgruppe';
		return($t_csv_fields_array);
	}
	
}
