<?php
/* --------------------------------------------------------------
   kelkoo_premium.php 2010-07-29 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2010 Gambio GmbH
   Released under the GNU General Public License
   --------------------------------------------------------------
*/
?><?php
class Kelkoo_Premium{
	var $v_partnerlink;
	var $v_export_type;
	var $v_module_name;
	var $v_module_homepage;
	var $v_module_format;
	var $v_module_export_filename;
	var $v_filename;
	var $v_keyname;
	var $v_linkname;
	var $v_delimiter;
	var	$v_enclosure;

	var $v_field_filename;
	var $v_field_customers_groups;
	var $v_field_currency;
	var $v_field_shipping_costs;
	var $v_field_shipping_costs_free;
	var $v_field_attributes;
	var $v_field_campaign;
	var $v_field_export;
	
	var $v_custom_config;
	var $v_custom_config_data;

	function Kelkoo_Premium() {
		$this->formSettings();
		
		$this->v_custom_config = array(
			'promotion'          => array('PROMOTION', '', '6', '1'),
		);
		
		$this->v_custom_config_data = array(
			'promotion' => gm_get_conf('GM_KELKOOPREMIUM_PROMOTION'),
		);
	}

	function formSettings(){
		$this->v_partnerlink='';
		$this->v_export_type='comparison';
		$this->v_module_name='Kelkoo Premium';
		$this->v_module_homepage='www.kelkoo.de';
		$this->v_module_format='txt';
		$this->v_module_export_filename='kelkoo_premium.txt';
		$this->v_filename='kelkoo_premium.php';
		$this->v_keyname='KELKOOPREMIUM';
		$this->v_linkname='kelkoo premium';
		$this->v_delimiter="\t";
		$this->v_enclosure='';

		$this->v_field_filename=true;
		$this->v_field_customers_groups=true;
		$this->v_field_currency=true;
		$this->v_field_shipping_costs=true;
		$this->v_field_shipping_costs_free=true;
		$this->v_field_attributes=true;
		$this->v_field_campaign=true;
		$this->v_field_export=true;
	}
	
	function formAddOn(){
		//$promotion = $this->v_custom_config_data['promotion']; // don't use here, doesn't get updated after saving
		$promotion = gm_get_conf('GM_KELKOOPREMIUM_PROMOTION');
		$addon = '<tr style="vertical-align:top; background-color:#d6e6f3;">';
		$addon .= '<td class="dataTableContent_gm"><strong>Promotion</strong></td>';
		$addon .= '<td class="dataTableContent_gm">'.xtc_draw_input_field('promotion', $promotion) .'</td>';
		$addon .= '</tr>';
		return $addon;
	}

	function formatResults($p_products_array){
		$p_products_array['products_description']=str_replace("\t", "", no_html($p_products_array['products_description']));
		if (strlen($p_products_array['products_description'])>150) {
		  $p_products_array['products_description']=substr($p_products_array['products_description'], 0, strpos($p_products_array['products_description'], ' ', 140)).'...';
		}
		$p_products_array['products_price']=number_format( (double)$p_products_array['products_price'], 2, '.', '');
		if(isset($p_products_array['retail_price'])) {
			$p_products_array['price-no-rebate'] = number_format($p_products_array['retail_price'], 2, '.', '');
		}
		else {
			$p_products_array['price-no-rebate'] = '';
		}
		$p_products_array['baseprice']=number_format( (double)$p_products_array['baseprice'], 2, ',', '');
		$p_products_array['products_shipping_costs']=number_format( (double)$p_products_array['products_shipping_costs'], 2, '.', '');
		$p_products_array['products_availability']='003';
		$p_products_array['promotion'] = $this->v_custom_config_data['promotion'];
		return($p_products_array);
	}

	function exportScheme(){
		$t_csv_fields_array=array();
		$t_csv_fields_array['products_name']= 'title';
		$t_csv_fields_array['products_link']= 'product-url';
		$t_csv_fields_array['products_price']= 'price';
		$t_csv_fields_array['manufacturers_name']= 'brand';
		$t_csv_fields_array['products_description']= 'description';
		$t_csv_fields_array['products_image_1']= 'image-url';
		$t_csv_fields_array['products_ean']= 'ean';
		$t_csv_fields_array['products_categories']= 'merchant-category';
		//$t_csv_fields_array['products_model']= 'model';
		$t_csv_fields_array['products_availability']= 'availability';
		$t_csv_fields_array['products_shipping_costs']= 'delivery-cost';
		$t_csv_fields_array['products_shippingtime']= 'delivery-time';
		$t_csv_fields_array['promotion'] = 'voucher-title';
		$t_csv_fields_array['price-no-rebate'] = 'price-no-rebate';
		//$t_csv_fields_array['baseprice']= 'baseprice';
		return($t_csv_fields_array);
	}
}
?>