<?php
/* --------------------------------------------------------------
   movendor.php 2010-08-31 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2010 Gambio GmbH
   Released under the GNU General Public License
   --------------------------------------------------------------
*/
?><?php
class Movendor{
	var $v_partnerlink;
	var $v_export_type;
	var $v_module_name;
	var $v_module_homepage;
	var $v_module_format;
	var $v_module_export_filename;
	var $v_filename;
	var $v_keyname;
	var $v_linkname;
	var $v_delimiter;
	var	$v_enclosure;

	var $v_field_filename;
	var $v_field_customers_groups;
	var $v_field_currency;
	var $v_field_shipping_costs;
	var $v_field_shipping_costs_free;
	var $v_field_attributes;
	var $v_field_campaign;
	var $v_field_export;
	
	var $itemNumberSeen;

	function Movendor() {
		$this->formSettings();
	}

	function formSettings(){
		$this->v_partnerlink='';
		$this->v_export_type='affiliate';
		$this->v_module_name='MoVendor Mobile Commerce';
		$this->v_module_homepage='www.movendor.com';
		$this->v_module_format='csv';
		$this->v_module_export_filename='movendor.csv';
		$this->v_filename='movendor.php';
		$this->v_keyname='MOVENDOR';
		$this->v_linkname='movendor';
		$this->v_delimiter="\t";
		$this->v_enclosure='';

		$this->v_field_filename=true;
		$this->v_field_customers_groups=true;
		$this->v_field_currency=true;
		$this->v_field_shipping_costs=false; #true;
		$this->v_field_shipping_costs_free=false; #true;
		$this->v_field_attributes=true;
		$this->v_field_campaign=false; #true;
		$this->v_field_export=true;
		
	}

	function formAddOn(){

	}
	
	
   /*
   * mv_buildCAT
   *
   * MoVendor: copied from GMProductExport to fetch all categories, not just the last db entry
   *
   * @param int $catID  id for categorie
   * @return string  string containing the categories (e.g. "aaa > bbb > ccc")
   */
  function mv_buildCAT($catID)
  {
    if (isset($this->CAT[$catID])) {
      return $this->CAT[$catID];
    } else {
      $cat   = array();
      $tmpID = $catID;
      while ($this->mv_getParent($catID) != 0 || $catID != 0) {
        $cat_select=xtc_db_query("SELECT categories_name
                                  FROM " . TABLE_CATEGORIES_DESCRIPTION . "
                                  WHERE
                                    categories_id = '" . $catID . "' AND
                                    language_id='" . $_SESSION['languages_id'] . "'");
        $cat_data = xtc_db_fetch_array($cat_select);
        $catID = $this->mv_getParent($catID);
        $cat[] = $cat_data['categories_name'];
      }
      $catStr = '';
      for ($i = count($cat); $i > 0; $i--) {
        $catStr .= $cat[$i-1].' > ';
      }
      $this->CAT[$tmpID] = $catStr;
      return $this->CAT[$tmpID];
    }
    return true;
  }


  /*
   * mv_getParent
   *
   * MoVendor: copied from GMProductExport to fetch all categories, not just the last db entry
   *
   * @param int $catID  id for categorie
   * @return bool
   */
  function mv_getParent($catID)
  {
    if (isset($this->PARENT[$catID])) {
      return $this->PARENT[$catID];
    } else {
      $parent_query = xtc_db_query("SELECT parent_id
                                    FROM " . TABLE_CATEGORIES . "
                                    WHERE categories_id = '" . $catID . "'");
      $parent_data = xtc_db_fetch_array($parent_query);
      $this->PARENT[$catID] = $parent_data['parent_id'];
      return $parent_data['parent_id'];
    }
    return true;
  }
  
  
  

	function formatResults($p_products_array){
	
		$p_products_array['products_price']=number_format( (double)$p_products_array['products_price'], 2, '.', '');
		# Grundpreis
		if ($p_products_array['products_vpe_value'] > 0) {
			if ($p_products_array['products_vpe_name'] == 'ml' or $p_products_array['products_vpe_name'] == 'g') {
				$p_products_array['baseprice'] = "100 " . $p_products_array['products_vpe_name'] . " = " . number_format( (double)$p_products_array['baseprice']*100, 2, '.', '') . ' ' .  $p_products_array['products_currency'];
			} else {
				$p_products_array['baseprice'] = "1 " . $p_products_array['products_vpe_name'] . " = " . number_format( (double)$p_products_array['baseprice'], 2, '.', '')  . ' ' . $p_products_array['products_currency'];
			}
		} else {
			$p_products_array['baseprice']='';
		}
		# Groesse aus Inhalt+Name
		if ($p_products_array['products_vpe_value'] > 0) {
			$p_products_array['inhalt'] = number_format( (double)$p_products_array['products_vpe_value'], 0, '.', '') . ' ' . $p_products_array['products_vpe_name'];
		} else {
			$p_products_array['inhalt']='';
		}
		
		$p_products_array['products_meta_keywords'] = $p_products_array['products_meta_keywords'] . " " . $p_products_array['manufacturers_name'];
		
		# Artikelnummer gefuellt?
		if ($p_products_array['products_model'] == '') {
			$p_products_array['products_model'] = $p_products_array['products_id'];
		}
		
		# Artikel gelinkt, >1 Kategorie?
		$pId=$p_products_array['products_id'];
		if ($p_products_array['products_id_copy']>0) {
			$pId=$p_products_array['products_id_copy'];
		}
		
		if ($this->itemNumberSeen[$p_products_array['products_model']]) {
			# nicht gelinkt, sondern kopiert mit gleicher ArtNummer
			$p_products_array['products_categories']=trim($p_products_array['products_categories']); # Bug, ein Leerzeichen zuviel
			$p_products_array['products_categories'] = $p_products_array['products_categories'] . ' | ' . $this->itemNumberSeen[$p_products_array['products_model']];
			
		} else {
			$t_categorie_query = xtc_db_query("SELECT  categories_id
		                                 FROM " . TABLE_PRODUCTS_TO_CATEGORIES . "
		                                 WHERE products_id = '" . $pId . "' AND categories_id != '0'");
		
			$mv_catString=''; 
			while ($t_categorie_data=xtc_db_fetch_array($t_categorie_query)) {
				$mv_cat = $this->mv_buildCAT($t_categorie_data['categories_id']);
				$mv_cat=substr($mv_cat, 0, strlen($mv_cat)-3);
				$mv_catString = $mv_cat . ' | ' . $mv_catString; 
			}
	      		$p_products_array['products_categories'] = substr($mv_catString, 0, strlen($mv_catString)-2);
		}
		$this->itemNumberSeen[$p_products_array['products_model']]=$p_products_array['products_categories'];
		
		# Tabs raus
		$p_products_array = str_replace("\t", "", $p_products_array);
		
		# Umlaute wandeln?
		if (! mb_detect_encoding( $p_products_array['products_categories'] . $p_products_array['products_name'] . 
					$p_products_array['products_description'] . $p_products_array['products_meta_keywords'] .
					$p_products_array['products_shippingtime']
					  , 'UTF-8', true)) {
			$p_products_array['products_categories'] = utf8_encode($p_products_array['products_categories']);
			$p_products_array['products_name'] = utf8_encode($p_products_array['products_name']);
			$p_products_array['products_description'] = utf8_encode($p_products_array['products_description']);
			$p_products_array['products_meta_keywords'] = utf8_encode($p_products_array['products_meta_keywords']);
			$p_products_array['products_shippingtime'] = utf8_encode($p_products_array['products_shippingtime']);
		}
		
		return($p_products_array);
	}

	function exportScheme(){
		$t_csv_fields_array=array();
		$t_csv_fields_array['products_model']= 'id';
		$t_csv_fields_array['products_categories']= 'category';
		$t_csv_fields_array['products_name']= 'name';
		# groesse?
		$t_csv_fields_array['inhalt']= 'size';
		#$t_csv_fields_array['products_short_description']= 'description_short';
		$t_csv_fields_array['products_description']= 'description';
		$t_csv_fields_array['products_meta_keywords']= 'keywords';
		$t_csv_fields_array['products_price'] = 'price';
		$t_csv_fields_array['baseprice']= 'unitprice';
		$t_csv_fields_array['products_image_1']= 'image1';
		#$t_csv_fields_array['products_currency']= 'currency';
		$t_csv_fields_array['products_shippingtime']= 'lieferbar';
		$t_csv_fields_array['products_tax']='mwst';
		#$t_csv_fields_array['products_link']= 'deeplink1';
		#$t_csv_fields_array['manufacturers_name']= 'manufacturer';
		#$t_csv_fields_array['products_start']= 'valid_from';
		#$t_csv_fields_array['products_end']= 'valid_to';
		$t_csv_fields_array['products_ean']= 'ean';
		#$t_csv_fields_array['products_shipping_costs']= 'shipping';
		#$t_csv_fields_array['products_contract'] ='plan';
		#$t_csv_fields_array['products_mobile_profile'] ='phone_operator';
		
		return($t_csv_fields_array);
	}

}
?>
