<?php
/* --------------------------------------------------------------
   preissuchmaschine.php 2010-07-29 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2010 Gambio GmbH
   Released under the GNU General Public License
   --------------------------------------------------------------
*/

class Preissuchmaschine{
	var $v_partnerlink;
	var $v_export_type;
	var $v_module_name;
	var $v_module_homepage;
	var $v_module_format;
	var $v_module_export_filename;
	var $v_filename;
	var $v_keyname;
	var $v_linkname;
	var $v_delimiter;
	var	$v_enclosure;

	var $v_field_filename;
	var $v_field_customers_groups;
	var $v_field_currency;
	var $v_field_shipping_costs;
	var $v_field_shipping_costs_free;
	var $v_field_attributes;
	var $v_field_campaign;
	var $v_field_export;

	var $v_use_variants;
	var $_attributes;

	function Preissuchmaschine() {
		$this->formSettings();
		$this->v_use_variants = true;
		if($this->v_use_variants) {
			$this->_attributes = ProductsVariantsCombinator::getAttributes();
		}
	}

	function formSettings(){
		$this->v_partnerlink='www.gambio.de/Schnittstellen/Preissuchmaschinen.html';
		$this->v_export_type='comparison';
		$this->v_module_name='Preissuchmaschine.de';
		$this->v_module_homepage='www.preissuchmaschine.de';
		$this->v_module_format='csv';
		$this->v_module_export_filename='preissuchmaschine.csv';
		$this->v_filename='preissuchmaschine.php';
		$this->v_keyname='PREISSUCHMASCHINE';
		$this->v_linkname='preissuchmaschine';
		$this->v_delimiter='|';
		$this->v_enclosure='';

		$this->v_field_filename=true;
		$this->v_field_customers_groups=true;
		$this->v_field_currency=true;
		$this->v_field_shipping_costs=true;
		$this->v_field_shipping_costs_free=true;
		$this->v_field_attributes=true;
		$this->v_field_campaign=true;
		$this->v_field_export=true;
	}

	function formAddOn(){

	}

	function formatResults($p_products_array){
		$p_products_array['products_quantity']=floor($p_products_array['products_quantity']);
		$p_products_array['products_price']=number_format( (double)$p_products_array['products_price'], 2, ',', '');
		$p_products_array['products_shipping_costs']=number_format( (double)$p_products_array['products_shipping_costs'], 2, ',', '');
		$p_products_array['products_description']=trim(no_html($p_products_array['products_description']));
		$p_products_array['products_short_description']=trim(no_html($p_products_array['products_short_description']));
		if($p_products_array['products_vpe_compare'] == 1) {
			$p_products_array['grundpreis'] = $p_products_array['baseprice'].' '.$p_products_array['products_currency'].'/'.$p_products_array['products_vpe_name'];
		}
		else {
			$p_products_array['grundpreis'] = '';
		}
		if($this->v_use_variants) {
			$p_products_array['products_variants_id'] = strtr($p_products_array['products_variants_id'], '|', '.');
			$p_products_array['products_id'] .= $p_products_array['products_variants_id'];
			$options_names = array();
			if(!empty($p_products_array['options'])) {
				foreach($p_products_array['options'] as $options_id => $options_values_id) {
					$options_names[] = $this->_attributes[$options_id]['name'].': '.$this->_attributes[$options_id]['values'][$options_values_id];
				}
			}
			$options_string = implode(', ', $options_names);
			if(!empty($p_products_array['properties'])) {
				$properties_names = array();
				foreach($p_products_array['properties'] as $property) {
					$properties_names[] = $property['properties_name'].': '.$property['values_name'];
				}
				$properties_string = implode(', ', $properties_names);
			}
			if(!empty($options_string) || !empty($properties_string)) {
				$p_products_array['products_name'] .= ' (';
				if(!empty($options_string)) {
					$p_products_array['products_name'] .= $options_string;
				}
				if(!empty($properties_string)) {
					$p_products_array['products_name'] .= $properties_string;
				}
				$p_products_array['products_name'] .= ')';
			}
		}
		return($p_products_array);
	}

	function exportScheme(){
		$t_csv_fields_array=array();
		$t_csv_fields_array['products_id']= 'ProduktID';
		$t_csv_fields_array['products_weight']= 'Gewicht';
		$t_csv_fields_array['products_ean']= 'EAN';
		$t_csv_fields_array['products_quantity']= 'Lagerbestand';
		$t_csv_fields_array['manufacturers_name']= 'Hersteller';
		$t_csv_fields_array['products_name']= 'ProduktBezeichnung';
		$t_csv_fields_array['products_model']= 'ArtikelNroderHerstellerArtikelNr';
		$t_csv_fields_array['products_price']= 'Preis';
		$t_csv_fields_array['products_description']= 'ProduktLangBeschreibung';
		$t_csv_fields_array['products_short_description']= 'ProduktKurzBeschreibung';
		$t_csv_fields_array['products_shippingtime']= 'Lieferzeit';
		$t_csv_fields_array['products_link']= 'Produktlink';
		$t_csv_fields_array['products_image_1']= 'FotoLink';
		$t_csv_fields_array['products_categories']= 'Kategoriename';
		$t_csv_fields_array['grundpreis'] = 'Grundpreis';
		return($t_csv_fields_array);
	}

}
