<?php

/* --------------------------------------------------------------
   prix.php 2012-10 gambio
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2012 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(ot_cod_fee.php,v 1.02 2003/02/24); www.oscommerce.com
   (C) 2001 - 2003 TheMedia, Dipl.-Ing Thomas Plnkers ; http://www.themedia.at & http://www.oscommerce.at
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: ot_cod_fee.php 1003 2005-07-10 18:58:52Z mz $)

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

if(!function_exists('xtc_get_languages')) {
	function xtc_get_languages() {
		$languages_query = xtc_db_query("select languages_id, name, code, image, directory from ".TABLE_LANGUAGES." order by sort_order");
		while ($languages = xtc_db_fetch_array($languages_query)) {
			$languages_array[] = array ('id' => $languages['languages_id'], 'name' => $languages['name'], 'code' => $languages['code'], 'image' => $languages['image'], 'directory' => $languages['directory']);
		}

		return $languages_array;
	}
}

class Prix {
	public $v_partnerlink;
	public $v_export_type;
	public $v_module_name;
	public $v_module_homepage;
	public $v_module_format;
	public $v_module_export_filename;
	public $v_filename;
	public $v_keyname;
	public $v_linkname;
	public $v_delimiter;
	public $v_enclosure;
	public $v_field_filename;
	public $v_field_customers_groups;
	public $v_field_currency;
	public $v_field_shipping_costs;
	public $v_field_shipping_costs_free;
	public $v_field_attributes;
	public $v_field_campaign;
	public $v_field_export;
	
	protected $_logger;

	public function __construct() {
		$this->_logger = new FileLog('artex_prix', true);
		$this->formSettings();
		$this->_loadConfig();
	}

	public function saveConfig() {
	}

	protected function _loadConfig() {
	}

	function formAddOn(){
	}
	
	public function formSettings() {
		$this->v_partnerlink = 'www.prix.ch/informationen-werden_sie_partners.html';
		$this->v_export_type = 'comparison';
		$this->v_module_name = 'Prix.ch';
		$this->v_module_homepage = 'www.prix.ch';
		$this->v_module_format = 'csv';
		$this->v_module_export_filename = 'prix-'.$this->_logger->get_secure_token().'.txt';
		$this->v_filename = 'prix.php';
		$this->v_keyname = 'PRIX';
		$this->v_linkname = 'prix';
		$this->v_delimiter = '|';
		$this->v_enclosure = '';

		$this->v_field_filename = false;
		$this->v_field_customers_groups = true;
		$this->v_field_currency = true;
		$this->v_field_shipping_costs = false;
		$this->v_field_shipping_costs_free = false;
		$this->v_field_attributes = true;
		$this->v_field_campaign = false;
		$this->v_field_export = true;
	}
	
	function formatResults($p_products_array){
		$p_products_array['products_description_txt255'] = substr(strip_tags($p_products_array['products_description']), 0, 255);
		$p_products_array['products_description_txt255'] = str_replace($this->v_delimiter, '', $p_products_array['products_description_txt255']);
		$p_products_array['products_name'] = str_replace($this->v_delimiter, '', $p_products_array['products_name']);
		$p_products_array['manufacturers_code'] = '';
		return($p_products_array);
	}
	
	function exportScheme(){
		$t_csv_fields_array = array();
		$t_csv_fields_array['products_categories_last'] = 'Kategorie';
		$t_csv_fields_array['products_id'] = 'Produktcode';
		$t_csv_fields_array['products_name'] = 'Produktname';
		$t_csv_fields_array['products_price'] = 'Preis';
		$t_csv_fields_array['products_link'] = 'Link_zur_Produktseite';
		$t_csv_fields_array['products_image_1'] = 'Link_zum_Foto';
		$t_csv_fields_array['products_description_txt255'] = 'Beschreibung';
		$t_csv_fields_array['products_shipping_costs'] = 'Versandkosten';
		$t_csv_fields_array['products_quantity'] = 'Verfuegbarkeit';
		$t_csv_fields_array['manufacturers_name'] = 'Marke';
		$t_csv_fields_array['manufacturers_code'] = 'Herstellercode';
		
		return($t_csv_fields_array);
	}
	
}
