<?php

/* --------------------------------------------------------------
   shops-ch.php 2012-06 gambio
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2012 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(ot_cod_fee.php,v 1.02 2003/02/24); www.oscommerce.com
   (C) 2001 - 2003 TheMedia, Dipl.-Ing Thomas Plnkers ; http://www.themedia.at & http://www.oscommerce.at
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: ot_cod_fee.php 1003 2005-07-10 18:58:52Z mz $)

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

define('SHOPS_ATTRNAME_IN_TITLE', false);

if(!function_exists('xtc_get_languages')) {
	function xtc_get_languages() {
		$languages_query = xtc_db_query("select languages_id, name, code, image, directory from ".TABLE_LANGUAGES." order by sort_order");
		while ($languages = xtc_db_fetch_array($languages_query)) {
			$languages_array[] = array ('id' => $languages['languages_id'], 'name' => $languages['name'], 'code' => $languages['code'], 'image' => $languages['image'], 'directory' => $languages['directory']);
		}

		return $languages_array;
	}
}

class Shops {
	public $v_partnerlink;
	public $v_export_type;
	public $v_module_name;
	public $v_module_homepage;
	public $v_module_format;
	public $v_module_export_filename;
	public $v_filename;
	public $v_keyname;
	public $v_linkname;
	public $v_delimiter;
	public $v_enclosure;
	public $v_field_filename;
	public $v_field_customers_groups;
	public $v_field_currency;
	public $v_field_shipping_costs;
	public $v_field_shipping_costs_free;
	public $v_field_attributes;
	public $v_field_campaign;
	public $v_field_export;
	public $v_use_variants;
	
	protected $_debug = false;
	protected $_items_fp;
	protected $_items_filepath;
	protected $_attr_assignment;
	protected $_shops_attributes;
	
	protected $_languages;
	protected $_allowed_languages;
	protected $_all_options;
	protected $_default_language_id;
	
	var $v_custom_config;
	var $v_custom_config_data;
	
	public function __construct() {
		$this->_shops_attributes = array(
			8 => 'Bindeart',
			9 => 'Sprache',
			23 => 'Gre',
			24 => 'Farbe',
			25 => 'Durchmesser',
			26 => 'Krmmung',
			27 => 'Strke',
			28 => 'Material',
			31 => 'Lnge',
			32 => 'Breite',
			33 => 'Hhe',
			34 => 'Gewicht',
			37 => 'Stein 1',
			38 => 'Stein 2', 
			39 => 'Stein 3',
			40 => 'Stein 1 Karat',
			41 => 'Stein 2 Karat', 
			42 => 'Stein 3 Karat',
			43 => 'Stein 1 Qualitt',
			44 => 'Variation',
			51 => 'Volumen',
			63 => 'Melodie',
			64 => 'Montage',
			74 => 'Gewinde',
			76 => 'Querschnitt',
			77 => 'Stablnge',
		);
		$this->formSettings();
		$this->_loadConfig();
	}
	
	public function saveConfig() {
		gm_set_conf('GM_SHOPS_ATTRASSIGN', serialize($_POST['attrassign']));
	}
	
	protected function _loadConfig() {
		$attr_assign_cfg = gm_get_conf('GM_SHOPS_ATTRASSIGN');
		if(empty($attr_assign_cfg)) {
			$attr_assign = array();
		}
		else {
			$attr_assign = unserialize($attr_assign_cfg);
		}
		foreach(array_keys($this->_shops_attributes) as $idx) {
			if(!isset($attr_assign[$idx])) {
				$attr_assign[$idx] = -1;
			}
		}
		$this->_attr_assignment = $attr_assign;
	}

	
	public function formSettings() {
		$this->v_partnerlink = '';
		$this->v_export_type = 'selling';
		$this->v_module_name = 'shops.ch';
		$this->v_module_homepage = 'www.shops.ch';
		$this->v_module_format = 'inc';
		$this->v_module_export_filename = 'shops.xml';
		$this->v_filename = 'shops.php';
		$this->v_keyname = 'SHOPS';
		$this->v_linkname = 'shops';
		$this->v_delimiter = '';
		$this->v_enclosure = '';

		$this->v_field_filename = false;
		$this->v_field_customers_groups = true;
		$this->v_field_currency = true;
		$this->v_field_shipping_costs = false;
		$this->v_field_shipping_costs_free = false;
		$this->v_field_attributes = true;
		$this->v_field_campaign = false;
		$this->v_field_export = true;
		$this->v_use_variants = true;
	}
	
	public function formAddOn() {
		$options = ProductsVariantsCombinator::getAttributes($_SESSION['languages_id']);
		$properties_query = "SELECT pd.*, pvd.* FROM `properties_description` pd
				join properties_values pv on pv.properties_id = pd.properties_id
				join properties_values_description pvd on pvd.properties_values_id = pv.properties_values_id
				where pd.language_id = pvd.language_id
				and pd.language_id = ".$_SESSION['languages_id'];
		$properties = array();
		$propresult = xtc_db_query($properties_query);
		while($proprow = xtc_db_fetch_array($propresult)) {
			if(!isset($properties[$proprow['properties_id']])) {
				$properties[$proprow['properties_id']] = array(
					'properties_name' => $proprow['properties_name'],
					'values' => array(),
				);
			}
			$properties[$proprow['properties_id']]['values'][$proprow['properties_values_id']] = $proprow['values_name'];
		}
		//$attrlist = 'to be implemented'.'<pre>'.print_r($options, true).'</pre>';
		$attrlist .= '<table>';
		foreach($this->_shops_attributes as $sa_id => $sa_name) {
			$attrlist .= '<tr><td>';
			$attrlist .= $sa_name;
			$attrlist .= '</td><td>';
			$attrlist .= '<select name="attrassign['.$sa_id.']" size="1">';
			$attrlist .= '<option value="-1"'.($this->_attr_assignment[$sa_id] == -1 ? ' selected="selected"' : '').'>- nicht verwenden -</em></option>';
			foreach($options as $oid => $option) {
				$example_values = substr(implode(', ', $option['values']), 0, 30);
				$value = 'attr_'.$oid;
				$attrlist .= '<option value="'.$value.'"'.($this->_attr_assignment[$sa_id] == $value ? ' selected="selected"' : '').'>Attribut '.$option['name'].' ('.$example_values.')</option>';
			}
			foreach($properties as $propid => $property) {
				$example_properties = substr(implode(', ', $property['values']), 0, 30);
				$value = 'prop_'.$propid;
				$attrlist .= '<option value="prop_'.$propid.'"'.($this->_attr_assignment[$sa_id] == $value ? ' selected="selected"' : '').'>Eigenschaft '.$property['properties_name'].' ('.$example_properties.')</option>';
			}
			$attrlist .= '</select>';
			$attrlist .= '</td></tr>';
		}
		$attrlist .= '</table>';
		
		$addon = '<tr style="vertical-align:top; background-color:#d6e6f3;">
				<td class="dataTableContent_gm"><b>Attribute</b></td>
				<td class="dataTableContent_gm">'.$attrlist.'
				</td>
				</tr>';
		return $addon;
	}
	
	public function formatResults($p_products_array) {
		return $p_products_array;
	}
	
	public function exportScheme() {
		$t_csv_fields_array = array();
		$t_csv_fields_array['products_id']= 'xml_products_id';
		return $t_csv_fields_array;
	}
	
	public function startExport($filename) {
		if($this->_debug == true) {
			$filedate = '11112233445566'; // DEV/DEBUG
		}
		else {
			$filedate = date('YmdHis');
		}
		
		$items_filename = 'Items_'.$filedate.'.xml';
		$this->_items_filepath = DIR_FS_CATALOG . 'export/shops/'.$items_filename;
		$this->_items_fp = @fopen($this->_items_filepath, 'w');
		if($this->_items_fp === false) {
			die('ERROR opening output file '.$this->_items_filepath);
		}
		fwrite($this->_items_fp, "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<items>\n");

		$stocks_filename = 'Stocks_'.$filedate.'.xml';
		$this->_stocks_filepath = DIR_FS_CATALOG . 'export/shops/'.$stocks_filename;
		$this->_stocks_fp = @fopen($this->_stocks_filepath, 'w');
		if($this->_stocks_fp === false) {
			die('ERROR opening output file '.$this->_stocks_filepath);
		}
		fwrite($this->_stocks_fp, "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<items>\n");
		
		$this->_allowed_languages = array('de', 'fr');
		$this->_languages = xtc_get_languages();
		$this->_all_options = array();
		foreach($this->_languages as $lang) {
			$this->_all_options[$lang['id']] = ProductsVariantsCombinator::getAttributes();
			if($lang['code'] == DEFAULT_LANGUAGE) {
				$this->_default_language_id = $lang['id'];
			}
		}
	}
	
	public function exportProduct($pdata) {
		$products_id = isset($pdata['products_id_copy']) ? $pdata['products_id_copy'] : $pdata['products_id'];
		
		/*
		if($this->_hasTooManyAttributesOrProperties($products_id)) {
			// can't handle this, don't export
			return;
		}
		*/
		
		// ITEMS
		$pdesc = $this->_getProductsDescription($products_id);
		//$pattr = $this->_getProductsAttributes($products_id);
		fwrite($this->_items_fp, " <item>\n");
		fwrite($this->_items_fp, "  <cat>".$pdata['products_categories_id']."</cat>\n");
		//fwrite($this->_items_fp, "<shopCat></shopCat>\n");
		if(isset($pdata['products_id_copy'])) {
			fwrite($this->_items_fp, "  <ref>".$pdata['products_id_copy'].$pdata['products_variants_id']."</ref>\n");
			fwrite($this->_items_fp, "  <refgrp>".$pdata['products_id_copy']."</refgrp>\n");
		}
		else {
			fwrite($this->_items_fp, "  <ref>".$pdata['products_id']."</ref>\n");
		}
		fwrite($this->_items_fp, "  <active>".$pdata['products_status']."</active>\n");
		
		// Attributes
		fwrite($this->_items_fp, "  <ItemAttributes>\n");
		if(!empty($pdata['products_ean'])) {
			fwrite($this->_items_fp, '   <attribute id="2"><![CDATA['.$pdata['products_ean'].']]></attribute>'."\n");
		}
		if(!empty($pdata['manufacturers_name'])) {
			fwrite($this->_items_fp, '   <attribute id="13"><![CDATA['.utf8_encode($pdata['manufacturers_name']).']]></attribute>'."\n");
		}
		if(!empty($pdata['code_isbn'])) {
			fwrite($this->_items_fp, '   <attribute id="3"><![CDATA['.$pdata['code_isbn'].']]></attribute>'."\n");
		}
		if(!empty($pdata['products_model'])) {
			fwrite($this->_items_fp, '   <attribute id="4"><![CDATA['.utf8_encode($pdata['products_model']).']]></attribute>'."\n");
		}
		if(!empty($pdata['products_shippingtime'])) {
			fwrite($this->_items_fp, '   <attribute id="53"><![CDATA['.utf8_encode($pdata['products_shippingtime']).']]></attribute>'."\n");
		}
		$options_used = array();
		$properties_used = array();
		foreach($this->_attr_assignment as $shops_attr_idx => $gambio_attr_key) {
			if($gambio_attr_key == -1) {
				continue;
			}
			else {
				$attr_value = array();
				list($key_type, $key_id) = explode('_', $gambio_attr_key);
				switch($key_type) {
					case 'attr':
						//$all_options = $this->_all_options[$this->_default_language_id];
						if(!empty($pdata['options']) && isset($pdata['options'][$key_id])) {
							$ovid = $pdata['options'][$key_id];
							foreach($this->_languages as $lang) {
								$attr_value[$lang['id']] = $this->_all_options[$lang['id']][$key_id]['values'][$ovid];
							}
							$options_used[] = $oid;
						}
						break;
					case 'prop':
						if(!empty($pdata['properties'])) {
							foreach($pdata['properties'] as $property) {
								if($property['properties_id'] == $key_id) {
									//$attr_value = $property['values_name'];
									foreach($this->_languages as $lang) {
										$attr_value[$lang['id']] = ProductsVariantsCombinator::getPropertiesValuesName($property['properties_values_id'], $lang['id']);
									}
									$properties_used[] = $property['properties_id'];
								}
							}
						}
						break;
				}
				if(!empty($attr_value)) {
					foreach($this->_languages as $lang) {
						fwrite($this->_items_fp, '   <attribute id="'.$shops_attr_idx.'" lang="'.$lang['code'].'-CH"><![CDATA['.utf8_encode($attr_value[$lang['id']]).']]></attribute>'."\n");
					}
				}
			}
		}
		if(!empty($pdata['options'])) {
			foreach($pdata['options'] as $oid => $ovid) {
				if(in_array($oid, $options_used)) {
					continue;
				}
				else {
					foreach($this->_languages as $lang) {
						$label = utf8_encode($this->_all_options[$lang['id']][$oid]['name']);
						$value = utf8_encode($this->_all_options[$lang['id']][$oid]['values'][$ovid]);
						fwrite($this->_items_fp, '   <attribute lang="'.$lang['code'].'-CH" label="'.$label.'"><![CDATA['.$value.']]></attribute>'."\n");
					}
				}
			}
		}
		if(!empty($pdata['properties'])) {
			foreach($pdata['properties'] as $property) {
				if(in_array($property['properties_id'], $properties_used)) {
					continue;
				}
				else {
					foreach($this->_languages as $lang) {
						$label = utf8_encode(ProductsVariantsCombinator::getPropertyName($property['properties_id'], $lang['id']));
						$value = utf8_encode(ProductsVariantsCombinator::getPropertiesValuesName($property['properties_values_id'], $lang['id']));
						fwrite($this->_items_fp, '   <attribute lang="'.$lang['code'].'-CH" label="'.$label.'"><![CDATA['.$value.']]></attribute>'."\n");
					}
				}
			}
		}
		fwrite($this->_items_fp, "  </ItemAttributes>\n");
		
		// Localizations
		fwrite($this->_items_fp, "  <ItemLocalizations>\n");
		foreach($pdesc as $code => $desc) {
			if(SHOPS_ATTRNAME_IN_TITLE && !empty($pdata['options_id'])) {
				$attr_name = ' ('.$this->_getAttributeName($pdata['options_id'], $pdata['options_values_id'], $code).')';
			}
			else {
				$attr_name = '';
			}
			fwrite($this->_items_fp, "   <localization langcode=\"".$code."-CH\">\n");
			fwrite($this->_items_fp, "    <title><![CDATA[".utf8_encode($desc['name'].$attr_name)."]]></title>\n");
			fwrite($this->_items_fp, "    <shortdescription><![CDATA[".utf8_encode($desc['short_description'])."]]></shortdescription>\n");
			fwrite($this->_items_fp, "    <description><![CDATA[".utf8_encode($desc['description'])."]]></description>\n");
			fwrite($this->_items_fp, "   </localization>\n");
		}
		fwrite($this->_items_fp, "  </ItemLocalizations>\n");
		if(!empty($pdata['products_image'])) {
			fwrite($this->_items_fp, "  <ItemPictures>\n");
			fwrite($this->_items_fp, "   <Picture>\n");
			fwrite($this->_items_fp, "    <url size=\"s\"><![CDATA[".$pdata['products_image_1_small']."]]></url>\n");
			//fwrite($this->_items_fp, "    <url size=\"m\"><![CDATA[".$pdata['products_image_1']."]]></url>\n");
			fwrite($this->_items_fp, "    <url size=\"m\"><![CDATA[".HTTP_CATALOG_SERVER.DIR_WS_CATALOG.'images/product_images/info_images/'.$pdata['products_image']."]]></url>\n");
			fwrite($this->_items_fp, "    <url size=\"l\"><![CDATA[".HTTP_CATALOG_SERVER.DIR_WS_CATALOG.'images/product_images/popup_images/'.$pdata['products_image']."]]></url>\n");
			fwrite($this->_items_fp, "   </Picture>\n");
			fwrite($this->_items_fp, "  </ItemPictures>\n");
		}
		/*
		fwrite($this->_items_fp, "  <ItemOptions>\n");
		foreach($pattr as $po_id => $attr_data) {
			foreach(array('de', 'fr') as $lcode) {
				if(isset($attr_data[$lcode])) {
					fwrite($this->_items_fp, '   <option code="'.$po_id.'" label="'.utf8_encode($attr_data[$lcode]['name']).'" langcode="'.$lcode.'-CH">'."\n");
					foreach($attr_data[$lcode]['values'] as $ov_id => $ov_name) {
						fwrite($this->_items_fp, '    <value code="'.$ov_id.'">'.utf8_encode($ov_name).'</value>'."\n");
					}
					fwrite($this->_items_fp, '   </option>'."\n");
				}
			}
		}
		fwrite($this->_items_fp, "  </ItemOptions>\n");
		*/
		if($this->_debug) {
			fwrite($this->_items_fp, "<![CDATA[\n");
			fwrite($this->_items_fp, print_r($pdata, true));
			fwrite($this->_items_fp, "]]>\n");
		}
		
		fwrite($this->_items_fp, " </item>\n");
		
		// STOCKS
		fwrite($this->_stocks_fp, " <item>\n");
		if(isset($pdata['products_id_copy'])) {
			fwrite($this->_stocks_fp, "  <ref>".$pdata['products_id_copy'].$pdata['products_variants_id']."</ref>\n");
		}
		else {
			fwrite($this->_stocks_fp, "  <ref>".$pdata['products_id']."</ref>\n");
		}
		fwrite($this->_stocks_fp, "  <price>".$pdata['products_price']."</price>\n");
		fwrite($this->_stocks_fp, "  <qty>".(int)$pdata['products_quantity']."</qty>\n");
		
		$cfg_result = xtc_db_query("SELECT count(*) as anzahl FROM `shipping_status` where `number_of_days`> 0");
		$cfg_row = xtc_db_fetch_array($cfg_result);
		if($cfg_row['anzahl'] == 0) {
			// common misconfiguration
			fwrite($this->_stocks_fp, "  <stockAvailability>1</stockAvailability>\n");
		}
		else {
			if($pdata['products_shippingdays'] <= 0) {
				fwrite($this->_stocks_fp, "  <stockAvailability>-1</stockAvailability>\n");
			}
			if($pdata['products_shippingdays'] >= 1 && $pdata['products_shippingdays'] <= 3) {
				fwrite($this->_stocks_fp, "  <stockAvailability>1</stockAvailability>\n");
			}
			if($pdata['products_shippingdays'] > 3 && $pdata['products_shippingdays'] <= 7) {
				fwrite($this->_stocks_fp, "  <stockAvailability>2</stockAvailability>\n");
			}
			if($pdata['products_shippingdays'] > 7 && $pdata['products_shippingdays'] <= 14) {
				fwrite($this->_stocks_fp, "  <stockAvailability>3</stockAvailability>\n");
			}
			if($pdata['products_shippingdays'] > 14) {
				fwrite($this->_stocks_fp, "  <stockAvailability>4</stockAvailability>\n");
			}
		}
		if($this->_debug) {
			fwrite($this->_stocks_fp, "<debug><![CDATA[\n");
			fwrite($this->_stocks_fp, print_r($pdata, true));
			fwrite($this->_stocks_fp, "]]></debug>\n");
		}
		fwrite($this->_stocks_fp, " </item>\n");

	}

	public function finishExport() {
		fwrite($this->_items_fp, "</items>\n");
		fclose($this->_items_fp);
		// create OK file to mark export file as ready
		file_put_contents($this->_items_filepath.'.ok', '');

		fwrite($this->_stocks_fp, "</items>\n");
		fclose($this->_stocks_fp);
		// create OK file to mark export file as ready
		file_put_contents($this->_stocks_filepath.'.ok', '');
	}
	
	protected function _getProductsDescription($products_id) {
		$query = "SELECT l.code, pd.products_name, pd.products_short_description, pd.products_description FROM `products_description` pd
				left join languages l on l.languages_id = pd.language_id
				where products_id = :products_id
				and code in ('de', 'fr')";
		$query = strtr($query, array(':products_id' => $products_id));
		$desc = array();
		$result = xtc_db_query($query);
		while($row = xtc_db_fetch_array($result)) {
			$desc[$row['code']]['name'] = $row['products_name'];
			$desc[$row['code']]['short_description'] = $row['products_short_description'];
			$row['products_description'] = preg_replace('/\[TAB:.*?\]/', '', $row['products_description']);
			$desc[$row['code']]['description'] = $row['products_description'];
		}
		return $desc;
	}
	
	protected function _getProductsAttributes($products_id) {
		$query = "SELECT pa.`products_attributes_id`, pa.`products_id`, pa.`options_id`, pa.options_values_id,
			l.code, po.*, pov.*
			FROM `products_attributes` pa
			left join products_options po on po.products_options_id = pa.options_id
			left join products_options_values pov on pov.products_options_values_id = pa.options_values_id
			left join languages l on l.languages_id = po.language_id
			where products_id = :products_id
			and pov.language_id = po.language_id";
		$query = strtr($query, array(':products_id' => $products_id));
		$attribs = array();
		$result = xtc_db_query($query);
		while($row = xtc_db_fetch_array($result)) {
			$attribs[$row['products_options_id']][$row['code']]['name'] = $row['products_options_name'];
			$attribs[$row['products_options_id']][$row['code']]['values'][$row['options_values_id']] = $row['products_options_values_name'];
		}
		return $attribs;
	}
	
	protected function _getAttributeName($options_id, $options_values_id, $lang_code) {
		$oquery = "SELECT products_options_name FROM products_options po LEFT JOIN languages l ON l.languages_id = po.language_id
			WHERE products_options_id = :po_id AND l.code = 'de'";
		$oquery = strtr($oquery, array(':po_id' => $options_id));
		$vquery = "SELECT products_options_values_name FROM products_options_values pov LEFT JOIN languages l ON l.languages_id = pov.language_id
			WHERE products_options_values_id = :pov_id AND l.code = 'de'";
		$vquery = strtr($vquery, array(':pov_id' => $options_values_id));
		$oresult = xtc_db_query($oquery);
		$vresult = xtc_db_query($vquery);
		$orow = xtc_db_fetch_array($oresult);
		$vrow = xtc_db_fetch_array($vresult);
		$attr_name = $orow['products_options_name'] .' '. $vrow['products_options_values_name'];
		return $attr_name;
	}
	
	protected function _hasTooManyAttributesOrProperties($products_id) {
		$count_attribs_query = "SELECT products_attributes_id FROM `products_attributes` WHERE products_id = :products_id GROUP BY options_id";
		$count_attribs_query = strtr($count_attribs_query, array(':products_id' => $products_id));
		$ca_result = xtc_db_query($count_attribs_query);
		$attributes_count = xtc_db_num_rows($ca_result);
		
		$count_properties_query = "SELECT count(products_properties_combis_id) AS properties_count FROM products_properties_combis WHERE products_id = :products_id";
		$count_properties_query = strtr($count_properties_query, array(':products_id' => $products_id));
		$cp_result = xtc_db_query($count_properties_query);
		if(xtc_db_num_rows($cp_result) > 0) {
			$cp_row = xtc_db_fetch_array($cp_result);
			$properties_count = $cp_row['properties_count'];
		}
		else {
			$properties_count = 0;
		}
				
		$too_many = $properties_count > 0 || $attributes_count > 1;
		
		return $too_many;
	}
}
