<?php
/* --------------------------------------------------------------
 webgains.php 2010-07-29 gm rev. 42
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2010 Gambio GmbH
 Released under the GNU General Public License
 --------------------------------------------------------------
 */
?><?php
class Webgains{
	var $v_partnerlink;
	var $v_export_type;
	var $v_module_name;
	var $v_module_homepage;
	var $v_module_format;
	var $v_module_export_filename;
	var $v_filename;
	var $v_keyname;
	var $v_linkname;
	var $v_delimiter;
	var $v_enclosure;
	var $v_field_filename;
	var $v_field_customers_groups;
	var $v_field_currency;
	var $v_field_shipping_costs;
	var $v_field_shipping_costs_free;
	var $v_field_attributes;
	var $v_field_campaign;
	var $v_field_export;

	var $v_custom_config;
	var $v_custom_config_data;

	function Webgains() {
		$this->formSettings();
		$this->v_custom_config = array(
			'paymentoptions'          => array('PAYMENTOPTIONS', '', '6', '1'),
			'shippingcountries'       => array('SHIPPINGCOUNTRIES', '', '6', '1'),
		);
		
		$this->v_custom_config_data = array(
			'paymentoptions' => gm_get_conf('GM_WEBGAINS_PAYMENTOPTIONS'),
			'shippingcountries' => gm_get_conf('GM_WEBGAINS_SHIPPINGCOUNTRIES'),
		);
	}

	function formSettings(){
		$this->v_partnerlink='';
		$this->v_export_type='affiliate';
		$this->v_module_name='Webgains.de';
		$this->v_module_homepage='www.webgains.de';
		$this->v_module_format='csv';
		$this->v_module_export_filename='webgains.csv';
		$this->v_filename='webgains.php';
		$this->v_keyname='WEBGAINS';
		$this->v_linkname='webgains';
		$this->v_delimiter="|";
		$this->v_enclosure='"';

		$this->v_field_filename=true;
		$this->v_field_customers_groups=true;
		$this->v_field_currency=true;
		$this->v_field_shipping_costs=true;
		$this->v_field_shipping_costs_free=true;
		$this->v_field_attributes=true;
		$this->v_field_campaign=true;
		$this->v_field_export=true;
	}

	function formAddOn(){
		$poptions = gm_get_conf('GM_WEBGAINS_PAYMENTOPTIONS');
		$scountries = gm_get_conf('GM_WEBGAINS_SHIPPINGCOUNTRIES');
		$addon = '<tr style="vertical-align:top; background-color:#d6e6f3;">
				<td class="dataTableContent_gm"><b>Zahlungsweisen</b></td>
				<td class="dataTableContent_gm">
					<input name="paymentoptions" type="text" value="'.$poptions.'"><br>
					Leer lassen f&uuml;r automatische Bestimmung.
				</td>
				</tr>';
		$addon .= '<tr style="vertical-align:top; background-color:#d6e6f3;">
				<td class="dataTableContent_gm"><b>Versandl&auml;nder</b></td>
				<td class="dataTableContent_gm">
					<input name="shippingcountries" type="text" value="'.$scountries.'"><br>
					Leer lassen f&uuml;r automatische Bestimmung.
				</td>
				</tr>';
		return $addon;
	}

	function formatResults($p_products_array){
		// replace enclosure character
		foreach(array('products_name', 'products_description') as $key) {
			$p_products_array[$key] = strtr($p_products_array[$key], array($this->v_enclosure => $this->v_enclosure.$this->v_enclosure));
		}
		
		$p_products_array['products_availability']='Nein';
		if($p_products_array['products_availability'] >= date("Y-m-d H:i:s", time())) {
			$p_products_array['products_availability'] = 'Ja';
		}
		if((int) $p_products_array['products_availability'] == 0) {
			$p_products_array['products_availability'] = 'Ja';
		}
		$p_products_array['products_condition']='neu';
		$p_products_array['products_shipping_costs'] = number_format((double)$p_products_array['products_shipping_costs'], 2, '.', '');
		
		$p_products_array['payment_methods'] = 'Test, Test, Test';
		$p_products_array['shipping_countries'] = 'Land, Land, Land';
		
		$p_products_array['einheit'] = '';
		if(!empty($p_products_array['packing_unit_name'])) {
			$p_products_array['einheit'] = $p_products_array['packing_unit_name'];
		}
		else if($p_products_array['products_vpe_status'] == 1 && !empty($p_products_array['products_vpe_name'])) {
			$p_products_array['einheit'] = $p_products_array['products_vpe_name'];
		}
		
		if(!empty($p_products_array['einheit'])) {
			$p_products_array['grundpreis'] = $p_products_array['products_price'] / $p_products_array['products_vpe_value'];
			$p_products_array['grundpreis'] = number_format((double)$p_products_array['grundpreis'], 2, '.', '');
		}
		else {
			$p_products_array['grundpreis'] = '';
		}
		
		// Formatting
		$p_products_array['products_price']=number_format( (double)$p_products_array['products_price'], 2, '.', '');
		if(empty($p_products_array['retail_price'])) {
			$p_products_array['retail_price'] = $p_products_array['products_price'];
		}
		$p_products_array['retail_price'] = number_format((double)$p_products_array['retail_price'], 2, '.', '');

		if(!empty($this->v_custom_config_data['paymentoptions'])) {
			$p_products_array['payment_modules'] = $this->v_custom_config_data['paymentoptions'];
		}
		$p_products_array['payment_modules'] = strip_tags($p_products_array['payment_modules']);

		if(!empty($this->v_custom_config_data['shippingcountries'])) {
			$p_products_array['countries_iso2'] = $this->v_custom_config_data['shippingcountries'];
		}

		
		if(isset($p_products_array['code_isbn']) && !isset($p_products_array['products_isbn'])) {
			$p_products_array['products_isbn'] = $p_products_array['code_isbn'];
		}
		
		if(!empty($p_products_array['products_image'])) {
			$p_products_array['products_image_original'] = HTTP_CATALOG_SERVER . DIR_WS_CATALOG_ORIGINAL_IMAGES . $p_products_array['products_image'];
			$p_products_array['products_image_thumb'] = HTTP_CATALOG_SERVER . DIR_WS_CATALOG_THUMBNAIL_IMAGES . $p_products_array['products_image'];
			$p_products_array['products_image_gallery'] = HTTP_CATALOG_SERVER . DIR_WS_CATALOG_IMAGES .'product_images/gallery_images/' . $p_products_array['products_image'];
		}
		else {
			$p_products_array['products_image_original'] = '';
			$p_products_array['products_image_thumb'] = '';
			$p_products_array['products_image_gallery'] = '';
		}
		return($p_products_array);
	}

	function exportScheme(){
		$t_csv_fields_array=array();		
		$t_csv_fields_array['products_name']= 'Produktname';
		$t_csv_fields_array['products_id'] = 'Produkt-Nummer';
		$t_csv_fields_array['products_categories']= 'Produkt-Kategorie';
		$t_csv_fields_array['products_categories_id'] = 'Produkt-Kategorie-ID';
		$t_csv_fields_array['products_description']= 'Produktbeschreibung';
		$t_csv_fields_array['products_link'] = 'Deeplink';
		$t_csv_fields_array['products_price']= 'Preis';
		$t_csv_fields_array['retail_price'] = 'Normaler Preis';
		$t_csv_fields_array['grundpreis'] = 'Grundpreis';
		$t_csv_fields_array['einheit'] = 'Einheit';
		$t_csv_fields_array['products_currency'] = 'Waehrung';
		$t_csv_fields_array['payment_modules'] = 'Bezahlmoeglichkeiten';
		$t_csv_fields_array['products_image_original'] = 'Produktbild gross';
		$t_csv_fields_array['products_image_gallery'] = 'Produktbild klein';
		$t_csv_fields_array['products_availability']= 'Verfuegbarkeit';
		$t_csv_fields_array['products_shippingtime']= 'Lieferzeit';
		$t_csv_fields_array['products_shipping_costs']= 'Lieferkosten';
		$t_csv_fields_array['countries_iso2'] = 'Versandlaender';
		$t_csv_fields_array['products_isbn']= 'ISBN';
		$t_csv_fields_array['products_ean']= 'EAN';
		$t_csv_fields_array['products_model']= 'Herstellernummer';
		$t_csv_fields_array['manufacturers_name'] = 'Hersteller';
		$t_csv_fields_array['products_meta_keywords'] = 'Keywords';
		return($t_csv_fields_array);
	}

}
?>