<?php
/* --------------------------------------------------------------
   zanox.php 2010-08-31 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2010 Gambio GmbH
   Released under the GNU General Public License
   --------------------------------------------------------------
*/
?><?php
class Zanox{
	var $v_partnerlink;
	var $v_export_type;
	var $v_module_name;
	var $v_module_homepage;
	var $v_module_format;
	var $v_module_export_filename;
	var $v_filename;
	var $v_keyname;
	var $v_linkname;
	var $v_delimiter;
	var	$v_enclosure;

	var $v_field_filename;
	var $v_field_customers_groups;
	var $v_field_currency;
	var $v_field_shipping_costs;
	var $v_field_shipping_costs_free;
	var $v_field_attributes;
	var $v_field_campaign;
	var $v_field_export;
	
	var $_seo_boost;

	function Zanox() {
		$this->formSettings();
	}

	function formSettings(){
		$this->v_partnerlink='';
		$this->v_export_type='affiliate';
		$this->v_module_name='Zanox';
		$this->v_module_homepage='www.zanox.de';
		$this->v_module_format='csv';
		$this->v_module_export_filename='zanox_'.md5(uniqid()).'.csv';
		$this->v_filename='zanox.php';
		$this->v_keyname='ZANOX';
		$this->v_linkname='zanox';
		$this->v_delimiter=';';
		$this->v_enclosure='"';

		$this->v_field_filename=true;
		$this->v_field_customers_groups=true;
		$this->v_field_currency=true;
		$this->v_field_shipping_costs=true;
		$this->v_field_shipping_costs_free=true;
		$this->v_field_attributes=true;
		$this->v_field_campaign=true;
		$this->v_field_export=true;
	}

	function formAddOn(){

	}

	function formatResults($p_products_array){
		// description
		$p_products_array['products_short_description']=str_replace("\t", "", no_html($p_products_array['products_short_description']));
		if (strlen($p_products_array['products_short_description'])>500) {
		  $p_products_array['products_short_description']=substr($p_products_array['products_short_description'], 0, strpos($p_products_array['products_description'], ' ', 490)).'...';
		}
		$p_products_array['products_description']=str_replace("\t", "", no_html($p_products_array['products_description']));
		if (strlen($p_products_array['products_description'])>4000) {
		  $p_products_array['products_description']=substr($p_products_array['products_description'], 0, strpos($p_products_array['products_description'], ' ', 3990)).'...';
		}
		$p_products_array['products_description'] = strtr($p_products_array['products_description'], array($this->v_enclosure => ''));
		$p_products_array['products_short_description'] = strtr($p_products_array['products_short_description'], array($this->v_enclosure => ''));
		
		// price
		$p_products_array['products_price']=number_format( (double)$p_products_array['products_price'], 2, '.', '');
		if(isset($p_products_array['retail_price'])) {
			$p_products_array['products_old_price'] = number_format((double)$p_products_array['retail_price'], 2, '.', '');
			$specials_query = "SELECT specials_date_added, expires_date FROM specials WHERE products_id = :pid AND status = 1";
			$pid = isset($p_products_array['products_id_copy']) ? $p_products_array['products_id_copy'] : $p_products_array['products_id'];
			$specials_query = strtr($specials_query, array(':pid' => (int)$pid));
			$specials_result = xtc_db_query($specials_query);
			$specials_dates = xtc_db_fetch_array($specials_result);
			if($specials_dates['expires_date'] == '0000-00-00 00:00:00') {
				$specials_dates['expires_date'] = '';
			}
			$p_products_array['products_start'] = $specials_dates['specials_date_added'];
			$p_products_array['products_end'] = $specials_dates['expires_date'];
		}
		$p_products_array['products_shipping_costs']=number_format( (double)$p_products_array['products_shipping_costs'], 2, '.', '');
		
		// categories
		$p_products_array['products_categories']=str_replace(" > ", " / ", no_html($p_products_array['products_categories']));
		$categories_id = $p_products_array['products_categories_id'];
		$seo = $this->_getSeoBoost();
		if($seo->boost_categories) {
			$cat_url = $seo->get_boosted_category_url($categories_id);
			$cat_url = HTTP_SERVER.DIR_WS_CATALOG.$cat_url;
		}
		else {
			$cat_url = xtc_category_link($categories_id, $p_products_array['products_categories_last']);
			$cat_url = HTTP_SERVER.DIR_WS_CATALOG.'index.php?'.$cat_url;
		}
		$p_products_array['products_categories_url'] = $cat_url;
		return($p_products_array);
	}

	function exportScheme(){
		$t_csv_fields_array=array();
		$t_csv_fields_array['products_id']= 'prod_number';
		$t_csv_fields_array['products_name']= 'prod_name';
		$t_csv_fields_array['products_price']= 'prod_price';
		$t_csv_fields_array['products_old_price']= 'prod_price_old';
		$t_csv_fields_array['products_currency']= 'currency_symbol';
		$t_csv_fields_array['products_link']= 'prod_url';
		$t_csv_fields_array['products_categories']= 'category';
		$t_csv_fields_array['products_categories_url']= 'category_url';
		$t_csv_fields_array['products_start']= 'valid_from_date';
		$t_csv_fields_array['products_end']= 'valid_to_date';
		$t_csv_fields_array['products_short_description']= 'prod_description';
		$t_csv_fields_array['products_description']= 'prod_description_long';
		$t_csv_fields_array['products_image_1']= 'img_large';
		$t_csv_fields_array['manufacturers_name']= 'manufacturer';
		$t_csv_fields_array['products_ean']= 'prod_ean';
		$t_csv_fields_array['products_shippingtime']= 'delivery_time';
		$t_csv_fields_array['products_shipping_costs']= 'shipping_costs';
		return($t_csv_fields_array);
	}
	
	function _getSeoBoost() {
		if($this->_seo_boost == null) {
			$this->_seo_boost = MainFactory::create_object('GMSEOBoost');
		}
		return $this->_seo_boost;
	}
}
?>