<?php
/* --------------------------------------------------------------
   zentralverkauf.php 2010-07-29 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2010 Gambio GmbH
   Released under the GNU General Public License
   --------------------------------------------------------------
*/

class Zentralverkauf{
	var $v_partnerlink;
	var $v_export_type;
	var $v_module_name;
	var $v_module_homepage;
	var $v_module_format;
	var $v_module_export_filename;
	var $v_filename;
	var $v_keyname;
	var $v_linkname;
	var $v_delimiter;
	var	$v_enclosure;

	var $v_field_filename;
	var $v_field_customers_groups;
	var $v_field_currency;
	var $v_field_shipping_costs;
	var $v_field_shipping_costs_free;
	var $v_field_attributes;
	var $v_field_campaign;
	var $v_field_export;

	function Zentralverkauf() {
		$this->formSettings();
	}

	function formSettings(){
		$this->v_partnerlink='www.gambio.de/Schnittstellen/Preissuchmaschinen.html';
		$this->v_export_type='selling';
		$this->v_module_name='Zentralverkauf.de';
		$this->v_module_homepage='www.zentralverkauf.de';
		$this->v_module_format='csv';
		$this->v_module_export_filename='zentralverkauf.csv';
		$this->v_filename='zentralverkauf.php';
		$this->v_keyname='ZENTRALVERKAUF';
		$this->v_linkname='zentralverkauf';
		$this->v_delimiter='|';
		$this->v_enclosure='';

		$this->v_field_filename=true;
		$this->v_field_customers_groups=true;
		$this->v_field_currency=true;
		$this->v_field_shipping_costs=true;
		$this->v_field_shipping_costs_free=true;
		$this->v_field_attributes=true;
		$this->v_field_campaign=true;
		$this->v_field_export=true;
	}

	function formAddOn(){

	}

	function formatResults($p_products_array){
		$p_products_array['products_price'] = number_format( (double)$p_products_array['products_price'], 2, ',', '');
		$p_products_array['products_shipping_costs'] = number_format( (double)$p_products_array['products_shipping_costs'], 2, ',', '');
		$p_products_array['products_description'] = trim(no_html($p_products_array['products_description']));
		$p_products_array['products_short_description'] = trim(no_html($p_products_array['products_short_description']));
		$p_products_array['packing_unit_value'] = $p_products_array['packing_unit_value'];
		$p_products_array['packing_unit_name'] = $p_products_array['packing_unit_name'];
		$p_products_array['packing_unit_refrence'] = $p_products_array['packing_unit_compare'];
		if($p_products_array['products_stock'] < 1) {
			$p_products_array['products_stock'] = 1;	
		} 
		$p_products_array['products_model_type'] = '';
		if(strlen($p_products_array['products_ean']) > 3) {
			$p_products_array['products_model_type'] = 'EAN';
		}
		$p_products_array['products_group'] = isset($p_products_array['products_id_copy']) ? $p_products_array['products_id_copy'] : $p_products_array['products_id'];

		$p_attribute_names = array();
		// attributes export
		$attr_query = "SELECT po.products_options_name, pov.products_options_values_name
			FROM `products_attributes` pa
			left join products_options po on po.products_options_id = pa.options_id and po.language_id = :languages_id
			left join products_options_values pov on pov.products_options_values_id = pa.options_values_id and pov.language_id = :languages_id
			where pa.products_id = :products_id";
		if(isset($p_products_array['products_attributes_id'])) {
			$attr_query .= " AND pa.products_attributes_id = :pa_id";
			$attr_query = strtr($attr_query, array(
				':languages_id' => $_SESSION['languages_id'],
				':products_id' => (int)$p_products_array['products_id_copy'],
				':pa_id' => (int)$p_products_array['products_attributes_id'],
			));
		}
		else {
			$attr_query = strtr($attr_query, array(
				':languages_id' => $_SESSION['languages_id'],
				':products_id' => (int)$p_products_array['products_id'],
			));
		}
		$attr_result = xtc_db_query($attr_query);
		while($attr_row = xtc_db_fetch_array($attr_result)) {
			$p_attribute_names[] = $attr_row['products_options_name'].': '.$attr_row['products_options_values_name'];
		}

		$p_products_array['products_attributes_string'] = implode(";", $p_attribute_names);
		return($p_products_array);
	}

	function exportScheme(){
		$t_csv_fields_array = array();
		$t_csv_fields_array['products_id'] = 'ID_VK';
		$t_csv_fields_array['products_condition'] = 'KLASSE';
		$t_csv_fields_array['products_status'] = 'STATUS';

		$t_csv_fields_array['products_name'] = 'BEZEICHNUNG';
		$t_csv_fields_array['manufacturers_name'] = 'DEF_1';
		$t_csv_fields_array['products_model'] = 'DEF_2';
		// DEF_2
		$t_csv_fields_array['products_ean'] = 'KENZ_ID';

		$t_csv_fields_array['products_description'] = 'BESCHR_LANG';
		$t_csv_fields_array['products_short_description'] = 'BESCHR_KURZ';

		$t_csv_fields_array['products_quantity'] = 'ANG_MENGE';
		$t_csv_fields_array['packing_unit_name'] = 'MENGEN_EINHEIT';
		$t_csv_fields_array['packing_unit_value'] = 'ENTH_EINHEIT';
		$t_csv_fields_array['products_min_order'] = 'MIND_BEST_MENGE';

		$t_csv_fields_array['packing_unit_value'] = 'GRUNDP_INHALT';
		$t_csv_fields_array['packing_unit_name'] = 'GRUNDP_EINHEIT';
		$t_csv_fields_array['packing_unit_refrence'] = 'GRUNDP_REFMENGE';

		$t_csv_fields_array['products_image_1'] = 'BILD_1';
		$t_csv_fields_array['products_image_2'] = 'BILD_2';
		$t_csv_fields_array['products_image_3'] = 'BILD_3';
		$t_csv_fields_array['products_image_4'] = 'BILD_4';
		$t_csv_fields_array['products_image_5'] = 'BILD_5';

		$t_csv_fields_array['products_keywords'] = 'KEYWORDS';
		$t_csv_fields_array['products_cross_selling'] = 'CROSS_SELLING';

		$t_csv_fields_array['products_price'] = 'PREIS';
		$t_csv_fields_array['products_tax'] = 'MWST';

		$t_csv_fields_array['products_shippingdays'] = 'VERS_ZEIT';
		$t_csv_fields_array['products_weight'] = 'VERS_EINHEITEN';
		$t_csv_fields_array['products_shipping_group'] = 'VERS_GRUPPE';
		$t_csv_fields_array['products_shipping_addition'] = 'VERS_AUFSCHL';
		$t_csv_fields_array['products_shipping_addition_type'] = 'VERS_AUFSCHL_BER';

		$t_csv_fields_array['products_categories'] = 'KAT_BAUM_VK';

		/*
		$t_csv_fields_array['products_model'] = 'ART_NR';
		$t_csv_fields_array['products_definition_type'] = 'DEF_ART';
		$t_csv_fields_array['products_model_type'] = 'KENZ_ART';
		$t_csv_fields_array['not_set_1'] = 'VARIANTENSATZ_ID';
		$t_csv_fields_array['products_retailprice'] = 'UVP';
		$t_csv_fields_array['products_discount_id'] = 'RABATTSATZ_ID';
		$t_csv_fields_array['products_cat_id'] = 'KAT_ID_VK';
		*/
		$t_csv_fields_array['products_group'] = 'VAR_GRUPPE';
		$t_csv_fields_array['products_attributes_string'] = 'VAR_ATTRIBUTE';
		return($t_csv_fields_array);
	}
}

