<?php
/* --------------------------------------------------------------
   gm_trusted_shop_id.php 2013-04-24 gm
   Gambio GmbH
	http://www.gambio.de
   Copyright (c) 2013 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
	--------------------------------------------------------------


   based on: 
   (c) 2000-2001 The Exchange Project 
   (c) 2002-2003 osCommerce coding standards (a typical file) www.oscommerce.com
   (c) 2003      nextcommerce (start.php,1.5 2004/03/17); www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: start.php 1235 2005-09-21 19:11:43Z mz $)

   Released under the GNU General Public License 
   --------------------------------------------------------------*/

require('includes/application_top.php');

$service = new GMTSService();
$certs = $service->retrieveCertificates();

if(!empty($certs)) {
	mysql_query('
		UPDATE content_manager
		SET content_status = "1"
		WHERE content_group = "15"
	');
}

if(!empty($_POST)) {
	if(isset($_POST['del_id'])) {
		$service->deleteCertificate($_POST['del_id']);
		$_SESSION['ts_flash'] = 'Zertifikat gelscht';
	}

	if(isset($_POST['cred_id'])) {
		$service->changeCredentials($_POST['cred_id'], $_POST['user'], $_POST['password']);
		$_SESSION['ts_flash'] = 'Zugangsdaten gespeichert';
	}
	
	if(isset($_POST['check_all_certs'])) {
		$service->checkAllCertificates();
		$service->reloadProtectionItems();
		$_SESSION['ts_flash'] = 'Zertifikate geprft';
	}
	
	if(isset($_POST['application_number'])) {
		$state = $service->getRequestState($_POST['application_number']);
		if($state === false) {
			$_SESSION['ts_flash'] = 'Statusabruf fehlgeschlagen';
		}
		else if($state < 0) {
			$_SESSION['ts_flash'] = $service->errorText($state);
		}
		else {
			$_SESSION['ts_flash'] = 'Status abgerufen.';
		}
	}
	
	if(isset($_POST['save_rating_cfg'])) {
		gm_set_conf('GM_TS_RATING_ENABLED', isset($_POST['activate_rating']) ? '1' : '0');
		gm_set_conf('GM_TS_RATING_COSUCCESS', isset($_POST['rating_cosuccess']) ? '1' : '0');
		gm_set_conf('GM_TS_RATING_EMAIL', isset($_POST['rating_email']) ? '1' : '0');
	}
	
	if(isset($_POST['seal_cfg'])) {
		if($_POST['enable_seal'] == '1') {
			gm_set_conf('GM_TS_SEAL_ENABLED', 1);
		}
		else {
			gm_set_conf('GM_TS_SEAL_ENABLED', 0);
		}
	}

	xtc_redirect(HTTP_SERVER.DIR_WS_ADMIN.basename(__FILE__));
}

$app_query = xtc_db_query("SELECT tsp.*, orders.customers_name, orders.date_purchased FROM ts_protection tsp, orders
		WHERE tsp.orders_id = orders.orders_id
		AND orders.date_purchased > DATE_SUB(NOW(), INTERVAL 31 DAY)
		ORDER BY orders.date_purchased DESC");
$applications = array();
while($app_row = xtc_db_fetch_array($app_query)) {
	$applications[] = $app_row;
}

$seal_enabled = gm_get_conf('GM_TS_SEAL_ENABLED') == 1;
$rating_enabled = gm_get_conf('GM_TS_RATING_ENABLED') == 1;
$rating_cosuccess = gm_get_conf('GM_TS_RATING_COSUCCESS') == 1;
$rating_email = gm_get_conf('GM_TS_RATING_EMAIL') == 1;

if(isset($_SESSION['ts_flash'])) {
	$flash = $_SESSION['ts_flash'];
	unset($_SESSION['ts_flash']);
}
else {
	$flash = '';
}

$cronjob_url = HTTP_SERVER.DIR_WS_CATALOG.'trusted_shops_cron.php?key='.$service->getKey();

?>
<!doctype html>
<html <?php echo HTML_PARAMS; ?>>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $_SESSION['language_charset']; ?>"> 
		<title><?php echo TITLE; ?></title>
		<link rel="stylesheet" type="text/css" href="<?php echo DIR_WS_ADMIN; ?>includes/stylesheet.css">		
		<style type="text/css">
			input[type="checkbox"] { vertical-align: middle; }
			.padded { padding: 1ex 1em; }
			form.padded { display: block; }
			.warning { color: #CC0000; font-weight: bold; }
			.tsmain {
				background: #f7f7f7;
				border: 1px solid #CCCCCC;
				font: 0.8em sans-serif;
				padding: 1ex;
			}

			.tsinfo .showhidecontent {
				margin-bottom: 1em;
			}

			.showhide {
				float: right;
				border: 1px solid #BBBBBB;
				background: #FFFF99;
				padding: .5ex;
				border-radius: .3ex;
				cursor: pointer;
			}

			.subHeading {
				background-color: #585858;
				padding: .3ex 0.5ex;
				margin: .5ex 0;
				color: #ffffff;
				font-size: 1.1em;
				font-weight: bold;
			}

			#message {
				color: red;
				font-weight: bold;
			}
			
			p.flash {
				border: 1px solid #CC0000;
				background: #fffacd;
				padding: 1ex 1em;
				font-weight: bold;
			}
			
			input.invalid {
				border-color: #CC0000;
			}
			
			.add_ts_id {
				background: #dddddd;
				margin: auto;
				padding: 1ex 1em;
				width: 80%;
				text-align: center;
			}

			table.tsids,
			table.applications {
				margin: 1em auto;
				width: 90%;
			}
			
			table.tsids thead,
			table.applications thead {
				background: #888888;
				color: #ffffff;
			}

			table.tsids th,
			table.tsids td,
			table.applications th,
			table.applications td {
				padding: .3ex .5ex;
			}

			table.tsids tbody,
			table.applications tbody {
				background: #dddddd;
			}
			
			.creds label {
				display: inline-block;
				width: 8em;
				margin-left: 2em;
			}
			
		</style>
		<script type="text/javascript" src="gm/javascript/LoadUrl.js"></script>
	</head>
	<body topmargin="0" leftmargin="0" bgcolor="#FFFFFF">

		<?php require(DIR_WS_INCLUDES . 'header.php'); ?>

		<script language="JavaScript" type="text/javascript">
		$(document).ready(function(){
			var coo_load_url = new LoadUrl();
			coo_load_url.load_url('load_content');
		});
		</script>
		
		<table border="0" width="100%" cellspacing="2" cellpadding="2">
			<tr>
				<td class="columnLeft2" width="<?php echo BOX_WIDTH; ?>" valign="top">
					<table border="0" width="<?php echo BOX_WIDTH; ?>" cellspacing="1" cellpadding="1" class="columnLeft">
						<?php require(DIR_WS_INCLUDES . 'column_left.php'); ?>
					</table>
				</td>
				<td class="boxCenter" width="100%" valign="top">
					<div class="pageHeading" style="background-image:url(images/gm_icons/gambio.png)"><?php echo HEADING_TITLE; ?></div>

					<div class="tsmain">
						<div class="tsinfo">
							<div class="showhide"><?php echo SHOWHIDEINFO ?></div>
							<div class="showhidecontent">
								<div class="subHeading"><?php echo HEADING_INFO ?></div>
								
								<!-- Trusted Shops Info -->
								<div id="url_loader">
									<img id="loading" src="../images/loading.gif" />
									<?php echo TEXT_CONTENT_LOADING; ?>
								</div>
								<div class="load_url">http://news.gambio.de/trustedshops/trusted_shops_info.php?language=<?php echo $_SESSION['language_code']; ?></div>
								<!-- END Trusted Shops Info -->
								
							</div>
						</div>
						<div class="tscfg">
							<div class="subHeading"><?php echo HEADING_CONFIGURATION ?></div>
							<?php if(!empty($flash)): ?>
							<p class="flash">
								<?php echo $flash ?>
							</p>
							<?php endif ?>
							<div class="add_ts_id">
								<form action="" method="post" class="pseudoform">
									<label for="new_id"><?php echo ADD_TS_ID ?></label>
									<input type="text" name="new_id" id="new_id" size="40" maxlength="33">
									<input type="submit" value="<?php echo CHECK_ADD ?>" id="add_id">
									<span id="message"></span>
								</form>
							</div>
							
							<?php if(empty($certs)): ?>
							<p><em><?php echo NO_TS_YET ?></em></p>
							<?php else: ?>
							<table class="tsids">
								<thead>
									<tr>
										<th><?php echo TH_TS_ID ?></th>
										<th><?php echo TH_TYPE ?></th>
										<th><?php echo TH_URL ?></th>
										<th><?php echo TH_LANGUAGE ?></th>
										<th><?php echo TH_STATE ?></th>
										<th><?php echo TH_FOR_RATING ?></th>
										<th>&nbsp;</th>
									</tr>
								</thead>
								<tbody>
									<?php foreach($certs as $cert): ?>
									<tr>
										<td><?php echo $cert['tsid'] ?></td>
										<td><?php echo $cert['type'] ?></td>
										<td><?php echo $cert['url'] ?></td>
										<td><?php echo $cert['language'] ?></td>
										<td><?php echo $cert['state'] ?></td>
										<td><?php echo $cert['rating_ok'] == true ? YES : NO ?></td>
										<td>
											<form action="" method="POST">
												<input type="hidden" name="del_id" value="<?php echo $cert['tsid'] ?>">
												<input type="submit" value="<?php echo TS_DELETE ?>">
											</form>
										</td>
									</tr>
									<?php if($cert['type'] == 'EXCELLENCE'): ?>
									<tr>
										<td colspan="7">
											<form action="" method="POST" class="creds">
												<input type="hidden" name="cred_id" value="<?php echo $cert['tsid'] ?>">
												<label for="user_<?php echo $cert['tsid'] ?>"><?php echo TS_USERNAME ?></label>
												<input type="text" name="user" value="<?php echo $cert['user'] ?>" id="user_<?php echo $cert['tsid'] ?>" size="25" maxlength="200">
												<?php if($cert['login_ok'] != true): ?>
												<span class="warning"><?php echo TS_LOGIN_INVALID ?></span>
												<?php endif ?>
												<br>
												<label for="password_<?php echo $cert['tsid'] ?>"><?php echo TS_PASSWORD ?></label>
												<input type="text" name="password" value="<?php echo $cert['password'] ?>" id="password_<?php echo $cert['tsid'] ?>" size="25" maxlength="200">
												<input type="submit" value="<?php echo TS_CHECKSAVE ?>">
											</form>
										</td>
									</tr>
									<?php endif ?>
									<?php endforeach ?>
								</tbody>
							</table>
							<form action="" method="post" class="padded">
								<input type="hidden" name="check_all_certs" value="1">
								<input type="submit" value="<?php echo TS_CHECKALLIDS ?>">
							</form>
							
							<form action="" method="post" class="padded">
								<input type="hidden" name="seal_cfg" value="1">
								<input type="checkbox" name="enable_seal" value="1" id="enable_seal" <?php echo $seal_enabled ? 'checked="checked"' : '' ?>>
								<label for="enable_seal"><?php echo TS_ENABLE_SEAL ?></label>
								<input type="submit" value="<?php echo TS_SAVE ?>" class="button">
							</form>

							<p>
								<?php echo TS_CRONJOB_URL ?> <a href="<?= $cronjob_url ?>"><?= $cronjob_url ?></a>
							</p>
							<?php endif // empty($certs) ?>
						</div>
						
						<?php if(!empty($applications)): ?>
						<div class="tscfg">
							<div class="subHeading"><?php echo TS_BP_APPLICATIONS ?></div>
							<table class="applications">
								<thead>
									<tr>
										<th><?php echo TH_ORDER ?></th>
										<th><?php echo TH_DATE ?></th>
										<th><?php echo TH_CUSTOMER ?></th>
										<th><?php echo TH_APPNO ?></th>
										<th><?php echo TH_GUARANTEENO ?></th>
									</tr>
								</thead>
								<tbody>
									<?php foreach($applications as $app): ?>
									<tr>
										<td><?= $app['orders_id'] ?></td>
										<td><?= $app['date_purchased'] ?></td>
										<td><?= $app['customers_name'] ?></td>
										<td><?= $app['application_number'] ?></td>
										<td>
											<?php if($app['result'] == '' || $app['result'] == '0'): ?>
											<?php if($app['result'] == '0'): ?>
											<?php echo TS_PROCESSING ?>
											<?php endif ?>
											<form action="" method="post">
												<input type="hidden" name="application_number" value="<?= $app['application_number'] ?>">
												<input type="submit" value="<?php echo TS_CHECKUPDATE ?>">
											</form>
											<?php else: ?>
											<?= $app['result'] ?>
											<?php endif ?>
										</td>
									</tr>
									<?php endforeach ?>
								</tbody>
							</table>
						</div>
						<?php endif; // !empty($applications) ?>
						
						
						<div class="tscfg">
							<div class="subHeading"><?php echo TS_HEADING_RATING ?></div>
							<form action="" method="post" class="padded">
								<input type="hidden" name="save_rating_cfg" value="1">
								<input type="checkbox" id="activate_rating" name="activate_rating" value="1" <?= $rating_enabled ? 'checked="checked"' : ''?>>
								<label for="activate_rating"><?php echo TS_ENABLE_MODULE ?></label>
								<br>
								<input type="checkbox" id="rating_cosuccess" name="rating_cosuccess" value="1" <?= $rating_cosuccess ? 'checked="checked"' : ''?>>
								<label for="rating_cosuccess"><?php echo TS_SHOW_RATING_COSUCCESS ?></label>
								<br>
								<input type="checkbox" id="rating_email" name="rating_email" value="1" <?= $rating_email ? 'checked="checked"' : ''?>>
								<label for="rating_email"><?php echo TS_SHOW_RATING_EMAIL ?></label>
								<br>
								<input class="button" type="submit" value="<?php echo TS_SAVE ?>">
							</form>
						</div>
					</div>

				</td>
			</tr>
		</table>
		<script>
			$(function() {
				var error_txt = {
					'TS_INVALID_ID': '<?php echo TS_INVALID_ID ?>',
					'TS_DOUBLE_ID': '<?php echo TS_DOUBLE_ID ?>',
					'TS_LOGIN_INVALID': '<?php echo TS_LOGIN_INVALID ?>'
				};
				$(".showhide").click(function(e) {
					var content = $(this).next(".showhidecontent");
					content.toggle('fast');
				});

				<?php if(!empty($certs)): ?>
				$(".tsinfo .showhidecontent").hide();
				<?php endif ?>

				$("form.pseudoform").submit(function(e) {
					return false;
				});

				$("#add_id").click(function(e) {
					var new_id = $("input[name=new_id]", $(this).closest("form")).val();
					var rpdata = {
						'new_id': new_id
					};
					$.ajax({
						type: "POST",
						url: "request_port.php?module=TrustedShopsAdmin&cmd=new_id",
						data: rpdata,
						dataType: 'json'
					}).done(function(result){
						if(result.error) {
							//$('#message').html(error_txt[result.error]);
							alert(error_txt[result.error]);
						}
						if(result.reload == true) {
							location.reload();
						}
					});
				});
				
				$("form.creds").submit(function(e) {
					var the_form = $(this);
					var user_input = $('input[name="user"]', this);
					var password_input = $('input[name="password"]', this);
					var tsid = $('input[name="cred_id"]', this).val();
					var user = user_input.val();
					var password = password_input.val();
					var rpdata = {
						'tsid': tsid,
						'user': user,
						'password': password
					};
					var valid = false;
					$.ajax({
						type: "POST",
						url: "request_port.php?module=TrustedShopsAdmin&cmd=check_login",
						data: rpdata,
						dataType: 'json',
						async: false
					}).done(function(result) {
						console.log(result);
						if(result.valid == true) {
							valid = true;
						}
						else {
							alert(error_txt['TS_LOGIN_INVALID']);
							user_input.addClass('invalid');
							password_input.addClass('invalid');
							valid = false;
						}
					});
					return valid;
				});
			});
		</script>
		<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
	</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>