<?php 
/* --------------------------------------------------------------
   iloxx.php 2012-09 gambio
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2012 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(ot_cod_fee.php,v 1.02 2003/02/24); www.oscommerce.com
   (C) 2001 - 2003 TheMedia, Dipl.-Ing Thomas Plnkers ; http://www.themedia.at & http://www.oscommerce.at
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: ot_cod_fee.php 1003 2005-07-10 18:58:52Z mz $)

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

require('includes/application_top.php');
defined('GM_HTTP_SERVER') or define('GM_HTTP_SERVER', HTTP_SERVER);
define('PAGE_URL', GM_HTTP_SERVER.DIR_WS_ADMIN.basename(__FILE__));

$iloxx = new GMIloxx();

if($_SERVER['REQUEST_METHOD'] == "POST") {
	switch($_POST['cmd']) {
		case 'save_cfg':
			$iloxx->userid = xtc_db_input($_POST['userid']);
			$iloxx->usertoken = xtc_db_input($_POST['usertoken']);
			$iloxx->oslabelacquired = xtc_db_input($_POST['os_label_acquired']);
			$iloxx->ostracking = xtc_db_input($_POST['os_tracking']);
			break;
		case 'get_transaction_list':
			$pdfdata = $iloxx->getDailyTransactionList($_POST['gdtl_date'], $_POST['gdtl_type']);
			if($pdfdata !== false) {
				header('Content-Type: application/pdf');
				header('Content-Disposition: attachment;filename=tagesabschluss_'.$_POST['gdtl_date'].'.pdf');
				echo $pdfdata;
			}
			break;
		default:
			die('What do you think you are doing, Dave?');
	}
	xtc_redirect(PAGE_URL);
}

$orders_status = xtc_get_orders_status();


?>
<!DOCTYPE html>
<html <?php echo HTML_PARAMS; ?>>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $_SESSION['language_charset']; ?>">
		<title><?php echo TITLE; ?></title>
		<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
		<link rel="stylesheet" type="text/css" href="includes/stylesheet_iloxx.css">
		<style>
		</style>
	</head>
	<body>
		<!-- header //-->
		<?php require(DIR_WS_INCLUDES . 'header.php'); ?>
		<!-- header_eof //-->

		<!-- body //-->
		<table border="0" width="100%" cellspacing="2" cellpadding="2">
			<tr>
				<td class="columnLeft2" width="<?php echo BOX_WIDTH; ?>" valign="top">
					<table border="0" width="<?php echo BOX_WIDTH; ?>" cellspacing="1" cellpadding="1" class="columnLeft">

						<!-- left_navigation //-->
						<?php require(DIR_WS_INCLUDES . 'column_left.php'); ?>
						<!-- left_navigation_eof //-->

					</table>
				</td>

				<!-- body_text //-->

				<td class="boxCenter" width="100%" valign="top">
					<table border="0" width="100%" cellspacing="0" cellpadding="0" class="credits">
						<tr>
							<td>
								<table border="0" width="100%" cellspacing="0" cellpadding="0">
									<tr>
										<td class="pageHeading" style="padding-left: 0px">Iloxx</td>
										<td width="80" rowspan="2">&nbsp;</td>
									</tr>
									<tr>
										<td class="main" valign="top">&nbsp;</td>
									</tr>
								</table>
							</td>
						</tr>
						<tr>
							<td class="main">

								<form action="<?php echo PAGE_URL ?>" method="post">
									<input type="hidden" name="cmd" value="save_cfg">
									<fieldset class="lefthalf">
										<legend>Konfiguration</legend>
										<dl class="form">
											<dt><label for="userid">UserID</label></dt>
											<dd>
												<input id="userid" name="userid" type="text" value="<?php echo $iloxx->userid ?>">
											</dd>
											<dt><label for="usertoken">User Token</label></dt>
											<dd>
												<input id="usertoken" name="usertoken" type="text" value="<?php echo $iloxx->usertoken ?>">
											</dd>
											<dt><label for="os_label_acquired">Bestellstatus nach Paketscheinanforderung</label></dt>
											<dd>
												<select name="os_label_acquired" size="1">
													<?php foreach($orders_status as $os): ?>
													<option value="<?php echo $os['id'] ?>"<?php echo $os['id'] == $iloxx->oslabelacquired ? ' selected="selected"' : '' ?>>
														<?php echo $os['text'] ?>
													</option>
													<?php endforeach ?>
												</select>
											</dd>
											<dt><label for="os_tracking">Bestellstatus nach Empfang von Tracking-Status</label></dt>
											<dd>
												<select name="os_tracking" size="1">
													<?php foreach($orders_status as $os): ?>
													<option value="<?php echo $os['id'] ?>"<?php echo $os['id'] == $iloxx->ostracking ? ' selected="selected"' : '' ?>>
														<?php echo $os['text'] ?>
													</option>
													<?php endforeach ?>
												</select>
											</dd>
										</dl>
										<div class="buttons">
											<input type="submit" value="speichern" class="button">
										</div>
									</fieldset>
								</form>

								<form action="<?php echo PAGE_URL ?>" method="post">
									<input type="hidden" name="cmd" value="get_transaction_list">
									<fieldset class="righthalf">
										<legend>Tagesabschlussliste</legend>
										<dl class="form">
											<dt><label for="gdtl_date">Datum</label></dt>
											<dd>
												<input type="text" name="gdtl_date" value="<?php echo date('Y-m-d') ?>">
											</dd>
											<dt><label for="gdtl_type">Dienstleister</label></dt>
											<dd>
												<select name="gdtl_type">
													<option value="DPD">DPD</option>
													<option value="Grosspaket">Gro&szlig;paket</option>
												</select>
											</dd>
										</dl>
										<div class="buttons">
											<input type="submit" value="abrufen" class="button">
										</div>
									</fieldset>
								</form>

								<p class="partnerinfo">
									F&uuml;r weitere Informationen zum Einsatz der Iloxx-Schnittstelle in Gambio GX
									klicken Sie bitte <a class="plink" target="_new" href="http://www.iloxx.de/net/Kooperationen/gambio.aspx">hier</a>.
								</p>
								
							</td><!--  main  -->
						</tr>
					</table>
				</td>

				<!-- body_text_eof //-->
				
			</tr>
		</table>
		<!-- body_eof //-->

		<!-- footer //-->
		<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
		<!-- footer_eof //-->
	</body>
</html>
<?php
require(DIR_WS_INCLUDES . 'application_bottom.php');
