<?php 
/* --------------------------------------------------------------
   iloxx.php 2012-09 gambio
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2012 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(ot_cod_fee.php,v 1.02 2003/02/24); www.oscommerce.com
   (C) 2001 - 2003 TheMedia, Dipl.-Ing Thomas Plnkers ; http://www.themedia.at & http://www.oscommerce.at
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: ot_cod_fee.php 1003 2005-07-10 18:58:52Z mz $)

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

require('includes/application_top.php');
defined('GM_HTTP_SERVER') or define('GM_HTTP_SERVER', HTTP_SERVER);
define('PAGE_URL', GM_HTTP_SERVER.DIR_WS_ADMIN.basename(__FILE__));

if(!is_array($_SESSION[basename(__FILE__)])) {
	$_SESSION[basename(__FILE__)] = array();
}
if(!is_array($_SESSION[basename(__FILE__)]['messages'])) {
	$_SESSION[basename(__FILE__)]['messages'] = array();
}

function getOrdersProducts($orders_id) {
	$query = "SELECT op.orders_products_id, op.products_quantity, op.products_name, p.products_weight FROM `orders_products` op
				left join products p on p.products_id = op.products_id
				where orders_id = :orders_id";
	$query = strtr($query, array(':orders_id' => (int)$orders_id));
	$result = xtc_db_query($query);
	$opdata = array();
	while($row = xtc_db_fetch_array($result)) {
		$opdata[] = $row;
	}
	return $opdata;
}

function getOrderData($orders_ids) {
	$orders = array();
	if(!empty($orders_ids)) {
		$orders_ids = array_slice($orders_ids, 0, 100); // web service will accept up to 100 entries
		$oquery = "SELECT o.*, ot.value FROM `orders` o ".
			"left join orders_total ot on ot.orders_id = o.orders_id and ot.class = 'ot_total' ".
			"WHERE o.orders_id IN (".implode(',', $orders_ids).") ";
		$oresult = xtc_db_query($oquery, 'db_link', false);
		while($orow = xtc_db_fetch_array($oresult)) {
			$opdata = getOrdersProducts($orow['orders_id']);
			$orders_weight = 0;
			$content = array();
			foreach($opdata as $od) {
				$orders_weight += $od['products_quantity'] * $od['products_weight'];
				$content[] = $od['products_quantity'] .' '. $od['products_name'];
			}
			$orow['orders_weight'] = $orders_weight;
			$orow['content'] = implode(', ', $content);
			$orders[] = $orow;
		}
	}
	else {
	}
	return $orders;
}

$iloxx = new GMIloxx();

if(isset($_GET['dl_labels'])) {
	header('Content-Type: application/pdf');
	header('Content-Disposition: attachment; filename=iloxx_labels.pdf');
	readfile($iloxx->getLabelsFileName());
	exit;
}

if($_SERVER['REQUEST_METHOD'] == "POST") {
	switch($_POST['cmd']) {
		case 'select_orders':
			$_SESSION['iloxx_debug'] = print_r($_POST, true);
			$_SESSION['iloxx']['return_uri'] = $_POST['return_uri'];
			$_SESSION['iloxx']['orders_ids'] = explode('_', rtrim($_POST['checked_ids'], '_'));
			break;
		case 'add_orders':
			$orders_ids = $_SESSION['iloxx']['orders_ids'];
			if(isset($_POST['remove_selected']) && !empty($_POST['selected'])) {
				$selected_ids = array_keys($_POST['selected']);
				$orders_ids = array_diff($orders_ids, $selected_ids);
				$_SESSION['iloxx']['orders_ids'] = $orders_ids;
			}
			$orders = getOrderData($orders_ids);
			foreach($orders as $idx => $order) {
				$orders[$idx]['orders_weight'] = (double)$_POST['orders_weight'][$order['orders_id']];
				$orders[$idx]['iloxx_service'] = $_POST['ordertype'][$order['orders_id']];
				$iloxxdata = $iloxx->getOrderIloxxData($order['orders_id']);
				$iloxxdata['weight'] = (double)$_POST['orders_weight'][$order['orders_id']];
				$iloxxdata['service'] = $_POST['ordertype'][$order['orders_id']];
				$iloxxdata['shipdate'] = $_POST['shipdate'];
				$iloxx->setOrderIloxxData($iloxxdata['orders_id'], $iloxxdata['parcelnumber'], $iloxxdata['service'], $iloxxdata['weight'], $iloxxdata['shipdate']);
			}
			if(isset($_POST['check'])) {
				$result = $iloxx->addOrder($orders, $_POST['shipdate'], $_POST['labelsize'], $_POST['labelpos'], 'check');
				if($result === false) {
					foreach($iloxx->_service_errors as $service_error) {
						$_SESSION[basename(__FILE__)]['messages'][] = $service_error;
					}
				}
				else {
					$_SESSION[basename(__FILE__)]['messages'][] = "Alle Adressen in Ordnung.";
				}
			}
			else if(isset($_POST['addorders'])) {
				$result = $iloxx->addOrder($orders, $_POST['shipdate'], $_POST['labelsize'], $_POST['labelpos'], 'addOrder');
				if($result !== false) {
					$_SESSION[basename(__FILE__)]['messages'][] = "Paketscheine erzeugt.";
					$_SESSION[basename(__FILE__)]['labels_ready'] = true;
					//$_SESSION['iloxx']['orders_ids'] = array();
				}
			}
			break;
		default:
			die("Just what do you think you're doing, Dave?");
	}
	xtc_redirect(PAGE_URL);
}

$return_uri = $_SESSION['iloxx']['return_uri'];
$orders_ids = $_SESSION['iloxx']['orders_ids'];
$orders = getOrderData($orders_ids);

$messages = $_SESSION[basename(__FILE__)]['messages'];
$_SESSION[basename(__FILE__)]['messages'] = array();

if($_SESSION[basename(__FILE__)]['labels_ready'] === true) {
	$_SESSION[basename(__FILE__)]['labels_ready'] = false;
	header('Refresh: 1; url='.PAGE_URL.'?dl_labels=1');
}

//$debug = $_SESSION['iloxx_debug'];
//$debug = print_r($orders, true);

?>
<!DOCTYPE html>
<html <?php echo HTML_PARAMS; ?>>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $_SESSION['language_charset']; ?>">
		<title><?php echo TITLE; ?></title>
		<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
		<link rel="stylesheet" type="text/css" href="includes/stylesheet_iloxx.css">
		<style>
		input.small { width: 5em; }
		</style>
	</head>
	<body>
		<!-- header //-->
		<?php require(DIR_WS_INCLUDES . 'header.php'); ?>
		<!-- header_eof //-->

		<!-- body //-->
		<table border="0" width="100%" cellspacing="2" cellpadding="2">
			<tr>
				<td class="columnLeft2" width="<?php echo BOX_WIDTH; ?>" valign="top">
					<table border="0" width="<?php echo BOX_WIDTH; ?>" cellspacing="1" cellpadding="1" class="columnLeft">

						<!-- left_navigation //-->
						<?php require(DIR_WS_INCLUDES . 'column_left.php'); ?>
						<!-- left_navigation_eof //-->

					</table>
				</td>

				<!-- body_text //-->

				<td class="boxCenter" width="100%" valign="top">
					<table border="0" width="100%" cellspacing="0" cellpadding="0" class="credits">
						<tr>
							<td>
								<table border="0" width="100%" cellspacing="0" cellpadding="0">
									<tr>
										<td class="pageHeading" style="padding-left: 0px">Iloxx Auftragsvorbereitung</td>
										<td width="80" rowspan="2">&nbsp;</td>
									</tr>
									<tr>
										<td class="main" valign="top">&nbsp;</td>
									</tr>
								</table>
							</td>
						</tr>
						<tr>
							<td class="main">
								<?php foreach($messages as $msg): ?>
								<p class="message"><?php echo htmlspecialchars($msg) ?></p>
								<?php endforeach ?>
								
								<form action="<?php echo PAGE_URL ?>" method="POST">
									<input type="hidden" name="cmd" value="add_orders">
									<table class="orders">
										<thead>
											<tr>
												<th></th>
												<th>Bestellnummer</th>
												<th>Name Besteller</th>
												<th>Versandadresse</th>
												<th>Inhalt</th>
												<th>Versandart</th>
												<th>Wert</th>
												<th>Gewicht</th>
												<th>Paketnummer</th>
											</tr>
										</thead>
										<tbody>
											<?php foreach($orders as $o): ?>
											<?php $idata = $iloxx->getOrderIloxxData($o['orders_id']); ?>
											<?php $weight = $idata['weight'] > 0 ? $idata['weight'] : $o['orders_weight']; ?>
											<tr>
												<td>
													<input type="checkbox" name="selected[<?php echo $o['orders_id'] ?>]" value="1">
												</td>
												<td><?php echo $o['orders_id'] ?></td>
												<td><?php echo $o['customers_name'] ?></td>
												<td><?php 
													echo $o['delivery_name'] .'<br>'. 
														$o['delivery_company'] .'<br>'.
														$o['delivery_street_address'] .'<br>'.
														$o['delivery_postcode'] .' '. $o['delivery_city'] .'<br>'.
														$o['delivery_country_iso_code_2'];
													?>
												</td>
												<td><?php echo $o['content'] ?></td>
												<td>
													<select name="ordertype[<?php echo $o['orders_id'] ?>]">
														<?php foreach(GMIloxx::getShipServices() as $key => $name): ?>
														<option value="<?php echo $key ?>"<?php echo $key == $idata['service'] ? ' selected="selected"' : '' ?>><?php echo $name ?></option>
														<?php endforeach ?>
													</select>
												</td>
												<td>
													<input class="small" type="text" name="orders_codamount[<?php echo $o['orders_id'] ?>" value="<?php echo number_format($o['value'], 2, '.', '') ?>">
													<?php echo $o['currency'] ?>
												</td>
												<td>
													<input class="small" type="text" name="orders_weight[<?php echo $o['orders_id'] ?>]" value="<?php echo $weight ?>"> kg
												</td>
												<td>
													<?php echo empty($idata['parcelnumber']) ? '<em>noch keine</em>' : $idata['parcelnumber'] ?>
												</td>
											</tr>
											<?php endforeach ?>
										</tbody>
									</table>
									<br>
									<label for="labelsize">Labelformat:</label>
									<select name="labelsize">
										<option value="a4">A4 (mehrere Labels pro Seite)</option>
										<option value="a6">A6 (ein Label pro Seite)</option>
									</select>
									<br>
									<label for="labelpos">Startposition (bei A4-Format):</label>
									<select name="labelpos">
										<option value="ul">oben links</option>
										<option value="ur">oben rechts</option>
										<option value="ll">unten links</option>
										<option value="lr">unten rechts</option>
									</select>
									<br>
									<label for="shipdate">Versanddatum:</label>
									<input name="shipdate" type="text" value="<?php echo date('Y-m-d') ?>"><br>
									<input type="submit" name="check" value="Adressen prfen" class="button button_wide">
									<input type="submit" name="addorders" value="Versandlabels abrufen" class="button button_wide">
									<input type="submit" name="remove_selected" value="Gewhlte entfernen" class="button button_wide">
								</form>
								
								<pre><?php echo $debug ?></pre>
								
							</td><!--  main  -->
						</tr>
					</table>
				</td>

				<!-- body_text_eof //-->
				
			</tr>
		</table>
		<!-- body_eof //-->

		<!-- footer //-->
		<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
		<!-- footer_eof //-->
	</body>
</html>
<?php
require(DIR_WS_INCLUDES . 'application_bottom.php');
