<?php
/**
 * Sprache beziehen
 *
 * @return String ISO CODE, zweistellig, z.B. 'de'
 */
function getLanguageIsoCode()
{
	if(empty($_SESSION['language_code']) === false) {
		return $_SESSION['language_code'];
	} else {
		return SHOP_SYSTEM_DEFAULT_LANGUAGE_ISO_CODE;
	}
}

/**
 * Bezieht die Registrierungsdaten vom Vertriebspartner bzw. angemeldeten
 * Administrator
 *
 * @return array
 */
function getPublisherRegistrationData()
{
	$publisherRegistrationData = array();
	mysql_query("set names 'utf8'");
	$result = xtc_db_query("
		SELECT
			a.entry_gender AS gender,
			a.entry_firstname AS firstName,
			a.entry_lastname AS lastName,
			a.entry_company AS company,
			a.entry_street_address AS street,
			a.entry_postcode AS postcode,
			a.entry_city AS city,
			c.customers_email_address AS email,
			c.customers_telephone AS phone
		FROM " . TABLE_CUSTOMERS . " c, " . TABLE_ADDRESS_BOOK . " a
		WHERE
			c.customers_id = '" . (int)$_SESSION['customer_id'] . "' 
		AND
			c.customers_default_address_id = a.address_book_id");

	if(xtc_db_num_rows($result) == 1) {
		$publisherRegistrationData = xtc_db_fetch_array($result);
	}

	return $publisherRegistrationData;
}

/**
 * Bezieht die Gutscheine von AffiliPRINT über eine entsprechende Schnittstelle
 *
 * @var mixed $lastOrder / letzte Bestellnummer
 * @return mixed
 */
function getVouchers($lastOrder)
{
	/* Konfiguration beziehen */
	require_once (DIR_FS_CATALOG . 'affiliprint_module/includes/config.php');

	/* Sofern die Gutscheine zur Bestellung $lastOrder bereits in der aktuellen
	 * $_SESSION gecached worden sind, gebe diese aus */
	if(isset($_SESSION['affiliprint'][$lastOrder]) && AFFILIPRINT_DEBUG_MODE === false && $moduleConfig->moduleStatus == 1) {
		return $_SESSION['affiliprint'][$lastOrder];
	}

	/* Konfigurationseinstellungen für das Modul beziehen */
	$moduleConfig = json_decode(gm_get_conf('AFFILIPRINT_CONFIGURATION_DATA', 'ASSOC', true));

	/* Sofern das Modul aktiviert worden ist und auch eine Bestellnummer vorhanden
	 * ist, beziehe die Gutscheine zur Bestellung $lastOrder */
	if(empty($lastOrder) === false && $moduleConfig->moduleStatus == 1) {
		/* Überprüfen, ob eine SSL-Verschlüsselung im Onlineshop verwendet wird */
		$protocol = "http://";
		if(ENABLE_SSL === true || ENABLE_SSL === 'true') {
			$protocol = "https://";
		}

		/* Gutschein-Schnipsel generieren */
		$snippetUrl = $protocol . str_replace($moduleConfig->transactionIdWildcard, $lastOrder, $moduleConfig->adsUrl);
		$snippetSource = str_replace(AFFILIPRINT_SNIPPET_JS_SOURCE, $snippetUrl, AFFILIPRINT_SNIPPET_JS);
		/* Schnipsel in der $_SESSION cachen, um erneute Aufrufe zu vermeiden */
		$_SESSION['affiliprint'][$lastOrder] = $snippetSource;
		
		return $snippetSource;
	} else {
		return false;
	}
}
?>