<?php
/* --------------------------------------------------------------
   GMAttributesCalculator.php 2013-05-13 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2013 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/
	
class GMAttributesCalculator {

	var $products_id = 0;
	var $attributes = array();
	var $tax_class_id = 0;
	var $v_combi_price = 0;

	function GMAttributesCalculator($products_id, $attributes, $tax_class_id, $p_combi_price = 0) {
		$this->products_id = $products_id;
		$this->attributes = $attributes;
		$this->tax_class_id = $tax_class_id;
		$this->v_combi_price = $p_combi_price;
		return;
	}


	function attributes_price() {
		global $xtPrice;
		$attributes_price = 0;


		$customers_status_discount_attributes_copy = $xtPrice->cStatus['customers_status_discount_attributes'];
		$xtPrice->cStatus['customers_status_discount_attributes'] = 0; // kein Rabatt berechnen, da Gesamtpreis spter rabattiert wird

		for($i = 0; $i < count($this->attributes); $i++){
			$values = $xtPrice->xtcGetOptionPrice($this->products_id, $this->attributes[$i]['option'], $this->attributes[$i]['value']);
			$attributes_price += $values['price'];
		}
		$xtPrice->cStatus['customers_status_discount_attributes'] = $customers_status_discount_attributes_copy; // alten Zustand wiederherstellen

		$attributes_price += $this->v_combi_price;

		return $attributes_price;
	}


	function calculate($qty = 1, $format = false, $curr = false, $vpeStatus = 0){
		global $xtPrice;
		$pPrice = 0;

		if($xtPrice->cStatus['customers_status_show_price_tax'] != '0') $tax = $xtPrice->TAX[$this->tax_class_id];
		else $tax = 0;

		$pPrice = $xtPrice->getPprice($this->products_id);

		// graduated sPrice
		$graduated_sPrice = $xtPrice->xtcGetGraduatedPrice($this->products_id, $qty);

		// check specialprice
		if ($sPrice = $xtPrice->xtcCheckSpecial($this->products_id)){
			$sPrice = $xtPrice->xtcCheckSpecial($this->products_id);
			$pPrice = $xtPrice->xtcFormatSpecial($this->products_id, $xtPrice->xtcAddTax($sPrice, $tax) + $this->attributes_price(), $xtPrice->xtcAddTax($pPrice, $tax) + $this->attributes_price(), $format, $vpeStatus);
		}
		// check graduated
		elseif ($xtPrice->cStatus['customers_status_graduated_prices'] == '1' && !empty($graduated_sPrice) && $graduated_sPrice != $pPrice) {
			if($graduated_sPrice < $pPrice) $pPrice = $xtPrice->xtcFormatSpecialGraduated($this->products_id, $xtPrice->xtcAddTax($graduated_sPrice, $tax) + $this->attributes_price(), $xtPrice->xtcAddTax($pPrice, $tax) + $this->attributes_price(), $format, $vpeStatus, $this->products_id);
			else $pPrice = $xtPrice->xtcFormat($xtPrice->xtcAddTax($graduated_sPrice, $tax) + $this->attributes_price(), $format, 0, $curr, $vpeStatus, $this->products_id);
		}			
		// check Group Price
		elseif ($xtPrice->xtcGetGroupPrice($this->products_id, 1)){
			$sPrice = $xtPrice->xtcGetGroupPrice($this->products_id, 1);
			if($sPrice < $pPrice) $pPrice = $xtPrice->xtcFormatSpecialGraduated($this->products_id, $xtPrice->xtcAddTax($sPrice, $tax) + $this->attributes_price(), $xtPrice->xtcAddTax($pPrice, $tax) + $this->attributes_price(), $format, $vpeStatus, $this->products_id);
			elseif($xtPrice->xtcCheckDiscount($this->products_id)){
				$discount = $xtPrice->xtcCheckDiscount($this->products_id);
				if($xtPrice->cStatus['customers_status_discount_attributes'] == '1')
										$pPrice = $xtPrice->xtcFormatSpecialDiscount($this->products_id, $discount, $xtPrice->xtcAddTax($pPrice, $tax) + $this->attributes_price(), $format, $vpeStatus);
				else
										$pPrice = $xtPrice->xtcFormatSpecialDiscount($this->products_id, $discount, $xtPrice->xtcAddTax($pPrice, $tax), $format, $vpeStatus, $this->attributes_price());
			}
			else $pPrice = $xtPrice->xtcFormat($xtPrice->xtcAddTax($sPrice, $tax) + $this->attributes_price(), $format, 0, $curr, $vpeStatus, $this->products_id);
		}
		// check Product Discount
		elseif ($xtPrice->xtcCheckDiscount($this->products_id)){
			$discount = $xtPrice->xtcCheckDiscount($this->products_id);
			if($xtPrice->cStatus['customers_status_discount_attributes'] == '1')
								$pPrice = $xtPrice->xtcFormatSpecialDiscount($this->products_id, $discount, $xtPrice->xtcAddTax($pPrice, $tax) + $this->attributes_price(), $format, $vpeStatus);
			else
								$pPrice = $xtPrice->xtcFormatSpecialDiscount($this->products_id, $discount, $xtPrice->xtcAddTax($pPrice, $tax), $format, $vpeStatus, $this->attributes_price());
		}
		// normal price
		else{
			$pPrice = $xtPrice->xtcFormat($xtPrice->xtcAddTax($pPrice, $tax) + $this->attributes_price(), $format, 0, $curr, $vpeStatus, $this->products_id);
		}

		return $pPrice;
	}

}