<?php
/* --------------------------------------------------------------
   set_shipping_status.php 2013-01-18 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2013 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/*
 * set the shipping status based on the number of items
 * 
 * @param int $p_product_id Product id
 * @return bool true:OK
 */
function set_shipping_status($p_product_id)
{
	// get a product ID from a product ID with attributes
	$c_product_id = (int)xtc_get_prid($p_product_id);
	
	// check if the configuration is set to change the shipping status
	$auto_shipping_status = gm_get_conf('GM_AUTO_SHIPPING_STATUS');
	if($auto_shipping_status == 'false' || ACTIVATE_SHIPPING_STATUS == 'false' || STOCK_LIMITED == 'false') {
		return true;
	}
	
	// determine delivery time of the article
	$t_query = "SELECT 
					products_shippingtime,
					products_quantity
				FROM " . TABLE_PRODUCTS . "
				WHERE products_id = '" . $c_product_id . "'";
	$t_shippingtime_query = xtc_db_query($t_query);
	if(xtc_db_num_rows($t_shippingtime_query) == 1)
	{
		$t_shippingtime_values = xtc_db_fetch_array($t_shippingtime_query);
		$t_shippingtime_id = $t_shippingtime_values['products_shippingtime'];
		$t_products_quantity = $t_shippingtime_values['products_quantity'];

		// get the next shipping status
		$t_query = "SELECT shipping_status_id
					FROM " . TABLE_SHIPPING_STATUS . "
					WHERE shipping_quantity >= '" . xtc_db_input($t_products_quantity) . "'
					ORDER BY shipping_quantity ASC
					LIMIT 1";
		$t_new_shipping_status_query = xtc_db_query($t_query);
		if(xtc_db_num_rows($t_new_shipping_status_query) == 1)
		{
			$t_new_shipping_status_values = xtc_db_fetch_array($t_new_shipping_status_query);
			$t_shipping_status_id_new = $t_new_shipping_status_values['shipping_status_id'];

			// update product shipping status
			if($t_shipping_status_id_new != $t_shippingtime_id) {
				$t_query = "UPDATE " . TABLE_PRODUCTS . "
							SET products_shippingtime = '" . xtc_db_input($t_shipping_status_id_new) . "'
							WHERE products_id = '" . $c_product_id . "'";
				xtc_db_query($t_query);
			}
		}
	}
	
	return true;
}
?>