<?php
/*************************************************************************

$Id: iclear.php 499 2010-10-06 20:33:34Z dis $

iclear payment system - because secure is simply secure
http://www.iclear.de

Copyright (c) 2001 - 2010 iclear - Christian Arnold

Released under the GNU General Public License

************************************************************************

All rights reserved.

This program is free software licensed under the GNU General Public License (GPL).

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
USA

*************************************************************************/

if(!class_exists('IclearWrapperOxid', false)) {
	require $icCore->getPath( 'wrapper' ) . 'oxid.base.php';
}

define('IC_WRAPPER_ID', 'oxid-4.x' );

class IclearWrapper extends IclearWrapperOxid  {

	// class constructor
	function __construct(&$icCore) {
		$this->icVersion = '$Id$';
		global $icCore;
		parent::__construct($icCore);
	}

	function storeOrder( ) {
		$rc = false;
		$bIsPaid = false;
		$aSession = array();
		if( $basket = $this->icCore->getBasket( ) ) {
			$icLang = $this->icCore->getLanguage( );
				
			if( $basket->status( ) == IC_ORDER_OPEN )
			$bIsPaid = true;
			else if ( $basket->status( ) == IC_ORDER_WAIT )
			$bIsPaid = false;
			else {
				$basket->addError ( "storeOrder: Order not in open or wait state." );
				return $rc;
			}
				
			$order = $basket->getOrder( );

			$oSes = oxSession::getInstance( );
			if ( $oSes->getId() != $basket->sessionID( ) ) {
				$oSes->destroy();
				$aSession = $basket->session( );
				$_SERVER['HTTP_USER_AGENT'] = $aSession['user_agent'];
				$_COOKIE['sid_key'] = $aSession['sid_key'];
				$_COOKIE['sid'] = $basket->sessionID( );
				$oSes->start( );
			}
			$oUser = $oSes->getUser( );
			$oBasket = $oSes->getBasket( );
			$oBasket->setPayment( IC_OXID_MODULE_NAME );

			if ( $oUser ) {
				try {
					$oOrder = oxNew( 'oxorder' );
					$iSuccess = $oOrder->finalizeIclearOrder( $oBasket, $oUser, false, $bIsPaid );
					$oUser->onOrderExecute( $oBasket, $iSuccess );
					$basket->orderID ( $oOrder->getId( ) );
					$rc = true;

				} catch ( oxOutOfStockException $oEx ) {
					oxUtilsView::getInstance()->addErrorToDisplay( $oEx, false, true, 'basket' );
					$basket->addError ( "storeOrder: Cannot store Order:"  . $oEx->getString() );
				} catch ( oxNoArticleException $oEx ) {
					oxUtilsView::getInstance()->addErrorToDisplay( $oEx );
					$basket->addError ( "storeOrder: Cannot store Order:"  . $oEx->getString() );
				} catch ( oxArticleInputException $oEx ) {
					oxUtilsView::getInstance()->addErrorToDisplay( $oEx );
					$basket->addError ( "storeOrder: Cannot store Order:"  . $oEx->getString() );
				}
			} else {
				$basket->addError ( "storeOrder: Cannot load user session." );
			}
			$oSes->freeze( );
		}
		return $rc;
	}
}

?>
