<?php
/*
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
*/
class heidelpay
{
	var $version    = 'Standard 13.08';
	var $response   = '';
	var $error      = '';

	#var $live_url   = 'https://ctpe.net/frontend/payment.prc';
	#var $demo_url   = 'https://test.ctpe.net/frontend/payment.prc';
	var $live_url   = 'https://heidelpay.hpcgw.net/sgw/gtw';
	var $demo_url   = 'https://test-heidelpay.hpcgw.net/sgw/gtw';

	var $availablePayments = array('CC','DD','DC','VA','OT','IV','PP','PC');
	var $pageURL = '';
	var $actualPaymethod = 'CC';
	var $url;

	var $importantPPFields = array(
    'PRESENTATION_AMOUNT', 
    'PRESENTATION_CURRENCY', 
    'CONNECTOR_ACCOUNT_COUNTRY', 
    'CONNECTOR_ACCOUNT_HOLDER', 
    'CONNECTOR_ACCOUNT_NUMBER', 
    'CONNECTOR_ACCOUNT_BANK',
    'CONNECTOR_ACCOUNT_BIC', 
	'CONNECTOR_ACCOUNT_IBAN',
    'IDENTIFICATION_SHORTID',
	);

	function heidelpay()/*{{{*/
	{
		ob_start();
		$this->pageURL = GM_HTTP_SERVER.'';
	}/*}}}*/

	function handleDebit($order, $payCode, $insertId = NULL)/*{{{*/
	{
		$debug = false;
		//$debug = true;

		$payMethod = @constant('MODULE_PAYMENT_HP'.strtoupper($this->actualPaymethod).'_PAY_MODE');

		$user_id  = $_SESSION['hpLastData']['user_id'];
		$orderId  = 'User '.$user_id.'-'.date('YmdHis');
		if ($insertId > 0) $orderId = 'User '.$user_id.' Order '.$insertId;
		$amount   = $_SESSION['hpLastData']['amount'];
		$currency = $_SESSION['hpLastData']['currency'];
		$language = $_SESSION['hpLastData']['language'];
		$userData = $_SESSION['hpLastData']['userData'];
		if ($debug) echo '<pre>SESSION: '.print_r($_SESSION['hpLastData'], 1).'</pre>';
		$data = $this->prepareData($orderId, $amount, $currency, $payCode, $userData, $language, $payMethod, $_SESSION['hpUniqueID']);
		if ($debug) echo '<pre>'.print_r($data, 1).'</pre>';
		$res = $this->doRequest($data);
		if ($debug) echo '<pre>resp('.print_r($this->response, 1).')</pre>';
		if ($debug) echo '<pre>'.print_r($res, 1).'</pre>';
		$res = $this->parseResult($res);
		if ($debug) echo '<pre>'.print_r($res, 1).'</pre>';
		if ($debug) echo '<pre>'.print_r($_SESSION, 1).'</pre>';
		$_SESSION['HEIDELPAY_IFRAME'] = false;
		$_SESSION['HEIDELPAY_FRAMEURL'] = false;
		
		// switch to go to payment server
		$base = GM_HTTP_SERVER.DIR_WS_CATALOG;
		$comment = 'ShortID: '.$res['all']['IDENTIFICATION_SHORTID'];
		
		if (!empty($res['url']) AND $res['all']['PROCESSING_RESULT'] == 'ACK' ) {
			// use IFRAME
			if ($res['all']['CRITERION.IFRAME'] == 'true') {
				$hpIframe = '<center><iframe id="heidelpay" src="" frameborder="0" style="width: 450px; height: 450px"></iframe></center>';	
				$hpIframe .= '<SCRIPT LANGUAGE="JavaScript"> document.getElementById(\'heidelpay\').src = \''.trim($res['url']).'\'; </script>';
			}else { 
					$hpIframe.= '<form method="post" action="'.trim($res['all']['PROCESSING.REDIRECT.URL']).'" id="heidelpay_form">';
					foreach($res['all'] AS $k => $v) {
						if(strpos($k,'PROCESSING_REDIRECT_PARAMETER_')!==false ) {
							$key = preg_replace('/PROCESSING_REDIRECT_PARAMETER_/', '', $k);
							$hpIframe.= '<input type="hidden" name="'.$key.'" value="'.$v.'">';
							$input = +1 ;
						}
					}
					$hpIframe.= '<input  type="submit" value="Weiter"/>';
					$hpIframe.= '</form>';
      				$hpIframe.= '<script>document.getElementById("heidelpay_form").submit();</script>';
			}
			// Redirct if payment returns an url
			$_SESSION['HEIDELPAY_IFRAME'] = $hpIframe ;
			$returnURL = $base."heidelpay_iframe.php?".session_name().'='.session_id();
			if (!$debug) header('Location: '.$returnURL);
			if (!$debug) exit();
		}elseif ($res['all']['PROCESSING_RESULT'] == 'ACK' AND $res['all']['PROCESSING.REASON.CODE'] == '00') {

				// SET BARPAY E-MAIL TEXT
				if ($payCode == 'bp') $repl = array('{BARPAY_PAYCODE_URL}' => $res['all']['CRITERION_BARPAY_PAYCODE_URL']);
				// SET PREPAYMENT OR INVOICE E-MAIL TEXT
				if ($payCode == 'iv' or $payCode == 'pp') 
			    	$repl = array(
						'{CURRENCY}' => $res['all']['PRESENTATION_CURRENCY'],
						'{AMOUNT}' => $res['all']['PRESENTATION_AMOUNT'],
						'{ACC_COUNTRY}' => $res['all']['CONNECTOR_ACCOUNT_COUNTRY'],
						'{ACC_OWNER}' => $res['all']['CONNECTOR_ACCOUNT_HOLDER'],
						'{ACC_NUMBER}' => $res['all']['CONNECTOR_ACCOUNT_NUMBER'],
						'{ACC_BANKCODE}' => $res['all']['CONNECTOR_ACCOUNT_BANK'],
						'{ACC_IBAN}' => $res['all']['CONNECTOR_ACCOUNT_IBAN'],
						'{ACC_BIC}' => $res['all']['CONNECTOR_ACCOUNT_BIC'],
						'{SHORTID}' => $res['all']['IDENTIFICATION_SHORTID']
						);
				$mail_content =  strtr(constant('MODULE_PAYMENT_HP'.strtoupper($payCode).'_EMAIL_TEXT'),$repl);
				$_SESSION['hp']['INFO_TEXT_HTML'] = $mail_content; 
				$text_mail_content = strip_tags(html_entity_decode(preg_replace('/<br(\s+)?\/?>/i', "\n", $mail_content),'ENT_NOQUOTES','ISO-8859-1'));
				$_SESSION['hp']['INFO_TEXT_TXT']  = $text_mail_content;
				
			$status = constant('MODULE_PAYMENT_HP'.strtoupper($payCode).'_PROCESSED_STATUS_ID');
			$this->addHistoryComment($insertId, $comment."\n ".$text_mail_content, $status);
			$this->setOrderStatus($insertId, $status);
		}
		else {
			$returnURL = $base.'checkout_payment.php?payment_error=hp'.$payCode.'&error='.urlencode($res['all']['PROCESSING_RETURN']).'&'.session_name().'='.session_id();
			$status = constant('MODULE_PAYMENT_HP'.strtoupper($payCode).'_CANCELED_STATUS_ID');
			$comment .= "\n Fehler: ".$res['all']['PROCESSING_RETURN'];
			$this->addHistoryComment($insertId, $comment, $status);
			$this->setOrderStatus($insertId, $status);
			if (!$debug) header('Location: '.$returnURL);
			exit();
		}
		
		if ($debug) print "<pre>".print_r($_SESSION,1)."</pre>";
		if ($debug) print $hpIframe;
		if ($debug) print $returnURL ;
		if ($debug) exit();
		
		return returnURL;
	}/*}}}*/

	function prepareData($orderId, $amount, $currency, $payCode, $userData, $lang, $mode = 'DB', $uniqueId = NULL)/*{{{*/
	{
		$payCode = strtoupper($payCode);
		$amount = sprintf('%1.2f', $amount);
		$currency = strtoupper($currency);
		$userData = $this->encodeData($userData);
		$parameters['FRONTEND.ENABLED']     = "true";
		unset($_SESSION['hp']['INFO_TEXT_HTML']);
		unset($_SESSION['hp']['INFO_TEXT_TXT']);
		switch($payCode) {
			case 'CC':
			$payCode 	= 	'CC';
			$parameters['CRITERION.IFRAME'] = 'true';
			break;
			case 'DD':
			$payCode 	= 	'DD';
			$mode 		=	'DB';
			$parameters['FRONTEND.ENABLED']     = "false";
			$parameters['ACCOUNT.HOLDER']	    = $_SESSION['hpdd']['Holder'];
			$parameters['ACCOUNT.NUMBER']     	= $_SESSION['hpdd']['AccountNumber'];
			$parameters['ACCOUNT.BANK']    	 	= $_SESSION['hpdd']['BankCode'];
			break;
			case 'DC':
			$payCode 	= 	'DC';
			$parameters['CRITERION.IFRAME'] = 'true';
			
			break;
			case 'GP':
			$payCode 	= 	'OT';
			$mode 		=	'PA';
			$parameters['ACCOUNT.HOLDER']	    = $_SESSION['hpgp']['Holder'];
			$parameters['ACCOUNT.NUMBER']     	= $_SESSION['hpgp']['AccountNumber'];
			$parameters['ACCOUNT.BANK']    	 	= $_SESSION['hpgp']['BankCode'];
			$parameters['FRONTEND.ENABLED']     = "false";
			break;
			case 'IDL':
			$payCode 	= 	'OT';
			$mode 		=	'PA';
			$parameters['CRITERION.IFRAME'] = 'true';
			break;
			case 'EPS':
			$payCode 	= 	'OT';
			$mode 		=	'PA';
			$parameters['CRITERION.IFRAME'] = 'true';
			break;
			case 'SU':
			$payCode 	= 	'OT';
			$mode 		=	'PA';
			$parameters['FRONTEND.ENABLED']     = "false";
			$parameters['ACCOUNT.HOLDER']	    = $_SESSION['hpsu']['Holder'];
			$parameters['ACCOUNT.NUMBER']     	= $_SESSION['hpsu']['AccountNumber'];
			$parameters['ACCOUNT.BANK']    	 	= $_SESSION['hpsu']['BankCode'];
			break;
			case 'MK': 
			$payCode 	= 	'PC';
			$mode 		=	'PA';
			$parameters['ACCOUNT.BRAND'] = "MANGIRKART";
			$parameters['FRONTEND.ENABLED']     = "false";
			break;
			case 'BP':
			$payCode 	= 	'PP';
			$mode 		=	'PA';
			$parameters['ACCOUNT.BRAND'] = "BARPAY";
			$parameters['FRONTEND.ENABLED']     = "false";
			break;
			case 'PPAL':
			$payCode 	= 	'VA';
			$mode 		=	'PA';
			$parameters['ACCOUNT.BRAND']          = 'PAYPAL';
			$parameters['FRONTEND.ENABLED']     = "false";
			break;
			case 'BS':
			$payCode 	= 	'IV';
			$mode 		=	'PA';
			$parameters['ACCOUNT.BRAND']          = 'BILLSAFE';
			$parameters['FRONTEND.ENABLED']     = "false";
     		$oId = preg_replace('/.*Order /', '', $orderId);
      		$order = $order = new order($oId);
			$bsParams = $this->getBillsafeBasket($order);
      		$parameters = array_merge($parameters, $bsParams);
      		$_SESSION['hp']['INFO_TEXT_HTML']  = MODULE_PAYMENT_HPBS_EMAIL_TEXT;
			
			break;
			case 'IV':
			$payCode 	= 	'IV';
			$mode 		=	'PA';
			$parameters['FRONTEND.ENABLED']     = "false";
			break;
			
			case 'PP';
			$payCode 	= 	'PP';
			$mode 		=	'PA';
			$parameters['FRONTEND.ENABLED']     = "false";
			
			break;
		}

		$parameters['SECURITY.SENDER']        = constant('MODULE_PAYMENT_HP'.$this->actualPaymethod.'_SECURITY_SENDER');
		$parameters['USER.LOGIN']             = constant('MODULE_PAYMENT_HP'.$this->actualPaymethod.'_USER_LOGIN');
		$parameters['USER.PWD']               = constant('MODULE_PAYMENT_HP'.$this->actualPaymethod.'_USER_PWD');
		$parameters['TRANSACTION.CHANNEL']    = constant('MODULE_PAYMENT_HP'.$this->actualPaymethod.'_TRANSACTION_CHANNEL');
		$parameters['TRANSACTION.MODE']       = constant('MODULE_PAYMENT_HP'.$this->actualPaymethod.'_TRANSACTION_MODE');
		$parameters['REQUEST.VERSION']        = "1.0";
		include_once('release_info.php');
		$parameters['SHOP.TYPE']        	  = "Gambio GX2 - $gx_version";
		$parameters['SHOPMODUL.VERSION']      = $this->version ;
		$parameters['IDENTIFICATION.TRANSACTIONID'] = $orderId;
		$parameters['FRONTEND.REDIRECT_TIME'] = "0";
		$parameters['FRONTEND.POPUP']         = "false";
		$parameters['FRONTEND.MODE']          = "DEFAULT";
		$parameters['FRONTEND.LANGUAGE']      = $lang;
		$parameters['FRONTEND.LANGUAGE_SELECTOR'] = "true";
		$parameters['FRONTEND.ONEPAGE']       = "true";
		$parameters['FRONTEND.NEXTTARGET']    = "location.href";
		$parameters['FRONTEND.CSS_PATH']      = $this->pageURL.DIR_WS_CATALOG."heidelpay_style.css";
		$parameters['FRONTEND.RETURN_ACCOUNT']= "true";

		foreach($this->availablePayments as $key=>$value) {
			if ($value != $payCode) {
				$parameters["FRONTEND.PM." . (string)($key + 1) . ".METHOD"] = $value;
				$parameters["FRONTEND.PM." . (string)($key + 1) . ".ENABLED"] = "false";
			}
		}

		$parameters['PAYMENT.CODE']           = $payCode.".".$mode;
		$parameters['FRONTEND.RESPONSE_URL']  = $this->pageURL.DIR_WS_CATALOG."heidelpay_response.php".'?'.session_name().'='.session_id();
		if (strpos($_SERVER['REMOTE_ADDR'], '127.0.0') !== false) $parameters['FRONTEND.RESPONSE_URL']  = "http://testshops.heidelpay.de/JR/gambio/heidelpay_response.php".'?'.session_name().'='.session_id();
		$parameters['NAME.GIVEN']             = trim($userData['firstname']);
		$parameters['NAME.FAMILY']            = trim($userData['lastname']);
		$parameters['NAME.SALUTATION']        = $userData['salutation'];
		$parameters['ADDRESS.STREET']         = $userData['street'];
		$parameters['ADDRESS.ZIP']            = $userData['zip'];
		$parameters['ADDRESS.CITY']           = $userData['city'];
		$parameters['ADDRESS.COUNTRY']        = $userData['country'];
		$parameters['ADDRESS.STATE']          = $userData['state'];
		$parameters['CONTACT.EMAIL']          = $userData['email'];
		$parameters['CONTACT.IP']             = $userData['ip'];
		$parameters['PRESENTATION.AMOUNT']    = $amount; // 99.00
		$parameters['PRESENTATION.CURRENCY']  = $currency; // EUR
		$parameters['ACCOUNT.COUNTRY']        = $userData['country'];
		$parameters['CRITERION.SHOPSYSTEM']   = 'Gambio';
		// $imagePath = GM_HTTP_SERVER.DIR_WS_CATALOG.'templates/'.CURRENT_TEMPLATE.'/buttons/' . $_SESSION['language'] . '/';
		// $parameters['FRONTEND.BUTTON.1.NAME'] = 'CANCEL';
		// $parameters['FRONTEND.BUTTON.1.TYPE'] = 'IMAGE';
		// $parameters['FRONTEND.BUTTON.1.LINK'] = $imagePath.'back.jpg'; // Gambio Buttons
		// $parameters['FRONTEND.BUTTON.2.NAME'] = 'PAY';
		// $parameters['FRONTEND.BUTTON.2.TYPE'] = 'IMAGE';
		// $parameters['FRONTEND.BUTTON.2.LINK'] = $imagePath.'next.jpg'; // Gambio Buttons
		return $parameters;
	}/*}}}*/

	function encodeData($data)/*{{{*/
	{
		$tmp = array();
		foreach($data AS $k => $v){
			$tmp[$k] = $v;
			if (!$this->isUTF8($v)) $tmp[$k] = utf8_encode($v);
		}
		return $tmp;
	}/*}}}*/

	function isUTF8($string)/*{{{*/
	{
		if (is_array($string)) {
			$enc = implode('', $string);
			return @!((ord($enc[0]) != 239) && (ord($enc[1]) != 187) && (ord($enc[2]) != 191));
		} else {
			return (utf8_encode(utf8_decode($string)) == $string);
		}
	}/*}}}*/

	function isHTTPS()/*{{{*/
	{
		if (strpos($_SERVER['HTTP_HOST'], '.local') === false){
			if (   !isset($_SERVER['HTTPS']) || ( strtolower($_SERVER['HTTPS']) != 'on' && $_SERVER['HTTPS'] != '1') ) {
				return false;
			}
		} else {
			// Local
			return false;
		}
		return true;
	}/*}}}*/

	function doRequest($data)/*{{{*/
	{
		/*
		 $msg = urlencode('Curl Fehler');
		 $res = 'PROCESSING.RESULT=NOK&PROCESSING.RETURN='.$msg;
		 return $res;
		 */
		
		$url = $this->demo_url;
		if (constant('MODULE_PAYMENT_HP'.$this->actualPaymethod.'_TRANSACTION_MODE') == 'LIVE'){
			$url = $this->live_url;
		}
		$this->url = $url;

		// Erstellen des Strings fr die Datenbermittlung
		foreach (array_keys($data) AS $key) {
			$data[$key] = utf8_decode($data[$key]);
			$$key .= $data[$key];
			$$key = urlencode($$key);
			$$key .= "&";
			$var = strtoupper($key);
			$value = $$key;
			$result .= "$var=$value";
		}
		$strPOST = stripslashes($result);

		// prfen ob CURL existiert
		if (function_exists('curl_init')) {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_FAILONERROR, 1);
			curl_setopt($ch, CURLOPT_TIMEOUT, 60);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 60);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $strPOST);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,0);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,0);
			curl_setopt($ch, CURLOPT_USERAGENT, "php ctpepost");

			$this->response     = curl_exec($ch);
			$this->error        = curl_error($ch);
			curl_close($ch);

			$res = $this->response;
			if (!$this->response && $this->error){
				$res = 'PROCESSING_RESULT=NOK&PROCESSING_RETURN='.$this->error;
			}

		} else {
			$msg = urlencode('Curl Fehler');
			$res = 'PROCESSING_RESULT=NOK&PROCESSING_RETURN='.$msg;
		}

		return $res;
	}/*}}}*/

	function parseResult($curlresultURL)/*{{{*/
	{
		$r_arr=explode("&",$curlresultURL);
		foreach($r_arr AS $buf) {
			$temp=urldecode($buf);
			list($postatt, $postvar) = explode('=', $temp,2); // nderung da Split ab PHP 5.3 nicht mehr untersttzt wird
			$returnvalue[$postatt]=$postvar;
		}
		$processingresult = $returnvalue['PROCESSING.RESULT'];
		if (empty($processingresult)) $processingresult = $returnvalue['POST.VALIDATION'];
		 if (!empty($returnvalue['FRONTEND.REDIRECT_URL']))$redirectURL = $returnvalue['FRONTEND.REDIRECT_URL'];
		 if (!empty($returnvalue['PROCESSING_REDIRECT_URL']))$redirectURL = $returnvalue['PROCESSING_REDIRECT_URL'];
		if (!isset($returnvalue['PROCESSING.RETURN']) && $returnvalue['POST.VALIDATION'] > 0){
			$returnvalue['PROCESSING.RETURN'] = 'Errorcode: '.$returnvalue['POST.VALIDATION'];
		}
		ksort($returnvalue);
		return array('result' => $processingresult, 'url' => $redirectURL, 'all' => $returnvalue);
	}/*}}}*/

	function addHistoryComment($order_id, $comment, $status = '', $customer_notified = '0')/*{{{*/
	{
		if (empty($order_id) || empty($comment)) return false;
		// Alten Eintrag laden
		$orderHistory = $this->getLastHistoryComment($order_id);
		// Kunde benachrichtigt
		$orderHistory['customer_notified'] = $customer_notified;
		// Timestamp korrekt erneuern
		$orderHistory['date_added'] = date('Y-m-d H:i:s');
		// Kommentar setzen
		$orderHistory['comments'] = urldecode($comment);
		// Neuer Status eintragen
		if(!empty($status)) $orderHistory['orders_status_id'] = addslashes($status);
		// Alte History ID entfernen
		unset($orderHistory['orders_status_history_id']);
		// Neue History eintragen
		return xtc_db_perform(TABLE_ORDERS_STATUS_HISTORY, $orderHistory);
	}/*}}}*/

	function hasHistoryComment($order_id, $status, $customer_notified)/*{{{*/
	{
		if (empty($order_id) || empty($status) || empty($customer_notified)) return false;
		$sql = 'SELECT * FROM `'.TABLE_ORDERS_STATUS_HISTORY.'`
      WHERE `orders_id`       = "'.addslashes($order_id).'"
      AND `orders_status_id`  = "'.addslashes($status).'"
      AND `customer_notified` = "'.addslashes($customer_notified).'"
      ';
		$orderHistoryArray = xtc_db_query($sql);
		while ($ordersHistoryTMP = xtc_db_fetch_array($orderHistoryArray)) {
			$ordersHistory[] = $ordersHistoryTMP;
		}
		return count($ordersHistory) > 0;
	}/*}}}*/

	function getLastHistoryComment($order_id)/*{{{*/
	{
		if (empty($order_id)) return array();
		$sql = 'SELECT * FROM `'.TABLE_ORDERS_STATUS_HISTORY.'`
      WHERE `orders_id` = "'.addslashes($order_id).'"
      ORDER BY `orders_status_history_id` DESC
      ';
		$orderHistoryArray = xtc_db_query($sql);
		return xtc_db_fetch_array($orderHistoryArray);
	}/*}}}*/

	function getOrderHistory($order_id)/*{{{*/
	{
		if (empty($order_id)) return array();
		$sql = 'SELECT * FROM `'.TABLE_ORDERS_STATUS_HISTORY.'`
      WHERE `orders_id` = "'.addslashes($order_id).'"
      ORDER BY `orders_status_history_id` DESC
      ';
		$orderHistoryArray = xtc_db_query($sql);
		$ordersHistory = array();
		while ($ordersHistoryTMP = xtc_db_fetch_array($orderHistoryArray)) {
			$ordersHistory[] = $ordersHistoryTMP;
		}
		return $ordersHistory;
	}/*}}}*/

	function setOrderStatus($order_id, $status, $doubleCheck = false)/*{{{*/
	{
		GLOBAL $db_link;
		// Status History laden
		$orderHistory = $this->getOrderHistory($order_id);
		if ($doubleCheck){
			// Prfen ob Status schon mal gesetzt
			$found = false;
			foreach($orderHistory as $k => $v){
				if ($v['orders_status_id'] == $status) $found = true;
			}
			// Wenn Status schon mal gesetzt dann nichts tun
			if ($found) return false;
		}
		// Bestellstatus setzen
		$res = xtc_db_query("UPDATE `".TABLE_ORDERS."` SET `orders_status` = '".addslashes($status)."' WHERE `orders_id` = '".addslashes($order_id)."'");
		$stat = mysql_affected_rows($db_link);
		return $stat > 0;
	}/*}}}*/

	function saveShortId($order_id, $orders_ident_key)/*{{{*/
	{
		return xtc_db_query("UPDATE `".TABLE_ORDERS."` SET `orders_ident_key` = '".addslashes($orders_ident_key)."' WHERE `orders_id` = '".addslashes($order_id)."'");
	}/*}}}*/

	function checkInstall($code)/*{{{*/
	{
		return true;
	}/*}}}*/

	function saveMEMO($customerId, $key, $value)/*{{{*/
	{
		$data = $this->loadMEMO($customerId, $key);
		if (!empty($data)){
			return xtc_db_query('UPDATE `customers_memo` SET `memo_text` = "'.addslashes($value).'", `memo_date` = NOW(), `poster_id` = 1 WHERE `customers_id` = "'.addslashes($customerId).'" AND `memo_title` = "'.addslashes($key).'"');
		} else {
			return xtc_db_query('INSERT INTO `customers_memo` SET `memo_text` = "'.addslashes($value).'", `customers_id` = "'.addslashes($customerId).'", `memo_title` = "'.addslashes($key).'", `memo_date` = NOW(), `poster_id` = 1');
		}
	}/*}}}*/

	function loadMEMO($customerId, $key)/*{{{*/
	{
		$res = xtc_db_query('SELECT * FROM `customers_memo` WHERE `customers_id` = "'.addslashes($customerId).'" AND `memo_title` = "'.addslashes($key).'"');
		$res = xtc_db_fetch_array($res);
		return $res['memo_text'];
	}/*}}}*/

	function getPayCodeByChannel($TRANSACTION_CHANNEL)/*{{{*/
	{
		$otPayTypes = array('gp', 'su', 'tp', 'idl', 'eps');
		$keys = array();
		foreach($otPayTypes AS $k => $v){
			$keys[] = 'MODULE_PAYMENT_HP'.strtoupper($v).'_TRANSACTION_CHANNEL';
		}
		$sql = 'SELECT * FROM `configuration` WHERE `configuration_value` = "'.addslashes($TRANSACTION_CHANNEL).'" AND `configuration_key` IN ("'.implode('","', $keys).'") ';
		#echo $sql;
		$res = xtc_db_query($sql);
		$res = xtc_db_fetch_array($res);
		return str_replace(array('MODULE_PAYMENT_HP', '_TRANSACTION_CHANNEL'), '', $res['configuration_key']);
	}/*}}}*/

	function getCustomerState($state)/*{{{*/
	{
		$customer_state = xtc_db_query('SELECT `zone_code` FROM `'.TABLE_ZONES.'` WHERE `zone_name` = "'.$state.'" OR `zone_code` = "'.$state.'"');
		$attributes_values = xtc_db_fetch_array($customer_state);
		$cus_state = $attributes_values['zone_code'];
		return $cus_state;
	}/*}}}*/

	function getCustomerStateByZoneId($zoneId)/*{{{*/
	{
		$customer_state = xtc_db_query('SELECT `zone_code` FROM `'.TABLE_ZONES.'` WHERE `zone_id` = "'.$zoneId.'"');
		$attributes_values = xtc_db_fetch_array($customer_state);
		$cus_state = $attributes_values['zone_code'];
		return $cus_state;
	}/*}}}*/

	function getCustomerCountry($country)/*{{{*/
	{
		$country_query  = xtc_db_query('SELECT `countries_iso_code_2` FROM `'.TABLE_COUNTRIES.'` WHERE `countries_id` = "'.$country.'"');
		$country_res    = xtc_db_fetch_array($country_query);
		$cus_country    = $country_res['countries_iso_code_2'];
		return $cus_country;
	}/*}}}*/

	function rememberOrderData($order)/*{{{*/
	{
		if ($_SESSION['customers_status']['customers_status_show_price_tax'] == 0 && $_SESSION['customers_status']['customers_status_add_tax_ot'] == 1) {
			$total = $order->info['total'] + $order->info['tax'];
		} else {
			$total = $order->info['total'];
		}
		$currency_value = $order->info['currency_value'];
		if (empty($currency_value)) $currency_value = 1.0;

		$amount   = $total;// * $currency_value;
		$user_id  = $_SESSION['customer_id'];
		$currency = $order->info['currency'];
		$language = strtoupper($_SESSION['language_code']);
		$userData = array(
      'firstname' => $order->billing['firstname'],
      'lastname'  => $order->billing['lastname'],
      'salutation'=> ($order->customer['gender']=='f' ? 'MRS' : 'MR'),
      'street'    => $order->billing['street_address'],
      'zip'       => $order->billing['postcode'],
      'city'      => $order->billing['city'],
      'country'   => $order->billing['country']['iso_code_2'],
      'email'     => $order->customer['email_address'],
      'state'     => $this->getCustomerStateByZoneId($order->billing['zone_id']),
      'ip'        => $_SERVER['REMOTE_ADDR'],
		);
		if (empty($userData['state'])) $userData['state'] = $userData['country']; // Wenn Bundesstaat leer dann nimm Land
		$_SESSION['hpLastData']['user_id'] = $user_id;
		$_SESSION['hpLastData']['amount'] = $amount;
		$_SESSION['hpLastData']['currency'] = $currency;
		$_SESSION['hpLastData']['language'] = $language;
		$_SESSION['hpLastData']['userData'] = $userData;
	}/*}}}*/
	
	  function getBillsafeBasket($order)/*{{{*/
  {
    global $xtPrice;
    $order->cart();
    //echo '<pre>'.print_r($order, 1).'</pre>';

    $items = $order->products;
    $i = 0;
    if ($items) {
      foreach($items as $id => $item) {
        $i++;
        $prefix = 'CRITERION.POS_'.sprintf('%02d', $i);
        $parameters[$prefix.'.POSITION'] 				= $i;
        $parameters[$prefix.'.QUANTITY'] 				= (int)$item['qty'];
        $parameters[$prefix.'.UNIT'] 						= 'Stk.'; // Liter oder so
        if ($_SESSION['customers_status']['customers_status_show_price_tax'] == '0') {
          $parameters[$prefix.'.AMOUNT_UNIT'] 		= round($item['price']*100);
          $parameters[$prefix.'.AMOUNT'] 		      = round($item['final_price']*100);
        } else {
          $parameters[$prefix.'.AMOUNT_UNIT_GROSS'] = round($item['price']*100);
          $parameters[$prefix.'.AMOUNT_GROSS'] 		= round($item['price']*100);
        }
        $parameters[$prefix.'.TEXT'] 						= $item['name'];
        $parameters[$prefix.'.ARTICLE_NUMBER'] 	= $item['id'];
        $parameters[$prefix.'.PERCENT_VAT'] 		= sprintf('%1.2f', $item['tax']);
        $parameters[$prefix.'.ARTICLE_TYPE'] 		= 'goods'; // "goods" (Versandartikel), "shipment" (Versandkosten) oder "voucher" (Gutschein/Rabatt)
      }
    }
    if ($order->info['shipping_cost'] > 0){
      $shipping_id = explode('_', $order->info['shipping_class']);
      $shipping_id = $shipping_id[0];
      $shipping_tax_rate = $this->get_shipping_tax_rate($shipping_id);
      $shipping_cost = round($order->info['shipping_cost'] * $xtPrice->currencies[$currency]['value'], $xtPrice->get_decimal_places($currency));
      //$shipping_cost = xtc_add_tax($shipping_cost, $shipping_tax_rate);
      $i++;
      $prefix = 'CRITERION.POS_'.sprintf('%02d', $i);
      $parameters[$prefix.'.POSITION'] 				= $i;
      $parameters[$prefix.'.QUANTITY'] 				= '1';
      $parameters[$prefix.'.UNIT'] 						= 'Stk.'; // Liter oder so
      if ($_SESSION['customers_status']['customers_status_show_price_tax'] == '0') {
        $parameters[$prefix.'.AMOUNT_UNIT'] 		= round($order->info['shipping_cost']*100);
        $parameters[$prefix.'.AMOUNT'] 		      = round($order->info['shipping_cost']*100);
      } else {
        $parameters[$prefix.'.AMOUNT_UNIT_GROSS'] 		= round($order->info['shipping_cost']*100);
        $parameters[$prefix.'.AMOUNT_GROSS'] 		      = round($order->info['shipping_cost']*100);
      }
      $parameters[$prefix.'.TEXT'] 						= $order->info['shipping_method'];
      $parameters[$prefix.'.ARTICLE_NUMBER'] 	= '0';
      $parameters[$prefix.'.PERCENT_VAT'] 		= sprintf('%1.2f', $shipping_tax_rate);
      $parameters[$prefix.'.ARTICLE_TYPE'] 		= 'shipment'; // "goods" (Versandartikel), "shipment" (Versandkosten) oder "voucher" (Gutschein/Rabatt)
    }
    $items = $order->totals;
    if ($items) {
      foreach($items as $id => $item) {
        if ($item['value'] >= 0) continue;
        $i++;
        $prefix = 'CRITERION.POS_'.sprintf('%02d', $i);
        $parameters[$prefix.'.POSITION'] 				= $i;
        $parameters[$prefix.'.QUANTITY'] 				= 1;
        $parameters[$prefix.'.UNIT'] 						= 'Stk.'; // Liter oder so
        if ($_SESSION['customers_status']['customers_status_show_price_tax'] == '0') {
          $parameters[$prefix.'.AMOUNT_UNIT'] 		= round($item['value']*100);
          $parameters[$prefix.'.AMOUNT'] 		      = round($item['value']*100);
        } else {
          $parameters[$prefix.'.AMOUNT_UNIT'] 		= round($item['value']*100) + round($item['value']*$item['tax']);
          $parameters[$prefix.'.AMOUNT'] 		      = round($item['value']*100) + round($item['value']*$item['tax']);
        }
        $parameters[$prefix.'.TEXT'] 						= $item['title'];
        $parameters[$prefix.'.ARTICLE_NUMBER'] 	= '0';
        $parameters[$prefix.'.PERCENT_VAT'] 		= sprintf('%1.2f', 0);
        $parameters[$prefix.'.ARTICLE_TYPE'] 		= 'voucher'; // "goods" (Versandartikel), "shipment" (Versandkosten) oder "voucher" (Gutschein/Rabatt)
      }
    }

    //echo '<pre>'.print_r($parameters, 1).'</pre>';
    //exit();

    return $parameters;
  }/*}}}*/
  
    function get_shipping_tax_rate($shipping_id) {
  		$check_query = xtc_db_query('SELECT configuration_value FROM '.TABLE_CONFIGURATION.' WHERE configuration_key = "MODULE_SHIPPING_'.$shipping_id.'_TAX_CLASS"');
		$configuration = xtc_db_fetch_array($check_query);
		$tax_class_id = $configuration['configuration_value'];
		$shipping_tax_rate = xtc_get_tax_rate($tax_class_id);
		return $shipping_tax_rate;
	}
}
?>
