<?php
/*
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
*/

if (file_exists(DIR_WS_CLASSES.'class.heidelpay.php')){
  include_once(DIR_WS_CLASSES.'class.heidelpay.php');
} else {
  require_once(DIR_FS_CATALOG.DIR_WS_CLASSES.'class.heidelpay.php');
}

class hpbp {
	var $code, $title, $description, $enabled, $hp, $payCode, $tmpStatus;

	// class constructor
  function hpbp() /*{{{*/
  {
		global $order, $language;

    $this->payCode = 'bp';
		$this->code = 'hp'.$this->payCode;
		$this->title = MODULE_PAYMENT_HPBP_TEXT_TITLE;
		$this->description = MODULE_PAYMENT_HPBP_TEXT_DESC;
		$this->sort_order = MODULE_PAYMENT_HPBP_SORT_ORDER;
		$this->enabled = ((MODULE_PAYMENT_HPBP_STATUS == 'True') ? true : false);
    $this->info = MODULE_PAYMENT_HPBP_TEXT_INFO;
    #$this->form_action_url = 'checkout_bpccess.php';
		$this->tmpOrders = false;
    $this->tmpStatus = MODULE_PAYMENT_HPBP_NEWORDER_STATUS_ID;
    $this->order_status = MODULE_PAYMENT_HPBP_NEWORDER_STATUS_ID;
    $this->hp = new heidelpay();
    $this->hp->actualPaymethod = strtoupper($this->payCode);
    $this->version = $hp->version;
    /*
		$this->icons_available = xtc_image(DIR_WS_ICONS . 'cc_amex_small.jpg') . ' ' .
		xtc_image(DIR_WS_ICONS . 'cc_mastercard_small.jpg') . ' ' .
		xtc_image(DIR_WS_ICONS . 'cc_visa_small.jpg') . ' ' .
    xtc_image(DIR_WS_ICONS . 'cc_diners_small.jpg');
     */

    if (is_object($order)) $this->update_status();

    // OT FIX
    if ($_GET['payment_error'] == 'hpot'){
      GLOBAL $smarty;
      $error = $this->get_error();
      $smarty->assign('error', htmlspecialchars($error['error']));
    }
		
	}/*}}}*/

  function update_status() /*{{{*/
  {
		global $order;

		if (($this->enabled == true) && ((int) MODULE_PAYMENT_HPBP_ZONE > 0)) {
			$check_flag = false;
			$check_query = xtc_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_HPBP_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
			while ($check = xtc_db_fetch_array($check_query)) {
				if ($check['zone_id'] < 1) {
					$check_flag = true;
					break;
				}
				elseif ($check['zone_id'] == $order->billing['zone_id']) {
					$check_flag = true;
					break;
				}
			}

			if ($check_flag == false) {
				$this->enabled = false;
			}
		}
	}/*}}}*/

  function javascript_validation() /*{{{*/
  {
    return false;
	}/*}}}*/

 	function selection() /*{{{*/
	{
		GLOBAL $order;
		if (strpos($_SERVER['SCRIPT_FILENAME'], 'checkout_payment') !== false){
			unset($_SESSION['hpLastData']);
			unset($_SESSION['hpUseUniqueId']);
		}
		
		if (MODULE_PAYMENT_HPBP_TRANSACTION_MODE != 'LIVE' && strpos(MODULE_PAYMENT_HPBP_TEST_ACCOUNT, $order->customer['email_address']) === false) {
			$this->info = '<div style="color: red">'. MODULE_PAYMENT_HPBP_DEBUGTEXT . '</div><br/>'.$this->info ;
		}
		

		return array (
			'id'          => $this->code,
			'module'      => $this->title,
			'description' => $this->info
		);
	}/*}}}*/

  function pre_confirmation_check() /*{{{*/
  {
    GLOBAL $order;
    if (MODULE_PAYMENT_HPBP_TRANSACTION_MODE != 'LIVE' && strpos(MODULE_PAYMENT_HPBP_TEST_ACCOUNT, $order->customer['email_address']) === false) {
      $payment_error_return = 'payment_error=hpeps&error='.urlencode(MODULE_PAYMENT_HPBP_DEBUGTEXT); 
      xtc_redirect(xtc_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
    }
	}/*}}}*/

  function confirmation() /*{{{*/
  {
		return false;
	}/*}}}*/

  function process_button() /*{{{*/
  {
    global $order;
    $this->hp->rememberOrderData($order);
		return false;
	}/*}}}*/

  function payment_action() /*{{{*/
  {
    return true;
	}/*}}}*/

  function before_process() /*{{{*/
  {
		return false;
	}/*}}}*/

  function after_process() /*{{{*/
  {
    global $order, $xtPrice, $insert_id;
    $this->hp->setOrderStatus($insert_id, $this->order_status);
    $comment = ' ';
    $this->hp->addHistoryComment($insert_id, $comment, $this->order_status);
    $hpIframe = $this->hp->handleDebit($order, $this->payCode, $insert_id);
		return true;
	}/*}}}*/

  function admin_order($oID) /*{{{*/
  {
    return false;
	}/*}}}*/

  function get_error() /*{{{*/
  {
		global $_GET;

		$error = array (
			'title' => MODULE_PAYMENT_HPBP_TEXT_ERROR,
			'error' => stripslashes(urldecode($_GET['error']
		)));

		return $error;
	}/*}}}*/

  function check() /*{{{*/
  {
		if (!isset ($this->_check)) {
			$check_query = xtc_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_HPBP_STATUS'");
			$this->_check = xtc_db_num_rows($check_query);
		}
		return $this->_check;
	}/*}}}*/

  function install() /*{{{*/
  {
	$this->remove(true);

    $groupId = 6;
    $sqlBase = 'INSERT INTO `'.TABLE_CONFIGURATION.'` SET ';
    $prefix = 'MODULE_PAYMENT_HPBP_';
    $inst = array();
    $inst[] = array(
      'configuration_key'       => $prefix.'STATUS',
      'configuration_value'     => 'True',
      'set_function'            => 'xtc_cfg_select_option(array(\'True\', \'False\'), ',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'SECURITY_SENDER',
      'configuration_value'     => '31HA07BC810C91F08643A5D477BDD7C0',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'USER_LOGIN',
      'configuration_value'     => '31ha07bc810c91f086431f7471d042d6',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'USER_PWD',
      'configuration_value'     => 'password',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'TRANSACTION_CHANNEL',
      'configuration_value'     => '31HA07BC81009F135218293AE82EA620',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'TRANSACTION_MODE',
      'configuration_value'     => 'CONNECTOR_TEST',
      'set_function'            => 'xtc_cfg_select_option(array(\'LIVE\', \'INTEGRATOR_TEST\', \'CONNECTOR_TEST\'), ',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'TEST_ACCOUNT',
      'configuration_value'     => '',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'SORT_ORDER',
      'configuration_value'     => '1.10',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'ZONE',
      'configuration_value'     => '',
      'set_function'            => 'xtc_cfg_pull_down_zone_classes(',
      'use_function'            => 'xtc_get_zone_class_title',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'ALLOWED',
      'configuration_value'     => '',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'PROCESSED_STATUS_ID',
      'configuration_value'     => '0',
      'set_function'            => 'xtc_cfg_pull_down_order_statuses(',
      'use_function'            => 'xtc_get_order_status_name',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'PENDING_STATUS_ID',
      'configuration_value'     => '0',
      'set_function'            => 'xtc_cfg_pull_down_order_statuses(',
      'use_function'            => 'xtc_get_order_status_name',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'CANCELED_STATUS_ID',
      'configuration_value'     => '0',
      'set_function'            => 'xtc_cfg_pull_down_order_statuses(',
      'use_function'            => 'xtc_get_order_status_name',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'NEWORDER_STATUS_ID',
      'configuration_value'     => '0',
      'set_function'            => 'xtc_cfg_pull_down_order_statuses(',
      'use_function'            => 'xtc_get_order_status_name',
    );
    $inst[] = array(
      'configuration_key'       => $prefix.'DEBUG',
      'configuration_value'     => 'False',
      'set_function'            => 'xtc_cfg_select_option(array(\'True\', \'False\'), ',
    );
    
    /*
    $inst[] = array(
      'configuration_key'       => $prefix.'',
      'configuration_value'     => '',
      'set_function'            => '',
      'use_function'            => '',
    );
    */
    foreach($inst AS $k => $v){
      $sql = $sqlBase.' ';
      foreach($v AS $key => $val){
        $sql.= '`'.addslashes($key).'` = "'.$val.'", ';
      }
      $sql.= '`sort_order` = "'.$k.'", ';
      $sql.= '`configuration_group_id` = "'.addslashes($groupId).'", ';
      $sql.= '`date_added` = NOW() ';
      #echo $sql.'<br>';
      xtc_db_query($sql);
    }

	}/*}}}*/

  function remove($install = false) /*{{{*/
  {
    if ($install) heidelpay::checkInstall($this->code);
		xtc_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
	}/*}}}*/

  function keys() /*{{{*/
  {
    $prefix = 'MODULE_PAYMENT_HPBP_';
		return array (
			$prefix.'STATUS',
      $prefix.'SECURITY_SENDER',
      $prefix.'USER_LOGIN',
      $prefix.'USER_PWD',
      $prefix.'TRANSACTION_CHANNEL',
      $prefix.'TRANSACTION_MODE',
			$prefix.'SYSTEM',
      $prefix.'DIRECT_MODE',
      $prefix.'TEST_ACCOUNT',
			$prefix.'MIN_AMOUNT',
      $prefix.'MAX_AMOUNT',
      $prefix.'PROCESSED_STATUS_ID',
      $prefix.'PENDING_STATUS_ID',
			$prefix.'CANCELED_STATUS_ID',
			$prefix.'NEWORDER_STATUS_ID',
			$prefix.'SORT_ORDER',
			$prefix.'ALLOWED',
      $prefix.'ZONE',
      #$prefix.'',
		);
	}/*}}}*/

}
?>