<?php
/* --------------------------------------------------------------
   PageToken.inc.php 2013-09-18 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2013 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

class PageToken
{
	protected $v_page_token_array;
	protected $v_coo_logger;
	private $v_max_array_size = 100;
	
	public function __construct()
	{
		$this->v_coo_logger = MainFactory::create_object('FileLog', array('security'));
	}
	
	public function generate_token()
	{
		$t_key =  md5(time() . rand());
		$this->v_page_token_array[$t_key] = true;
		if(count($this->v_page_token_array) > $this->v_max_array_size)
		{
			$this->v_page_token_array = array_slice($this->v_page_token_array, $this->v_max_array_size * -1);
		}
		
		return $t_key;
	}
	
	public function is_valid($p_check)
	{
		if(!isset($this->v_page_token_array[$p_check]) || $this->v_page_token_array[$p_check] !== true || !preg_match('/^[a-f0-9]{32}$/', $p_check))
		{
			$this->write_page_token_warning($p_check);
			return false;
		}
		
		return true;
	}
	
	protected function write_page_token_warning($p_check)
	{
		$t_security_message  = "================================================================================\n";
		$t_security_message .= "Unsecure page token\n\n";
		$t_security_message .= 'URI: '. gm_get_env_info('REQUEST_URI') ."\n";
		$t_security_message .= 'HTTP-Referer: '. $_SERVER['HTTP_REFERER'] ."\n";
		$t_security_message .= "generated token-array:\n" . print_r($this->v_page_token_array, true) ."\n";
		$t_security_message .= 'used token: '. $p_check ."\n";
		$t_security_message .= 'IP: '. xtc_get_ip_address() ."\n";
		$t_security_message .= 'Time: '. date('Y-m-d H-i-s') ."\n";
		$t_security_message .= "POST-Array:\n" . print_r($_POST, true) ."\n";
		$t_security_message .= "================================================================================\n\n";
		$this->v_coo_logger->write($t_security_message);
		xtc_db_close();
		die('Unsecure page token!');
	}
}