<?php
/* --------------------------------------------------------------
   VersionInfo.inc.php 2013-05-22 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2013 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

class VersionInfo
{
	var $v_shop_versioninfo_array;
		
	function get_shop_versioninfo()
	{
		if(!isset($this->v_shop_versioninfo_array))
		{
			$this->set_shop_versioninfo();
		}

		if(!count($this->v_shop_versioninfo_array))
		{
			return '';
		}

		return $this->v_shop_versioninfo_array;		
	}
	
	
	function set_shop_versioninfo()
	{
		//$t_pattern = DIR_FS_CATALOG . 'version_info/_samples/*.php';
		$t_pattern = DIR_FS_CATALOG . 'version_info/*.php';
		$t_versioninfo_array = glob($t_pattern);
		
		if($t_versioninfo_array !== false && count($t_versioninfo_array) > 0)
		{
			foreach($t_versioninfo_array as $t_path)
			{
				$this->v_shop_versioninfo_array[basename($t_path, '.php')] = $this->get_versioninfo_content($t_path);
			}
		}
		else
		{
			$this->v_shop_versioninfo_array = array();
		}
	}

	
	function get_versioninfo_content($p_path)
	{
		$t_content = '';
		
		if(function_exists('file_get_contents'))
		{
			$t_content = file_get_contents($p_path);
		}
		else
		{
			$fp = fopen($p_path, 'r');
			if($fp !== false)
			{
				while(!feof($fp))
				{
					$t_content .= fread($fp, filesize($p_path));
				}
				fclose($fp);
			}
		}
		
		$t_content = utf8_encode(trim(preg_replace('/<\?.*?\?>/s', '', $t_content)));
		return $t_content;
	}
	
	
	function get_updaters()
	{
		$t_updates_array = array();
		
		if(file_exists(DIR_FS_CATALOG . 'gambio_updater'))
		{
			include(DIR_FS_CATALOG . 'release_info.php');
			$t_db_shop_version = gm_get_conf('GM_UPDATER_VERSION');
			
			if(empty($t_db_shop_version) || $t_db_shop_version != $gx_version)
			{
				$t_pattern = DIR_FS_CATALOG . 'gambio_updater/update*.php';
				$t_update_files_array = glob($t_pattern);
				if( is_array($t_update_files_array) && count( $t_update_files_array ) > 0 )
				{
					foreach($t_update_files_array AS $t_file_path)
					{
						$t_updates_array[] = HTTP_SERVER . DIR_WS_CATALOG . 'gambio_updater/' . basename($t_file_path);
					}
				}
			}			
		}
		
		return $t_updates_array;
	}
}
