<?php
/* --------------------------------------------------------------
   LightboxPluginAdminAjaxHandler.inc.php 2012-12-20 tb@gambio
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2012 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/
require_once(DIR_FS_CATALOG . 'gm/classes/JSON.php');

class LightboxPlugin2AdminAjaxHandler extends AjaxHandler
{
    function get_permission_status($p_customers_id=NULL)
    {
        return true;
    }

    function proceed()
    {
		$t_output_array = array();
		$t_enable_json_output = true;
		
		$c_action = preg_replace( '/[^\w.]/i', '', $this->v_data_array[ 'GET' ][ 'action' ] );
		
		$c_template = trim( preg_replace( '/[^\w.]/i', '', $this->v_data_array[ 'GET' ][ 'template' ] ) );
		
		$c_template_section = preg_replace( '/[^\w]/i', '', $this->v_data_array[ 'GET' ][ 'section' ] );
		
		$c_param = $this->v_data_array[ 'GET' ][ 'param' ];
		
		switch( $c_action )
		{
			case 'get_template':	$t_output_array = $this->get_template($c_template, $c_template_section, $c_param);
									break;
						
			default:				trigger_error( 'Lightbox: could not proceed action ['.htmlentities($c_action).']', E_USER_ERROR );
		}
		
		if($t_enable_json_output)
		{			
			$coo_json = new Services_JSON(SERVICES_JSON_LOOSE_TYPE);
			$t_output_json = $coo_json->encode($t_output_array);
			
			$this->v_output_buffer = $t_output_json;
		}	
        return true;
    }

    function get_template_map()
    {
        $t_template_map_array = array();
        $t_template_map_array['PropertiesEdit.html'] = 'PropertiesAdminContentView';
        $t_template_map_array['PropertiesDelete.html'] = 'PropertiesAdminContentView';
        $t_template_map_array['PropertiesValuesEdit.html'] = 'PropertiesAdminContentView';
        $t_template_map_array['PropertiesValuesDelete.html'] = 'PropertiesAdminContentView';
        $t_template_map_array['PropertiesCombisEdit.html'] = 'PropertiesCombisAdminContentView';
        $t_template_map_array['PropertiesCombisDelete.html'] = 'PropertiesCombisAdminContentView';
        $t_template_map_array['PropertiesCombisDeleteSelected.html'] = 'PropertiesCombisAdminContentView';
        $t_template_map_array['CombisSettings.html'] = 'PropertiesCombisAdminContentView';
        $t_template_map_array['CombisDefaults.html'] = 'PropertiesCombisAdminContentView';
		$t_template_map_array['FeatureSetContainer.html'] = 'FeatureSetAdminContentView';
		$t_template_map_array['ExportSchemeDetails.html'] = 'CSVContentView';
		$t_template_map_array['DBBackupRestore.html'] = 'DBBackupContentView';

        return $t_template_map_array;
    }

    function get_section_map()
    {
        $t_section_map_array = array();
        $t_section_map_array['shop'] = DIR_FS_CATALOG.'templates/EyeCandy/lightbox/';
        $t_section_map_array['admin'] = DIR_FS_CATALOG.'admin/templates/';
        return $t_section_map_array;
    }

    function get_template($p_template_name, $p_template_section, $p_param)
    {
		if( empty( $p_template_name ) ) trigger_error( 'LightboxPlugin: empty template', E_USER_ERROR );
		
        $t_template_map_array = $this->get_template_map();
        if(array_key_exists($p_template_name, $t_template_map_array))
        {
            $coo_view = MainFactory::create_object($t_template_map_array[$p_template_name]);
        }
        else
        {
            $coo_view = MainFactory::create_object('LightboxContentView');
        }

        $t_section_map_array = $this->get_section_map();

        if($_SESSION['customers_status']['customers_status_id'] !== '0' && $p_template_section == 'admin')
        {
            trigger_error('Lightbox: access denied to admin section', E_USER_ERROR);
        }
        else
        {
            if(array_key_exists($p_template_section, $t_section_map_array))
            {
                $coo_view->set_template_dir($t_section_map_array[$p_template_section]);
            }
            else
            {
                trigger_error('Lightbox: template section is not defined', E_USER_ERROR);
            }
        }

        $p_param['template'] = $p_template_name;
        $coo_view->set_content_template( $p_template_name );
		$coo_view->set_lightbox_mode( true );
		$coo_view->set_lightbox_parameters( $p_param );
		$t_javascript_section = str_replace( ".html", "", $p_template_name );
		$coo_view->set_javascript_section( $t_javascript_section );
        
        $t_html = $coo_view->get_html_array( $p_param );
        return $t_html;
    }
}
