<?php
/* --------------------------------------------------------------
   LogoffContentView.inc.php 2013-05-27 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2013 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------


   based on:
   (c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
   (c) 2002-2003 osCommerce(logoff.php,v 1.12 2003/02/13); www.oscommerce.com
   (c) 2003	 nextcommerce (logoff.php,v 1.16 2003/08/17); www.nextcommerce.org
   (c) 2003 XT-Commerce - community made shopping http://www.xt-commerce.com ($Id: logoff.php 1071 2005-07-22 16:36:53Z mz $)

   Released under the GNU General Public License
   -----------------------------------------------------------------------------------------
   Third Party contribution:

   Credit Class/Gift Vouchers/Discount Coupons (Version 5.10)
   http://www.oscommerce.com/community/contributions,282
   Copyright (c) Strider | Strider@oscworks.com
   Copyright (c  Nick Stanko of UkiDev.com, nick@ukidev.com
   Copyright (c) Andre ambidex@gmx.net
   Copyright (c) 2001,2002 Ian C Wilson http://www.phesis.org


   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

class LogoffContentView extends ContentView
{
	function LogoffContentView()
	{
		$this->set_content_template('module/logoff.html');
		$this->set_flat_assigns(true);
	}
	
	function get_html()
	{
		//delete Guests from Database
		$this->delete_guest_account($_SESSION['customer_id']);
		
		$this->reset_session();
		
		$this->set_content_data('BUTTON_CONTINUE', '<a href="'.xtc_href_link(FILENAME_DEFAULT).'">'.xtc_image_button('button_continue.gif', IMAGE_BUTTON_CONTINUE).'</a>');
		$this->set_content_data('CONTINUE_LINK', xtc_href_link(FILENAME_DEFAULT));

		$t_html_output = $this->build_html();		

		return $t_html_output;
	}
	
	function reset_session()
	{
		if($_SESSION['style_edit_mode'] != 'edit') xtc_session_destroy();

		unset ($_SESSION['customer_id']);
		unset ($_SESSION['customer_default_address_id']);
		unset ($_SESSION['customer_first_name']);
		unset ($_SESSION['customer_country_id']);
		unset ($_SESSION['customer_zone_id']);
		unset ($_SESSION['comments']);
		unset ($_SESSION['user_info']);
		unset ($_SESSION['customers_status']);
		unset ($_SESSION['selected_box']);
		unset ($_SESSION['navigation']);
		unset ($_SESSION['shipping']);
		unset ($_SESSION['payment']);
		unset ($_SESSION['ccard']);
		// GV Code Start
		unset ($_SESSION['gv_id']);
		unset ($_SESSION['cc_id']);
		// GV Code End
		$_SESSION['cart']->reset();
		// write customers status guest in session again
		require (DIR_WS_INCLUDES.'write_customers_status.php');
	}
	
	function delete_guest_account($p_customer_id)
	{
		$t_deleted_customer_id = false;
		
		if(DELETE_GUEST_ACCOUNT == 'true')
		{
			$c_customer_id = (int)$p_customer_id;
			$coo_customer = MainFactory::create_object('GMDataObject', array(TABLE_CUSTOMERS, array('customers_id' => $c_customer_id)));

			if($coo_customer->get_result_count() == 1 && $coo_customer->get_data_value('account_type') == '1')
			{
				xtc_db_query("DELETE FROM " . TABLE_CUSTOMERS . " WHERE customers_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_ADDRESS_BOOK . " WHERE customers_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_CUSTOMERS_INFO . " WHERE customers_info_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_CUSTOMERS_BASKET . " WHERE customers_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_CUSTOMERS_BASKET_ATTRIBUTES . " WHERE customers_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_CUSTOMERS_IP . " WHERE customers_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_CUSTOMERS_WISHLIST . " WHERE customers_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_CUSTOMERS_WISHLIST_ATTRIBUTES . " WHERE customers_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_CUSTOMERS_STATUS_HISTORY . " WHERE customers_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_COUPON_GV_CUSTOMER . " WHERE customer_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_COUPON_GV_QUEUE . " WHERE customer_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_COUPON_REDEEM_TRACK . " WHERE customer_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_WHOS_ONLINE . " WHERE customer_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_GM_GPRINT_CART_ELEMENTS . " WHERE customers_id = '" . $c_customer_id . "'");
				xtc_db_query("DELETE FROM " . TABLE_GM_GPRINT_WISHLIST_ELEMENTS . " WHERE customers_id = '" . $c_customer_id . "'");			
				xtc_db_query("UPDATE " . TABLE_ORDERS . " SET customers_id = 0 WHERE customers_id = '" . $c_customer_id . "'");
				xtc_db_query("UPDATE " . TABLE_GM_GPRINT_UPLOADS . " SET customers_id = 0 WHERE customers_id = '" . $c_customer_id . "'");
				xtc_db_query("UPDATE " . TABLE_NEWSLETTER_RECIPIENTS . " SET customers_id = 0 WHERE customers_id = '" . $c_customer_id . "'");
				
				$t_deleted_customer_id = $c_customer_id;
			}
		}
		
		return $t_deleted_customer_id;
	}
	
	function delete_unused_guest_accounts()
	{
		$t_deleted_customers_array = array();
		
		if(DELETE_GUEST_ACCOUNT == 'true')
		{
			$t_sql = "SELECT 
							c.customers_id,
							w.customer_id
						FROM
							" . TABLE_CUSTOMERS . " c
						LEFT JOIN " . TABLE_WHOS_ONLINE . " AS w ON (c.customers_id = w.customer_id)
						WHERE
							c.customers_status = 1 AND
							c.account_type = 1 AND
							w.customer_id IS NULL";
			$t_result = xtc_db_query($t_sql, 'db_link', false);
			while($t_result_array = xtc_db_fetch_array($t_result))
			{
				$t_deleted_customers_array[] = $this->delete_guest_account($t_result_array['customers_id']);			
			}
		}
		
		return $t_deleted_customers_array;
	}
}
