
DROP TABLE IF EXISTS `address_book`;
CREATE TABLE `address_book` (
  `address_book_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `entry_gender` char(1) NOT NULL default '',
  `entry_company` varchar(255) default NULL,
  `entry_firstname` varchar(32) NOT NULL default '',
  `entry_lastname` varchar(32) NOT NULL default '',
  `entry_street_address` varchar(64) NOT NULL default '',
  `entry_suburb` varchar(32) default NULL,
  `entry_postcode` varchar(10) NOT NULL default '',
  `entry_city` varchar(32) NOT NULL default '',
  `entry_state` varchar(32) default NULL,
  `entry_country_id` int(11) NOT NULL default '0',
  `entry_zone_id` int(11) NOT NULL default '0',
  `address_date_added` datetime default '0000-00-00 00:00:00',
  `address_last_modified` datetime default '0000-00-00 00:00:00',
  `address_class` varchar(32) NOT NULL,
  PRIMARY KEY  (`address_book_id`),
  KEY `idx_address_book_customers_id` (`customers_id`),
  KEY `entry_country_id` (`entry_country_id`),
  KEY `entry_zone_id` (`entry_zone_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `address_format`;
CREATE TABLE `address_format` (
  `address_format_id` int(11) NOT NULL auto_increment,
  `address_format` varchar(128) NOT NULL default '',
  `address_summary` varchar(48) NOT NULL default '',
  PRIMARY KEY  (`address_format_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `admin_access`;
CREATE TABLE `admin_access` (
  `customers_id` varchar(32) NOT NULL default '0',
  `configuration` int(1) NOT NULL default '0',
  `modules` int(1) NOT NULL default '0',
  `countries` int(1) NOT NULL default '0',
  `currencies` int(1) NOT NULL default '0',
  `zones` int(1) NOT NULL default '0',
  `geo_zones` int(1) NOT NULL default '0',
  `tax_classes` int(1) NOT NULL default '0',
  `tax_rates` int(1) NOT NULL default '0',
  `accounting` int(1) NOT NULL default '0',
  `backup` int(1) NOT NULL default '0',
  `cache` int(1) NOT NULL default '0',
  `server_info` int(1) NOT NULL default '0',
  `whos_online` int(1) NOT NULL default '0',
  `languages` int(1) NOT NULL default '0',
  `define_language` int(1) NOT NULL default '0',
  `orders_status` int(1) NOT NULL default '0',
  `shipping_status` int(1) NOT NULL default '0',
  `module_export` int(1) NOT NULL default '0',
  `customers` int(1) NOT NULL default '0',
  `create_account` int(1) NOT NULL default '0',
  `customers_status` int(1) NOT NULL default '0',
  `orders` int(1) NOT NULL default '0',
  `campaigns` int(1) NOT NULL default '0',
  `print_packingslip` int(1) NOT NULL default '0',
  `print_order` int(1) NOT NULL default '0',
  `popup_memo` int(1) NOT NULL default '0',
  `coupon_admin` int(1) NOT NULL default '0',
  `listcategories` int(1) NOT NULL default '0',
  `gv_queue` int(1) NOT NULL default '0',
  `gv_mail` int(1) NOT NULL default '0',
  `gv_sent` int(1) NOT NULL default '0',
  `validproducts` int(1) NOT NULL default '0',
  `validcategories` int(1) NOT NULL default '0',
  `mail` int(1) NOT NULL default '0',
  `categories` int(1) NOT NULL default '0',
  `new_attributes` int(1) NOT NULL default '0',
  `products_attributes` int(1) NOT NULL default '0',
  `manufacturers` int(1) NOT NULL default '0',
  `reviews` int(1) NOT NULL default '0',
  `specials` int(1) NOT NULL default '0',
  `stats_products_expected` int(1) NOT NULL default '0',
  `stats_products_viewed` int(1) NOT NULL default '0',
  `stats_products_purchased` int(1) NOT NULL default '0',
  `stats_customers` int(1) NOT NULL default '0',
  `stats_sales_report` int(1) NOT NULL default '0',
  `stats_campaigns` int(1) NOT NULL default '0',
  `banner_manager` int(1) NOT NULL default '0',
  `banner_statistics` int(1) NOT NULL default '0',
  `module_newsletter` int(1) NOT NULL default '0',
  `start` int(1) NOT NULL default '0',
  `content_manager` int(1) NOT NULL default '0',
  `content_preview` int(1) NOT NULL default '0',
  `credits` int(1) NOT NULL default '0',
  `blacklist` int(1) NOT NULL default '0',
  `orders_edit` int(1) NOT NULL default '0',
  `popup_image` int(1) NOT NULL default '0',
  `csv_backend` int(1) NOT NULL default '0',
  `products_vpe` int(1) NOT NULL default '0',
  `cross_sell_groups` int(1) NOT NULL default '0',
  `fck_wrapper` int(1) NOT NULL default '0',
  `econda` int(1) NOT NULL default '0',
  `listproducts` int(1) NOT NULL default '0',
  `gm_scroller` int(1) NOT NULL default '0',
  `gm_pdf` int(1) NOT NULL default '0',
  `gm_id_starts` int(1) NOT NULL default '0',
  `gm_pdf_order` int(1) NOT NULL default '0',
  `gm_pdf_action` int(1) NOT NULL default '0',
  `gm_emails` int(1) NOT NULL default '0',
  `gm_emails_preview` int(1) NOT NULL default '0',
  `gm_guestbook` int(1) NOT NULL default '0',
  `gm_counter` int(1) NOT NULL default '0',
  `gm_counter_action` int(1) NOT NULL default '0',
  `gm_meta` int(1) NOT NULL default '0',
  `gm_meta_action` int(1) NOT NULL default '0',
  `gm_analytics` int(1) NOT NULL default '0',
  `gm_bookmarks` int(1) NOT NULL default '0',
  `gm_bookmarks_action` int(1) NOT NULL default '0',
  `gm_logo` int(1) NOT NULL default '0',
  `gm_security` int(1) NOT NULL default '0',
  `gm_style_edit` int(1) NOT NULL default '0',
  `gm_send_order` int(1) NOT NULL default '0',
  `gm_order_menu` int(1) NOT NULL default '0',
  `gm_miscellaneous` int(1) NOT NULL default '0',
  `paypal` int(1) NOT NULL default '0',
  `gm_lang_edit` int(1) NOT NULL default '0',
  `gm_sitemap` int(1) NOT NULL default '0',
  `gm_sitemap_creator` int(1) NOT NULL default '0',
  `gm_sql` int(1) NOT NULL default '0',
  `gm_offline` int(1) NOT NULL default '0',
  `gm_lightbox` int(1) NOT NULL default '0',
  `gm_seo_boost` int(1) NOT NULL default '0',
  `gm_trusted_shop_id` int(1) NOT NULL default '0',
  `nc_clickandbuy` int(1) NOT NULL default '0',
  `gm_opensearch` int(1) NOT NULL default '0',
  `gm_opensearch_action` int(1) NOT NULL default '0',
  `gm_module_export` int(1) NOT NULL default '0',
  `gm_backup_files_zip` int(1) NOT NULL default '0',
  `gm_janolaw` int(1) NOT NULL default '0',
  `gm_module_part_export` int(1) NOT NULL default '0',
  `gm_product_export` int(1) NOT NULL default '0',
  `gm_gprint` int(1) NOT NULL default '0',
  `gm_gprint_download` int(1) NOT NULL default '0',
  `gm_gmotion` int(1) NOT NULL default '0',
  `xml_export` int(1) NOT NULL default '0',
  `gm_feature_control` int(1) NOT NULL default '0',
  `properties` int(1) NOT NULL default '0',
  `properties_combis` int(1) NOT NULL default '0',
  `request_port` int(1) NOT NULL default '0',
  `gm_slider` int(1) NOT NULL default '0',
  `template_configuration` int(1) NOT NULL default '0',
  `quantity_units` int(1) NOT NULL default '0',
  `show_logs` int(1) NOT NULL default '0',
  `robots_download` int(1) NOT NULL default '0',
  `clear_cache` int(1) NOT NULL default '0',
  `directory_scan` int(1) NOT NULL default '0',
  `yoochoose` int(1) NOT NULL default '0',
  `yatego` int(1) NOT NULL default '0',
  `gm_invoicing` int(1) NOT NULL default '0',
  `brickfox` int(1) NOT NULL default '0',
  `phpminiadmin` int(1) NOT NULL default '0',
  `minisql` int(1) NOT NULL default '0',
  `ekomi` int(1) NOT NULL default '0',
  `magnalister` int(1) NOT NULL default '0',
  `mobile` int(1) NOT NULL default '0',
  `shopgate` int(1) NOT NULL default '0',
  `mediafinanz` int(1) NOT NULL default '0',
  `lettr_de` int(1) NOT NULL default '0',
  `admin_javascript` int(1) NOT NULL default '0',
  `hermes_collection` int(1) NOT NULL default '0',
  `hermes_list` int(1) NOT NULL default '0',
  `hermes_info` int(1) NOT NULL default '0',
  `hermes_order` int(1) NOT NULL default '0',
  `hermes_config` int(1) NOT NULL default '0',
  `iloxx` int(1) NOT NULL default '0',
  `orders_iloxx` int(1) NOT NULL default '0',
  `affiliprint_module` int(1) NOT NULL default '0',
  PRIMARY KEY  (`customers_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `additional_fields`;
CREATE TABLE `additional_fields` (
  `additional_field_id` int(11) NOT NULL AUTO_INCREMENT,
  `field_key` varchar(255) NOT NULL,
  `item_type` enum('product') NOT NULL DEFAULT 'product',
  `multilingual` TINYINT UNSIGNED NOT NULL,
  PRIMARY KEY (`additional_field_id`),
  UNIQUE KEY `field_key` (`field_key`,`item_type`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `additional_field_descriptions`;
CREATE TABLE `additional_field_descriptions` (
  `additional_field_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL,
  `name` text NOT NULL,
  PRIMARY KEY (`additional_field_id`,`language_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `additional_field_values`;
CREATE TABLE `additional_field_values` (
  `additional_field_value_id` int(11) NOT NULL AUTO_INCREMENT,
  `additional_field_id` int(11) NOT NULL,
  `item_id` int(11) NOT NULL,
  PRIMARY KEY (`additional_field_value_id`),
  UNIQUE KEY `additional_field_id` (`additional_field_id`,`item_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `additional_field_value_descriptions`;
CREATE TABLE `additional_field_value_descriptions` (
  `additional_field_value_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL DEFAULT '0',
  `value` text NOT NULL,
  PRIMARY KEY (`additional_field_value_id`,`language_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `banktransfer`;
CREATE TABLE `banktransfer` (
  `orders_id` int(11) NOT NULL default '0',
  `banktransfer_owner` varchar(64) default NULL,
  `banktransfer_number` varchar(24) default NULL,
  `banktransfer_bankname` varchar(255) default NULL,
  `banktransfer_blz` varchar(8) default NULL,
  `banktransfer_status` int(11) default NULL,
  `banktransfer_prz` char(2) default NULL,
  `banktransfer_fax` char(2) default NULL,
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `banktransfer_blz`;
CREATE TABLE `banktransfer_blz` (
  `blz` int(10) NOT NULL default '0',
  `bankname` varchar(255) NOT NULL default '',
  `prz` char(2) NOT NULL default '',
  PRIMARY KEY  (`blz`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `banners`;
CREATE TABLE `banners` (
  `banners_id` int(11) NOT NULL auto_increment,
  `banners_title` varchar(64) NOT NULL default '',
  `banners_url` varchar(255) NOT NULL default '',
  `banners_image` varchar(64) NOT NULL default '',
  `banners_group` varchar(10) NOT NULL default '',
  `banners_html_text` text,
  `expires_impressions` int(7) default '0',
  `expires_date` datetime default NULL,
  `date_scheduled` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_status_change` datetime default NULL,
  `status` int(1) NOT NULL default '1',
  PRIMARY KEY  (`banners_id`),
  KEY `status` (`status`,`banners_group`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `banners_history`;
CREATE TABLE `banners_history` (
  `banners_history_id` int(11) NOT NULL auto_increment,
  `banners_id` int(11) NOT NULL default '0',
  `banners_shown` int(5) NOT NULL default '0',
  `banners_clicked` int(5) NOT NULL default '0',
  `banners_history_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`banners_history_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `campaigns`;
CREATE TABLE `campaigns` (
  `campaigns_id` int(11) NOT NULL auto_increment,
  `campaigns_name` varchar(32) NOT NULL default '',
  `campaigns_refID` varchar(64) default NULL,
  `campaigns_leads` int(11) NOT NULL default '0',
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  PRIMARY KEY  (`campaigns_id`),
  KEY `IDX_CAMPAIGNS_NAME` (`campaigns_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `campaigns_ip`;
CREATE TABLE `campaigns_ip` (
  `user_ip` varchar(15) NOT NULL default '',
  `time` datetime NOT NULL default '0000-00-00 00:00:00',
  `campaign` varchar(32) NOT NULL default ''
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `card_blacklist`;
CREATE TABLE `card_blacklist` (
  `blacklist_id` int(5) NOT NULL auto_increment,
  `blacklist_card_number` varchar(20) NOT NULL default '',
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  KEY `blacklist_id` (`blacklist_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `categories`;
CREATE TABLE `categories` (
  `categories_id` int(11) NOT NULL auto_increment,
  `categories_image` varchar(64) default NULL,
  `parent_id` int(11) NOT NULL default '0',
  `categories_status` tinyint(1) unsigned NOT NULL default '1',
  `categories_template` varchar(64) default NULL,
  `group_permission_0` tinyint(1) NOT NULL default '0',
  `group_permission_1` tinyint(1) NOT NULL default '0',
  `group_permission_2` tinyint(1) NOT NULL default '0',
  `group_permission_3` tinyint(1) NOT NULL default '0',
  `listing_template` varchar(64) default NULL,
  `sort_order` int(3) NOT NULL default '0',
  `products_sorting` varchar(32) default NULL,
  `products_sorting2` varchar(32) default NULL,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  `categories_icon` varchar(255) NOT NULL,
  `categories_icon_w` int(11) NOT NULL,
  `categories_icon_h` int(11) NOT NULL,
  `group_ids` varchar(50) NOT NULL default '',
  `gm_show_attributes` int(1) unsigned NOT NULL default '0',
  `gm_show_graduated_prices` int(1) unsigned NOT NULL default '0',
  `gm_show_qty` int(1) unsigned NOT NULL default '1',
  `gm_priority` varchar(3) NOT NULL default '0.5',
  `gm_changefreq` varchar(255) NOT NULL default 'weekly',
  `gm_sitemap_entry` int(1) NOT NULL default '1',
  `gm_show_qty_info` int(1) unsigned NOT NULL default '0',
  `show_sub_categories` tinyint(1) NOT NULL default '1',
  `show_sub_categories_images` tinyint(1) NOT NULL default '1',
  `show_sub_categories_names` tinyint(1) NOT NULL default '1',
  `show_sub_products` tinyint(1) NOT NULL default '0',
  `view_mode_tiled` tinyint(1) NOT NULL default '0',
PRIMARY KEY  (`categories_id`),
  KEY `idx_categories_parent_id` (`parent_id`),
  KEY `categories_id` (`categories_id`,`parent_id`,`categories_status`,`sort_order`),
  KEY `parent_id` (`parent_id`,`categories_status`,`sort_order`),
  KEY `categories_status` (`categories_status`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `categories_description`;
CREATE TABLE `categories_description` (
  `categories_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `categories_name` varchar(255) NOT NULL,
  `categories_heading_title` varchar(255) NOT NULL default '',
  `categories_description` text NOT NULL,
  `categories_meta_title` text NOT NULL,
  `categories_meta_description` text NOT NULL,
  `categories_meta_keywords` text NOT NULL,
  `gm_alt_text` varchar(255) default NULL,
  `gm_url_keywords` varchar(255) NOT NULL,
  PRIMARY KEY  (`categories_id`,`language_id`),
  KEY `idx_categories_name` (`categories_name`),
  KEY `seo_boost_index` (`gm_url_keywords`,`categories_id`,`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `cm_file_flags`;
CREATE TABLE `cm_file_flags` (
  `file_flag` int(11) NOT NULL default '0',
  `file_flag_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`file_flag`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `configuration`;
CREATE TABLE `configuration` (
  `configuration_id` int(11) NOT NULL auto_increment,
  `configuration_key` varchar(64) NOT NULL default '',
  `configuration_value` text NOT NULL,
  `configuration_group_id` int(11) NOT NULL default '0',
  `sort_order` int(5) default NULL,
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `use_function` varchar(255) default NULL,
  `set_function` varchar(255) default NULL,
  PRIMARY KEY  (`configuration_id`),
  KEY `idx_configuration_group_id` (`configuration_group_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `configuration_group`;
CREATE TABLE `configuration_group` (
  `configuration_group_id` int(11) NOT NULL auto_increment,
  `configuration_group_title` varchar(64) NOT NULL default '',
  `configuration_group_description` varchar(255) NOT NULL default '',
  `sort_order` int(5) default NULL,
  `visible` int(1) default '1',
  PRIMARY KEY  (`configuration_group_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `content_manager`;
CREATE TABLE `content_manager` (
  `content_id` int(11) NOT NULL auto_increment,
  `categories_id` int(11) NOT NULL default '0',
  `parent_id` int(11) NOT NULL default '0',
  `group_ids` text,
  `languages_id` int(11) NOT NULL default '0',
  `content_title` text NOT NULL,
  `content_heading` text NOT NULL,
  `content_text` text NOT NULL,
  `sort_order` int(4) NOT NULL default '0',
  `file_flag` int(1) NOT NULL default '0',
  `content_file` varchar(64) NOT NULL default '',
  `content_status` int(1) NOT NULL default '0',
  `content_group` int(11) NOT NULL default '0',
  `content_delete` int(1) NOT NULL default '1',
  `gm_link` text NOT NULL,
  `gm_link_target` varchar(10) NOT NULL,
  `gm_priority` varchar(3) NOT NULL default '0.5',
  `gm_changefreq` varchar(255) NOT NULL default 'weekly',
  `gm_last_modified` datetime default NULL,
  `gm_sitemap_entry` int(1) NOT NULL default '1',
  `gm_url_keywords` varchar(255) NOT NULL,
  `contents_meta_title` text NOT NULL,
  `contents_meta_description` text NOT NULL,
  `contents_meta_keywords` text NOT NULL,
  PRIMARY KEY  (`content_id`),
  KEY `languages_id` (`languages_id`,`file_flag`,`content_status`,`sort_order`),
  KEY `content_id` (`content_id`,`languages_id`),
  KEY `content_group` (`content_group`,`languages_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `counter`;
CREATE TABLE `counter` (
  `startdate` char(8) default NULL,
  `counter` int(12) default NULL
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `counter_history`;
CREATE TABLE `counter_history` (
  `month` char(8) default NULL,
  `counter` int(12) default NULL
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `countries`;
CREATE TABLE `countries` (
  `countries_id` int(11) NOT NULL auto_increment,
  `countries_name` varchar(64) NOT NULL default '',
  `countries_iso_code_2` char(2) NOT NULL default '',
  `countries_iso_code_3` char(3) NOT NULL default '',
  `address_format_id` int(11) NOT NULL default '0',
  `status` int(1) default '1',
  PRIMARY KEY  (`countries_id`),
  KEY `IDX_COUNTRIES_NAME` (`countries_name`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `coupons`;
CREATE TABLE `coupons` (
  `coupon_id` int(11) NOT NULL auto_increment,
  `coupon_type` char(1) NOT NULL default 'F',
  `coupon_code` varchar(32) NOT NULL default '',
  `coupon_amount` decimal(8,4) NOT NULL default '0.0000',
  `coupon_minimum_order` decimal(8,4) NOT NULL default '0.0000',
  `coupon_start_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `coupon_expire_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `uses_per_coupon` int(5) NOT NULL default '1',
  `uses_per_user` int(5) NOT NULL default '0',
  `restrict_to_products` varchar(255) default NULL,
  `restrict_to_categories` varchar(255) default NULL,
  `restrict_to_customers` text,
  `coupon_active` char(1) NOT NULL default 'Y',
  `date_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`coupon_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `coupons_description`;
CREATE TABLE `coupons_description` (
  `coupon_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '0',
  `coupon_name` varchar(32) NOT NULL default '',
  `coupon_description` text,
  KEY `coupon_id` (`coupon_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `coupon_email_track`;
CREATE TABLE `coupon_email_track` (
  `unique_id` int(11) NOT NULL auto_increment,
  `coupon_id` int(11) NOT NULL default '0',
  `customer_id_sent` int(11) NOT NULL default '0',
  `sent_firstname` varchar(32) default NULL,
  `sent_lastname` varchar(32) default NULL,
  `emailed_to` varchar(32) default NULL,
  `date_sent` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`unique_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `coupon_gv_customer`;
CREATE TABLE `coupon_gv_customer` (
  `customer_id` int(5) NOT NULL default '0',
  `amount` decimal(8,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`customer_id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `coupon_gv_queue`;
CREATE TABLE `coupon_gv_queue` (
  `unique_id` int(5) NOT NULL auto_increment,
  `customer_id` int(5) NOT NULL default '0',
  `order_id` int(5) NOT NULL default '0',
  `amount` decimal(8,4) NOT NULL default '0.0000',
  `date_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `ipaddr` varchar(32) NOT NULL default '',
  `release_flag` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`unique_id`),
  KEY `uid` (`unique_id`,`customer_id`,`order_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `coupon_redeem_track`;
CREATE TABLE `coupon_redeem_track` (
  `unique_id` int(11) NOT NULL auto_increment,
  `coupon_id` int(11) NOT NULL default '0',
  `customer_id` int(11) NOT NULL default '0',
  `redeem_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `redeem_ip` varchar(32) NOT NULL default '',
  `order_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`unique_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `currencies`;
CREATE TABLE `currencies` (
  `currencies_id` int(11) NOT NULL auto_increment,
  `title` varchar(32) NOT NULL default '',
  `code` char(3) NOT NULL default '',
  `symbol_left` varchar(12) default NULL,
  `symbol_right` varchar(12) default NULL,
  `decimal_point` char(1) default NULL,
  `thousands_point` char(1) default NULL,
  `decimal_places` char(1) default NULL,
  `value` float(13,8) default NULL,
  `last_updated` datetime default NULL,
  PRIMARY KEY  (`currencies_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `customers`;
CREATE TABLE `customers` (
  `customers_id` int(11) NOT NULL auto_increment,
  `customers_cid` varchar(32) default NULL,
  `customers_vat_id` varchar(20) default NULL,
  `customers_vat_id_status` int(2) NOT NULL default '0',
  `customers_warning` varchar(32) default NULL,
  `customers_status` int(5) NOT NULL default '1',
  `customers_gender` char(1) NOT NULL default '',
  `customers_firstname` varchar(32) NOT NULL default '',
  `customers_lastname` varchar(32) NOT NULL default '',
  `customers_dob` datetime NOT NULL default '0000-00-00 00:00:00',
  `customers_email_address` varchar(96) NOT NULL default '',
  `customers_default_address_id` int(11) NOT NULL default '0',
  `customers_telephone` varchar(32) NOT NULL default '',
  `customers_fax` varchar(32) default NULL,
  `customers_password` varchar(40) NOT NULL default '',
  `customers_newsletter` char(1) default NULL,
  `customers_newsletter_mode` char(1) NOT NULL default '0',
  `member_flag` char(1) NOT NULL default '0',
  `delete_user` char(1) NOT NULL default '1',
  `account_type` int(1) NOT NULL default '0',
  `password_request_key` varchar(32) NOT NULL default '',
  `payment_unallowed` varchar(255) NOT NULL default '',
  `shipping_unallowed` varchar(255) NOT NULL default '',
  `refferers_id` int(5) NOT NULL default '0',
  `customers_date_added` datetime default '0000-00-00 00:00:00',
  `customers_last_modified` datetime default '0000-00-00 00:00:00',
  PRIMARY KEY  (`customers_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_basket`;
CREATE TABLE `customers_basket` (
  `customers_basket_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `customers_basket_quantity` decimal(15,4) NOT NULL default '0.0000',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `customers_basket_date_added` varchar(8) default NULL,
  `clickandbuy_TransactionID` char(11) NOT NULL,
  `clickandbuy_externalBDRID` varchar(11) NOT NULL,
  PRIMARY KEY  (`customers_basket_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_basket_attributes`;
CREATE TABLE `customers_basket_attributes` (
  `customers_basket_attributes_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_value_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`customers_basket_attributes_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_info`;
CREATE TABLE `customers_info` (
  `customers_info_id` int(11) NOT NULL default '0',
  `customers_info_date_of_last_logon` datetime default NULL,
  `customers_info_number_of_logons` int(5) default NULL,
  `customers_info_date_account_created` datetime default NULL,
  `customers_info_date_account_last_modified` datetime default NULL,
  `global_product_notifications` int(1) default '0',
  PRIMARY KEY  (`customers_info_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_ip`;
CREATE TABLE `customers_ip` (
  `customers_ip_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `customers_ip` varchar(15) NOT NULL default '',
  `customers_ip_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `customers_host` varchar(255) NOT NULL default '',
  `customers_advertiser` varchar(30) default NULL,
  `customers_referer_url` varchar(255) default NULL,
  PRIMARY KEY  (`customers_ip_id`),
  KEY `customers_id` (`customers_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_logs_history`;
CREATE TABLE `customers_logs_history` (
  `customers_logs_history_id` int(10) unsigned NOT NULL auto_increment,
  `customers_id` int(10) unsigned NOT NULL,
  `confirmation_date` varchar(32) NOT NULL,
  `logfile` varchar(255) NOT NULL,
  PRIMARY KEY  (`customers_logs_history_id`),
  UNIQUE KEY `customers_id` (`customers_id`,`logfile`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_memo`;
CREATE TABLE `customers_memo` (
  `memo_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `memo_date` date NOT NULL default '0000-00-00',
  `memo_title` text NOT NULL,
  `memo_text` text NOT NULL,
  `poster_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`memo_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_status`;
CREATE TABLE `customers_status` (
  `customers_status_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `customers_status_name` varchar(32) NOT NULL default '',
  `customers_status_public` int(1) NOT NULL default '1',
  `customers_status_min_order` decimal(15,2) default NULL,
  `customers_status_max_order` decimal(15,2) default NULL,
  `customers_status_image` varchar(64) default NULL,
  `customers_status_discount` decimal(4,2) default '0.00',
  `customers_status_ot_discount_flag` char(1) NOT NULL default '0',
  `customers_status_ot_discount` decimal(4,2) default '0.00',
  `customers_status_graduated_prices` char(1) NOT NULL default '0',
  `customers_status_show_price` int(1) NOT NULL default '1',
  `customers_status_show_price_tax` int(1) NOT NULL default '1',
  `customers_status_add_tax_ot` int(1) NOT NULL default '0',
  `customers_status_payment_unallowed` varchar(255) NOT NULL default '',
  `customers_status_shipping_unallowed` varchar(255) NOT NULL default '',
  `customers_status_discount_attributes` int(1) NOT NULL default '0',
  `customers_fsk18` int(1) NOT NULL default '1',
  `customers_fsk18_display` int(1) NOT NULL default '1',
  `customers_status_write_reviews` int(1) NOT NULL default '1',
  `customers_status_read_reviews` int(1) NOT NULL default '1',
  PRIMARY KEY  (`customers_status_id`,`language_id`),
  KEY `idx_orders_status_name` (`customers_status_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_status_history`;
CREATE TABLE `customers_status_history` (
  `customers_status_history_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `new_value` int(5) NOT NULL default '0',
  `old_value` int(5) default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `customer_notified` int(1) default '0',
  PRIMARY KEY  (`customers_status_history_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_wishlist`;
CREATE TABLE `customers_wishlist` (
  `customers_basket_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `customers_basket_quantity` decimal(15,4) NOT NULL default '0.0000',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `customers_basket_date_added` varchar(8) default NULL,
  PRIMARY KEY  (`customers_basket_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `customers_wishlist_attributes`;
CREATE TABLE `customers_wishlist_attributes` (
  `customers_basket_attributes_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_value_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`customers_basket_attributes_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `database_version`;
CREATE TABLE `database_version` (
  `version` varchar(32) NOT NULL default ''
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `geo_zones`;
CREATE TABLE `geo_zones` (
  `geo_zone_id` int(11) NOT NULL auto_increment,
  `geo_zone_name` varchar(32) NOT NULL default '',
  `geo_zone_description` varchar(255) NOT NULL default '',
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`geo_zone_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_admin_boxes`;
CREATE TABLE `gm_admin_boxes` (
  `boxes_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL,
  `box_key` varchar(64) NOT NULL,
  `box_status` tinyint(4) NOT NULL,
  PRIMARY KEY  (`boxes_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_admin_favorites`;
CREATE TABLE `gm_admin_favorites` (
  `favorites_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL,
  `link_key` varchar(255) NOT NULL,
  `sort_order` int(11) NOT NULL,
  PRIMARY KEY  (`favorites_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_bookmarks`;
CREATE TABLE `gm_bookmarks` (
  `gm_bookmarks_id` int(11) NOT NULL auto_increment,
  `gm_bookmarks_name` varchar(255) default NULL,
  `gm_bookmarks_link` varchar(255) default NULL,
  `gm_bookmarks_image` varchar(255) default NULL,
  PRIMARY KEY  (`gm_bookmarks_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_boxes`;
CREATE TABLE `gm_boxes` (
  `boxes_id` int(11) NOT NULL auto_increment,
  `template_name` varchar(32) NOT NULL default '',
  `box_name` varchar(64) NOT NULL,
  `position` varchar(32) NOT NULL,
  `box_status` tinyint(1) NOT NULL,
  PRIMARY KEY  (`boxes_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_configuration`;
CREATE TABLE `gm_configuration` (
  `gm_configuration_id` int(11) NOT NULL auto_increment,
  `gm_key` varchar(255) NOT NULL default '',
  `gm_value` text NOT NULL,
  `gm_group_id` int(11) NOT NULL default '0',
  `gm_sort_order` int(5) NOT NULL default '0',
  PRIMARY KEY  (`gm_configuration_id`),
  KEY `gm_key` (`gm_key`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_contents`;
CREATE TABLE `gm_contents` (
  `gm_contents_id` int(10) unsigned NOT NULL auto_increment,
  `languages_id` int(10) unsigned NOT NULL default '0',
  `gm_key` varchar(255) NOT NULL default '',
  `gm_value` text NOT NULL,
  `gm_group_id` int(11) NOT NULL default '0',
  `gm_sort_order` int(5) NOT NULL default '0',
  PRIMARY KEY  (`gm_contents_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_counter_extern_search`;
CREATE TABLE `gm_counter_extern_search` (
  `gm_counter_extern_search_id` int(10) NOT NULL auto_increment,
  `gm_counter_extern_search_name` varchar(255) default NULL,
  `gm_counter_extern_search_engine` varchar(255) default NULL,
  `gm_counter_extern_search_hits` int(10) NOT NULL default '0',
  PRIMARY KEY  (`gm_counter_extern_search_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_counter_info`;
CREATE TABLE `gm_counter_info` (
  `gm_counter_info_id` int(10) NOT NULL auto_increment,
  `gm_counter_info_type_id` int(10) NOT NULL default '0',
  `gm_counter_info_hits` int(10) NOT NULL default '0',
  `gm_counter_info_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`gm_counter_info_id`),
  KEY `gm_counter_info_type_id` (`gm_counter_info_type_id`,`gm_counter_info_name`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_counter_info_type`;
CREATE TABLE `gm_counter_info_type` (
  `gm_counter_info_type_id` int(10) NOT NULL auto_increment,
  `gm_counter_info_type_name` varchar(255) default NULL,
  PRIMARY KEY  (`gm_counter_info_type_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_counter_intern_search`;
CREATE TABLE `gm_counter_intern_search` (
  `gm_counter_intern_search_id` int(10) NOT NULL auto_increment,
  `gm_counter_intern_search_name` varchar(255) default NULL,
  `gm_counter_intern_search_hits` int(10) NOT NULL default '0',
  PRIMARY KEY  (`gm_counter_intern_search_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_counter_ip`;
CREATE TABLE `gm_counter_ip` (
  `gm_ip_id` int(10) NOT NULL auto_increment,
  `gm_ip_value` varchar(255) default NULL,
  `gm_ip_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_ip_id`),
  KEY `gm_ip_date` (`gm_ip_date`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_counter_page`;
CREATE TABLE `gm_counter_page` (
  `gm_counter_page_id` int(10) NOT NULL auto_increment,
  `gm_counter_page_name` varchar(255) default NULL,
  `gm_counter_page_type` varchar(255) default NULL,
  `gm_counter_page_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_counter_page_id`),
  KEY `gm_counter_page_date` (`gm_counter_page_date`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_counter_page_history`;
CREATE TABLE `gm_counter_page_history` (
  `gm_counter_page_history_id` int(10) NOT NULL auto_increment,
  `gm_counter_page_history_name` varchar(255) default NULL,
  `gm_counter_page_history_type` varchar(255) default NULL,
  `gm_counter_page_history_hits` int(10) default NULL,
  `gm_counter_page_history_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_counter_page_history_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_counter_visits`;
CREATE TABLE `gm_counter_visits` (
  `gm_counter_id` int(10) NOT NULL auto_increment,
  `gm_counter_visits_total` int(10) NOT NULL default '0',
  `gm_counter_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_counter_id`),
  KEY `gm_counter_date` (`gm_counter_date`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_css_style`;
CREATE TABLE `gm_css_style` (
  `gm_css_style_id` int(11) NOT NULL auto_increment,
  `template_name` varchar(32) NOT NULL default '',
  `style_name` varchar(255) NOT NULL default '',
  `editable` tinyint(4) NOT NULL default '1',
  `selectors_specificity` varchar(8) NOT NULL,
  PRIMARY KEY  (`gm_css_style_id`),
  KEY `name` (`style_name`),
  KEY `editable` (`editable`,`template_name`,`selectors_specificity`,`gm_css_style_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_css_style_content`;
CREATE TABLE `gm_css_style_content` (
  `gm_css_style_content_id` int(11) NOT NULL auto_increment,
  `gm_css_style_id` int(11) NOT NULL default '0',
  `style_attribute` varchar(32) NOT NULL default '',
  `style_value` text NOT NULL,
  `editable` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`gm_css_style_content_id`),
  KEY `gm_css_style_id` (`gm_css_style_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_css_style_fonts`;
CREATE TABLE `gm_css_style_fonts` (
  `gm_css_style_fonts_id` int(10) unsigned NOT NULL auto_increment,
  `font` varchar(255) NOT NULL,
  PRIMARY KEY  (`gm_css_style_fonts_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_css_style_history`;
CREATE TABLE IF NOT EXISTS `gm_css_style_history` (
  `gm_css_style_history_id` int(10) unsigned NOT NULL auto_increment,
  `gm_css_style_security_id` int(10) unsigned NOT NULL,
  `gm_css_style_id` int(10) unsigned NOT NULL,
  `gm_css_history_active` enum('true','false') NOT NULL default 'true',
  `date` datetime default NULL,
  PRIMARY KEY  (`gm_css_style_history_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_css_style_history_content`;
CREATE TABLE IF NOT EXISTS `gm_css_style_history_content` (
  `gm_css_style_history_content_id` int(10) unsigned NOT NULL auto_increment,
  `gm_css_style_history_id` int(10) unsigned NOT NULL,
  `style_attribute` varchar(32) default NULL,
  `style_value` text,
  PRIMARY KEY  (`gm_css_style_history_content_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_css_style_security`;
CREATE TABLE IF NOT EXISTS `gm_css_style_security` (
  `gm_css_style_security_id` int(10) unsigned NOT NULL auto_increment,
  `gm_css_style_security_token` varchar(64) NOT NULL,
  `gm_css_style_security_date` datetime default NULL,
  PRIMARY KEY  (`gm_css_style_security_id`)
) ENGINE=MyISAM  COMMENT='Gambio StyleEdit INTERFACE TABLE';

DROP TABLE IF EXISTS `gm_emails`;
CREATE TABLE `gm_emails` (
  `gm_emails_id` int(10) unsigned NOT NULL auto_increment,
  `gm_email_id` int(10) unsigned NOT NULL default '0',
  `languages_id` int(10) unsigned NOT NULL default '0',
  `folder` varchar(64) NOT NULL default '',
  `filename` varchar(255) NOT NULL default '',
  `backup_original_html` MEDIUMTEXT NOT NULL,
  `backup_user_html` MEDIUMTEXT NOT NULL,
  `backup_original_txt` MEDIUMTEXT NOT NULL,
  `backup_user_txt` MEDIUMTEXT NOT NULL,
  PRIMARY KEY  (`gm_emails_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_guestbook`;
CREATE TABLE `gm_guestbook` (
  `gm_guestbook_id` int(10) unsigned NOT NULL auto_increment,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `name` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `homepage` varchar(255) NOT NULL default '',
  `message` text NOT NULL,
  `ip` varchar(255) NOT NULL default '',
  `activated` int(1) NOT NULL default '0',
  PRIMARY KEY  (`gm_guestbook_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_guestbook_customers_status`;
CREATE TABLE `gm_guestbook_customers_status` (
  `gm_guestbook_customers_status_id` int(10) unsigned NOT NULL auto_increment,
  `customers_status_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`gm_guestbook_customers_status_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_lang_files`;
CREATE TABLE `gm_lang_files` (
  `lang_files_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL,
  `file_path` varchar(255) NOT NULL,
  PRIMARY KEY  (`lang_files_id`),
  KEY `lang_files_id` (`lang_files_id`,`file_path`),
  KEY `file_path` (`file_path`,`lang_files_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_lang_files_content`;
CREATE TABLE `gm_lang_files_content` (
  `lang_files_content_id` int(11) NOT NULL auto_increment,
  `lang_files_id` int(11) NOT NULL,
  `constant_name` varchar(255) NOT NULL,
  `constant_value` text NOT NULL,
  PRIMARY KEY  (`lang_files_content_id`),
  KEY `lang_files_id` (`lang_files_id`),
  FULLTEXT KEY `constant_value` (`constant_value`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_lang_module`;
CREATE TABLE `gm_lang_module` (
  `language_module_id` int(11) NOT NULL auto_increment,
  `module_name` varchar(128) NOT NULL,
  PRIMARY KEY  (`language_module_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_lang_module_content`;
CREATE TABLE `gm_lang_module_content` (
  `lang_module_content_id` int(11) NOT NULL auto_increment,
  `language_module_id` int(11) NOT NULL,
  `content_key` varchar(128) NOT NULL,
  `content_value` text NOT NULL,
  PRIMARY KEY  (`lang_module_content_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `gm_login_history`;
CREATE TABLE `gm_login_history` (
  `gm_login_history_id` int(10) NOT NULL auto_increment,
  `gm_login_ip` varchar(15) NOT NULL default '',
  `gm_login_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_login_history_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gmotion`;
CREATE TABLE `gm_gmotion` (
  `gm_gmotion_id` int(10) unsigned NOT NULL auto_increment,
  `products_id` int(10) unsigned NOT NULL,
  `image_nr` smallint(6) NOT NULL default '0',
  `position_from` varchar(32) NOT NULL,
  `position_to` varchar(32) NOT NULL,
  `zoom_from` decimal(3,1) NOT NULL,
  `zoom_to` decimal(3,1) NOT NULL,
  `duration` int(10) unsigned NOT NULL default '1',
  `sort_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`gm_gmotion_id`),
  UNIQUE KEY `products_id` (`products_id`,`image_nr`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gmotion_products`;
CREATE TABLE `gm_gmotion_products` (
  `gm_gmotion_products_id` int(10) unsigned NOT NULL auto_increment,
  `products_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`gm_gmotion_products_id`),
  UNIQUE KEY `products_id` (`products_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_prd_img_alt`;
CREATE TABLE `gm_prd_img_alt` (
  `img_alt_id` int(11) NOT NULL auto_increment,
  `image_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL default '1',
  `gm_alt_text` varchar(255) default NULL,
  PRIMARY KEY  (`img_alt_id`),
  UNIQUE KEY `image_id` (`image_id`,`products_id`,`language_id`),
  KEY `image_id2` (`image_id`,`language_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_search_history`;
CREATE TABLE `gm_search_history` (
  `gm_search_history_id` int(10) NOT NULL auto_increment,
  `gm_search_ip` varchar(15) NOT NULL default '',
  `gm_search_date` datetime NOT NULL,
  PRIMARY KEY  (`gm_search_history_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `infobox_messages`;
CREATE TABLE IF NOT EXISTS `infobox_messages` (
  `infobox_messages_id` int(10) unsigned NOT NULL auto_increment,
  `source` varchar(255) NOT NULL,
  `identifier` varchar(255) NOT NULL,
  `status` enum('new','read','hidden','deleted') NOT NULL default 'new',
  `type` enum('info','warning','success') NOT NULL default 'info',
  `visibility` enum('alwayson','hideable','removable') NOT NULL default 'hideable',
  `button_link` varchar(255) NOT NULL,
  `customers_id` int(10) unsigned NOT NULL,
  `date_added` datetime NOT NULL,
  `date_modified` datetime NOT NULL,
  PRIMARY KEY  (`infobox_messages_id`),
  UNIQUE KEY `identifier` (`identifier`,`customers_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `ipayment_log`;
CREATE TABLE IF NOT EXISTS `ipayment_log` (
  `ipayment_log_id` int(11) NOT NULL AUTO_INCREMENT,
  `orders_id` int(11) NOT NULL,
  `action` varchar(255) NOT NULL,
  `trxuser_id` varchar(255) NOT NULL,
  `trx_currency` varchar(255) NOT NULL,
  `trx_amount` varchar(255) NOT NULL,
  `trx_typ` varchar(255) NOT NULL,
  `addr_name` varchar(255) NOT NULL,
  `addr_email` varchar(255) NOT NULL,
  `shopper_id` varchar(255) NOT NULL,
  `client_name` varchar(255) NOT NULL,
  `client_version` varchar(255) NOT NULL,
  `addr_street` varchar(255) NOT NULL,
  `addr_zip` varchar(255) NOT NULL,
  `addr_city` varchar(255) NOT NULL,
  `trx_paymenttyp` varchar(255) NOT NULL,
  `ret_transdate` varchar(255) NOT NULL,
  `ret_transtime` varchar(255) NOT NULL,
  `ret_errorcode` varchar(255) NOT NULL,
  `ret_fatalerror` varchar(255) NOT NULL,
  `ret_errormsg` varchar(255) NOT NULL,
  `ret_additionalmsg` varchar(255) NOT NULL,
  `ret_authcode` varchar(255) NOT NULL,
  `ret_ip` varchar(255) NOT NULL,
  `ret_booknr` varchar(255) NOT NULL,
  `ret_trx_number` varchar(255) NOT NULL,
  `ret_param_checksum` varchar(255) NOT NULL,
  `redirect_needed` varchar(255) NOT NULL,
  `trx_paymentmethod` varchar(255) NOT NULL,
  `trx_paymentdata_country` varchar(255) NOT NULL,
  `trx_remoteip_country` varchar(255) NOT NULL,
  `ret_status` varchar(255) NOT NULL,
  `trx_payauth_status` varchar(255) NOT NULL,
  `trx_issuer_avs_response` varchar(255) NOT NULL,
  `ret_url_checksum` varchar(255) NOT NULL,
  `addr_check_result` varchar(255) NOT NULL,
  `paydata` varchar(255) NOT NULL,
  PRIMARY KEY (`ipayment_log_id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `infobox_messages_description`;
CREATE TABLE IF NOT EXISTS `infobox_messages_description` (
  `infobox_messages_id` int(10) unsigned NOT NULL,
  `languages_id` int(10) unsigned NOT NULL,
  `headline` varchar(255) NOT NULL,
  `message` text NOT NULL,
  `button_label` varchar(64) NOT NULL,
  PRIMARY KEY  (`infobox_messages_id`,`languages_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `languages`;
CREATE TABLE `languages` (
  `languages_id` int(11) NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `code` char(2) NOT NULL default '',
  `image` varchar(64) default NULL,
  `directory` varchar(32) default NULL,
  `sort_order` int(3) default NULL,
  `language_charset` text NOT NULL,
  PRIMARY KEY  (`languages_id`),
  KEY `IDX_LANGUAGES_NAME` (`name`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `manufacturers`;
CREATE TABLE `manufacturers` (
  `manufacturers_id` int(11) NOT NULL auto_increment,
  `manufacturers_name` varchar(64) NOT NULL,
  `manufacturers_image` varchar(64) default NULL,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  PRIMARY KEY  (`manufacturers_id`),
  KEY `IDX_MANUFACTURERS_NAME` (`manufacturers_name`),
  KEY `manufacturers_id` (`manufacturers_id`,`manufacturers_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `manufacturers_info`;
CREATE TABLE `manufacturers_info` (
  `manufacturers_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `manufacturers_meta_title` text NOT NULL,
  `manufacturers_meta_description` text NOT NULL,
  `manufacturers_meta_keywords` text NOT NULL,
  `manufacturers_url` varchar(255) NOT NULL default '',
  `url_clicked` int(5) NOT NULL default '0',
  `date_last_click` datetime default NULL,
  PRIMARY KEY  (`manufacturers_id`,`languages_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `media_content`;
CREATE TABLE `media_content` (
  `file_id` int(11) NOT NULL auto_increment,
  `old_filename` text NOT NULL,
  `new_filename` text NOT NULL,
  `file_comment` text NOT NULL,
  PRIMARY KEY  (`file_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `module_newsletter`;
CREATE TABLE `module_newsletter` (
  `newsletter_id` int(11) NOT NULL auto_increment,
  `title` text NOT NULL,
  `bc` text NOT NULL,
  `cc` text NOT NULL,
  `date` datetime default NULL,
  `status` int(1) NOT NULL default '0',
  `body` text NOT NULL,
  PRIMARY KEY  (`newsletter_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `module_newsletter_temp_1`;
CREATE TABLE `module_newsletter_temp_1` (
  `id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `customers_status` int(11) NOT NULL default '0',
  `customers_firstname` varchar(64) NOT NULL default '',
  `customers_lastname` varchar(64) NOT NULL default '',
  `customers_email_address` text NOT NULL,
  `mail_key` varchar(32) NOT NULL,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `comment` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `newsletters`;
CREATE TABLE `newsletters` (
  `newsletters_id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `content` text NOT NULL,
  `module` varchar(255) NOT NULL default '',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_sent` datetime default NULL,
  `status` int(1) default NULL,
  `locked` int(1) default '0',
  PRIMARY KEY  (`newsletters_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `newsletters_history`;
CREATE TABLE `newsletters_history` (
  `news_hist_id` int(11) NOT NULL default '0',
  `news_hist_cs` int(11) NOT NULL default '0',
  `news_hist_cs_date_sent` date default NULL,
  PRIMARY KEY  (`news_hist_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `newsletter_recipients`;
CREATE TABLE `newsletter_recipients` (
  `mail_id` int(11) NOT NULL auto_increment,
  `customers_email_address` varchar(96) NOT NULL default '',
  `customers_id` int(11) NOT NULL default '0',
  `customers_status` int(5) NOT NULL default '0',
  `customers_firstname` varchar(32) NOT NULL default '',
  `customers_lastname` varchar(32) NOT NULL default '',
  `mail_status` int(1) NOT NULL default '0',
  `mail_key` varchar(32) NOT NULL default '',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`mail_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders`;
CREATE TABLE `orders` (
  `orders_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `customers_cid` varchar(32) default NULL,
  `customers_vat_id` varchar(20) default NULL,
  `customers_status` int(11) default NULL,
  `customers_status_name` varchar(32) NOT NULL default '',
  `customers_status_image` varchar(64) default NULL,
  `customers_status_discount` decimal(4,2) default NULL,
  `customers_name` varchar(64) NOT NULL default '',
  `customers_firstname` varchar(64) NOT NULL default '',
  `customers_lastname` varchar(64) NOT NULL default '',
  `customers_gender` char(1) NOT NULL default '',
  `customers_company` varchar(255) default NULL,
  `customers_street_address` varchar(64) NOT NULL default '',
  `customers_suburb` varchar(32) default NULL,
  `customers_city` varchar(32) NOT NULL default '',
  `customers_postcode` varchar(10) NOT NULL default '',
  `customers_state` varchar(32) default NULL,
  `customers_country` varchar(32) NOT NULL default '',
  `customers_telephone` varchar(32) NOT NULL default '',
  `customers_email_address` varchar(96) NOT NULL default '',
  `customers_address_format_id` int(5) NOT NULL default '0',
  `delivery_name` varchar(64) NOT NULL default '',
  `delivery_firstname` varchar(64) NOT NULL default '',
  `delivery_lastname` varchar(64) NOT NULL default '',
  `delivery_company` varchar(255) default NULL,
  `delivery_street_address` varchar(64) NOT NULL default '',
  `delivery_suburb` varchar(32) default NULL,
  `delivery_city` varchar(32) NOT NULL default '',
  `delivery_postcode` varchar(10) NOT NULL default '',
  `delivery_state` varchar(32) default NULL,
  `delivery_country` varchar(32) NOT NULL default '',
  `delivery_country_iso_code_2` char(2) NOT NULL default '',
  `delivery_address_format_id` int(5) NOT NULL default '0',
  `billing_name` varchar(64) NOT NULL default '',
  `billing_firstname` varchar(64) NOT NULL default '',
  `billing_lastname` varchar(64) NOT NULL default '',
  `billing_company` varchar(255) default NULL,
  `billing_street_address` varchar(64) NOT NULL default '',
  `billing_suburb` varchar(32) default NULL,
  `billing_city` varchar(32) NOT NULL default '',
  `billing_postcode` varchar(10) NOT NULL default '',
  `billing_state` varchar(32) default NULL,
  `billing_country` varchar(32) NOT NULL default '',
  `billing_country_iso_code_2` char(2) NOT NULL default '',
  `billing_address_format_id` int(5) NOT NULL default '0',
  `payment_method` varchar(32) NOT NULL default '',
  `cc_type` varchar(20) default NULL,
  `cc_owner` varchar(64) default NULL,
  `cc_number` varchar(64) default NULL,
  `cc_expires` varchar(4) default NULL,
  `cc_start` varchar(4) default NULL,
  `cc_issue` char(3) default NULL,
  `cc_cvv` varchar(4) default NULL,
  `comments` text default NULL,
  `last_modified` datetime default NULL,
  `date_purchased` datetime default NULL,
  `orders_status` int(5) NOT NULL default '0',
  `orders_date_finished` datetime default NULL,
  `currency` char(3) default NULL,
  `currency_value` decimal(14,6) default NULL,
  `account_type` int(1) NOT NULL default '0',
  `payment_class` varchar(32) NOT NULL default '',
  `shipping_method` varchar(32) NOT NULL default '',
  `shipping_class` varchar(32) NOT NULL default '',
  `customers_ip` varchar(32) NOT NULL default '',
  `language` varchar(32) NOT NULL default '',
  `afterbuy_success` int(1) NOT NULL default '0',
  `afterbuy_id` int(32) NOT NULL default '0',
  `refferers_id` varchar(32) NOT NULL default '',
  `conversion_type` int(1) NOT NULL default '0',
  `orders_ident_key` varchar(128) default NULL,
  `gm_orders_id` int(11) default NULL,
  `gm_packings_id` int(11) default NULL,
  `gm_orders_code` varchar(255) NOT NULL,
  `gm_packings_code` varchar(255) NOT NULL,
  `gm_order_html` MEDIUMTEXT,
  `gm_order_txt` MEDIUMTEXT NOT NULL,
  `gm_order_send_date` datetime NOT NULL,
  `gm_send_order_status` int(1) NOT NULL,
  `gm_cancel_date` datetime NOT NULL,
  PRIMARY KEY  (`orders_id`),
  KEY `date_purchased` (`date_purchased`)
) ENGINE=MyISAM AUTO_INCREMENT=400210;

DROP TABLE IF EXISTS `orders_clickandbuy`;
CREATE TABLE `orders_clickandbuy` (
  `id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL,
  `f_transactionID` varchar(50) NOT NULL,
  `x_transactionID` varchar(255) NOT NULL,
  `f_externalBDRID` varchar(50) NOT NULL,
  `f_userid` int(11) NOT NULL,
  `x_userid` varchar(255) NOT NULL,
  `price` decimal(9,2) NOT NULL default '0.00',
  `date` datetime NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_hermes`;
CREATE TABLE `orders_hermes` (
  `orderno` varchar(255) NOT NULL,
  `order_type` enum('props','prips') NOT NULL DEFAULT 'props',
  `orders_id` int(11) NOT NULL,
  `receiver_firstname` varchar(25) DEFAULT NULL,
  `receiver_lastname` varchar(25) NOT NULL,
  `receiver_street` varchar(27) NOT NULL,
  `receiver_housenumber` varchar(5) DEFAULT NULL,
  `receiver_addressadd` varchar(25) DEFAULT NULL,
  `receiver_postcode` varchar(25) NOT NULL,
  `receiver_city` varchar(30) NOT NULL,
  `receiver_district` varchar(25) DEFAULT NULL,
  `receiver_countrycode` varchar(3) NOT NULL,
  `receiver_email` varchar(255) DEFAULT NULL,
  `receiver_telephonenumber` varchar(32) DEFAULT NULL,
  `receiver_telephoneprefix` varchar(25) DEFAULT NULL,
  `clientreferencenumber` varchar(255) DEFAULT NULL,
  `parcelclass` varchar(255) DEFAULT NULL,
  `amountcashondeliveryeurocent` int(11) NOT NULL,
  `state` enum('not_sent','sent','printed') NOT NULL DEFAULT 'not_sent',
  `shipping_id` varchar(255) DEFAULT NULL,
  `paket_shop_id` varchar(255) DEFAULT NULL,
  `hand_over_mode` varchar(255) DEFAULT NULL,
  `collection_desired_date` datetime DEFAULT NULL,
  PRIMARY KEY (`orderno`),
  KEY `order_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_iclear`;
CREATE TABLE `orders_iclear` (
  `wsdl_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) default NULL,
  `basket_id` varchar(32) NOT NULL default '',
  `request_id` varchar(100) NOT NULL default '',
  `session_id` varchar(32) NOT NULL default '',
  `status` int(4) NOT NULL default '0',
  `status_message` varchar(255) default '',
  `billing` text NOT NULL,
  `delivery` text NOT NULL,
  `accepted` datetime NOT NULL,
  `basket_value` int(11) NOT NULL,
  `ts` timestamp NOT NULL,
  PRIMARY KEY  (`wsdl_id`),
  KEY `orders_id` (`orders_id`),
  KEY `basket_id` (`basket_id`),
  KEY `session_id` (`session_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_products`;
CREATE TABLE `orders_products` (
  `orders_products_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL default '0',
  `products_model` varchar(64) default NULL,
  `products_name` varchar(255) NOT NULL default '',
  `products_price` decimal(15,4) NOT NULL default '0.0000',
  `products_discount_made` decimal(4,2) default NULL,
  `products_shipping_time` varchar(255) default NULL,
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `products_tax` decimal(7,4) NOT NULL default '0.0000',
  `products_quantity` decimal(15,4) NOT NULL default '0.0000',
  `allow_tax` int(1) NOT NULL default '0',
  PRIMARY KEY  (`orders_products_id`),
  KEY `orders_id` (`orders_id`),
  KEY `products_id` (`products_id`,`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_products_attributes`;
CREATE TABLE `orders_products_attributes` (
  `orders_products_attributes_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `orders_products_id` int(11) NOT NULL default '0',
  `products_options` varchar(255) NOT NULL default '',
  `products_options_values` varchar(255) NOT NULL default '',
  `options_values_price` decimal(15,4) NOT NULL default '0.0000',
  `price_prefix` char(1) NOT NULL default '',
  PRIMARY KEY  (`orders_products_attributes_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_products_download`;
CREATE TABLE `orders_products_download` (
  `orders_products_download_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `orders_products_id` int(11) NOT NULL default '0',
  `orders_products_filename` varchar(255) NOT NULL default '',
  `download_maxdays` int(2) NOT NULL default '0',
  `download_count` int(2) NOT NULL default '0',
  PRIMARY KEY  (`orders_products_download_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_recalculate`;
CREATE TABLE `orders_recalculate` (
  `orders_recalculate_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `n_price` decimal(15,4) NOT NULL default '0.0000',
  `b_price` decimal(15,4) NOT NULL default '0.0000',
  `tax` decimal(15,4) NOT NULL default '0.0000',
  `tax_rate` decimal(7,4) NOT NULL default '0.0000',
  `class` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`orders_recalculate_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_status`;
CREATE TABLE `orders_status` (
  `orders_status_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `orders_status_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`orders_status_id`,`language_id`),
  KEY `idx_orders_status_name` (`orders_status_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_status_history`;
CREATE TABLE `orders_status_history` (
  `orders_status_history_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `orders_status_id` int(5) NOT NULL default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `customer_notified` int(1) default '0',
  `comments` text,
  PRIMARY KEY  (`orders_status_history_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_total`;
CREATE TABLE `orders_total` (
  `orders_total_id` int(10) unsigned NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `text` varchar(255) NOT NULL default '',
  `value` decimal(15,4) NOT NULL default '0.0000',
  `class` varchar(32) NOT NULL default '',
  `sort_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`orders_total_id`),
  KEY `idx_orders_total_orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payment_ipayment`;
CREATE TABLE `payment_ipayment` (
  `ip_BOOKNR` varchar(255) NOT NULL,
  `ip_INFO` text NOT NULL,
  `ip_ORDERID` int(11) NOT NULL,
  `ip_IS_CAPTURED` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`ip_BOOKNR`),
  KEY `ip_ORDERID` (`ip_ORDERID`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payment_ipayment_log`;
CREATE TABLE `payment_ipayment_log` (
  `ip_LOG_ID` int(10) unsigned NOT NULL auto_increment,
  `ip_LOG_MESSAGE` varchar(255) NOT NULL,
  `ip_LOG_INFO` text NOT NULL,
  `ip_LOG_DATE` datetime NOT NULL,
  PRIMARY KEY  (`ip_LOG_ID`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payment_moneybookers`;
CREATE TABLE `payment_moneybookers` (
  `mb_TRID` varchar(255) NOT NULL default '',
  `mb_ERRNO` smallint(3) unsigned NOT NULL default '0',
  `mb_ERRTXT` varchar(255) NOT NULL default '',
  `mb_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
  `mb_MBTID` bigint(18) unsigned NOT NULL default '0',
  `mb_STATUS` tinyint(1) NOT NULL default '0',
  `mb_ORDERID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`mb_TRID`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payment_moneybookers_countries`;
CREATE TABLE `payment_moneybookers_countries` (
  `osc_cID` int(11) NOT NULL default '0',
  `mb_cID` char(3) NOT NULL default '',
  PRIMARY KEY  (`osc_cID`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payment_moneybookers_currencies`;
CREATE TABLE `payment_moneybookers_currencies` (
  `mb_currID` char(3) NOT NULL default '',
  `mb_currName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`mb_currID`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `payment_qenta`;
CREATE TABLE `payment_qenta` (
  `q_TRID` varchar(255) NOT NULL default '',
  `q_DATE` datetime NOT NULL default '0000-00-00 00:00:00',
  `q_QTID` bigint(18) unsigned NOT NULL default '0',
  `q_ORDERDESC` varchar(255) NOT NULL default '',
  `q_STATUS` tinyint(1) NOT NULL default '0',
  `q_ORDERID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`q_TRID`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `paypal`;
CREATE TABLE `paypal` (
  `paypal_ipn_id` int(11) unsigned NOT NULL auto_increment,
  `xtc_order_id` int(11) unsigned NOT NULL default '0',
  `txn_type` varchar(32) NOT NULL default '',
  `reason_code` varchar(15) default NULL,
  `payment_type` varchar(7) NOT NULL default '',
  `payment_status` varchar(17) NOT NULL default '',
  `pending_reason` varchar(14) default NULL,
  `invoice` varchar(64) default NULL,
  `mc_currency` char(3) NOT NULL default '',
  `first_name` varchar(32) NOT NULL default '',
  `last_name` varchar(32) NOT NULL default '',
  `payer_business_name` varchar(64) default NULL,
  `address_name` varchar(32) default NULL,
  `address_street` varchar(64) default NULL,
  `address_city` varchar(32) default NULL,
  `address_state` varchar(32) default NULL,
  `address_zip` varchar(10) default NULL,
  `address_country` varchar(64) default NULL,
  `address_status` varchar(11) default NULL,
  `payer_email` varchar(96) NOT NULL default '',
  `payer_id` varchar(32) NOT NULL default '',
  `payer_status` varchar(10) NOT NULL default '',
  `payment_date` datetime NOT NULL default '0001-01-01 00:00:00',
  `business` varchar(96) NOT NULL default '',
  `receiver_email` varchar(96) NOT NULL default '',
  `receiver_id` varchar(32) NOT NULL default '',
  `txn_id` varchar(20) NOT NULL default '',
  `parent_txn_id` varchar(20) default NULL,
  `num_cart_items` tinyint(4) unsigned NOT NULL default '1',
  `mc_gross` decimal(7,2) NOT NULL default '0.00',
  `mc_fee` decimal(7,2) NOT NULL default '0.00',
  `mc_shipping` decimal(7,2) NOT NULL default '0.00',
  `payment_gross` decimal(7,2) default NULL,
  `payment_fee` decimal(7,2) default NULL,
  `settle_amount` decimal(7,2) default NULL,
  `settle_currency` char(3) default NULL,
  `exchange_rate` decimal(4,2) default NULL,
  `notify_version` decimal(2,1) NOT NULL default '0.0',
  `verify_sign` varchar(128) NOT NULL default '',
  `last_modified` datetime NOT NULL default '0001-01-01 00:00:00',
  `date_added` datetime NOT NULL default '0001-01-01 00:00:00',
  `memo` text,
  `mc_authorization` decimal(7,2) NOT NULL,
  `mc_captured` decimal(7,2) NOT NULL,
  PRIMARY KEY  (`paypal_ipn_id`,`txn_id`),
  KEY `xtc_order_id` (`xtc_order_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `paypal_status_history`;
CREATE TABLE `paypal_status_history` (
  `payment_status_history_id` int(11) NOT NULL auto_increment,
  `paypal_ipn_id` int(11) NOT NULL default '0',
  `txn_id` varchar(64) NOT NULL default '',
  `parent_txn_id` varchar(64) NOT NULL default '',
  `payment_status` varchar(17) NOT NULL default '',
  `pending_reason` varchar(64) default NULL,
  `mc_amount` decimal(7,2) NOT NULL,
  `date_added` datetime NOT NULL default '0001-01-01 00:00:00',
  PRIMARY KEY  (`payment_status_history_id`),
  KEY `paypal_ipn_id` (`paypal_ipn_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_shopgate_order`;
CREATE TABLE `orders_shopgate_order` (
  `shopgate_order_id` int(11) NOT NULL AUTO_INCREMENT,
  `orders_id` int(11) NOT NULL,
  `shopgate_order_number` bigint(20) NOT NULL,
  `last_response` text NOT NULL,
  `modified` datetime DEFAULT NULL,
  `created` datetime DEFAULT NULL,
  PRIMARY KEY (`shopgate_order_id`),
  KEY `orders_id` (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `personal_offers_by_customers_status_`;
CREATE TABLE `personal_offers_by_customers_status_` (
  `price_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `quantity` decimal(15,4) default NULL,
  `personal_offer` decimal(15,4) default NULL,
  PRIMARY KEY  (`price_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `products`;
CREATE TABLE `products` (
  `products_id` int(11) NOT NULL auto_increment,
  `products_ean` varchar(128) default NULL,
  `products_quantity` decimal(15,4) NOT NULL default '0.0000',
  `products_shippingtime` int(4) NOT NULL default '0',
  `products_model` varchar(64) default NULL,
  `group_permission_0` tinyint(1) NOT NULL default '0',
  `group_permission_1` tinyint(1) NOT NULL default '0',
  `group_permission_2` tinyint(1) NOT NULL default '0',
  `group_permission_3` tinyint(1) NOT NULL default '0',
  `products_sort` int(4) NOT NULL default '0',
  `products_image` varchar(64) default NULL,
  `products_price` decimal(15,4) NOT NULL default '0.0000',
  `products_discount_allowed` decimal(5,2) NOT NULL default '0.00',
  `products_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `products_last_modified` datetime default NULL,
  `products_date_available` datetime default NULL,
  `products_weight` decimal(15,4) NOT NULL default '0.00',
  `products_status` tinyint(1) NOT NULL default '0',
  `products_tax_class_id` int(11) NOT NULL default '0',
  `product_template` varchar(64) default NULL,
  `options_template` varchar(64) default NULL,
  `manufacturers_id` int(11) default NULL,
  `products_ordered` decimal(15,4) NOT NULL default '0.0000',
  `products_fsk18` int(1) NOT NULL default '0',
  `products_vpe` int(11) NOT NULL default '0',
  `products_vpe_status` int(1) NOT NULL default '0',
  `products_vpe_value` decimal(15,4) NOT NULL default '0.0000',
  `products_startpage` int(1) NOT NULL default '0',
  `products_startpage_sort` int(4) NOT NULL default '0',
  `group_ids` varchar(5) NOT NULL default '',
  `nc_ultra_shipping_costs` decimal(15,4) NOT NULL default '0.00',
  `gm_show_date_added` int(1) unsigned NOT NULL default '0',
  `gm_show_price_offer` int(1) unsigned NOT NULL default '0',
  `gm_show_weight` int(1) NOT NULL,
  `gm_price_status` int(10) unsigned NOT NULL default '0',
  `gm_min_order` decimal(15,4) NOT NULL default '1.0000',
  `gm_graduated_qty` decimal(15,4) NOT NULL default '1.0000',
  `gm_options_template` varchar(64) default NULL,
  `gm_priority` varchar(3) NOT NULL default '0.5',
  `gm_changefreq` varchar(255) NOT NULL default 'weekly',
  `gm_show_qty_info` int(1) unsigned NOT NULL default '0',
  `gm_sitemap_entry` int(1) NOT NULL default '1',
  `products_image_w` int(11) NOT NULL,
  `products_image_h` int(11) NOT NULL,
  `gm_show_image` int(1) unsigned NOT NULL default '1',
  `properties_dropdown_mode` varchar(30) NOT NULL,
  `properties_show_price` varchar(10) NOT NULL,
  `use_properties_combis_weight` tinyint(1) NOT NULL,
  `use_properties_combis_quantity` tinyint(1) NOT NULL ,
  `use_properties_combis_shipping_time` tinyint(1) NOT NULL,
  PRIMARY KEY  (`products_id`),
  KEY `idx_products_date_added` (`products_date_added`),
  KEY `products_id` (`products_id`,`products_status`,`products_date_added`),
  KEY `products_status` (`products_status`,`products_id`,`products_date_added`),
  KEY `products_status_2` (`products_status`,`products_id`,`products_price`),
  KEY `products_status_3` (`products_status`,`products_ordered`,`products_id`),
  KEY `products_status_4` (`products_status`,`products_model`,`products_id`),
  KEY `products_id_2` (`products_id`,`products_startpage`,`products_status`,`products_startpage_sort`),
  KEY `products_date_available` (`products_date_available`,`products_id`),
  KEY `products_quantity` (`products_quantity`),
  KEY `products_sort` (`products_sort`),
  KEY `products_tax_class_id` (`products_tax_class_id`),
  KEY `manufacturers_id` (`manufacturers_id`),
  KEY `products_model` (`products_model`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_attributes`;
CREATE TABLE `products_attributes` (
  `products_attributes_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `options_id` int(11) NOT NULL default '0',
  `options_values_id` int(11) NOT NULL default '0',
  `options_values_price` decimal(15,4) NOT NULL default '0.0000',
  `price_prefix` char(1) NOT NULL default '',
  `attributes_model` varchar(64) default NULL,
  `attributes_stock` decimal(15,4) default NULL,
  `options_values_weight` decimal(15,4) NOT NULL default '0.0000',
  `weight_prefix` char(1) NOT NULL default '',
  `sortorder` int(11) default NULL,
  `products_vpe_id` int(11) UNSIGNED default '0' NOT NULL ,
  `gm_vpe_value` decimal(15,4 ) default '0.0000' NOT NULL ,
  `gm_ean` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`products_attributes_id`),
  KEY `products_id` (`products_id`,`options_id`,`options_values_id`,`sortorder`),
  KEY `options_values_id` (`options_values_id`),
  KEY `sortorder` (`sortorder`),
  FULLTEXT KEY `attributes_model` (`attributes_model`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_attributes_download`;
CREATE TABLE `products_attributes_download` (
  `products_attributes_id` int(11) NOT NULL default '0',
  `products_attributes_filename` varchar(255) NOT NULL default '',
  `products_attributes_maxdays` int(2) default '0',
  `products_attributes_maxcount` int(2) default '0',
  PRIMARY KEY  (`products_attributes_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_content`;
CREATE TABLE `products_content` (
  `content_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `group_ids` text,
  `content_name` varchar(32) NOT NULL default '',
  `content_file` varchar(64) NOT NULL default '',
  `content_link` text NOT NULL,
  `languages_id` int(11) NOT NULL default '0',
  `content_read` int(11) NOT NULL default '0',
  `file_comment` text NOT NULL,
  PRIMARY KEY  (`content_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_description`;
CREATE TABLE `products_description` (
  `products_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL default '1',
  `products_name` varchar(255) NOT NULL default '',
  `products_description` text,
  `products_short_description` text,
  `products_keywords` varchar(255) default NULL,
  `products_meta_title` text NOT NULL,
  `products_meta_description` text NOT NULL,
  `products_meta_keywords` text NOT NULL,
  `products_url` varchar(255) default NULL,
  `products_viewed` int(5) default '0',
  `gm_alt_text` varchar(255) default NULL,
  `gm_url_keywords` varchar(255) NOT NULL,
  `checkout_information` text NOT NULL,
  PRIMARY KEY  (`products_id`,`language_id`),
  KEY `products_name` (`products_name`),
  KEY `language_id` (`language_id`,`products_keywords`),
  KEY `language_id_2` (`language_id`,`products_name`),
  KEY `seo_boost_index` (`gm_url_keywords`,`products_id`,`language_id`),
  FULLTEXT KEY `products_name_2` (`products_name`),
  FULLTEXT KEY `products_description` (`products_description`),
  FULLTEXT KEY `products_short_description` (`products_short_description`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_graduated_prices`;
CREATE TABLE `products_graduated_prices` (
  `products_id` int(11) NOT NULL default '0',
  `quantity` int(11) NOT NULL default '0',
  `unitprice` decimal(15,4) NOT NULL default '0.0000',
  KEY `products_id` (`products_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_hermesoptions`;
CREATE TABLE `products_hermesoptions` (
  `products_id` int(11) NOT NULL,
  `min_pclass` enum('XS','S','M','L','XL','XXL') NOT NULL,
  PRIMARY KEY (`products_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_images`;
CREATE TABLE `products_images` (
  `image_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `image_nr` smallint(6) NOT NULL default '0',
  `image_name` varchar(254) NOT NULL default '',
  `gm_show_image` int(1) unsigned NOT NULL default '1', 
  PRIMARY KEY  (`image_id`),
  UNIQUE KEY `products_id` (`products_id`,`image_nr`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_notifications`;
CREATE TABLE `products_notifications` (
  `products_id` int(11) NOT NULL default '0',
  `customers_id` int(11) NOT NULL default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`products_id`,`customers_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_options`;
CREATE TABLE `products_options` (
  `products_options_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `products_options_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`products_options_id`,`language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_options_values`;
CREATE TABLE `products_options_values` (
  `products_options_values_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `products_options_values_name` varchar(255) NOT NULL default '',
  `gm_filename` varchar(255) NOT NULL,
  PRIMARY KEY  (`products_options_values_id`,`language_id`),
  KEY `products_options_values_name` (`products_options_values_name`,`language_id`),
  FULLTEXT KEY `products_options_values_name_2` (`products_options_values_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_options_values_to_products_options`;
CREATE TABLE `products_options_values_to_products_options` (
  `products_options_values_to_products_options_id` int(11) NOT NULL auto_increment,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_values_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`products_options_values_to_products_options_id`),
  KEY `products_options_id` (`products_options_id`),
  KEY `products_options_values_id` (`products_options_values_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_to_categories`;
CREATE TABLE `products_to_categories` (
  `products_id` int(11) NOT NULL default '0',
  `categories_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`products_id`,`categories_id`),
  KEY `categories_id` (`categories_id`,`products_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_vpe`;
CREATE TABLE `products_vpe` (
  `products_vpe_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '0',
  `products_vpe_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`products_vpe_id`, `language_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_xsell`;
CREATE TABLE `products_xsell` (
  `ID` int(10) NOT NULL auto_increment,
  `products_id` int(10) unsigned NOT NULL default '1',
  `products_xsell_grp_name_id` int(10) unsigned NOT NULL default '1',
  `xsell_id` int(10) unsigned NOT NULL default '1',
  `sort_order` int(10) unsigned NOT NULL default '1',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_xsell_grp_name`;
CREATE TABLE `products_xsell_grp_name` (
  `products_xsell_grp_name_id` int(10) NOT NULL default '0',
  `xsell_sort_order` int(10) NOT NULL default '0',
  `language_id` smallint(6) NOT NULL default '0',
  `groupname` varchar(255) NOT NULL default ''
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `products_google_categories`;
CREATE TABLE `products_google_categories` (
  `products_google_categories_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) default NULL,
  `google_category` text,
  PRIMARY KEY  (`products_google_categories_id`),
  KEY `products_id` (`products_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_item_codes`;
CREATE TABLE `products_item_codes` (
  `products_id` int(11) NOT NULL,
  `code_isbn` varchar(128) default NULL,
  `code_upc` varchar(128) default NULL,
  `code_mpn` varchar(128) default NULL,
  `code_jan` varchar(128) default NULL,
  `google_export_condition` varchar(64) NOT NULL default 'neu',
  `google_export_availability_id` int(10) unsigned NOT NULL,
  `brand_name` varchar(128) NOT NULL,
  `identifier_exists` TINYINT(1) NOT NULL DEFAULT '1',
  `gender` ENUM( '', 'Herren', 'Damen', 'Unisex' ) NOT NULL DEFAULT '',
  `age_group` ENUM( '', 'Erwachsene', 'Kinder' ) NOT NULL DEFAULT '',
  `expiration_date` DATE NOT NULL,
  PRIMARY KEY  (`products_id`),
  KEY `google_export_condition` (`google_export_condition`),
  KEY `brand_name` (`brand_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `shipping_status_to_google_availability`;
CREATE TABLE `shipping_status_to_google_availability` (
  `shipping_status_id` int(10) unsigned NOT NULL,
  `google_export_availability_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`shipping_status_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `google_export_availability`;
CREATE TABLE `google_export_availability` (
  `google_export_availability_id` int(10) unsigned NOT NULL auto_increment,
  `availability` varchar(64) NOT NULL,
  PRIMARY KEY  (`google_export_availability_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `reviews`;
CREATE TABLE `reviews` (
  `reviews_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `customers_id` int(11) default NULL,
  `customers_name` varchar(64) NOT NULL default '',
  `reviews_rating` int(1) default NULL,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  `reviews_read` int(5) NOT NULL default '0',
  PRIMARY KEY  (`reviews_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `reviews_description`;
CREATE TABLE `reviews_description` (
  `reviews_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `reviews_text` text NOT NULL,
  PRIMARY KEY  (`reviews_id`,`languages_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `sessions`;
CREATE TABLE `sessions` (
  `sesskey` varchar(32) NOT NULL default '',
  `expiry` int(11) unsigned NOT NULL default '0',
  `value` text NOT NULL,
  PRIMARY KEY  (`sesskey`),
  KEY `sesskey` (`sesskey`,`expiry`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `shipping_status`;
CREATE TABLE `shipping_status` (
  `shipping_status_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `shipping_status_name` varchar(32) NOT NULL default '',
  `shipping_status_image` varchar(32) NOT NULL default '',
  `number_of_days` INT(10) NOT NULL default '0',
  `shipping_quantity` DECIMAL(15,4) NULL DEFAULT NULL,
  PRIMARY KEY  (`shipping_status_id`,`language_id`),
  KEY `idx_shipping_status_name` (`shipping_status_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `specials`;
CREATE TABLE `specials` (
  `specials_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `specials_quantity` decimal(15,4) NOT NULL default '0.0000',
  `specials_new_products_price` decimal(15,4) NOT NULL default '0.0000',
  `specials_date_added` datetime default NULL,
  `specials_last_modified` datetime default NULL,
  `expires_date` datetime default NULL,
  `date_status_change` datetime default NULL,
  `status` int(1) NOT NULL default '1',
  PRIMARY KEY  (`specials_id`),
  UNIQUE KEY `products_id_2` (`products_id`),
  KEY `products_id` (`products_id`,`status`,`specials_date_added`),
  KEY `status` (`status`,`expires_date`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `tax_class`;
CREATE TABLE `tax_class` (
  `tax_class_id` int(11) NOT NULL auto_increment,
  `tax_class_title` varchar(32) NOT NULL default '',
  `tax_class_description` varchar(255) NOT NULL default '',
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tax_class_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `tax_rates`;
CREATE TABLE `tax_rates` (
  `tax_rates_id` int(11) NOT NULL auto_increment,
  `tax_zone_id` int(11) NOT NULL default '0',
  `tax_class_id` int(11) NOT NULL default '0',
  `tax_priority` int(5) default '1',
  `tax_rate` decimal(7,4) NOT NULL default '0.0000',
  `tax_description` varchar(255) NOT NULL default '',
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tax_rates_id`),
  KEY `tax_zone_id` (`tax_zone_id`),
  KEY `tax_class_id` (`tax_class_id`,`tax_priority`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `whos_online`;
CREATE TABLE `whos_online` (
  `customer_id` int(11) default NULL,
  `full_name` varchar(64) NOT NULL default '',
  `session_id` varchar(128) NOT NULL default '',
  `ip_address` varchar(15) NOT NULL default '',
  `time_entry` varchar(14) NOT NULL default '',
  `time_last_click` varchar(14) NOT NULL default '',
  `last_page_url` varchar(255) NOT NULL default '',
  KEY `customer_id` (`customer_id`),
  KEY `session_id` (`session_id`),
  KEY `time_last_click` (`time_last_click`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `zones`;
CREATE TABLE `zones` (
  `zone_id` int(11) NOT NULL auto_increment,
  `zone_country_id` int(11) NOT NULL default '0',
  `zone_code` varchar(32) NOT NULL default '',
  `zone_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`zone_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `zones_to_geo_zones`;
CREATE TABLE `zones_to_geo_zones` (
  `association_id` int(11) NOT NULL auto_increment,
  `zone_country_id` int(11) NOT NULL default '0',
  `zone_id` int(11) default NULL,
  `geo_zone_id` int(11) default NULL,
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`association_id`),
  KEY `zone_id` (`zone_id`),
  KEY `geo_zone_id` (`geo_zone_id`, `zone_country_id`),
  KEY `zone_country_id` (`zone_country_id`,`zone_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `gm_gprint_cart_elements`;
CREATE TABLE `gm_gprint_cart_elements` (
  `gm_gprint_cart_elements_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_elements_id` int(10) unsigned default NULL,
  `products_id` tinytext,
  `customers_id` int(10) unsigned default NULL,
  `elements_value` text,
  `gm_gprint_uploads_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`gm_gprint_cart_elements_id`),
  UNIQUE KEY `gm_gprint_uploads_id` (`gm_gprint_uploads_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_elements`;
CREATE TABLE `gm_gprint_elements` (
  `gm_gprint_elements_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_elements_groups_id` int(10) unsigned NOT NULL,
  `gm_gprint_surfaces_id` int(10) unsigned NOT NULL,
  `position_x` int(10) NOT NULL default '0',
  `position_y` int(10) NOT NULL default '0',
  `height` int(10) unsigned NOT NULL default '0',
  `width` int(10) unsigned NOT NULL default '0',
  `z_index` int(10) NOT NULL default '0',
  `max_characters` int(10) NOT NULL default '0',
  `allowed_extensions` VARCHAR( 255 ) NOT NULL default '',
  `show_name` tinyint(1) unsigned NOT NULL default '0',
  `minimum_filesize` decimal(7,4) NOT NULL default '0.0000',
  `maximum_filesize` decimal(7,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`gm_gprint_elements_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_elements_groups`;
CREATE TABLE `gm_gprint_elements_groups` (
  `gm_gprint_elements_groups_id` int(10) unsigned NOT NULL auto_increment,
  `group_type` varchar(255) default NULL,
  `group_name` varchar(255) default NULL,
  PRIMARY KEY  (`gm_gprint_elements_groups_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_elements_values`;
CREATE TABLE `gm_gprint_elements_values` (
  `gm_gprint_elements_values_id` int(10) unsigned NOT NULL auto_increment,
  `languages_id` int(10) unsigned NOT NULL,
  `gm_gprint_elements_groups_id` int(10) unsigned NOT NULL,
  `name` varchar(255) default NULL,
  `elements_value` text,
  PRIMARY KEY  (`gm_gprint_elements_values_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_orders_elements`;
CREATE TABLE `gm_gprint_orders_elements` (
  `gm_gprint_orders_elements_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_orders_surfaces_id` int(10) unsigned NOT NULL,
  `position_x` int(10) NOT NULL default '0',
  `position_y` int(10) NOT NULL default '0',
  `height` int(10) unsigned NOT NULL default '0',
  `width` int(10) unsigned NOT NULL default '0',
  `z_index` int(10) NOT NULL default '0',
  `show_name` tinyint(1) unsigned NOT NULL default '0',
  `group_type` varchar(255) default NULL,
  `name` varchar(255) default NULL,
  `elements_value` text,
  `gm_gprint_uploads_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`gm_gprint_orders_elements_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_orders_surfaces`;
CREATE TABLE `gm_gprint_orders_surfaces` (
  `gm_gprint_orders_surfaces_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_orders_surfaces_groups_id` int(10) unsigned NOT NULL,
  `name` varchar(255) default NULL,
  `width` int(10) unsigned NOT NULL,
  `height` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`gm_gprint_orders_surfaces_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_orders_surfaces_groups`;
CREATE TABLE `gm_gprint_orders_surfaces_groups` (
  `gm_gprint_orders_surfaces_groups_id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `orders_products_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`gm_gprint_orders_surfaces_groups_id`),
  UNIQUE KEY `orders_products_id` (`orders_products_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_surfaces`;
CREATE TABLE `gm_gprint_surfaces` (
  `gm_gprint_surfaces_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_surfaces_groups_id` int(10) unsigned NOT NULL,
  `width` int(10) unsigned NOT NULL,
  `height` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`gm_gprint_surfaces_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_surfaces_description`;
CREATE TABLE `gm_gprint_surfaces_description` (
  `gm_gprint_surfaces_id` int(10) unsigned NOT NULL,
  `languages_id` int(10) unsigned NOT NULL,
  `name` varchar(255) default NULL,
  PRIMARY KEY  (`gm_gprint_surfaces_id`,`languages_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_surfaces_groups`;
CREATE TABLE `gm_gprint_surfaces_groups` (
  `gm_gprint_surfaces_groups_id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  PRIMARY KEY  (`gm_gprint_surfaces_groups_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_surfaces_groups_to_products`;
CREATE TABLE `gm_gprint_surfaces_groups_to_products` (
  `gm_gprint_surfaces_groups_id` int(10) unsigned NOT NULL,
  `products_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`gm_gprint_surfaces_groups_id`,`products_id`),
  UNIQUE KEY `products_id` (`products_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_uploads`;
CREATE TABLE `gm_gprint_uploads` (
  `gm_gprint_uploads_id` int(11) NOT NULL auto_increment,
  `datetime` datetime NOT NULL,
  `customers_id` int(10) unsigned default NULL,
  `filename` varchar(255) NOT NULL,
  `encrypted_filename` varchar(255) NOT NULL,
  `download_key` varchar(32) NOT NULL,
  `ip_hash` varchar(32) NOT NULL,
  PRIMARY KEY  (`gm_gprint_uploads_id`),
  UNIQUE KEY `encrypted_filename` (`encrypted_filename`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_gprint_wishlist_elements`;
CREATE TABLE `gm_gprint_wishlist_elements` (
  `gm_gprint_wishlist_elements_id` int(10) unsigned NOT NULL auto_increment,
  `gm_gprint_elements_id` int(10) unsigned default NULL,
  `products_id` tinytext,
  `customers_id` int(10) unsigned default NULL,
  `elements_value` text,
  `gm_gprint_uploads_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`gm_gprint_wishlist_elements_id`),
  UNIQUE KEY `gm_gprint_uploads_id` (`gm_gprint_uploads_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `gm_boxes_area`;
CREATE TABLE IF NOT EXISTS `gm_boxes_area` (
  `boxes_area_id` int(10) unsigned NOT NULL auto_increment,
  `boxes_id` int(11) NOT NULL,
  `area` varchar(32) NOT NULL,
  PRIMARY KEY  (`boxes_area_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_products_quantity_units` ;
CREATE TABLE `orders_products_quantity_units` (
`orders_products_id` INT NOT NULL ,
`quantity_unit_id` INT NOT NULL ,
`unit_name` VARCHAR( 45 ) NOT NULL ,
PRIMARY KEY ( `orders_products_id` )
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `quantity_unit` ;
CREATE  TABLE IF NOT EXISTS `quantity_unit` (
  `quantity_unit_id` INT NOT NULL AUTO_INCREMENT ,
  PRIMARY KEY (`quantity_unit_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `quantity_unit_description` ;
CREATE  TABLE IF NOT EXISTS `quantity_unit_description` (
  `quantity_unit_id` INT NOT NULL ,
  `language_id` INT NOT NULL ,
  `unit_name` VARCHAR(45) NOT NULL ,
  PRIMARY KEY (`quantity_unit_id`, `language_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_quantity_unit` ;
CREATE  TABLE IF NOT EXISTS `products_quantity_unit` (
  `products_id` INT NOT NULL ,
  `quantity_unit_id` INT NOT NULL ,
  PRIMARY KEY (`products_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `slider_set` ;
CREATE  TABLE IF NOT EXISTS `slider_set` (
  `slider_set_id` INT NOT NULL AUTO_INCREMENT ,
  `set_name` VARCHAR(255) NULL ,
  `slider_speed` INT NULL ,
  `width` int(10) unsigned NOT NULL default '760',
  `height` int(10) unsigned NOT NULL default '300',
  PRIMARY KEY (`slider_set_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `slider_image` ;
CREATE  TABLE IF NOT EXISTS `slider_image` (
  `slider_image_id` INT NOT NULL AUTO_INCREMENT ,
  `slider_set_id` INT NOT NULL ,
  `sort_order` INT NULL ,
  `image_file` VARCHAR(45) NULL ,
  `image_preview_file` VARCHAR(45) NULL ,
  `link_url` VARCHAR(255) NULL ,
  `link_window_target` VARCHAR(45) NULL ,
  PRIMARY KEY (`slider_image_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `slider_image_area`;
CREATE TABLE IF NOT EXISTS `slider_image_area` (
  `slider_image_area_id` int(11) NOT NULL auto_increment,
  `slider_image_id` int(11) NOT NULL,
  `shape` varchar(16) default NULL,
  `coords` varchar(255) default NULL,
  `title` varchar(255) default NULL,
  `link_url` varchar(255) default NULL,
  `link_target` varchar(16) default NULL,
  `flyover_content` TEXT default NULL,
  PRIMARY KEY  (`slider_image_area_id`),
  KEY `fk_slider_image_maparea_slider_image1` (`slider_image_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `category_slider_set` ;
CREATE  TABLE IF NOT EXISTS `category_slider_set` (
  `category_id` INT NOT NULL ,
  `category_slider_set_id` INT NOT NULL ,
  PRIMARY KEY (`category_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `slider_image_description` ;
CREATE  TABLE IF NOT EXISTS `slider_image_description` (
  `slider_image_id` INT NOT NULL ,
  `language_id` INT NOT NULL ,
  `image_title` VARCHAR(255) NULL ,
  `image_alt_text` VARCHAR(255) NULL ,
  PRIMARY KEY (`language_id`, `slider_image_id`) )
ENGINE=MyISAM ;

DROP TABLE IF EXISTS `content_slider_set` ;
CREATE  TABLE IF NOT EXISTS`content_slider_set` (
  `content_slider_set_id` INT NOT NULL AUTO_INCREMENT ,
  `slider_set_id` INT NOT NULL ,
  PRIMARY KEY (`content_slider_set_id`) ,
  INDEX `fk_content_slider_set_slider_set1` (`slider_set_id` ASC)
)
ENGINE = MyISAM;

DROP TABLE IF EXISTS `products_slider_set` ;
CREATE  TABLE IF NOT EXISTS`products_slider_set` (
  `products_slider_set_id` INT NOT NULL AUTO_INCREMENT ,
  `slider_set_id` INT NOT NULL ,
  PRIMARY KEY (`products_slider_set_id`) ,
  INDEX `fk_products_slider_set_slider_set1` (`slider_set_id` ASC)
)
ENGINE = MyISAM;

DROP TABLE IF EXISTS `orders_products_properties`;
CREATE TABLE IF NOT EXISTS `orders_products_properties` (
  `orders_products_properties_id` int(10) unsigned NOT NULL auto_increment,
  `orders_products_id` int(10) unsigned default NULL,
  `products_properties_combis_id` int(10) unsigned default NULL,
  `properties_name` varchar(255) NOT NULL,
  `values_name` varchar(255) NOT NULL,
  `properties_price_type` varchar(8) NOT NULL,
  `properties_price` decimal(16,4) NOT NULL,
  PRIMARY KEY  (`orders_products_properties_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_properties_admin_select`;
CREATE TABLE  `products_properties_admin_select` (
  `products_properties_admin_select_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL,
  `properties_id` int(11) NOT NULL,
  `properties_values_id` int(11) NOT NULL,
  PRIMARY KEY  (`products_properties_admin_select_id`),
  KEY `products_id` (`products_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_properties_combis`;
CREATE TABLE `products_properties_combis` (
  `products_properties_combis_id` int(10) unsigned NOT NULL auto_increment,
  `products_id` int(10) unsigned NOT NULL,
  `sort_order` int(10) unsigned NOT NULL,
  `combi_model` varchar(64) NOT NULL,
  `combi_quantity_type` enum('','plus','minus','fix') NULL,
  `combi_quantity` int(10) unsigned NOT NULL,
  `combi_shipping_status_id` int(11) NOT NULL,
  `combi_weight` decimal(15,4) NOT NULL,
  `combi_price_type` enum('plus','minus','fix') NOT NULL,
  `combi_price` decimal(15,4) NOT NULL,
  `combi_image` varchar(255) NOT NULL,
  `products_vpe_id` int(11) NOT NULL,
  `vpe_value` decimal(16,4) NOT NULL,
  PRIMARY KEY  (`products_properties_combis_id`),
  KEY `products_properties_combis_id` (`products_properties_combis_id`,`products_id`,`sort_order`),
  KEY `products_id` (`products_id`,`sort_order`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_properties_combis_values`;
CREATE TABLE `products_properties_combis_values` (
  `products_properties_combis_values_id` int(10) unsigned NOT NULL auto_increment,
  `products_properties_combis_id` int(10) unsigned NOT NULL,
  `properties_values_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`products_properties_combis_values_id`),
  KEY `products_properties_combis_values_id` (`products_properties_combis_values_id`,`products_properties_combis_id`,`properties_values_id`),
  KEY `products_properties_combis_id` (`products_properties_combis_id`,`properties_values_id`),
  KEY `properties_values_id` (`properties_values_id`,`products_properties_combis_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_properties_index`;
CREATE TABLE IF NOT EXISTS `products_properties_index` (
  `products_id` int(10) NOT NULL,
  `language_id` int(10) NOT NULL,
  `properties_id` int(10) NOT NULL,
  `products_properties_combis_id` int(10) default '0',
  `properties_values_id` int(10) default NULL,
  `properties_name` varchar(255) default NULL,
  `properties_sort_order` int(10) NOT NULL,
  `values_name` varchar(255) default NULL,
  `value_sort_order` int(10) default NULL,
  KEY `products_id` (`products_id`,`language_id`,`products_properties_combis_id`),
  KEY `products_id_2` (`products_id`,`language_id`,`properties_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `properties`;
CREATE TABLE `properties` (
  `properties_id` int(10) unsigned NOT NULL auto_increment,
  `sort_order` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`properties_id`),
  KEY `properties_id` (`properties_id`,`sort_order`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `properties_description`;
CREATE TABLE `properties_description` (
  `properties_description_id` int(10) unsigned NOT NULL auto_increment,
  `properties_id` int(10) unsigned NOT NULL,
  `language_id` int(10) unsigned NOT NULL,
  `properties_name` varchar(255) NOT NULL,
  `properties_admin_name` varchar(255) NOT NULL,
  PRIMARY KEY  (`properties_description_id`),
  KEY `properties_id` (`properties_id`,`language_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `properties_values`;
CREATE TABLE `properties_values` (
  `properties_values_id` int(10) unsigned NOT NULL auto_increment,
  `properties_id` int(10) unsigned NOT NULL,
  `sort_order` int(10) unsigned NOT NULL,
  `value_model` varchar(64) NOT NULL,
  `value_price_type` enum('plus','minus','fix') NOT NULL,
  `value_price` decimal(9,4) NOT NULL,
  PRIMARY KEY  (`properties_values_id`),
  KEY `properties_values_id` (`properties_values_id`,`properties_id`,`sort_order`),
  KEY `properties_id` (`properties_id`,`sort_order`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `properties_values_description`;
CREATE TABLE `properties_values_description` (
  `properties_values_description_id` int(10) unsigned NOT NULL auto_increment,
  `properties_values_id` int(10) unsigned NOT NULL,
  `language_id` int(10) unsigned NOT NULL,
  `values_name` varchar(255) NOT NULL,
  `values_image` varchar(255) NOT NULL,
  PRIMARY KEY  (`properties_values_description_id`),
  KEY `properties_values_description_id` (`properties_values_description_id`,`properties_values_id`,`language_id`),
  KEY `properties_values_id` (`properties_values_id`,`language_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `categories_filter`;
CREATE TABLE IF NOT EXISTS `categories_filter` (
  `categories_id` int(11) NOT NULL,
  `feature_id` int(11) NOT NULL,
  `sort_order` int(11) default NULL,
  `selection_preview_mode` varchar(45) default NULL,
  `selection_template` varchar(45) default NULL,
  `value_conjunction` INT( 1  ) UNSIGNED NOT NULL DEFAULT '1',
  PRIMARY KEY  (`categories_id`,`feature_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature`;
CREATE TABLE IF NOT EXISTS `feature` (
  `feature_id` int(11) NOT NULL auto_increment,
  PRIMARY KEY  (`feature_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature_description`;
CREATE TABLE IF NOT EXISTS `feature_description` (
  `feature_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL,
  `feature_name` varchar(45) default NULL,
  `feature_admin_name` VARCHAR(45) NOT NULL,
  PRIMARY KEY  (`feature_id`,`language_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature_index`;
CREATE TABLE IF NOT EXISTS `feature_index` (
  `products_id` int(11) NOT NULL,
  `date_created` datetime default NULL,
  `categories_index` text,
  `feature_value_index` text,
  PRIMARY KEY  (`products_id`),
  FULLTEXT KEY `categories_index` (`categories_index`),
  FULLTEXT KEY `feature_value_index` (`feature_value_index`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature_parent`;
CREATE TABLE IF NOT EXISTS `feature_parent` (
  `feature_value_id` int(11) NOT NULL,
  `parent_feature_value_id` int(11) NOT NULL,
  PRIMARY KEY  (`feature_value_id`,`parent_feature_value_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature_value`;
CREATE TABLE IF NOT EXISTS `feature_value` (
  `feature_value_id` int(11) NOT NULL auto_increment,
  `feature_id` int(11) default NULL,
  `sort_order` int(11) default NULL,
  PRIMARY KEY  (`feature_value_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `feature_value_description`;
CREATE TABLE IF NOT EXISTS `feature_value_description` (
  `feature_value_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL,
  `feature_value_text` varchar(45) default NULL,
  PRIMARY KEY  (`feature_value_id`,`language_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `products_feature_value`;
CREATE TABLE IF NOT EXISTS `products_feature_value` (
  `feature_value_id` int(11) NOT NULL,
  `products_id` int(11) NOT NULL,
  PRIMARY KEY  (`feature_value_id`,`products_id`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `brickfox_export`;
CREATE TABLE `brickfox_export` (
  `brickfox_export_id` int(11) NOT NULL auto_increment,
  `type` varchar(50) NOT NULL default '',
  `number_exported` int(11) NOT NULL default '0',
  `date_exported` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`brickfox_export_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `brickfox_orders`;
CREATE TABLE `brickfox_orders` (
  `brickfox_orders_id` INT(11) NOT NULL,
  `extern_orders_id` VARCHAR(255) NOT NULL,
  `intern_orders_id` INT(11) NOT NULL,
  PRIMARY KEY  (`brickfox_orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `brickfox_orders_lines`;
CREATE TABLE `brickfox_orders_lines` (
  `brickfox_orders_lines_id` INT(11) NOT NULL,
  `orders_products_id` INT(11) NOT NULL,
  PRIMARY KEY  (`brickfox_orders_lines_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `ekomi_order_information`;
CREATE TABLE `ekomi_order_information` (
  `orders_id` int(11) NOT NULL,
  `link` varchar(255) NOT NULL,
  `hash` varchar(255) NOT NULL,
  `date_sent` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`orders_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `config`;
CREATE TABLE `mf_config` (
  `config_key` varchar(255) NOT NULL,
  `config_value` varchar(255) NOT NULL,
  KEY `config_name` (`config_key`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `claims`;
CREATE TABLE `mf_claims` (
  `orderId` int(10) unsigned NOT NULL,
  `fileNumber` int(10) unsigned NOT NULL,
  `firstname` VARCHAR(100) NOT NULL,
  `lastname` VARCHAR(100) NOT NULL,
  `transmissionDate` int(10) unsigned NOT NULL,
  `statusCode` smallint(5) unsigned NOT NULL,
  `statusText` text NOT NULL,
  `statusDetails` text NOT NULL,
  `lastChange` datetime NOT NULL,
  UNIQUE KEY `orderId` (`orderId`,`fileNumber`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `errors`;
CREATE TABLE `mf_errors` (
  `errorId` smallint(5) unsigned NOT NULL auto_increment,
  `errorText` text NOT NULL,
  `customerId` int(10) unsigned NOT NULL,
  `date` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`errorId`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `mf_score_results`;
CREATE TABLE `mf_score_results` (
	`scoreId` smallint(5) unsigned NOT NULL auto_increment,
	`customerId` int(10) unsigned NOT NULL,
	`score` decimal(2,1) NOT NULL,
	`explanation` text NOT NULL,
	`lastCheck` int(10) unsigned NOT NULL,
	`negativeEntryList` text NOT NULL,
PRIMARY KEY  (`scoreId`),
UNIQUE KEY `customerId` (`customerId`)) ENGINE=MyISAM;

DROP TABLE IF EXISTS `orders_iloxxdata`;
CREATE TABLE IF NOT EXISTS `orders_iloxxdata` (
	`orders_id` INT UNSIGNED NOT NULL ,
	`parcelnumber` VARCHAR(255) NULL DEFAULT NULL ,
	`service` VARCHAR(255) NOT NULL ,
	`weight` DECIMAL(15,4) NOT NULL DEFAULT '0',
	`shipdate` DATE NULL DEFAULT NULL ,
	PRIMARY KEY (`orders_id`),
	INDEX (`parcelnumber`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `ts_certs`;
CREATE TABLE `ts_certs` (
  `tsid` varchar(33) NOT NULL,
  `language` varchar(2) NOT NULL,
  `state` enum('PRODUCTION','CANCELLED','DISABLED','INTEGRATION','TEST','INVALID_TS_ID') NOT NULL,
  `type` enum('CLASSIC','EXCELLENCE','MIGRATION') NOT NULL,
  `url` text NOT NULL,
  `user` varchar(255) NOT NULL DEFAULT '',
  `password` varchar(255) NOT NULL DEFAULT '',
  `login_ok` tinyint(1) NOT NULL DEFAULT '0',
  `rating_ok` tinyint(1) NOT NULL DEFAULT '0',
  `date_checked` datetime NOT NULL,
  PRIMARY KEY (`tsid`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `ts_items`;
CREATE TABLE `ts_items` (
  `ts_items_id` int(11) NOT NULL AUTO_INCREMENT,
  `ts_id` varchar(33) NOT NULL,
  `retrievaldate` datetime NOT NULL,
  `creationdate` datetime NOT NULL,
  `id` int(11) NOT NULL,
  `currency` varchar(3) NOT NULL,
  `grossfee` decimal(15,5) NOT NULL,
  `netfee` decimal(15,5) NOT NULL,
  `protectedamount` decimal(15,5) NOT NULL,
  `protectionduration` int(11) NOT NULL,
  `tsproductid` varchar(255) NOT NULL,
  PRIMARY KEY (`ts_items_id`),
  KEY `ts_id` (`ts_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `ts_protection`;
CREATE TABLE `ts_protection` (
  `orders_id` int(11) NOT NULL,
  `application_number` int(11) NOT NULL,
  `tsid` varchar(33) NOT NULL,
  `result` int(11) DEFAULT NULL,
  PRIMARY KEY (`orders_id`),
  KEY `application_number` (`application_number`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `personal_offers_by_customers_status_0`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_1`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_2`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_3`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_4`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_5`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_6`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_7`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_8`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_9`;
DROP TABLE IF EXISTS `personal_offers_by_customers_status_10`;

DROP TABLE IF EXISTS `module_newsletter_temp_1`;
DROP TABLE IF EXISTS `module_newsletter_temp_2`;
DROP TABLE IF EXISTS `module_newsletter_temp_3`;
DROP TABLE IF EXISTS `module_newsletter_temp_4`;
DROP TABLE IF EXISTS `module_newsletter_temp_5`;
DROP TABLE IF EXISTS `module_newsletter_temp_6`;
DROP TABLE IF EXISTS `module_newsletter_temp_7`;
DROP TABLE IF EXISTS `module_newsletter_temp_8`;
DROP TABLE IF EXISTS `module_newsletter_temp_9`;
DROP TABLE IF EXISTS `module_newsletter_temp_10`;


ALTER TABLE `content_manager` CHANGE `gm_url_keywords` `gm_url_keywords` VARCHAR( 255 ) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL;
ALTER TABLE `categories_description` CHANGE `gm_url_keywords` `gm_url_keywords` VARCHAR( 255 ) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL;
ALTER TABLE `products_description` CHANGE `gm_url_keywords` `gm_url_keywords` VARCHAR( 255 ) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL;
 

INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES(1, '$firstname $lastname$cr$streets$cr$city, $postcode$cr$statecomma$country', '$city / $country');
INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES(2, '$firstname $lastname$cr$streets$cr$city, $state    $postcode$cr$country', '$city, $state / $country');
INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES(3, '$firstname $lastname$cr$streets$cr$city$cr$postcode - $statecomma$country', '$state / $country');
INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES(4, '$firstname $lastname$cr$streets$cr$city ($postcode)$cr$country', '$postcode / $country');
INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES(5, '$firstname $lastname$cr$streets$cr$postcode $city$cr$country', '$city / $country');


INSERT INTO `admin_access` (`customers_id`, `configuration`, `modules`, `countries`, `currencies`, `zones`, `geo_zones`, `tax_classes`, `tax_rates`, `accounting`, `backup`, `cache`, `server_info`, `whos_online`, `languages`, `define_language`, `orders_status`, `shipping_status`, `module_export`, `customers`, `create_account`, `customers_status`, `orders`, `campaigns`, `print_packingslip`, `print_order`, `popup_memo`, `coupon_admin`, `listcategories`, `gv_queue`, `gv_mail`, `gv_sent`, `validproducts`, `validcategories`, `mail`, `categories`, `new_attributes`, `products_attributes`, `manufacturers`, `reviews`, `specials`, `stats_products_expected`, `stats_products_viewed`, `stats_products_purchased`, `stats_customers`, `stats_sales_report`, `stats_campaigns`, `banner_manager`, `banner_statistics`, `module_newsletter`, `start`, `content_manager`, `content_preview`, `credits`, `blacklist`, `orders_edit`, `popup_image`, `csv_backend`, `products_vpe`, `cross_sell_groups`, `fck_wrapper`, `econda`, `listproducts`, `gm_scroller`, `gm_pdf`, `gm_id_starts`, `gm_pdf_order`, `gm_pdf_action`, `gm_emails`, `gm_emails_preview`, `gm_guestbook`, `gm_counter`, `gm_counter_action`, `gm_meta`, `gm_meta_action`, `gm_analytics`, `gm_bookmarks`, `gm_bookmarks_action`, `gm_logo`, `gm_security`, `gm_style_edit`, `gm_send_order`, `gm_order_menu`, `gm_miscellaneous`, `paypal`, `gm_lang_edit`, `gm_sitemap`, `gm_sitemap_creator`, `gm_sql`, `gm_offline`, `gm_lightbox`, `gm_seo_boost`, `gm_trusted_shop_id`, `nc_clickandbuy`, `gm_opensearch`, `gm_opensearch_action`, `gm_module_export`, `gm_backup_files_zip`, `gm_janolaw`, `gm_module_part_export`, `gm_product_export`, `gm_gprint`, `gm_gprint_download`, `gm_gmotion`, `xml_export`, `gm_feature_control`, `properties`, `properties_combis`, `request_port`, `gm_slider`, `template_configuration`, `quantity_units`, `show_logs`, `robots_download`, `clear_cache`, `directory_scan`, `yoochoose`, `yatego`, `gm_invoicing`, `brickfox`, `phpminiadmin`, `minisql`, `ekomi`, `magnalister`, `mobile`, `shopgate`, `mediafinanz`, `lettr_de`, `admin_javascript`, `hermes_collection`, `hermes_list`, `hermes_info`, `hermes_order`, `hermes_config`, `iloxx`, `orders_iloxx`, `affiliprint_module`) VALUES('groups', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 2, 4, 2, 2, 2, 2, 5, 5, 5, 5, 5, 5, 5, 5, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1);
INSERT INTO `admin_access` (`customers_id`, `configuration`, `modules`, `countries`, `currencies`, `zones`, `geo_zones`, `tax_classes`, `tax_rates`, `accounting`, `backup`, `cache`, `server_info`, `whos_online`, `languages`, `define_language`, `orders_status`, `shipping_status`, `module_export`, `customers`, `create_account`, `customers_status`, `orders`, `campaigns`, `print_packingslip`, `print_order`, `popup_memo`, `coupon_admin`, `listcategories`, `gv_queue`, `gv_mail`, `gv_sent`, `validproducts`, `validcategories`, `mail`, `categories`, `new_attributes`, `products_attributes`, `manufacturers`, `reviews`, `specials`, `stats_products_expected`, `stats_products_viewed`, `stats_products_purchased`, `stats_customers`, `stats_sales_report`, `stats_campaigns`, `banner_manager`, `banner_statistics`, `module_newsletter`, `start`, `content_manager`, `content_preview`, `credits`, `blacklist`, `orders_edit`, `popup_image`, `csv_backend`, `products_vpe`, `cross_sell_groups`, `fck_wrapper`, `econda`, `listproducts`, `gm_scroller`, `gm_pdf`, `gm_id_starts`, `gm_pdf_order`, `gm_pdf_action`, `gm_emails`, `gm_emails_preview`, `gm_guestbook`, `gm_counter`, `gm_counter_action`, `gm_meta`, `gm_meta_action`, `gm_analytics`, `gm_bookmarks`, `gm_bookmarks_action`, `gm_logo`, `gm_security`, `gm_style_edit`, `gm_send_order`, `gm_order_menu`, `gm_miscellaneous`, `paypal`, `gm_lang_edit`, `gm_sitemap`, `gm_sitemap_creator`, `gm_sql`, `gm_offline`, `gm_lightbox`, `gm_seo_boost`, `gm_trusted_shop_id`, `nc_clickandbuy`, `gm_opensearch`, `gm_opensearch_action`, `gm_module_export`, `gm_backup_files_zip`, `gm_janolaw`, `gm_module_part_export`, `gm_product_export`, `gm_gprint`, `gm_gprint_download`, `gm_gmotion`, `xml_export`, `gm_feature_control`, `properties`, `properties_combis`, `request_port`, `gm_slider`, `template_configuration`, `quantity_units`, `show_logs`, `robots_download`, `clear_cache`, `directory_scan`, `yoochoose`, `yatego`, `gm_invoicing`, `brickfox`, `phpminiadmin`, `minisql`, `ekomi`, `magnalister`, `mobile`, `shopgate`, `mediafinanz`, `lettr_de`, `admin_javascript`, `hermes_collection`, `hermes_list`, `hermes_info`, `hermes_order`, `hermes_config`, `iloxx`, `orders_iloxx`, `affiliprint_module`) VALUES('1', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1);


INSERT INTO `categories` (`categories_id`, `categories_image`, `parent_id`, `categories_status`, `categories_template`, `group_permission_0`, `group_permission_1`, `group_permission_2`, `group_permission_3`, `listing_template`, `sort_order`, `products_sorting`, `products_sorting2`, `date_added`, `last_modified`, `categories_icon`, `categories_icon_w`, `categories_icon_h`, `group_ids`, `gm_show_attributes`, `gm_show_graduated_prices`, `gm_show_qty`, `gm_priority`, `gm_changefreq`, `gm_sitemap_entry`, `gm_show_qty_info`) VALUES(1, '', 0, 1, 'categorie_listing.html', 0, 0, 0, 0, 'product_listing_v1.html', 0, 'p.products_price', 'ASC', '2008-08-08 17:16:41', '2008-08-25 17:33:52', 'item_ltr.gif', 5, 13, '', 0, 0, 1, '0.5', 'daily', 1, 0);


INSERT INTO `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `categories_meta_title`, `categories_meta_description`, `categories_meta_keywords`, `gm_alt_text`, `gm_url_keywords`) VALUES(1, 1, 'test category', 'test category', '<p>test category description</p>', '', '', '', '', 'test-category');
INSERT INTO `categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`, `categories_meta_title`, `categories_meta_description`, `categories_meta_keywords`, `gm_alt_text`, `gm_url_keywords`) VALUES(1, 2, 'Testkategorie', 'Testkategorie', '<p>Testkategorie Beschreibung</p>', '', '', '', '', 'Testkategorie');


INSERT INTO `cm_file_flags` (`file_flag`, `file_flag_name`) VALUES(0, 'information');
INSERT INTO `cm_file_flags` (`file_flag`, `file_flag_name`) VALUES(1, 'content');
INSERT INTO `cm_file_flags` (`file_flag`, `file_flag_name`) VALUES(2, 'topmenu_corner');
INSERT INTO `cm_file_flags` (`file_flag`, `file_flag_name`) VALUES(3, 'topmenu');
INSERT INTO `cm_file_flags` (`file_flag`, `file_flag_name`) VALUES(4, 'extraboxes');


INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(1, 'STORE_NAME', 'Shopname', 1, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2, 'STORE_OWNER', 'Shopbetreiber', 1, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(3, 'STORE_OWNER_EMAIL_ADDRESS', '', 1, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(4, 'EMAIL_FROM', '', 1, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(5, 'STORE_COUNTRY', '81', 1, 6, NULL, '0000-00-00 00:00:00', 'xtc_get_country_name', 'xtc_cfg_pull_down_country_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(6, 'STORE_ZONE', '88', 1, 7, NULL, '0000-00-00 00:00:00', 'xtc_cfg_get_zone_name', 'xtc_cfg_pull_down_zone_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(7, 'EXPECTED_PRODUCTS_SORT', 'asc', 1, 8, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''asc'', ''desc''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(8, 'EXPECTED_PRODUCTS_FIELD', 'date_expected', 1, 9, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''products_name'', ''date_expected''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(9, 'USE_DEFAULT_LANGUAGE_CURRENCY', 'false', 1, 10, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(11, 'DISPLAY_CART', 'true', 1, 13, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(12, 'ADVANCED_SEARCH_DEFAULT_OPERATOR', 'and', 1, 15, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''and'', ''or''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(13, 'STORE_NAME_ADDRESS', '', 1, 16, NULL, '0000-00-00 00:00:00', NULL, 'xtc_cfg_textarea(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(14, 'SHOW_COUNTS', 'false', 1, 17, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(15, 'DEFAULT_CUSTOMERS_STATUS_ID_ADMIN', '0', 1, 20, NULL, '0000-00-00 00:00:00', 'xtc_get_customers_status_name', 'xtc_cfg_pull_down_customers_status_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(16, 'DEFAULT_CUSTOMERS_STATUS_ID_GUEST', '1', 1, 21, NULL, '0000-00-00 00:00:00', 'xtc_get_customers_status_name', 'xtc_cfg_pull_down_customers_status_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(17, 'DEFAULT_CUSTOMERS_STATUS_ID', '2', 1, 23, NULL, '0000-00-00 00:00:00', 'xtc_get_customers_status_name', 'xtc_cfg_pull_down_default_customers_status_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(18, 'ALLOW_ADD_TO_CART', 'false', 1, 24, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(19, 'CURRENT_TEMPLATE', 'EyeCandy', 1, 26, NULL, '0000-00-00 00:00:00', NULL, 'xtc_cfg_pull_down_template_sets(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(20, 'PRICE_IS_BRUTTO', 'true', 1, 27, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(21, 'PRICE_PRECISION', '4', 1, 28, NULL, '0000-00-00 00:00:00', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(22, 'CC_KEYCHAIN', 'tobechanged', 1, 29, NULL, '0000-00-00 00:00:00', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(23, 'ENTRY_FIRST_NAME_MIN_LENGTH', '2', 2, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(24, 'ENTRY_LAST_NAME_MIN_LENGTH', '2', 2, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(25, 'ENTRY_DOB_MIN_LENGTH', '10', 2, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(26, 'ENTRY_EMAIL_ADDRESS_MIN_LENGTH', '6', 2, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(27, 'ENTRY_STREET_ADDRESS_MIN_LENGTH', '5', 2, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(28, 'ENTRY_COMPANY_MIN_LENGTH', '2', 2, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(29, 'ENTRY_POSTCODE_MIN_LENGTH', '4', 2, 7, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(30, 'ENTRY_CITY_MIN_LENGTH', '2', 2, 8, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(31, 'ENTRY_STATE_MIN_LENGTH', '2', 2, 9, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(32, 'ENTRY_TELEPHONE_MIN_LENGTH', '0', 2, 10, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(33, 'ENTRY_PASSWORD_MIN_LENGTH', '5', 2, 11, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(34, 'CC_OWNER_MIN_LENGTH', '3', 2, 12, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(35, 'CC_NUMBER_MIN_LENGTH', '10', 2, 13, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(36, 'REVIEW_TEXT_MIN_LENGTH', '50', 2, 14, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(37, 'MIN_DISPLAY_BESTSELLERS', '1', 2, 15, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(38, 'MIN_DISPLAY_ALSO_PURCHASED', '1', 2, 16, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(39, 'MAX_ADDRESS_BOOK_ENTRIES', '5', 3, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(40, 'MAX_DISPLAY_SEARCH_RESULTS', '8', 3, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(41, 'MAX_DISPLAY_PAGE_LINKS', '4', 3, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(42, 'MAX_DISPLAY_SPECIAL_PRODUCTS', '8', 3, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(44, 'MAX_DISPLAY_UPCOMING_PRODUCTS', '0', 3, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(45, 'MAX_DISPLAY_MANUFACTURERS_IN_A_LIST', '1', 3, 7, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(46, 'MAX_MANUFACTURERS_LIST', '1', 3, 7, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(47, 'MAX_DISPLAY_MANUFACTURER_NAME_LEN', '15', 3, 8, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(48, 'MAX_DISPLAY_NEW_REVIEWS', '6', 3, 9, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(49, 'MAX_RANDOM_SELECT_REVIEWS', '10', 3, 10, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(50, 'MAX_RANDOM_SELECT_NEW', '30', 3, 11, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(51, 'MAX_RANDOM_SELECT_SPECIALS', '10', 3, 12, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(52, 'MAX_DISPLAY_CATEGORIES_PER_ROW', '2', 3, 13, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(53, 'MAX_DISPLAY_PRODUCTS_NEW', '10', 3, 14, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(54, 'MAX_DISPLAY_BESTSELLERS', '5', 3, 15, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(55, 'MAX_DISPLAY_ALSO_PURCHASED', '4', 3, 16, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(56, 'MAX_DISPLAY_PRODUCTS_IN_ORDER_HISTORY_BOX', '6', 3, 17, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(57, 'MAX_DISPLAY_ORDER_HISTORY', '5', 3, 18, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(58, 'PRODUCT_REVIEWS_VIEW', '5', 3, 19, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(59, 'MAX_PRODUCTS_QTY', '1000000', 3, 21, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(60, 'MAX_DISPLAY_NEW_PRODUCTS_DAYS', '30', 3, 22, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(61, 'CONFIG_CALCULATE_IMAGE_SIZE', 'true', 4, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(62, 'IMAGE_QUALITY', '100', 4, 2, '2003-12-15 12:10:45', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(63, 'PRODUCT_IMAGE_THUMBNAIL_WIDTH', '150', 4, 7, '2003-12-15 12:10:45', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(64, 'PRODUCT_IMAGE_THUMBNAIL_HEIGHT', '130', 4, 8, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(65, 'PRODUCT_IMAGE_INFO_WIDTH', '369', 4, 9, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(66, 'PRODUCT_IMAGE_INFO_HEIGHT', '350', 4, 10, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(67, 'PRODUCT_IMAGE_POPUP_WIDTH', '600', 4, 11, '2003-12-15 12:11:00', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(68, 'PRODUCT_IMAGE_POPUP_HEIGHT', '600', 4, 12, '2003-12-15 12:11:09', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(69, 'PRODUCT_IMAGE_THUMBNAIL_BEVEL', '', 4, 13, '2003-12-15 13:14:39', '0000-00-00 00:00:00', '', '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(70, 'PRODUCT_IMAGE_THUMBNAIL_GREYSCALE', '', 4, 14, '2003-12-15 13:13:37', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(71, 'PRODUCT_IMAGE_THUMBNAIL_ELLIPSE', '', 4, 15, '2003-12-15 13:14:57', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(72, 'PRODUCT_IMAGE_THUMBNAIL_ROUND_EDGES', '', 4, 16, '2003-12-15 13:19:45', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(73, 'PRODUCT_IMAGE_THUMBNAIL_MERGE', '', 4, 17, '2003-12-15 12:01:43', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(74, 'PRODUCT_IMAGE_THUMBNAIL_FRAME', '', 4, 18, '2003-12-15 13:19:37', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(75, 'PRODUCT_IMAGE_THUMBNAIL_DROP_SHADDOW', '', 4, 19, '2003-12-15 13:15:14', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(76, 'PRODUCT_IMAGE_THUMBNAIL_MOTION_BLUR', '', 4, 20, '2003-12-15 12:02:19', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(77, 'PRODUCT_IMAGE_INFO_BEVEL', '', 4, 21, '2003-12-15 13:42:09', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(78, 'PRODUCT_IMAGE_INFO_GREYSCALE', '', 4, 22, '2003-12-15 13:18:00', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(79, 'PRODUCT_IMAGE_INFO_ELLIPSE', '', 4, 23, '2003-12-15 13:41:53', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(80, 'PRODUCT_IMAGE_INFO_ROUND_EDGES', '', 4, 24, '2003-12-15 13:21:55', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(81, 'PRODUCT_IMAGE_INFO_MERGE', '', 4, 25, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(82, 'PRODUCT_IMAGE_INFO_FRAME', '', 4, 26, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(83, 'PRODUCT_IMAGE_INFO_DROP_SHADDOW', '', 4, 27, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(84, 'PRODUCT_IMAGE_INFO_MOTION_BLUR', '', 4, 28, '2003-12-15 13:21:18', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(85, 'PRODUCT_IMAGE_POPUP_BEVEL', '', 4, 29, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(86, 'PRODUCT_IMAGE_POPUP_GREYSCALE', '', 4, 30, '2003-12-15 13:22:58', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(87, 'PRODUCT_IMAGE_POPUP_ELLIPSE', '', 4, 31, '2003-12-15 13:22:51', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(88, 'PRODUCT_IMAGE_POPUP_ROUND_EDGES', '', 4, 32, '2003-12-15 13:23:17', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(89, 'PRODUCT_IMAGE_POPUP_MERGE', '', 4, 33, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(90, 'PRODUCT_IMAGE_POPUP_FRAME', '', 4, 34, '2003-12-15 13:22:43', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(91, 'PRODUCT_IMAGE_POPUP_DROP_SHADDOW', '', 4, 35, '2003-12-15 13:22:26', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(92, 'PRODUCT_IMAGE_POPUP_MOTION_BLUR', '', 4, 36, '2003-12-15 13:22:32', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(93, 'MO_PICS', '3', 4, 3, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(94, 'IMAGE_MANIPULATOR', 'image_manipulator_GD2.php', 4, 3, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'xtc_cfg_select_option(array(''image_manipulator_GD2.php'', ''image_manipulator_GD1.php''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(95, 'ACCOUNT_GENDER', 'true', 5, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(96, 'ACCOUNT_DOB', 'false', 5, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(97, 'ACCOUNT_COMPANY', 'true', 5, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(98, 'ACCOUNT_SUBURB', 'false', 5, 4, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(99, 'ACCOUNT_STATE', 'false', 5, 5, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(100, 'ACCOUNT_OPTIONS', 'both', 5, 6, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''account'', ''guest'', ''both''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(101, 'DELETE_GUEST_ACCOUNT', 'true', 5, 7, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(102, 'MODULE_PAYMENT_INSTALLED', '', 6, 0, '2008-08-25 17:50:17', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(103, 'MODULE_ORDER_TOTAL_INSTALLED', 'ot_subtotal.php;ot_discount.php;ot_coupon.php;ot_shipping.php;ot_cod_fee.php;ot_gv.php;ot_subtotal_no_tax.php;ot_tax.php;ot_total_netto.php;ot_total.php', 6, 0, '2008-08-25 16:49:22', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2064, 'MODULE_ORDER_TOTAL_SUBTOTAL_STATUS', 'true', 6, 1, NULL, '2008-08-11 16:22:38', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(104, 'MODULE_SHIPPING_INSTALLED', '', 6, 0, '2008-08-25 17:50:34', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(105, 'DEFAULT_CURRENCY', 'EUR', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(106, 'DEFAULT_LANGUAGE', 'de', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(107, 'DEFAULT_ORDERS_STATUS_ID', '1', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(108, 'DEFAULT_PRODUCTS_VPE_ID', '', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(109, 'DEFAULT_SHIPPING_STATUS_ID', '1', 6, 0, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(125, 'SHIPPING_ORIGIN_COUNTRY', '81', 7, 1, NULL, '0000-00-00 00:00:00', 'xtc_get_country_name', 'xtc_cfg_pull_down_country_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(126, 'SHIPPING_ORIGIN_ZIP', '12345', 7, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(127, 'SHIPPING_MAX_WEIGHT', '50', 7, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(128, 'SHIPPING_BOX_WEIGHT', '0', 7, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(129, 'SHIPPING_BOX_PADDING', '0', 7, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(130, 'SHOW_SHIPPING', 'true', 7, 6, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(131, 'SHIPPING_INFOS', '1', 7, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2655, 'SHOW_CART_SHIPPING_COSTS', 'true', 7, 8, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(132, 'PRODUCT_LIST_FILTER', '1', 8, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(133, 'STOCK_CHECK', 'true', 9, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(134, 'ATTRIBUTE_STOCK_CHECK', 'true', 9, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(135, 'STOCK_LIMITED', 'true', 9, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(136, 'STOCK_ALLOW_CHECKOUT', 'true', 9, 4, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(137, 'STOCK_MARK_PRODUCT_OUT_OF_STOCK', '***', 9, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(138, 'STOCK_REORDER_LEVEL', '5', 9, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(139, 'STORE_PAGE_PARSE_TIME', 'false', 10, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(140, 'STORE_PAGE_PARSE_TIME_LOG', '/tmp/', 10, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(141, 'STORE_PARSE_DATE_TIME_FORMAT', '%d/%m/%Y %H:%M:%S', 10, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(142, 'DISPLAY_PAGE_PARSE_TIME', 'false', 10, 4, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(143, 'STORE_DB_TRANSACTIONS', 'false', 10, 8, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(144, 'USE_CACHE', 'false', 11, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(145, 'DIR_FS_CACHE', 'cache', 11, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(146, 'CACHE_LIFETIME', '3600', 11, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(147, 'CACHE_CHECK', 'false', 11, 4, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(148, 'DB_CACHE', 'false', 11, 5, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(149, 'DB_CACHE_EXPIRE', '3600', 11, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(150, 'EMAIL_TRANSPORT', 'mail', 12, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''sendmail'', ''smtp'', ''mail''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(151, 'SENDMAIL_PATH', '/usr/sbin/sendmail', 12, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(152, 'SMTP_MAIN_SERVER', 'localhost', 12, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(153, 'SMTP_Backup_Server', 'localhost', 12, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(154, 'SMTP_PORT', '25', 12, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(155, 'SMTP_USERNAME', 'Please Enter', 12, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(156, 'SMTP_PASSWORD', 'Please Enter', 12, 7, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(157, 'SMTP_AUTH', 'false', 12, 8, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(158, 'EMAIL_LINEFEED', 'LF', 12, 9, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''LF'', ''CRLF''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(159, 'EMAIL_USE_HTML', 'true', 12, 10, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(160, 'ENTRY_EMAIL_ADDRESS_CHECK', 'false', 12, 11, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(161, 'SEND_EMAILS', 'true', 12, 12, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(162, 'CONTACT_US_EMAIL_ADDRESS', '', 12, 20, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(163, 'CONTACT_US_NAME', 'Ihr Name', 12, 21, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(164, 'CONTACT_US_REPLY_ADDRESS', '', 12, 22, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(165, 'CONTACT_US_REPLY_ADDRESS_NAME', 'Ihr Name', 12, 23, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(166, 'CONTACT_US_EMAIL_SUBJECT', 'Kontakt', 12, 24, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(167, 'CONTACT_US_FORWARDING_STRING', '', 12, 25, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(168, 'EMAIL_SUPPORT_ADDRESS', '', 12, 26, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(169, 'EMAIL_SUPPORT_NAME', 'Ihr Name', 12, 27, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(170, 'EMAIL_SUPPORT_REPLY_ADDRESS', '', 12, 28, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(171, 'EMAIL_SUPPORT_REPLY_ADDRESS_NAME', 'Ihr Name', 12, 29, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(172, 'EMAIL_SUPPORT_SUBJECT', 'Technischer Support', 12, 30, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(173, 'EMAIL_SUPPORT_FORWARDING_STRING', '', 12, 31, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(174, 'EMAIL_BILLING_ADDRESS', '', 12, 32, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(175, 'EMAIL_BILLING_NAME', 'Ihr Name', 12, 33, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(176, 'EMAIL_BILLING_REPLY_ADDRESS', '', 12, 34, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(177, 'EMAIL_BILLING_REPLY_ADDRESS_NAME', 'Ihr Name', 12, 35, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(178, 'EMAIL_BILLING_SUBJECT', 'Verrechnung', 12, 36, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(179, 'EMAIL_BILLING_FORWARDING_STRING', '', 12, 37, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(180, 'EMAIL_BILLING_SUBJECT_ORDER', 'Ihre Bestellung {$nr}, am {$date}', 12, 38, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(181, 'DOWNLOAD_ENABLED', 'true', 13, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(182, 'DOWNLOAD_BY_REDIRECT', 'false', 13, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(183, 'DOWNLOAD_UNALLOWED_PAYMENT', 'banktransfer,cod,invoice,moneyorder', 13, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(184, 'DOWNLOAD_MIN_ORDERS_STATUS', '3', 13, 5, NULL, '0000-00-00 00:00:00', NULL, 'cfg_download_order_status_checkboxes(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(185, 'GZIP_COMPRESSION', 'true', 14, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(186, 'GZIP_LEVEL', '9', 14, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(187, 'SESSION_WRITE_DIRECTORY', '/tmp/', 15, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(188, 'SESSION_FORCE_COOKIE_USE', 'False', 15, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(189, 'SESSION_CHECK_SSL_SESSION_ID', 'False', 15, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(190, 'SESSION_CHECK_USER_AGENT', 'False', 15, 4, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(191, 'SESSION_CHECK_IP_ADDRESS', 'False', 15, 5, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(192, 'SESSION_RECREATE', 'False', 15, 7, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(204, 'CHECK_CLIENT_AGENT', 'true', 16, 13, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(205, 'USE_WYSIWYG', 'true', 17, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(206, 'ACTIVATE_GIFT_SYSTEM', 'false', 17, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(207, 'SECURITY_CODE_LENGTH', '10', 17, 3, NULL, '2003-12-05 05:01:41', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(208, 'NEW_SIGNUP_GIFT_VOUCHER_AMOUNT', '', 17, 4, NULL, '2003-12-05 05:01:41', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(209, 'NEW_SIGNUP_DISCOUNT_COUPON', '', 17, 5, NULL, '2003-12-05 05:01:41', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(210, 'ACTIVATE_SHIPPING_STATUS', 'true', 17, 6, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(213, 'GROUP_CHECK', 'false', 17, 9, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(214, 'ACTIVATE_NAVIGATOR', 'false', 17, 10, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(215, 'QUICKLINK_ACTIVATED', 'true', 17, 11, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(216, 'ACTIVATE_REVERSE_CROSS_SELLING', 'true', 17, 12, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(219, 'ACCOUNT_COMPANY_VAT_CHECK', 'true', 18, 4, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(221, 'DEFAULT_CUSTOMERS_VAT_STATUS_ID', '3', 18, 23, '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'xtc_get_customers_status_name', 'xtc_cfg_pull_down_default_customers_status_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(222, 'ACCOUNT_COMPANY_VAT_LIVE_CHECK', 'true', 18, 4, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(223, 'ACCOUNT_COMPANY_VAT_GROUP', 'false', 18, 4, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(224, 'ACCOUNT_VAT_BLOCK_ERROR', 'true', 18, 4, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(225, 'DEFAULT_CUSTOMERS_VAT_STATUS_ID_LOCAL', '3', 18, 24, NULL, '0000-00-00 00:00:00', 'xtc_get_customers_status_name', 'xtc_cfg_pull_down_default_customers_status_list(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(226, 'GOOGLE_CONVERSION_ID', '', 19, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(227, 'GOOGLE_LANG', 'de', 19, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(228, 'GOOGLE_CONVERSION', 'false', 19, 0, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(229, 'CSV_TEXTSIGN', '', 20, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(230, 'CSV_SEPERATOR', '|', 20, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(231, 'COMPRESS_EXPORT', 'false', 20, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(232, 'AFTERBUY_PARTNERID', '', 21, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(233, 'AFTERBUY_PARTNERPASS', '', 21, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(234, 'AFTERBUY_USERID', '', 21, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(235, 'AFTERBUY_ORDERSTATUS', '1', 21, 5, NULL, '0000-00-00 00:00:00', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(236, 'AFTERBUY_ACTIVATED', 'false', 21, 6, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(237, 'SEARCH_IN_DESC', 'true', 22, 2, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(238, 'SEARCH_IN_ATTR', 'true', 22, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(239, 'TRACKING_ECONDA_ACTIVE', 'false', 23, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(240, 'TRACKING_ECONDA_ID', '', 23, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(241, 'MODULE_EXPORT_INSTALLED', 'magnalister.php', 6, 0, '2008-08-25 22:19:34', '2007-11-25 14:11:52', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2158, 'MODULE_DELISPRINT_FILE', 'delisprint.txt', 6, 1, NULL, '2008-08-13 17:07:06', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2156, 'MODULE_HERMES_FILE', 'hermes.txt', 6, 1, NULL, '2008-08-12 12:59:02', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2157, 'MODULE_HERMES_STATUS', 'True', 6, 1, NULL, '2008-08-12 12:59:02', NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2159, 'MODULE_DELISPRINT_STATUS', 'True', 6, 1, NULL, '2008-08-13 17:07:06', NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2201, 'MODULE_GLS_STATUS', 'True', 6, 1, NULL, '2008-08-13 17:36:14', NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(415, 'MODULE_PAYMENT_MONEYBOOKERS_ALLOWED', '', 6, 0, NULL, '2008-02-18 22:36:19', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(405, 'MODULE_PAYMENT_MONEYBOOKERS_ALLOWED', '', 6, 0, NULL, '2008-02-18 22:35:32', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2200, 'MODULE_GLS_FILE', 'gls.txt', 6, 1, NULL, '2008-08-13 17:36:14', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(801, 'PAYPAL_API_SANDBOX_SIGNATURE', '', 25, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(802, 'PAYPAL_API_SANDBOX_PWD', '', 25, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(803, 'PAYPAL_API_SANDBOX_USER', '', 25, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(804, 'PAYPAL_SHOP_LOGO', '', 25, 13, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(805, 'PAYPAL_EXPRESS_ADDRESS_OVERRIDE', 'true', 25, 18, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'xtc_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(806, 'PAYPAL_EXPRESS_PAYMENTACTION', 'Sale', 25, 16, NULL, '2007-07-14 11:38:40', NULL, 'xtc_cfg_select_option(array(''Sale'', ''Authorization'', ''Order''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(807, 'PAYPAL_MODE', 'live', 25, 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'xtc_cfg_select_option(array(''sandbox'', ''live''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(808, 'PAYPAL_API_USER', '', 25, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(809, 'PAYPAL_API_PWD', '', 25, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(810, 'PAYPAL_API_SIGNATURE', '', 25, 6, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(811, 'PAYPAL_EXPRESS_ADDRESS_CHANGE', 'true', 25, 17, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'xtc_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(812, 'PAYPAL_COUNTRY_MODE', 'de', 25, 16, '0000-00-00 00:00:00', '0000-00-00 00:00:00', NULL, 'xtc_cfg_select_option(array(''de'', ''uk''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(813, 'PAYPAL_ORDER_STATUS_TMP_ID', '1', 25, 9, NULL, '2007-07-04 16:13:02', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(814, 'PAYPAL_ORDER_STATUS_SUCCESS_ID', '2', 25, 10, NULL, '2007-07-04 16:13:02', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(815, 'PAYPAL_ORDER_STATUS_PENDING_ID', '1', 25, 11, NULL, '2007-07-04 16:13:02', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(816, 'PAYPAL_ORDER_STATUS_REJECTED_ID', '1', 25, 12, NULL, '2007-07-04 16:13:02', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(817, 'PAYPAL_API_KEY', '120,116,99,111,109,109,101,114,99,101,95,83,104,111,112,112,105,110,103,67,97,114,116,95', 6, 5, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(1236, 'MODULE_PAYMENT_MONEYBOOKERS_ALLOWED', '', 6, 0, NULL, '2008-06-06 12:48:28', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(1734, 'GM_SET_OUT_OF_STOCK_PRODUCTS', 'false', 9, NULL, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(1735, 'GM_SET_OUT_OF_STOCK_ATTRIBUTES', 'false', 9, NULL, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(1736, 'GM_SET_OUT_OF_STOCK_ATTRIBUTES_SHOW', 'false', 9, NULL, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(1867, 'MODULE_PAYMENT_ICLEAR_ALLOWED', '', 6, 0, NULL, '2008-07-28 20:09:34', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(1873, 'MODULE_PAYMENT_ICLEAR_STATUS_WAIT_ID', '4', 6, 0, NULL, '2008-07-28 20:09:34', '', '');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2071, 'MODULE_ORDER_TOTAL_SHIPPING_TAX_CLASS', '0', 6, 7, NULL, '2008-08-11 16:22:45', 'xtc_get_tax_class_title', 'xtc_cfg_pull_down_tax_classes(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2070, 'MODULE_ORDER_TOTAL_SHIPPING_DESTINATION', 'national', 6, 5, NULL, '2008-08-11 16:22:45', NULL, 'xtc_cfg_select_option(array(''national'', ''international'', ''both''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2069, 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER', '50', 6, 4, NULL, '2008-08-11 16:22:45', 'currencies->format', NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2068, 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING', 'false', 6, 3, NULL, '2008-08-11 16:22:45', NULL, 'xtc_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2067, 'MODULE_ORDER_TOTAL_SHIPPING_SORT_ORDER', '30', 6, 2, NULL, '2008-08-11 16:22:45', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2066, 'MODULE_ORDER_TOTAL_SHIPPING_STATUS', 'true', 6, 1, NULL, '2008-08-11 16:22:45', NULL, 'xtc_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2065, 'MODULE_ORDER_TOTAL_SUBTOTAL_SORT_ORDER', '10', 6, 2, NULL, '2008-08-11 16:22:38', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2063, 'MODULE_ORDER_TOTAL_SUBTOTAL_NO_TAX_SORT_ORDER', '96', 6, 2, NULL, '2008-08-11 16:22:32', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2062, 'MODULE_ORDER_TOTAL_SUBTOTAL_NO_TAX_STATUS', 'true', 6, 1, NULL, '2008-08-11 16:22:32', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2058, 'MODULE_ORDER_TOTAL_TOTAL_STATUS', 'true', 6, 1, NULL, '2008-08-11 16:21:01', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2059, 'MODULE_ORDER_TOTAL_TOTAL_SORT_ORDER', '99', 6, 2, NULL, '2008-08-11 16:21:01', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2055, 'MODULE_ORDER_TOTAL_TOTAL_NETTO_SORT_ORDER', '98', 6, 2, NULL, '2008-08-11 16:20:34', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2054, 'MODULE_ORDER_TOTAL_TOTAL_NETTO_STATUS', 'true', 6, 1, NULL, '2008-08-11 16:20:34', NULL, 'xtc_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2275, 'MODULE_ORDER_TOTAL_GV_SORT_ORDER', '80', 6, 2, NULL, '2008-08-15 17:32:15', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2274, 'MODULE_ORDER_TOTAL_GV_STATUS', 'true', 6, 1, NULL, '2008-08-15 17:32:15', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2278, 'MODULE_ORDER_TOTAL_GV_INC_TAX', 'true', 6, 6, NULL, '2008-08-15 17:32:15', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2276, 'MODULE_ORDER_TOTAL_GV_QUEUE', 'true', 6, 3, NULL, '2008-08-15 17:32:15', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2277, 'MODULE_ORDER_TOTAL_GV_INC_SHIPPING', 'False', 6, 5, NULL, '2008-08-15 17:32:15', NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2435, 'MODULE_ORDER_TOTAL_FREEAMOUNT_FREE', 'AT:3.00,DE:3.58,00:9.99', 6, 0, NULL, '2008-08-19 10:55:02', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2281, 'MODULE_ORDER_TOTAL_GV_CREDIT_TAX', 'false', 6, 8, NULL, '2008-08-15 17:32:15', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2280, 'MODULE_ORDER_TOTAL_GV_TAX_CLASS', '0', 6, 0, NULL, '2008-08-15 17:32:15', 'xtc_get_tax_class_title', 'xtc_cfg_pull_down_tax_classes(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2279, 'MODULE_ORDER_TOTAL_GV_CALC_TAX', 'None', 6, 7, NULL, '2008-08-15 17:32:15', NULL, 'xtc_cfg_select_option(array(''None'', ''Standard'', ''Credit Note''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2585, 'MODULE_ORDER_TOTAL_TAX_SORT_ORDER', '97', 6, 2, NULL, '2008-08-25 16:49:21', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2586, 'MODULE_ORDER_TOTAL_TAX_STATUS', 'true', 6, 1, NULL, '2008-08-25 16:49:21', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2587, '_PAYMENT_MONEYBOOKERS_EMAILID', '', 31, 1, NULL, '', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2588, '_PAYMENT_MONEYBOOKERS_PWD', '', 31, 2, NULL, '', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2589, '_PAYMENT_MONEYBOOKERS_MERCHANTID', '', 31, 3, NULL, '', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2590, '_PAYMENT_MONEYBOOKERS_TMP_STATUS_ID', '0', 31, 4, NULL, '', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2591, '_PAYMENT_MONEYBOOKERS_PROCESSED_STATUS_ID', '0', 31, 5, NULL, '', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2592, '_PAYMENT_MONEYBOOKERS_PENDING_STATUS_ID', '0', 31, 6, NULL, '', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2593, '_PAYMENT_MONEYBOOKERS_CANCELED_STATUS_ID', '0', 31, 7, NULL, '', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');

INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2618, 'MODULE_BRICKFOX_URL', '', 26, 1, NULL, '2010-04-01 22:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2624, 'MODULE_BRICKFOX_PORT', '443', 26, 2, NULL, '2010-04-01 22:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2619, 'MODULE_BRICKFOX_USERNAME', '', 26, 3, NULL, '2010-04-01 22:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2620, 'MODULE_BRICKFOX_PASSWORD', '', 26, 4, NULL, '2010-04-01 22:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2621, 'MODULE_BRICKFOX_EXCLUDE_CATEGORIES', '', 26, 5, NULL, '2010-04-01 22:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2622, 'MODULE_BRICKFOX_EXCLUDE_PRODUCTS', '', 26, 6, NULL, '2010-04-01 22:00:00', null, NULL);
INSERT INTO `configuration` (`configuration_id`, `configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES(2623, 'MODULE_BRICKFOX_STATUS', 'False', 26, 7, NULL, '2010-04-01 22:00:00', NULL, 'gm_cfg_select_option(array(''True'', ''False''), ');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COD_FEE_TAX_CLASS', '0', 6, 0, NULL, '2008-08-19 10:55:02', 'xtc_get_tax_class_title', 'xtc_cfg_pull_down_tax_classes(');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COD_FEE_STATUS', 'true', 6, 0, NULL, '2008-08-19 10:55:02', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COD_FEE_SORT_ORDER', '35', 6, 0, NULL, '2008-08-19 10:55:02', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COD_FEE_RULES', 'free|AT:3.00,DE:3.58,00:9.99|flat|AT:3.00,DE:3.58,00:9.99|item|AT:3.00,DE:3.58,00:9.99|table|AT:3.00,DE:3.58,00:9.99|zones|CA:4.50,US:3.00,00:9.99|upse|AT:3.00,DE:3.58,00:9.99|chronopost|FR:4.00,00:9.99|dhl|AT:3.00,DE:3.58,00:9.99|ups|AT:3.00,DE:3.58,00:9.99|chp|CH:4.00,00:9.99|dpd|DE:4.00,00:9.99|ap|AT:3.63,00:9.99|zonese|DE:4.00,00:9.99|selfpickup|DE:4.00,00:9.99|gambioultra|DE:4.00,00:9.99|fedexeu|DE:4.00,00:9.99|dp|DE:4.00,00:9.99', 6, 0, NULL, '2013-11-12 10:46:04', '', 'cfg_cod_fee_form(');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ACCOUNT_TELEPHONE', 'true', 5, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('ACCOUNT_FAX', 'true', 5, 1, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('EMAIL_SIGNATURE', '', 12, 16, NULL, '0000-00-00 00:00:00', NULL, 'xtc_cfg_textarea(');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('HTTP_CACHING', 'true', 11, 7, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('LOG_SQL_FRONTEND', 'false', 10, 5, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('LOG_SQL_BACKEND', 'false', 10, 6, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('SQL_LOG_MAX_FILESIZE', '1', 10, 7, NULL, '0000-00-00 00:00:00', NULL, NULL);

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_STATUS', 'true', 6, 1, NULL, '2011-11-10 18:13:22', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_SORT_ORDER', '29', 6, 2, NULL, '2011-11-10 18:13:22', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_INC_SHIPPING', 'false', 6, 5, NULL, '2011-11-10 18:13:22', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_INC_TAX', 'true', 6, 6, NULL, '2011-11-10 18:13:22', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_CALC_TAX', 'Standard', 6, 7, NULL, '2011-11-10 18:13:22', NULL, 'xtc_cfg_select_option(array(''None'', ''Standard'', ''Credit Note''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_COUPON_TAX_CLASS', '0', 6, 0, NULL, '2011-11-10 18:13:22', 'xtc_get_tax_class_title', 'xtc_cfg_pull_down_tax_classes(');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_DISCOUNT_STATUS', 'true', 6, 1, NULL, '2011-11-10 18:15:39', NULL, 'gm_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('MODULE_ORDER_TOTAL_DISCOUNT_SORT_ORDER', '20', 6, 2, NULL, '2011-11-10 18:15:39', NULL, NULL);

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('APPEND_PROPERTIES_MODEL', 'true', 1, 30, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('SHOW_PRODUCTS_MODEL', 'false', 1, 31, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('PREFER_GZHANDLER', 'false', 14, 3, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('SEND_EMAIL_BY_BILLING_ADRESS', 'CUSTOMER_MAIL', 12, 40 , NULL , '0000-00-00 00:00:00', NULL , 'gm_cfg_select_option(array(''CUSTOMER_MAIL'', ''SHOP_OWNER''),');

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('GAMBIO_SHOP_KEY', '', 753, 1 , NULL , '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('GOOGLE_CONVERSION_LABEL', 'Purchase', 19, 4, NULL , '0000-00-00 00:00:00', NULL , NULL);

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_EMAILID', '', 32, 1, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_PWD', '', 32, 2, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_MERCHANTID', '', 32, 3, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_MODULES', '', 32, 4, NULL, '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_TMP_STATUS_ID', '0', 32, 5, NULL, '0000-00-00 00:00:00', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_PROCESSED_STATUS_ID', '0', 32, 6, NULL, '0000-00-00 00:00:00', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_PENDING_STATUS_ID', '0', 32, 7, NULL, '0000-00-00 00:00:00', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_CANCELED_STATUS_ID', '0', 32, 8, NULL, '0000-00-00 00:00:00', 'xtc_get_order_status_name', 'xtc_cfg_pull_down_order_statuses(');
INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('_PAYMENT_SKRILL_EXPERTMODE', '0', 32, 9, NULL, '0000-00-00 00:00:00', NULL, NULL);

INSERT INTO `configuration` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('SHOW_CART_SHIPPING_WEIGHT', 'true', 7, 9, NULL, '0000-00-00 00:00:00', NULL, 'gm_cfg_select_option(array(''true'', ''false''),');


INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(1, 'My Store', 'General information about my store', 1, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(2, 'Minimum Values', 'The minimum values for functions / data', 2, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(3, 'Maximum Values', 'The maximum values for functions / data', 3, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(4, 'Images', 'Image parameters', 4, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(5, 'Customer Details', 'Customer account configuration', 5, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(6, 'Module Options', 'Hidden from configuration', 6, 0);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(7, 'Shipping/Packaging', 'Shipping options available at my store', 7, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(8, 'Product Listing', 'Product Listing    configuration options', 8, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(9, 'Stock', 'Stock configuration options', 9, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(10, 'Logging', 'Logging configuration options', 10, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(11, 'Cache', 'Caching configuration options', 11, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(12, 'E-Mail Options', 'General setting for E-Mail transport and HTML E-Mails', 12, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(13, 'Download', 'Downloadable products options', 13, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(14, 'GZip Compression', 'GZip compression options', 14, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(15, 'Sessions', 'Session options', 15, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(16, 'Meta-Tags/Search engines', 'Meta-tags/Search engines', 16, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(18, 'Vat ID', 'Vat ID', 18, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(19, 'Google Conversion', 'Google Conversion-Tracking', 19, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(20, 'Import/Export', 'Import/Export', 20, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(21, 'Afterbuy', 'Afterbuy.de', 21, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(22, 'Search Options', 'Additional Options for search function', 22, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(25, 'PayPal', 'PayPal', 25, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(26, 'brickfox', 'brickfox.de', 26, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(31, 'Moneybookers', 'Moneybookers', 31, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(753, 'Gambio-Shop-Key', 'Gambio-Shop-Key', 753, 1);
INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES(32, 'Skrill', 'Skrill', 32, 1);


INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(1, 0, 0, '', 1, 'Shipping & Returns', 'Shipping & Returns', '<p>Enter&nbsp; your Shipping &amp; Returns information here.</p>', 0, 1, '', 1, 1, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:21:12', 1, 'shipping---returns');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(2, 0, 0, '', 1, 'Privacy Notice', 'Privacy Notice', '<p>Enter your Privacy Notice information here.</p>', 0, 1, '', 1, 2, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:21:28', 1, 'privacy-notice');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(3, 0, 0, '', 1, 'Conditions of Use', 'Conditions of Use', '<p>Enter your Conditions of Use information here.</p>', 0, 1, '', 1, 3, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:21:47', 1, 'conditions-of-use');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(4, 0, 0, '', 1, 'Imprint', 'Imprint', '<p>Enter your Company information here.</p>', 0, 1, '', 1, 4, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:22:50', 1, 'imprint');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(5, 0, 0, '', 1, 'Index', 'Welcome', '<p>This Onlineshop was created with <a href="http://www.gambio.de"><strong>Gambio Shopsoftware</strong></a>.</p>\r\n<p>This text can be edited at Content Manager -&gt; Index in the backend.</p>', 0, 1, '', 0, 5, 0, '', '_blank', '0.0', 'always', '2011-03-16 16:28:26', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(6, 0, 0, '', 2, 'Liefer- und Versandkosten', 'Liefer- und Versandkosten', '<p>F&uuml;gen Sie hier Ihre Informationen &uuml;ber Liefer- und Versandkosten ein.</p>', 2, 1, '', 1, 1, 0, '', '_blank', '1.0', 'weekly', '2008-08-26 19:59:13', 1, 'liefer--und-versandkosten');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(7, 0, 0, '', 2, 'Privatsphre und Datenschutz', 'Privatsphre und Datenschutz', '<p>F&uuml;gen Sie hier Ihre Informationen &uuml;ber Privatsph&auml;re und Datenschutz ein. Alternativ k&ouml;nnen Sie das Plugin <i>janolaw AGB-Hosting</i> nutzen und Ihre Datenschutzerkl&auml;rung mithilfe eines Online-Assistenten direkt zusammen mit AGB, Widerrufsbelehrung und Impressum erstellen. In nur wenigen Minuten haben Sie&nbsp;unter fachkundiger Anleitung die <strong>wichtigsten</strong> Dokumente f&uuml;r Ihren Shop <strong>individuell</strong> zusammengestellt.</p><p>Das Plugin sorgt&nbsp;daf&uuml;r, dass die Dokumente in Ihren Shop eingebunden und bei ver&auml;nderter Rechtslage <strong>automatisch aktualisiert</strong> werden. Dabei wird die aktuelle Widerrufsbelehrung zus&auml;tzlich auch in der <strong>E-Mail-Best&auml;tigung</strong> angezeigt, die Sie an Ihre Kunden verschicken. Zusammen mit&nbsp;der <strong>Abmahnkostenhaftung</strong> durch die janolaw AG sind Sie damit optimal vor Abmahnungen gesch&uuml;tzt. <a href="http://www.janolaw.de/internetrecht/agb/agb-hosting-service/gambio/?partnerid=8604#menu">Hier</a> k&ouml;nnen Sie den Service unseres Partners janolaw buchen.</p>', 3, 1, '', 1, 2, 0, '', '_blank', '0.0', 'always', '2008-08-26 19:59:30', 1, 'privatsphaere-und-datenschutz');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(8, 0, 0, '', 2, 'AGB', 'Allgemeine Geschftsbedingungen', '<strong>Hinweis:</strong><br />\r\nSie haben soeben eine <strong>&Auml;nderung in Ihren Zahlungseinstellungen</strong> vorgenommen. Beachten Sie, dass Sie ggf. Ihre rechtlichen Dokumente, in diesem Fall die <strong>Datenschutzerkl&auml;rung, anpassen</strong> m&uuml;ssen, um nicht das Risiko einer Abmahnung einzugehen.  <br />\r\n<br />\r\n<strong>Unsere Empfehlung:</strong> <br />\r\nNutzen Sie den preiswerten <strong>AGB Hosting-Service</strong> unseres Partners janolaw.  janolaw hilft Ihnen bei der Online-Erstellung Ihrer Datenschutzerkl&auml;rung sowie der AGB, Widerrufsbelehrung und des Impressums und h&auml;lt diese Dokumente f&uuml;r Sie aktuell. Einfach und bequem &uuml;ber die Gambio Schnittstelle. Mit <strong>dauerhaft 10% Rabatt</strong> f&uuml;r Sie als Gambio Kunde. <br />\r\n<br />\r\n<a type="Hier k&ouml;nnen Sie den Service buchen" href="http://www.janolaw.de/internetrecht/agb/agb-hosting-service/gambio/?partnerid=8604#menu" target="_blank" title="Hier k&ouml;nnen Sie den Service buchen">Hier k&ouml;nnen Sie den Service buchen</a><br />', 1, 1, '', 1, 3, 0, '', '_blank', '0.0', 'always', '2012-01-30 14:45:57', 1, 'allgemeine-geschaeftsbedingungen');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(47, 0, 0, '', 2, 'Suchen', '', '', 0, 3, '', 0, 30, 1, 'advanced_search.php', '_top', '0.0', 'always', '2008-07-30 04:24:06', 0, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(9, 0, 0, '', 2, 'Impressum', 'Impressum', '<p>F&uuml;gen Sie hier Ihr Impressum ein. Alternativ k&ouml;nnen Sie das Plugin <i>janolaw AGB-Hosting</i> nutzen und Ihr Impressum mithilfe eines Online-Assistenten direkt zusammen mit AGB, Widerrufsbelehrung und Datenschutzerkl&auml;rung erstellen. In nur wenigen Minuten haben Sie&nbsp;unter fachkundiger Anleitung die <strong>wichtigsten</strong> Dokumente f&uuml;r Ihren Shop <strong>individuell</strong> zusammengestellt.</p><p>Das Plugin sorgt&nbsp;daf&uuml;r, dass die Dokumente in Ihren Shop eingebunden und bei ver&auml;nderter Rechtslage <strong>automatisch aktualisiert</strong> werden. Dabei wird die aktuelle Widerrufsbelehrung zus&auml;tzlich auch in der <strong>E-Mail-Best&auml;tigung</strong> angezeigt, die Sie an Ihre Kunden verschicken. Zusammen mit&nbsp;der <strong>Abmahnkostenhaftung</strong> durch die janolaw AG sind Sie damit optimal vor Abmahnungen gesch&uuml;tzt. <a href="http://www.janolaw.de/internetrecht/agb/agb-hosting-service/gambio/?partnerid=8604#menu">Hier</a> k&ouml;nnen Sie den Service unseres Partners janolaw buchen.</p>', 0, 1, '', 1, 4, 0, '', '_top',   '1.0', 'always', '2008-07-29 18:01:46', 1, 'impressum');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(10, 0, 0, '', 2, 'Index', '', '<p>Dieser Onlineshop wurde mit der <a href="http://www.gambio.de"><strong>Gambio Shopsoftware</strong></a> erstellt.</p>\r\n<p>Diesen Text k&ouml;nnen Sie im Administrationsbereich unter Content Manager -&gt; Index bearbeiten.</p>', 0, 1, '', 0, 5, 0, '', '_blank', '0.0', 'always', '2011-03-16 16:24:27', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(11, 0, 0, '', 2, 'Gutscheine', 'Gutscheine - Fragen und Antworte', '<table cellSpacing=0 cellPadding=0>\r\n<tbody>\r\n<tr>\r\n<td class=main><STRONG>Gutscheine kaufen </STRONG></td></tr>\r\n<tr>\r\n<td class=main>Gutscheine knnen, falls sie im Shop angeboten werden, wie normale Artikel gekauft werden. Sobald Sie einen Gutschein gekauft haben und dieser nach erfolgreicher Zahlung freigeschaltet wurde, erscheint der Betrag unter Ihrem Warenkorb. Nun knnen Sie ber den Link " Gutschein versenden " den gewnschten Betrag per E-Mail versenden. </td></tr></tbody></table>\r\n<table cellSpacing=0 cellPadding=0>\r\n<tbody>\r\n<tr>\r\n<td class=main><STRONG>Wie man Gutscheine versendet </STRONG></td></tr>\r\n<tr>\r\n<td class=main>Um einen Gutschein zu versenden, klicken Sie bitte auf den Link "Gutschein versenden" in Ihrem Einkaufskorb. Um einen Gutschein zu versenden, bentigen wir folgende Angaben von Ihnen: Vor- und Nachname des Empfngers. Eine gltige E-Mail Adresse des Empfngers. Den gewnschten Betrag (Sie knnen auch Teilbetrge Ihres Guthabens versenden). Eine kurze Nachricht an den Empfnger. Bitte berprfen Sie Ihre Angaben noch einmal vor dem Versenden. Sie haben vor dem Versenden jederzeit die Mglichkeit Ihre Angaben zu korrigieren. </td></tr></tbody></table>\r\n<table cellSpacing=0 cellPadding=0>\r\n<tbody>\r\n<tr>\r\n<td class=main><STRONG>Mit Gutscheinen Einkaufen. </STRONG></td></tr>\r\n<tr>\r\n<td class=main>Sobald Sie ber ein Guthaben verfgen, knnen Sie dieses zum Bezahlen Ihrer Bestellung verwenden. Whrend des Bestellvorganges haben Sie die Mglichkeit Ihr Guthaben einzulsen. Falls das Guthaben unter dem Warenwert liegt mssen Sie Ihre bevorzugte Zahlungsweise fr den Differenzbetrag whlen. bersteigt Ihr Guthaben den Warenwert, steht Ihnen das Restguthaben selbstverstndlich fr Ihre nchste Bestellung zur Verfgung. </td></tr></tbody></table>\r\n<table cellSpacing=0 cellPadding=0>\r\n<tbody>\r\n<tr>\r\n<td class=main><STRONG>Gutscheine verbuchen. </STRONG></td></tr>\r\n<tr>\r\n<td class=main>Wenn Sie einen Gutschein per E-Mail erhalten haben, knnen Sie den Betrag wie folgt verbuchen:. <br />1. Klicken Sie auf den in der E-Mail angegebenen Link. Falls Sie noch nicht ber ein persnliches Kundenkonto verfgen, haben Sie die Mglichkeit ein Konto zu erffnen. <br />2. Nachdem Sie ein Produkt in den Warenkorb gelegt haben, knnen Sie dort Ihren Gutscheincode eingeben.</td></tr></tbody></table>\r\n<table cellSpacing=0 cellPadding=0>\r\n<tbody>\r\n<tr>\r\n<td class=main><STRONG>Falls es zu Problemen kommen sollte: </STRONG></td></tr>\r\n<tr>\r\n<td class=main>Falls es wider Erwarten zu Problemen mit einem Gutschein kommen sollte, kontaktieren Sie uns bitte per E-Mail : you@yourdomain.com. Bitte beschreiben Sie mglichst genau das Problem, wichtige Angaben sind unter anderem: Ihre Kundennummer, der Gutscheincode, Fehlermeldungen des Systems sowie der von Ihnen benutzte Browser. </td></tr></tbody></table>', 0, 1, '', 0, 6, 1, '', '', '', '', NULL, 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(12, 0, 0, '', 1, 'Vouchers', 'Vouchers', '<p>Enter your Vouchers information here.</p>', 0, 1, '', 0, 6, 1, '', '_blank', '0.0', 'always', '2008-08-25 17:23:24', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(48, 0, 0, '', 2, 'ber uns', 'ber uns', '<p>F&uuml;gen Sie hier Ihre Informationen &uuml;ber sich bzw. Ihr Unternehmen ein.</p>', 1, 3, '', 0, 82, 1, '', '_blank', '0.0', 'always', '2008-08-25 17:57:47', 0, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(13, 0, 0, '', 2, 'Kontakt', 'Kontakt', '<p>F&uuml;gen Sie hier Ihre Kontaktinformationen ein.</p>', 0, 1, '', 1, 7, 0, '', '_blank', '0.0', 'always', '2008-08-26 20:00:45', 1, 'mein-kontakt');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(14, 0, 0, '', 1, 'Contact', 'Contact', '<p>Enter your Contact information here.</p>', 0, 1, '', 1, 7, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:23:42', 1, 'contact');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(15, 0, 0, '', 1, 'Sitemap', '', '', 0, 0, 'sitemap.php', 1, 8, 0, '', '', '', '', NULL, 1, 'sitemap');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(16, 0, 0, '', 2, 'Sitemap', 'Sitemap', '', 0, 0, 'sitemap.php', 1, 8, 0, '', '_blank', '', '', NULL, 1, 'sitemap');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(22, 0, 0, '', 2, 'Callback Service', 'Callback Service', '<p>Den Inhalt dieses Bereiches k&ouml;nnen Sie im Administrationsbereich unter Content Manager -&gt; Callback Service bearbeiten.</p>', 5, 1, 'gm_callback_service.php', 1, 14, 1, '', '_blank', '0.0', 'always', '2008-08-26 20:02:29', 1, 'callback-service');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(24, 0, 0, '', 2, 'Zusatzbox 1', 'Zusatzbox 1', '<p style="text-align: center;"><a href="http://validator.w3.org/check?uri=referer"><img height="31" width="88" alt="Valid XHTML 1.0 Transitional" src="http://www.w3.org/Icons/valid-xhtml10" /></a></p>', 0, 4, '', 1, 61, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:45:27', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(25, 0, 0, '', 2, 'Zusatzbox 2', 'Zusatzbox 2 Titel', '<p>Zusatzbox Inhalt</p>\r\n<br />', 0, 4, '', 1, 62, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:10', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(26, 0, 0, '', 2, 'Zusatzbox 3', 'Zusatzbox 3 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', 1, 63, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:17', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(27, 0, 0, '', 2, 'Zusatzbox 4', 'Zusatzbox 4 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', 0, 64, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:22', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(28, 0, 0, '', 2, 'Zusatzbox 5', 'Zusatzbox 5 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', 0, 65, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:29', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(29, 0, 0, '', 2, 'Zusatzbox 6', 'Zusatzbox 6 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', 0, 66, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:35', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(30, 0, 0, '', 2, 'Zusatzbox 7', 'Zusatzbox 7 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', 0, 67, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:41', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(31, 0, 0, '', 2, 'Zusatzbox 8', 'Zusatzbox 8 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', 0, 68, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:16:50', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(32, 0, 0, '', 2, 'Zusatzbox 9', 'Zusatzbox 9 Titel', '<p>Zusatzbox Inhalt</p>', 0, 4, '', 1, 69, 0, '', '_blank', '0.0', 'always', '2008-08-25 17:17:00', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(33, 0, 0, '', 1, 'Extrabox 1', 'Extrabox 1 Title', '<a href="http://validator.w3.org/check?uri=referer"><img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0 Transitional" height="31" width="88" /></a>', 0, 4, '', 1, 61, 0, '', '_blank', '0.0', 'always', '2008-08-15 09:24:18', 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(34, 0, 0, '', 1, 'Extrabox 2', 'Extrabox 2 Title', 'Content Extrabox', 0, 4, '', 1, 62, 0, '', '', '', '', NULL, 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(35, 0, 0, '', 1, 'Extrabox 3', 'Extrabox 3 Title', 'Content Extrabox', 0, 4, '', 1, 63, 0, '', '', '', '', NULL, 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(36, 0, 0, '', 1, 'Extrabox 4', 'Extrabox 4 Title', 'Content Extrabox', 0, 4, '', 1, 64, 0, '', '', '', '', NULL, 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(37, 0, 0, '', 1, 'Extrabox 5', 'Extrabox 5 Title', 'Content Extrabox', 0, 4, '', 1, 65, 0, '', '', '', '', NULL, 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(38, 0, 0, '', 1, 'Extrabox 6', 'Extrabox 6 Title', 'Content Extrabox', 0, 4, '', 1, 66, 0, '', '', '', '', NULL, 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(39, 0, 0, '', 1, 'Extrabox 7', 'Extrabox 7 Title', 'Content Extrabox', 0, 4, '', 1, 67, 0, '', '', '', '', NULL, 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(40, 0, 0, '', 1, 'Extrabox 8', 'Extrabox 8 Title', 'Content Extrabox', 0, 4, '', 1, 68, 0, '', '', '', '', NULL, 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(41, 0, 0, '', 1, 'Extrabox 9', 'Extrabox 9 Title', 'Content Extrabox', 0, 4, '', 1, 69, 0, '', '', '', '', NULL, 1, '');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(44, 0, 0, '', 2, 'Widerrufsrecht', 'Widerrufsrecht', '<p>F&uuml;gen Sie hier Ihre Hinweise zum Widerrufsrecht ein. Alternativ k&ouml;nnen Sie das Plugin <i>janolaw AGB-Hosting</i> nutzen und Ihre Widerrufsbelehrung mithilfe eines Online-Assistenten direkt zusammen mit AGB, Datenschutzerkl&auml;rung und Impressum erstellen. In nur wenigen Minuten haben Sie&nbsp;unter fachkundiger Anleitung die <strong>wichtigsten</strong> Dokumente f&uuml;r Ihren Shop <strong>individuell </strong>zusammengestellt.</p><p>Das Plugin sorgt&nbsp;daf&uuml;r, dass die Dokumente in Ihren Shop eingebunden und bei ver&auml;nderter Rechtslage <strong>automatisch aktualisiert</strong> werden. Dabei wird die aktuelle Widerrufsbelehrung zus&auml;tzlich auch in der <strong>E-Mail-Best&auml;tigung</strong> angezeigt, die Sie an Ihre Kunden verschicken. Zusammen mit der <b>Abmahnkostenhaftung</b> durch die janolaw AG sind Sie damit optimal vor Abmahnungen gesch&uuml;tzt. <a href="http://www.janolaw.de/internetrecht/agb/agb-hosting-service/gambio/?partnerid=8604#menu">Hier</a> k&ouml;nnen Sie den Service unseres Partners janolaw buchen.</p>', 0, 1, '', 1, 9, 1, '', '_blank', '0.0', 'always', '2008-08-26 20:02:41', 1, 'widerrufsrecht');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(45, 0, 0, '', 1, 'Withdrawal', 'Withdrawal', '<p>Enter your Withdrawal information here.</p>', 0, 1, '', 1, 9, 1, '', '_blank', '0.0', 'always', '2008-08-25 17:24:31', 1, 'withdrawal');
INSERT INTO `content_manager` (`content_id`, `categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`) VALUES(46, 0, 0, '', 2, 'Trusted Shops', 'Trusted Shops', '', 0, 1, 'trustedshops.php', 0, 15, 1, '', '_blank', '1.0', 'never', '2008-08-26 20:02:53', 1, 'trusted-shops');
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `contents_meta_title`, `contents_meta_description`, `contents_meta_keywords`) VALUES(0, 0, '', 1, 'Index (center)', '', '', 0, 1, '', 0, 10, 0, '', '_blank', '0.0', 'always', '2008-07-29 18:04:53', 1, '', '', '', '');
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `contents_meta_title`, `contents_meta_description`, `contents_meta_keywords`) VALUES(0, 0, '', 2, 'Index (Mitte)', '', '', 0, 1, '', 0, 10, 0, '', '_blank', '0.0', 'always', '2008-07-29 18:03:44', 1, '', '', '', '');
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `contents_meta_title`, `contents_meta_description`, `contents_meta_keywords`) VALUES(0, 0, '', 1, 'Index (bottom)', '', '', 0, 1, '', 0, 11, 0, '', '_blank', '0.0', 'always', '2008-07-29 18:04:53', 1, '', '', '', '');
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `contents_meta_title`, `contents_meta_description`, `contents_meta_keywords`) VALUES(0, 0, '', 2, 'Index (unten)', '', '', 0, 1, '', 0, 11, 0, '', '_blank', '0.0', 'always', '2008-07-29 18:03:44', 1, '', '', '', '');
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `contents_meta_title`, `contents_meta_description`, `contents_meta_keywords`) VALUES(0, 0, '', 1, 'Footer', '', '<p>This text can be edited at Content Manager -&gt; Footer in the backend.</p>', 0, 4, '', 1, 199, 0, '', '_blank', '0.0', 'always', '2011-03-17 11:39:53', 0, '', '', '', '');
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `contents_meta_title`, `contents_meta_description`, `contents_meta_keywords`) VALUES(0, 0, '', 2, 'Footer', '', '<p>Diesen Text k&ouml;nnen Sie im Administrationsbereich unter Content Manager -&gt; Footer bearbeiten.</p>', 0, 4, '', 1, 199, 0, '', '_blank', '0.0', 'always', '2011-03-17 11:39:26', 0, '', '', '', '');
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `contents_meta_title`, `contents_meta_description`, `contents_meta_keywords`) VALUES(0, 0, '', 1, 'Checkout confirmation information', '', '', 0, 4, '', 1, 198, 0, '', '_blank', '0.0', 'always', '2011-03-17 11:39:53', 0, '', '', '', '');
INSERT INTO `content_manager` (`categories_id`, `parent_id`, `group_ids`, `languages_id`, `content_title`, `content_heading`, `content_text`, `sort_order`, `file_flag`, `content_file`, `content_status`, `content_group`, `content_delete`, `gm_link`, `gm_link_target`, `gm_priority`, `gm_changefreq`, `gm_last_modified`, `gm_sitemap_entry`, `gm_url_keywords`, `contents_meta_title`, `contents_meta_description`, `contents_meta_keywords`) VALUES(0, 0, '', 2, 'Bestellzusammenfassung Information', '', '', 0, 4, '', 1, 198, 0, '', '_blank', '0.0', 'always', '2011-03-17 11:39:26', 0, '', '', '', '');


INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(1, 'Afghanistan', 'AF', 'AFG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(2, 'Albania', 'AL', 'ALB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(3, 'Algeria', 'DZ', 'DZA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(4, 'American Samoa', 'AS', 'ASM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(5, 'Andorra', 'AD', 'AND', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(6, 'Angola', 'AO', 'AGO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(7, 'Anguilla', 'AI', 'AIA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(8, 'Antarctica', 'AQ', 'ATA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(9, 'Antigua and Barbuda', 'AG', 'ATG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(10, 'Argentina', 'AR', 'ARG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(11, 'Armenia', 'AM', 'ARM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(12, 'Aruba', 'AW', 'ABW', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(13, 'Australia', 'AU', 'AUS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(14, 'Austria', 'AT', 'AUT', 5, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(15, 'Azerbaijan', 'AZ', 'AZE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(16, 'Bahamas', 'BS', 'BHS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(17, 'Bahrain', 'BH', 'BHR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(18, 'Bangladesh', 'BD', 'BGD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(19, 'Barbados', 'BB', 'BRB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(20, 'Belarus', 'BY', 'BLR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(21, 'Belgium', 'BE', 'BEL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(22, 'Belize', 'BZ', 'BLZ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(23, 'Benin', 'BJ', 'BEN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(24, 'Bermuda', 'BM', 'BMU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(25, 'Bhutan', 'BT', 'BTN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(26, 'Bolivia', 'BO', 'BOL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(27, 'Bosnia and Herzegowina', 'BA', 'BIH', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(28, 'Botswana', 'BW', 'BWA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(29, 'Bouvet Island', 'BV', 'BVT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(30, 'Brazil', 'BR', 'BRA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(31, 'British Indian Ocean Territory', 'IO', 'IOT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(32, 'Brunei Darussalam', 'BN', 'BRN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(33, 'Bulgaria', 'BG', 'BGR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(34, 'Burkina Faso', 'BF', 'BFA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(35, 'Burundi', 'BI', 'BDI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(36, 'Cambodia', 'KH', 'KHM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(37, 'Cameroon', 'CM', 'CMR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(38, 'Canada', 'CA', 'CAN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(39, 'Cape Verde', 'CV', 'CPV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(40, 'Cayman Islands', 'KY', 'CYM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(41, 'Central African Republic', 'CF', 'CAF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(42, 'Chad', 'TD', 'TCD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(43, 'Chile', 'CL', 'CHL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(44, 'China', 'CN', 'CHN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(45, 'Christmas Island', 'CX', 'CXR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(46, 'Cocos (Keeling) Islands', 'CC', 'CCK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(47, 'Colombia', 'CO', 'COL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(48, 'Comoros', 'KM', 'COM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(49, 'Congo', 'CG', 'COG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(50, 'Cook Islands', 'CK', 'COK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(51, 'Costa Rica', 'CR', 'CRI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(52, 'Cote D''Ivoire', 'CI', 'CIV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(53, 'Croatia', 'HR', 'HRV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(54, 'Cuba', 'CU', 'CUB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(55, 'Cyprus', 'CY', 'CYP', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(56, 'Czech Republic', 'CZ', 'CZE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(57, 'Denmark', 'DK', 'DNK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(58, 'Djibouti', 'DJ', 'DJI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(59, 'Dominica', 'DM', 'DMA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(60, 'Dominican Republic', 'DO', 'DOM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(61, 'East Timor', 'TP', 'TMP', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(62, 'Ecuador', 'EC', 'ECU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(63, 'Egypt', 'EG', 'EGY', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(64, 'El Salvador', 'SV', 'SLV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(65, 'Equatorial Guinea', 'GQ', 'GNQ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(66, 'Eritrea', 'ER', 'ERI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(67, 'Estonia', 'EE', 'EST', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(68, 'Ethiopia', 'ET', 'ETH', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(69, 'Falkland Islands (Malvinas)', 'FK', 'FLK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(70, 'Faroe Islands', 'FO', 'FRO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(71, 'Fiji', 'FJ', 'FJI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(72, 'Finland', 'FI', 'FIN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(73, 'France', 'FR', 'FRA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(74, 'France, Metropolitan', 'FX', 'FXX', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(75, 'French Guiana', 'GF', 'GUF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(76, 'French Polynesia', 'PF', 'PYF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(77, 'French Southern Territories', 'TF', 'ATF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(78, 'Gabon', 'GA', 'GAB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(79, 'Gambia', 'GM', 'GMB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(80, 'Georgia', 'GE', 'GEO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(81, 'Germany', 'DE', 'DEU', 5, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(82, 'Ghana', 'GH', 'GHA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(83, 'Gibraltar', 'GI', 'GIB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(84, 'Greece', 'GR', 'GRC', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(85, 'Greenland', 'GL', 'GRL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(86, 'Grenada', 'GD', 'GRD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(87, 'Guadeloupe', 'GP', 'GLP', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(88, 'Guam', 'GU', 'GUM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(89, 'Guatemala', 'GT', 'GTM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(90, 'Guinea', 'GN', 'GIN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(91, 'Guinea-bissau', 'GW', 'GNB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(92, 'Guyana', 'GY', 'GUY', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(93, 'Haiti', 'HT', 'HTI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(94, 'Heard and Mc Donald Islands', 'HM', 'HMD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(95, 'Honduras', 'HN', 'HND', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(96, 'Hong Kong', 'HK', 'HKG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(97, 'Hungary', 'HU', 'HUN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(98, 'Iceland', 'IS', 'ISL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(99, 'India', 'IN', 'IND', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(100, 'Indonesia', 'ID', 'IDN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(101, 'Iran (Islamic Republic of)', 'IR', 'IRN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(102, 'Iraq', 'IQ', 'IRQ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(103, 'Ireland', 'IE', 'IRL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(104, 'Israel', 'IL', 'ISR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(105, 'Italy', 'IT', 'ITA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(106, 'Jamaica', 'JM', 'JAM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(107, 'Japan', 'JP', 'JPN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(108, 'Jordan', 'JO', 'JOR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(109, 'Kazakhstan', 'KZ', 'KAZ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(110, 'Kenya', 'KE', 'KEN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(111, 'Kiribati', 'KI', 'KIR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(112, 'Korea, Democratic People''s Republic of', 'KP', 'PRK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(113, 'Korea, Republic of', 'KR', 'KOR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(114, 'Kuwait', 'KW', 'KWT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(115, 'Kyrgyzstan', 'KG', 'KGZ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(116, 'Lao People''s Democratic Republic', 'LA', 'LAO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(117, 'Latvia', 'LV', 'LVA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(118, 'Lebanon', 'LB', 'LBN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(119, 'Lesotho', 'LS', 'LSO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(120, 'Liberia', 'LR', 'LBR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(121, 'Libyan Arab Jamahiriya', 'LY', 'LBY', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(122, 'Liechtenstein', 'LI', 'LIE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(123, 'Lithuania', 'LT', 'LTU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(124, 'Luxembourg', 'LU', 'LUX', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(125, 'Macau', 'MO', 'MAC', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(126, 'Macedonia, The Former Yugoslav Republic of', 'MK', 'MKD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(127, 'Madagascar', 'MG', 'MDG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(128, 'Malawi', 'MW', 'MWI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(129, 'Malaysia', 'MY', 'MYS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(130, 'Maldives', 'MV', 'MDV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(131, 'Mali', 'ML', 'MLI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(132, 'Malta', 'MT', 'MLT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(133, 'Marshall Islands', 'MH', 'MHL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(134, 'Martinique', 'MQ', 'MTQ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(135, 'Mauritania', 'MR', 'MRT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(136, 'Mauritius', 'MU', 'MUS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(137, 'Mayotte', 'YT', 'MYT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(138, 'Mexico', 'MX', 'MEX', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(139, 'Micronesia, Federated States of', 'FM', 'FSM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(140, 'Moldova, Republic of', 'MD', 'MDA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(141, 'Monaco', 'MC', 'MCO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(142, 'Mongolia', 'MN', 'MNG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(143, 'Montserrat', 'MS', 'MSR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(144, 'Morocco', 'MA', 'MAR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(145, 'Mozambique', 'MZ', 'MOZ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(146, 'Myanmar', 'MM', 'MMR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(147, 'Namibia', 'NA', 'NAM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(148, 'Nauru', 'NR', 'NRU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(149, 'Nepal', 'NP', 'NPL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(150, 'Netherlands', 'NL', 'NLD', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(151, 'Netherlands Antilles', 'AN', 'ANT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(152, 'New Caledonia', 'NC', 'NCL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(153, 'New Zealand', 'NZ', 'NZL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(154, 'Nicaragua', 'NI', 'NIC', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(155, 'Niger', 'NE', 'NER', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(156, 'Nigeria', 'NG', 'NGA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(157, 'Niue', 'NU', 'NIU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(158, 'Norfolk Island', 'NF', 'NFK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(159, 'Northern Mariana Islands', 'MP', 'MNP', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(160, 'Norway', 'NO', 'NOR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(161, 'Oman', 'OM', 'OMN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(162, 'Pakistan', 'PK', 'PAK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(163, 'Palau', 'PW', 'PLW', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(164, 'Panama', 'PA', 'PAN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(165, 'Papua New Guinea', 'PG', 'PNG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(166, 'Paraguay', 'PY', 'PRY', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(167, 'Peru', 'PE', 'PER', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(168, 'Philippines', 'PH', 'PHL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(169, 'Pitcairn', 'PN', 'PCN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(170, 'Poland', 'PL', 'POL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(171, 'Portugal', 'PT', 'PRT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(172, 'Puerto Rico', 'PR', 'PRI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(173, 'Qatar', 'QA', 'QAT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(174, 'Reunion', 'RE', 'REU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(175, 'Romania', 'RO', 'ROM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(176, 'Russian Federation', 'RU', 'RUS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(177, 'Rwanda', 'RW', 'RWA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(178, 'Saint Kitts and Nevis', 'KN', 'KNA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(179, 'Saint Lucia', 'LC', 'LCA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(180, 'Saint Vincent and the Grenadines', 'VC', 'VCT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(181, 'Samoa', 'WS', 'WSM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(182, 'San Marino', 'SM', 'SMR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(183, 'Sao Tome and Principe', 'ST', 'STP', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(184, 'Saudi Arabia', 'SA', 'SAU', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(185, 'Senegal', 'SN', 'SEN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(186, 'Seychelles', 'SC', 'SYC', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(187, 'Sierra Leone', 'SL', 'SLE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(188, 'Singapore', 'SG', 'SGP', 4, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(189, 'Slovakia (Slovak Republic)', 'SK', 'SVK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(190, 'Slovenia', 'SI', 'SVN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(191, 'Solomon Islands', 'SB', 'SLB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(192, 'Somalia', 'SO', 'SOM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(193, 'South Africa', 'ZA', 'ZAF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(194, 'South Georgia and the South Sandwich Islands', 'GS', 'SGS', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(195, 'Spain', 'ES', 'ESP', 3, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(196, 'Sri Lanka', 'LK', 'LKA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(197, 'St. Helena', 'SH', 'SHN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(198, 'St. Pierre and Miquelon', 'PM', 'SPM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(199, 'Sudan', 'SD', 'SDN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(200, 'Suriname', 'SR', 'SUR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(201, 'Svalbard and Jan Mayen Islands', 'SJ', 'SJM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(202, 'Swaziland', 'SZ', 'SWZ', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(203, 'Sweden', 'SE', 'SWE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(204, 'Switzerland', 'CH', 'CHE', 5, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(205, 'Syrian Arab Republic', 'SY', 'SYR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(206, 'Taiwan', 'TW', 'TWN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(207, 'Tajikistan', 'TJ', 'TJK', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(208, 'Tanzania, United Republic of', 'TZ', 'TZA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(209, 'Thailand', 'TH', 'THA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(210, 'Togo', 'TG', 'TGO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(211, 'Tokelau', 'TK', 'TKL', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(212, 'Tonga', 'TO', 'TON', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(213, 'Trinidad and Tobago', 'TT', 'TTO', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(214, 'Tunisia', 'TN', 'TUN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(215, 'Turkey', 'TR', 'TUR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(216, 'Turkmenistan', 'TM', 'TKM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(217, 'Turks and Caicos Islands', 'TC', 'TCA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(218, 'Tuvalu', 'TV', 'TUV', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(219, 'Uganda', 'UG', 'UGA', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(220, 'Ukraine', 'UA', 'UKR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(221, 'United Arab Emirates', 'AE', 'ARE', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(222, 'United Kingdom', 'GB', 'GBR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(223, 'United States', 'US', 'USA', 2, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(224, 'United States Minor Outlying Islands', 'UM', 'UMI', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(225, 'Uruguay', 'UY', 'URY', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(226, 'Uzbekistan', 'UZ', 'UZB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(227, 'Vanuatu', 'VU', 'VUT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(228, 'Vatican City State (Holy See)', 'VA', 'VAT', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(229, 'Venezuela', 'VE', 'VEN', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(230, 'Viet Nam', 'VN', 'VNM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(231, 'Virgin Islands (British)', 'VG', 'VGB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(232, 'Virgin Islands (U.S.)', 'VI', 'VIR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(233, 'Wallis and Futuna Islands', 'WF', 'WLF', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(234, 'Western Sahara', 'EH', 'ESH', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(235, 'Yemen', 'YE', 'YEM', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(236, 'Yugoslavia', 'YU', 'YUG', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(237, 'Zaire', 'ZR', 'ZAR', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(238, 'Zambia', 'ZM', 'ZMB', 1, 1);
INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `status`) VALUES(239, 'Zimbabwe', 'ZW', 'ZWE', 1, 1);

INSERT INTO `currencies` (`currencies_id`, `title`, `code`, `symbol_left`, `symbol_right`, `decimal_point`, `thousands_point`, `decimal_places`, `value`, `last_updated`) VALUES(1, 'Euro', 'EUR', '', 'EUR', ',', '.', '2', 1.00000000, '2008-05-08 14:15:39');
INSERT INTO `currencies` (`currencies_id`, `title`, `code`, `symbol_left`, `symbol_right`, `decimal_point`, `thousands_point`, `decimal_places`, `value`, `last_updated`) VALUES(2, 'Dollar', 'USD', '', 'USD', '.', ',', '2', 1.55792999, '2008-05-08 14:15:39');
INSERT INTO `currencies` (`currencies_id`, `title`, `code`, `symbol_left`, `symbol_right`, `decimal_point`, `thousands_point`, `decimal_places`, `value`, `last_updated`) VALUES(3, 'Schweizer Franken', 'CHF', '', 'CHF', ',', '.', '2', 1.62945998, NULL);

INSERT INTO `database_version` (`version`) VALUES('3.0.4.0');

INSERT INTO `feature_index` (`products_id`, `date_created`, `categories_index`, `feature_value_index`) VALUES(1, '0000-00-00 00:00:00', '-0--1-', '');

INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(530, 4, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(587, 4, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(581, 4, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(529, 4, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(230, 4, 'BOX_HEADING_ECONDA', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(532, 4, 'BOX_HEADING_STATISTICS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(589, 4, 'BOX_HEADING_MODULES', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(533, 4, 'BOX_HEADING_TOOLS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(583, 4, 'BOX_HEADING_GV_ADMIN', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(535, 4, 'BOX_HEADING_ZONE', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(536, 4, 'BOX_HEADING_CONFIGURATION', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(394, 7, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(269, 7, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(501, 8, 'BOX_HEADING_MODULES', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(502, 8, 'BOX_HEADING_STATISTICS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(223, 6, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(225, 6, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(320, 6, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(514, 8, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(372, 7, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(547, 8, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(378, 7, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(306, 7, 'BOX_HEADING_ZONE', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(505, 8, 'BOX_HEADING_ZONE', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(500, 8, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(366, 4, 'last', 0);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(557, 0, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(508, 8, 'BOX_HEADING_CONFIGURATION', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(504, 8, 'BOX_HEADING_GV_ADMIN', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(503, 8, 'BOX_HEADING_TOOLS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(432, 24, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(434, 24, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(436, 24, 'BOX_HEADING_GV_ADMIN', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(438, 24, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(456, 24, 'BOX_HEADING_ZONE', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(458, 24, 'BOX_HEADING_CONFIGURATION', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(450, 24, 'BOX_HEADING_STATISTICS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(454, 24, 'BOX_HEADING_TOOLS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(462, 24, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(464, 25, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(510, 25, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(516, 8, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(541, 44, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(543, 44, 'BOX_HEADING_GV_ADMIN', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(545, 44, 'BOX_HEADING_STATISTICS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(549, 44, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(597, 1, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(601, 2, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(561, 2, 'BOX_HEADING_PRODUCTS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(559, 2, 'BOX_HEADING_CUSTOMERS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(565, 2, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(567, 2, 'BOX_HEADING_MODULES', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(569, 3, 'BOX_HEADING_GAMBIO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(575, 2, 'BOX_HEADING_TOOLS', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(577, 3, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(593, 1, 'BOX_HEADING_GAMBIO_SEO', 1);
INSERT INTO `gm_admin_boxes` (`boxes_id`, `customers_id`, `box_key`, `box_status`) VALUES(603, 1, 'BOX_HEADING_GAMBIO', 1);


INSERT INTO `gm_admin_favorites` (`favorites_id`, `customers_id`, `link_key`, `sort_order`) VALUES(1, 1, 'id_e6d18015c0e4f88f119c48f00142e6d5', 0);
INSERT INTO `gm_admin_favorites` (`favorites_id`, `customers_id`, `link_key`, `sort_order`) VALUES(2, 1, 'id_46a7254c38e4bfacf97ae97135da12d9', 0);
INSERT INTO `gm_admin_favorites` (`favorites_id`, `customers_id`, `link_key`, `sort_order`) VALUES(3, 1, 'id_87bad688f21b28cca9981cbf2b843249', 0);
INSERT INTO `gm_admin_favorites` (`favorites_id`, `customers_id`, `link_key`, `sort_order`) VALUES(4, 1, 'id_ae14fd556f1e86067621605e2dac56b4', 0);
INSERT INTO `gm_admin_favorites` (`favorites_id`, `customers_id`, `link_key`, `sort_order`) VALUES(5, 1, 'id_393bb7cb2161a3c52f4feb39f71f1f2a', 0);


INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(14, 'digg.com', 'http://digg.com/submit?url=', 'diggs.gif');
INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(16, 'folkd', 'http://www.folkd.com/page/submit.html?addtofolkd=1&step1_sent=1&url=', 'folkd.gif');
INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(17, 'favoriten.de', 'http://www.favoriten.de/url-hinzufuegen.html?bm_url=', 'favoriten.gif');
INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(19, 'google', 'http://www.google.com/bookmarks/mark?op=add&hl=de&bkmk=', 'google.gif');
INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(20, 'del.icio.us', 'http://del.icio.us/post?url=', 'delicio.gif');
INSERT INTO `gm_bookmarks` (`gm_bookmarks_id`, `gm_bookmarks_name`, `gm_bookmarks_link`, `gm_bookmarks_image`) VALUES(24, 'edelight', 'http://www.edelight.de/geschenk/neu?purl=', 'edelight.gif');


INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'admin', 'gm_box_pos_2', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'categories', 'gm_box_pos_4', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'filter', 'gm_box_pos_6', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'login', 'gm_box_pos_8', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'bestsellers', 'gm_box_pos_10', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'reviews', 'gm_box_pos_12', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'gm_trusted_shops_widget', 'gm_box_pos_14', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'specials', 'gm_box_pos_16', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'add_quickie', 'gm_box_pos_18', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'search', 'gm_box_pos_20', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'manufacturers_info', 'gm_box_pos_22', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'languages', 'gm_box_pos_24', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'currencies', 'gm_box_pos_26', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'infobox', 'gm_box_pos_28', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'newsletter', 'gm_box_pos_30', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'gm_counter', 'gm_box_pos_32', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'last_viewed', 'gm_box_pos_34', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'whatsnew', 'gm_box_pos_36', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'order_history', 'gm_box_pos_38', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'manufacturers', 'gm_box_pos_40', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'trusted', 'gm_box_pos_42', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'gm_scroller', 'gm_box_pos_44', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'information', 'gm_box_pos_46', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'content', 'gm_box_pos_48', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'gm_bookmarks', 'gm_box_pos_50', 1);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'paypal', 'gm_box_pos_52', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox1', 'gm_box_pos_54', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox2', 'gm_box_pos_56', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox3', 'gm_box_pos_58', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox4', 'gm_box_pos_60', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox5', 'gm_box_pos_62', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox6', 'gm_box_pos_64', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox7', 'gm_box_pos_66', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'yoochoose_also_clicked', 'gm_box_pos_68', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox8', 'gm_box_pos_70', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'yoochoose_top_selling', 'gm_box_pos_72', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'extrabox9', 'gm_box_pos_74', 0);
INSERT INTO `gm_boxes` (`template_name`, `box_name`, `position`, `box_status`) VALUES('EyeCandy', 'ekomi', 'gm_box_pos_76', 0);

INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(7, 'GM_SCROLLER_HEIGHT', '200', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(8, 'GM_SCROLLER_SPEED', '50', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(921, 'GM_PDF_CONDITIONS_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(922, 'GM_PDF_CONDITIONS_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(923, 'GM_PDF_CONDITIONS_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(924, 'GM_PDF_HEADING_CONDITIONS_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(925, 'GM_PDF_HEADING_CONDITIONS_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(926, 'GM_PDF_HEADING_CONDITIONS_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(927, 'GM_PDF_FOOTER_FONT_SIZE', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(928, 'GM_PDF_FOOTER_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(929, 'GM_PDF_FOOTER_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(930, 'GM_PDF_ORDER_INFO_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(931, 'GM_PDF_ORDER_INFO_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(932, 'GM_PDF_ORDER_INFO_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(933, 'GM_PDF_HEADING_ORDER_INFO_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(934, 'GM_PDF_HEADING_ORDER_INFO_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(935, 'GM_PDF_HEADING_ORDER_INFO_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(936, 'GM_PDF_ORDER_TOTAL_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(937, 'GM_PDF_ORDER_TOTAL_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(938, 'GM_PDF_ORDER_TOTAL_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(939, 'GM_PDF_ORDER_FONT_SIZE', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(940, 'GM_PDF_ORDER_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(941, 'GM_PDF_ORDER_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(942, 'GM_PDF_HEADING_ORDER_FONT_SIZE', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(943, 'GM_PDF_HEADING_ORDER_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(944, 'GM_PDF_HEADING_ORDER_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(945, 'GM_PDF_HEADING_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(946, 'GM_PDF_HEADING_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(947, 'GM_PDF_HEADING_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(948, 'GM_PDF_COMPANY_RIGHT_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(949, 'GM_PDF_COMPANY_RIGHT_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(950, 'GM_PDF_COMPANY_RIGHT_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(951, 'GM_PDF_COMPANY_LEFT_FONT_SIZE', '9', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(952, 'GM_PDF_COMPANY_LEFT_FONT_STYLE', 'u', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(953, 'GM_PDF_COMPANY_LEFT_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(954, 'GM_PDF_CUSTOMER_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(955, 'GM_PDF_CUSTOMER_FONT_STYLE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(956, 'GM_PDF_CUSTOMER_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(957, 'GM_PDF_DEFAULT_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(958, 'GM_PDF_DEFAULT_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(959, 'GM_PDF_DEFAULT_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(960, 'GM_PDF_HEADING_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(961, 'GM_PDF_HEADING_INVOICE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(962, 'GM_PDF_COMPANY_ADRESS_RIGHT', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(963, 'GM_PDF_COMPANY_ADRESS_LEFT', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(964, 'GM_PDF_INFO_TEXT_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(965, 'GM_PDF_INFO_TEXT_INVOICE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(966, 'GM_PDF_INFO_TITLE_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(967, 'GM_PDF_INFO_TITLE_INVOICE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(968, 'GM_PDF_HEADING_INFO_TEXT_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(969, 'GM_PDF_HEADING_INFO_TEXT_INVOICE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(970, 'GM_PDF_FOOTER_CELL_4', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(971, 'GM_PDF_FOOTER_CELL_3', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(972, 'GM_PDF_FOOTER_CELL_2', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(973, 'GM_PDF_FOOTER_CELL_1', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(974, 'GM_PDF_HEADING_CONDITIONS', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1003, 'GM_PDF_USE_CUSTOMER_COMMENT', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1005, 'GM_PDF_LOGO_SRC', 'pdf_logo.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(975, 'GM_PDF_HEADING_WITHDRAWAL', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(976, 'GM_PDF_CONDITIONS', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(977, 'GM_PDF_WITHDRAWAL', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(978, 'GM_PDF_USE_CUSTOMER_CODE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(979, 'GM_PDF_USE_ORDER_CODE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(980, 'GM_PDF_USE_PACKING_CODE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(981, 'GM_PDF_USE_INVOICE_CODE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(982, 'GM_PDF_USE_ORDER_DATE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(983, 'GM_PDF_USE_DATE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(984, 'GM_PDF_USE_WITHDRAWAL', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(985, 'GM_PDF_USE_CONDITIONS', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(986, 'GM_PDF_USE_INFO_TEXT', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(987, 'GM_PDF_USE_INFO', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(988, 'GM_PDF_USE_FOOTER', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(989, 'GM_PDF_FIX_HEADER', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(990, 'GM_PDF_USE_HEADER', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(992, 'GM_PDF_DISPLAY_LAYOUT', 'continuous', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(993, 'GM_PDF_DISPLAY_ZOOM', 'real', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(994, 'GM_PDF_CUSTOMER_ADR_POS', '50', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(995, 'GM_PDF_CELL_HEIGHT', '5', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(996, 'GM_PDF_ORDER_INFO_MARGIN_TOP', '30', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(997, 'GM_PDF_HEADING_MARGIN_BOTTOM', '15', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(998, 'GM_PDF_HEADING_MARGIN_TOP', '15', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(999, 'GM_PDF_LEFT_MARGIN', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1000, 'GM_PDF_BOTTOM_MARGIN', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1001, 'GM_PDF_RIGHT_MARGIN', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1002, 'GM_PDF_TOP_MARGIN', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1009, 'GM_PDF_CONDITIONS_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1011, 'GM_PDF_HEADING_CONDITIONS_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1013, 'GM_PDF_FOOTER_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1015, 'GM_PDF_ORDER_INFO_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1017, 'GM_PDF_HEADING_ORDER_INFO_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1019, 'GM_PDF_ORDER_TOTAL_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1021, 'GM_PDF_ORDER_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1023, 'GM_PDF_HEADING_ORDER_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1025, 'GM_PDF_HEADING_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1027, 'GM_PDF_COMPANY_RIGHT_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1029, 'GM_PDF_COMPANY_LEFT_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1031, 'GM_PDF_CUSTOMER_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1033, 'GM_PDF_DEFAULT_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1034, 'GM_GUESTBOOK_WAITING_TIME', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1035, 'GM_GUESTBOOK_BLACKLIST', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1036, 'GM_GUESTBOOK_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1084, 'GM_STAT_PLOT_WIDTH', '640', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1039, 'GM_PDF_DRAW_COLOR', '#0065AC', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1040, 'GM_PDF_ALLOW_COPYING', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1038, 'GM_TEMPLATE_NAME', 'xtc4', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1041, 'GM_PDF_ALLOW_NOTIFYING', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1042, 'GM_PDF_ALLOW_MODIFYING', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1043, 'GM_PDF_ALLOW_PRINTING', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1048, 'GM_GUESTBOOK_ENTRIES_LIMIT', '5', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1046, 'GM_COUNTER_IP_BARRIER', '86400', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1047, 'GM_COUNTER_IP_BARRIER', '86400', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1049, 'UPLOAD_CONTENT_EXTENSIONS', 'html,htm,xhtml,xml,txt,php,php3,php4,php5,js', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1050, 'GM_BOOKMARKS_CATEGORIES', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1051, 'GM_BOOKMARKS_ARTICLES', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1052, 'GM_BOOKMARKS_START', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1053, 'GM_BOOKMARKS_REST', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1054, 'GM_LOGO_SHOP', 'shop_logo.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1055, 'GM_LOGO_MAIL', 'email_logo.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1056, 'GM_LOGO_OVERLAY', 'overlay.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1057, 'GM_LOGO_FAVICON', 'favicon.ico', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1058, 'GM_LOGIN_TIMEOUT', '20', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1059, 'GM_LOGIN_TRYOUT', '2', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1060, 'GM_LOGIN_TIMELINE', '20', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1061, 'GM_LOGO_SHOP_USE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1095, 'GM_TOPMENU_MODE', 'mode1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1063, 'GM_LOGO_FAVICON_USE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1064, 'GM_LOGO_FLASH_USE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1065, 'GM_LOGO_OVERLAY_USE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1072, 'GM_LOGO_FLASH', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1073, 'GM_LOGO_PDF_USE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1074, 'GM_LOGO_PDF', 'pdf_logo.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1075, 'GM_PRICE_OFFER_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1077, 'GM_REVIEWS_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1078, 'GM_TELL_A_FRIEND_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1079, 'TAX_INFO_TAX_FREE', 'false', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1080, 'GM_GUESTBOOK_ACTIVATE_ENTRIES', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1081, 'GM_CALLBACK_SERVICE_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1085, 'GM_STAT_PLOT_HEIGHT', '480', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1086, 'GM_TELL_A_FRIEND', 'false', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1089, 'GM_ANALYTICS_CODE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1090, 'GM_ANALYTICS_CODE_USE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1096, 'GM_SHOW_ATTRIBUTES_STOCK', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1097, 'GM_HIDE_ATTR_OUT_OF_STOCK', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1098, 'GM_SET_OUT_OF_STOCK_PRODUCTS_INACTIVE', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1099, 'GM_CONTACT_VVCODE', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1105, 'GM_CART_ON_TOP', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1106, 'GM_LOGO_CAT', 'item_ltr.gif', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1107, 'GM_LOGO_CAT_USE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1108, 'GM_SITEMAP_GOOGLE_CHANGEFREQ', 'weekly', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1109, 'GM_SITEMAP_GOOGLE_PRIORITY', '0.5', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1110, 'GM_SITEMAP_GOOGLE_LANGUAGE_ID', '2', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1111, 'GM_SPECIALS_STARTPAGE', '6', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1112, 'GM_NEW_PRODUCTS_STARTPAGE', '3', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1113, 'GM_PDF_USE_PRODUCTS_MODEL', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1114, 'GM_SHOW_WISH_LIST', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1115, 'GM_SHOP_OFFLINE_MSG', '<p><font face="Arial" size="2">Unser Shop ist aufgrund von Wartungsarbeiten im Moment nicht erreichbar.<br />\r\n</font><font face="Arial" size="2">Bitte besuchen Sie uns zu einem sp&auml;teren Zeitpunkt noch einmal.</font><br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<a href="login_admin.php"><font color="#808080">Login</font></a></p>', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1116, 'GM_SHOP_OFFLINE', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1117, 'TRUNCATE_PRODUCTS_NAME', '40', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1123, 'GM_SEO_BOOST_PRODUCTS', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1118, 'GM_LIGHTBOX_CREATE_ACCOUNT', 'false', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1119, 'GM_LIGHTBOX_CART', 'false', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1120, 'GM_LIGHTBOX_CHECKOUT', 'false', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1124, 'GM_SEO_BOOST_CATEGORIES', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1125, 'GM_SEO_BOOST_CONTENT', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1126, 'GM_CHECK_CONDITIONS', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1127, 'GM_SHOW_CONDITIONS', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1136, 'GM_WITHDRAWAL_CONTENT_ID', '9', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1129, 'GM_SHOW_WITHDRAWAL', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1137, 'GM_SHOW_PRIVACY_ORDER', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1133, 'GM_SHOW_PRIVACY_REGISTRATION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1138, 'GM_CHECK_PRIVACY_ORDER', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1139, 'GM_SHOW_PRIVACY_CONFIRMATION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1140, 'GM_SHOW_CONDITIONS_CONFIRMATION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1141, 'GM_SHOW_WITHDRAWAL_CONFIRMATION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1150, 'GM_LOGO_MAIL_USE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1147, 'GM_LOG_IP', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1145, 'GM_CHECK_WITHDRAWAL', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1146, 'TRUSTED_SHOP_ID', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1148, 'GM_SHOW_IP', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1149, 'GM_CONFIRM_IP', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1152, 'GM_SEARCH_TRYOUT', '2', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1153, 'GM_SEARCH_TIMELINE', '20', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1154, 'GM_SEARCH_TIMEOUT', '20', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1155, 'GM_UNDERLINE_LINKS', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1156, 'GM_GUESTBOOK_SEND_MAIL', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1157, 'GM_ORDER_STATUS_CANCEL_ID', '99', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1158, 'GM_PDF_CANCEL_FONT_COLOR', '#000000', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1159, 'GM_PDF_CANCEL_FONT_SIZE', '11', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1160, 'GM_PDF_CANCEL_FONT_STYLE', 'b', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1161, 'GM_PDF_CANCEL_FONT_FACE', 'helvetica', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1162, 'GM_PDF_DISPLAY_OUTPUT', 'I', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1163, 'GM_GAMBIO_CORNER', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1164, 'GM_BOOKMARKS_CONTENT', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1165, 'GM_CAT_HOVER', '#b3ccdd', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1166, 'GM_STARTPAGE_HOVER', '#b3ccdd', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1168, 'GM_FOOTER', '<a href="http://www.gambio.de" target="_blank">Shopsoftware</a> by Gambio.de &copy; 2011', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1170, 'GM_OPENSEARCH_BOX', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1171, 'GM_OPENSEARCH_SEARCH', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1173, 'TRUNCATE_PRODUCTS_HISTORY', '16', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1174, 'GM_NEXT_INVOICE_ID', '12', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1175, 'GM_NEXT_PACKINGS_ID', '87', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1176, 'GM_INVOICE_ID', 'R_{INVOICE_ID}_2008', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1177, 'GM_PACKINGS_ID', '{DELIVERY_ID}_2008', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1178, 'GM_OPENSEARCH_CHANGED', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1179, 'GM_SHOW_FLYOVER', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1180, 'GM_LOGO_CAT_SIZE_W', '5', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1181, 'GM_LOGO_CAT_SIZE_H', '13', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1182, 'GM_LOGO_SHOP_SIZE_W', '142', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1183, 'GM_LOGO_SHOP_SIZE_H', '96', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1184, 'GM_LOGO_FLASH_SIZE_W', '160', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1185, 'GM_LOGO_FLASH_SIZE_H', '600', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1186, 'GM_SHOW_WISHLIST', 'true', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1187, 'GM_TITLE_USE_STANDARD_META_TITLE', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_configuration_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(1188, 'GM_TITLE_SHOW_STANDARD_META_TITLE', 'before', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_ALLOWED_FILE_EXTENSIONS', 'jpg,png,gif,jpeg', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_CHARACTER_LENGTH', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_AUTO_WIDTH', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_POSITION', '3', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_SHOW_PRODUCTS_DESCRIPTION', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_EXCLUDE_SPACES', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_SHOW_TABS', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_UPLOADS_PER_IP', '0', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GPRINT_UPLOADS_PER_IP_INTERVAL', '60', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_POSITION', '3', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_WIDTH', '351', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_HEIGHT', '200', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_LIGHTBOX_WIDTH', '700', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_LIGHTBOX_HEIGHT', '400', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_AUTO_WIDTH', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_LIGHTBOX', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_POSITION_FROM', '0% 50%', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_POSITION_TO', '100% 50%', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_ZOOM_FROM', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_ZOOM_TO', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_LIGHTBOX_ZOOM_FROM', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_LIGHTBOX_ZOOM_TO', '1', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_GMOTION_STANDARD_DURATION', '10', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_PDF_ORDER_STATUS_INVOICE_DATE', '149', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_PDF_ORDER_STATUS_INVOICE_MAIL', '149', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_PDF_ORDER_STATUS_INVOICE', '149', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('TRUNCATE_FLYOVER', '35', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('TRUNCATE_FLYOVER_TEXT', '150', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_CAPTCHA_TYPE', 'standard', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_RECAPTCHA_PUBLIC_KEY', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_RECAPTCHA_PRIVATE_KEY', '', 0, 0);
INSERT INTO `gm_configuration` (`gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES('GM_FORGOT_PASSWORD_VVCODE', 'true', 0, 0);

INSERT INTO `gm_configuration` SET `gm_key` = 'GM_AUTO_SHIPPING_STATUS', `gm_value` = 'true';

INSERT INTO `gm_configuration` SET `gm_key` = 'CUSTOMIZER_POSITION', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_GALLERY', `gm_value` = 'true';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_ZOOM', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'CAT_MENU_TOP', `gm_value` = 'true';
INSERT INTO `gm_configuration` SET `gm_key` = 'CAT_MENU_LEFT', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'CAT_MENU_CLASSIC', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_TOP_LANGUAGE_SELECTION', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_TOP_CURRENCY_SELECTION', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_FOOTER', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_QUICK_SEARCH', `gm_value` = 'true';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_FACEBOOK', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_PRINT', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_BOOKMARKING', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SECURE_TOKEN', `gm_value` = md5(rand());
INSERT INTO `gm_configuration` SET `gm_key` = 'PRICE_FILTER_FROM_ACTIVE', `gm_value` = 'true';
INSERT INTO `gm_configuration` SET `gm_key` = 'PRICE_FILTER_TO_ACTIVE', `gm_value` = 'true';

INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_CALLBACK', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_CONTACT', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_TELL_A_FRIEND', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_FOUND_CHEAPER', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_REVIEWS', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_ACCOUNT_CONTACT', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_ACCOUNT_ADDRESS_BOOK', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_ACCOUNT_NEWSLETTER', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_CHECKOUT_SHIPPING', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_CHECK_PRIVACY_CHECKOUT_PAYMENT', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'MAIN_SHOW_ATTRIBUTES', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'MAIN_SHOW_GRADUATED_PRICES', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'MAIN_SHOW_QTY', `gm_value` = 'true';
INSERT INTO `gm_configuration` SET `gm_key` = 'MAIN_SHOW_QTY_INFO', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'MAIN_VIEW_MODE_TILED', `gm_value` = 'false';

INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_OLD_SPECIAL_PRICE', `gm_value` = '0';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_OLD_DISCOUNT_PRICE', `gm_value` = '1';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_OLD_GROUP_PRICE', `gm_value` = '0';

INSERT INTO `gm_configuration` SET `gm_key` = 'EKOMI_STATUS', `gm_value` = '0';
INSERT INTO `gm_configuration` SET `gm_key` = 'EKOMI_API_PASSWORD', `gm_value` = '';
INSERT INTO `gm_configuration` SET `gm_key` = 'EKOMI_API_ID', `gm_value` = '';
INSERT INTO `gm_configuration` SET `gm_key` = 'EKOMI_WIDGET_CODE', `gm_value` = '';

INSERT INTO `gm_configuration` SET `gm_key` = 'DISPLAY_TAX', `gm_value` = '1';

INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_TWITTER', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_GOOGLEPLUS', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'SHOW_PINTEREST', `gm_value` = 'false';
INSERT INTO `gm_configuration` SET `gm_key` = 'GM_ORDER_STATUS_INVOICE_CREATED_ID', `gm_value` = '149';

INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(103, 1, 'robots', 'index,follow', 1, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(104, 2, 'robots', 'index,follow', 1, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(105, 1, 'keywords', '', 1, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(107, 2, 'keywords', 'keywords,kommagetrennt', 1, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(117, 2, 'XTCsid', 'b391baf59be7494b871846d2d5bf7a45', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(5, 2, 'GM_PDF_HEADING_PACKINGSLIP', 'Ihr Lieferschein', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(6, 2, 'GM_PDF_HEADING_INVOICE', 'Ihre Rechnung', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(7, 2, 'GM_PDF_COMPANY_ADRESS_RIGHT', 'Ihr Name \nIhre Strasse 1 \n\n12345 Ihr Ort', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(8, 2, 'GM_PDF_COMPANY_ADRESS_LEFT', 'Ihr Name, Ihre Strasse 1, 12345 Ihr Ort', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(9, 1, 'GM_PDF_HEADING_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(10, 1, 'GM_PDF_HEADING_INVOICE', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(11, 1, 'GM_PDF_COMPANY_ADRESS_RIGHT', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(12, 1, 'GM_PDF_COMPANY_ADRESS_LEFT', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(13, 2, 'GM_PDF_HEADING_CONDITIONS', 'Unsere AGB', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(14, 2, 'GM_PDF_HEADING_WITHDRAWAL', 'Unser Widerrufsrecht', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(15, 2, 'GM_PDF_CONDITIONS', 'Hier knnten Ihre AGB stehen.', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(16, 2, 'GM_PDF_WITHDRAWAL', 'Hier knnte Ihr Widerrufsrecht stehen.', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(17, 1, 'GM_PDF_HEADING_CONDITIONS', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(18, 1, 'GM_PDF_HEADING_WITHDRAWAL', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(19, 1, 'GM_PDF_CONDITIONS', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(20, 1, 'GM_PDF_WITHDRAWAL', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(43, 1, 'GM_PDF_EMAIL_TEXT', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(44, 2, 'GM_PDF_EMAIL_TEXT', 'Sehr geehrte/r {CUSTOMER},\n\nSie erhalten mit dieser E-Mail Ihre Rechnung Nr. {INVOICE_ID} von der Bestellung Nr. {ORDER_ID} vom {DATE}.\n\nMit freundlichem Gruss\n\nIhr Ansprechpartner', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(21, 2, 'GM_PDF_INFO_TEXT_PACKINGSLIP', 'Ihr Hinweistext fr den Lieferschein', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(22, 2, 'GM_PDF_INFO_TEXT_INVOICE', 'Ihr Hinweistext fr die Rechnung', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(23, 2, 'GM_PDF_INFO_TITLE_PACKINGSLIP', 'Beachten Sie bitte', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(24, 2, 'GM_PDF_INFO_TITLE_INVOICE', 'Beachten Sie bitte', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(25, 2, 'GM_PDF_HEADING_INFO_TEXT_PACKINGSLIP', 'Lieferhinweis', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(26, 2, 'GM_PDF_HEADING_INFO_TEXT_INVOICE', 'Rechnungshinweis', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(27, 2, 'GM_PDF_FOOTER_CELL_4', 'Zustzliche\nInformationen\nin der vierten\nSpalte\n', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(28, 2, 'GM_PDF_FOOTER_CELL_3', 'Ihre Steuernummer\nIhre Ust. ID. Nr.\nIhre Gerichtsbarkeit\nIhre Informationen', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(29, 2, 'GM_PDF_FOOTER_CELL_2', 'Ihre Telefonnummer\nIhre Faxnummer\nIhre Homepage\nIhre E-Mail', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(30, 2, 'GM_PDF_FOOTER_CELL_1', 'Ihr Name \nIhre Strasse 1 \n\n12345 Ihr Ort', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(31, 1, 'GM_PDF_INFO_TEXT_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(32, 1, 'GM_PDF_INFO_TEXT_INVOICE', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(33, 1, 'GM_PDF_INFO_TITLE_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(34, 1, 'GM_PDF_INFO_TITLE_INVOICE', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(35, 1, 'GM_PDF_HEADING_INFO_TEXT_PACKINGSLIP', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(36, 1, 'GM_PDF_HEADING_INFO_TEXT_INVOICE', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(37, 1, 'GM_PDF_FOOTER_CELL_4', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(38, 1, 'GM_PDF_FOOTER_CELL_3', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(39, 1, 'GM_PDF_FOOTER_CELL_2', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(40, 1, 'GM_PDF_FOOTER_CELL_1', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(73, 0, 'GM_BOOKMARKS_CATEGORIES', '1', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(74, 0, 'GM_BOOKMARKS_ARTICLES', '1', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(75, 0, 'GM_BOOKMARKS_START', '1', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(76, 0, 'GM_BOOKMARKS_REST', '1', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(120, 2, 'GM_SCROLLER_CONTENT', '<p style="text-align: center;"><strong>Hier ist genug Platz f&uuml;r Ihre Texte, Links&nbsp;und Bilder!</strong></p>\r\n<p style="text-align: center;">&nbsp;</p>\r\n<p style="text-align: center;"><a href="http://www.gambio.de"><strong><img height="64" width="145" src="images/gambio-logo.jpg" alt="" /></strong></a></p>', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(121, 1, 'GM_SCROLLER_CONTENT', '<p>News</p>', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(125, 2, 'GM_PDF_EMAIL_SUBJECT', 'Ihre Rechnung der Nr. {INVOICE_ID} vom {DATE} mit der Bestellnummer {ORDER_ID}', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(127, 2, 'GM_OPENSEARCH_SHORTNAME', 'Shop Suche', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(128, 2, 'GM_OPENSEARCH_LONGNAME', 'Unsere Shopsuche findet alles', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(129, 2, 'GM_OPENSEARCH_DESCRIPTION', 'Super Such Beschreibung', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(130, 2, 'GM_OPENSEARCH_TAGS', 'Shopsuche Suchen Shop', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(131, 2, 'GM_OPENSEARCH_CONTACT', 'admin@shop.de', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(143, 1, 'GM_OPENSEARCH_TEXT', 'Instant Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(133, 2, 'GM_OPENSEARCH_LINK', 'Suche zu Ihrer Browser-Schnellsuche hinzufgen.', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(141, 2, 'GM_OPENSEARCH_TEXT', 'Browser-Schnellsuche', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(135, 1, 'GM_OPENSEARCH_LINK', 'Add this Search to your Browser Instant Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(136, 1, 'GM_OPENSEARCH_SHORTNAME', 'Shop Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(137, 1, 'GM_OPENSEARCH_LONGNAME', 'Shop Instant Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(138, 1, 'GM_OPENSEARCH_DESCRIPTION', 'Add this Search to your Browser Instant Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(139, 1, 'GM_OPENSEARCH_TAGS', 'Instant Search', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(140, 1, 'GM_OPENSEARCH_CONTACT', 'you@example.com', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(142, 1, 'GM_PDF_EMAIL_SUBJECT', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(145, 2, 'date', '', 1, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(146, 1, 'GM_TITLE_STANDARD_META_TITLE_SEPARATOR', ' - ', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(147, 2, 'GM_TITLE_STANDARD_META_TITLE_SEPARATOR', ' - ', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(148, 1, 'GM_TITLE_STANDARD_META_TITLE', '', 0, 0);
INSERT INTO `gm_contents` (`gm_contents_id`, `languages_id`, `gm_key`, `gm_value`, `gm_group_id`, `gm_sort_order`) VALUES(149, 2, 'GM_TITLE_STANDARD_META_TITLE', '', 0, 0);
INSERT INTO gm_contents (languages_id, gm_key, gm_value) VALUES (1, 'YOOCHOOSE_BOX_TOP_SELLING_HEADER', 'Ultimately Bought');
INSERT INTO gm_contents (languages_id, gm_key, gm_value) VALUES (2, 'YOOCHOOSE_BOX_TOP_SELLING_HEADER', 'Anschlie&szlig;end gekauft');
INSERT INTO gm_contents (languages_id, gm_key, gm_value) VALUES (1, 'YOOCHOOSE_BOX_ALSO_CLICKED_HEADER', 'Also Viewed');
INSERT INTO gm_contents (languages_id, gm_key, gm_value) VALUES (2, 'YOOCHOOSE_BOX_ALSO_CLICKED_HEADER', 'Schauen Sie sich auch an');
INSERT INTO gm_contents (languages_id, gm_key, gm_value) VALUES (1, 'EMAIL_BILLING_SUBJECT_ORDER', 'Your order {$nr}, {$date}');
INSERT INTO gm_contents (languages_id, gm_key, gm_value) VALUES (2, 'EMAIL_BILLING_SUBJECT_ORDER', 'Ihre Bestellung {$nr}, am {$date}');

INSERT INTO `gm_counter_info` (`gm_counter_info_id`, `gm_counter_info_type_id`, `gm_counter_info_hits`, `gm_counter_info_name`) VALUES(126, 1, 1, 'Mozilla Firefox 3.0.1');
INSERT INTO `gm_counter_info` (`gm_counter_info_id`, `gm_counter_info_type_id`, `gm_counter_info_hits`, `gm_counter_info_name`) VALUES(127, 2, 1, 'Windows XP');
INSERT INTO `gm_counter_info` (`gm_counter_info_id`, `gm_counter_info_type_id`, `gm_counter_info_hits`, `gm_counter_info_name`) VALUES(128, 5, 1, 'de');
INSERT INTO `gm_counter_info` (`gm_counter_info_id`, `gm_counter_info_type_id`, `gm_counter_info_hits`, `gm_counter_info_name`) VALUES(129, 3, 1, '1680x1050');
INSERT INTO `gm_counter_info` (`gm_counter_info_id`, `gm_counter_info_type_id`, `gm_counter_info_hits`, `gm_counter_info_name`) VALUES(130, 4, 1, '32');


INSERT INTO `gm_counter_info_type` (`gm_counter_info_type_id`, `gm_counter_info_type_name`) VALUES(1, 'browser');
INSERT INTO `gm_counter_info_type` (`gm_counter_info_type_id`, `gm_counter_info_type_name`) VALUES(2, 'platform');
INSERT INTO `gm_counter_info_type` (`gm_counter_info_type_id`, `gm_counter_info_type_name`) VALUES(3, 'resolution');
INSERT INTO `gm_counter_info_type` (`gm_counter_info_type_id`, `gm_counter_info_type_name`) VALUES(4, 'color_depth');
INSERT INTO `gm_counter_info_type` (`gm_counter_info_type_id`, `gm_counter_info_type_name`) VALUES(5, 'origin');



INSERT INTO `gm_counter_visits` (`gm_counter_id`, `gm_counter_visits_total`, `gm_counter_date`) VALUES(1, 1, '2008-08-25 00:00:00');


INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(1, 1, 2, '', 'change_password_mail', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n    <tbody>\r\n        <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">            \r\n		{if $gm_logo_mail}\r\n                        <div align="right">{$gm_logo_mail}</div>\r\n                {/if}		\r\n            </td>\r\n        </tr>\r\n        <tr>\r\n            <td>\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><strong>Sehr geehrter Kunde,</strong></font></p>\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">ihr Passwort wurde erfolgreich ge&auml;ndert.<br />\r\n            <br />\r\n            Ihre neuen Logindaten lauten:</font><font size="1" face="Verdana, Arial, Helvetica, sans-serif">       </font></p>\r\n            <table width="100%" border="0" bgcolor="#f1f1f1">\r\n                <tbody>\r\n                    <tr>\r\n                        <td><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><strong>E-Mail:</strong>                     {$EMAIL}             <br />\r\n                        <strong>Neues Passwort:</strong>            {$PASSWORD}         </font></td>\r\n                    </tr>\r\n                </tbody>\r\n            </table>\r\n            </td>\r\n        </tr>\r\n    </tbody>\r\n</table>\r\n<br />\r\n<br />\r\n{$EMAIL_SIGNATURE_HTML}', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n    <tbody>\r\n        <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">            \r\n		{if $gm_logo_mail}\r\n                        <div align="right">{$gm_logo_mail}</div>\r\n                {/if}		\r\n            </td>\r\n        </tr>\r\n        <tr>\r\n            <td>\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><strong>Sehr geehrter Kunde,</strong></font></p>\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">ihr Passwort wurde erfolgreich ge&auml;ndert.<br />\r\n            <br />\r\n            Ihre neuen Logindaten lauten:</font><font size="1" face="Verdana, Arial, Helvetica, sans-serif">       </font></p>\r\n            <table width="100%" border="0" bgcolor="#f1f1f1">\r\n                <tbody>\r\n                    <tr>\r\n                        <td><font size="1" face="Verdana, Arial, Helvetica, sans-serif"><strong>E-Mail:</strong>                     {$EMAIL}             <br />\r\n                        <strong>Neues Passwort:</strong>            {$PASSWORD}         </font></td>\r\n                    </tr>\r\n                </tbody>\r\n            </table>\r\n            </td>\r\n        </tr>\r\n    </tbody>\r\n</table>', 'Sehr geehrter Kunde,\r\n\r\nihr Passwort wurde erfolgreich gendert.\r\n\r\nIhre neuen Logindaten lauten: \r\nE-Mail: {$EMAIL}\r\nNeues Passwort: {$PASSWORD}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Sehr geehrter Kunde,\r\n\r\nihr Passwort wurde erfolgreich gendert.\r\n\r\nIhre neuen Logindaten lauten: \r\nE-Mail: {$EMAIL}\r\nNeues Passwort: {$PASSWORD}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(2, 2, 2, '', 'create_account_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong></font> <br />\n            <br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">Sie haben soeben Ihr Kundenkonto erfolgreich erstellt. Als registrierter Kunde haben Sie folgende Vorteile in unserem Shop:</font><br />\n            <br />\n            <font size="2"><b><font face="Verdana, Arial, Helvetica, sans-serif">- Kundenwarenkorb:</font></b><font face="Verdana, Arial, Helvetica, sans-serif"> Jeder Artikel bleibt registriert bis Sie zur Kasse gehen oder die Produkte aus dem Warenkorb entfernen.<br />\n            <b>- Adressbuch:</b> Wir k&ouml;nnen jetzt die Produkte zu der von Ihnen ausgesuchten Adresse senden. Der perfekte Weg ein Geburtstagsgeschenk zu versenden.<br />\n            <b>- Vorherige Bestellungen:</b> Sie k&ouml;nnen jederzeit Ihre vorherigen Bestellungen &uuml;berpr&uuml;fen.<br />\n            <b>- Meinungen &uuml;ber Produkte:</b> Teilen Sie Ihre Meinung zu unseren Produkten mit anderen Kunden.<br />\n            </font></font><br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">Falls Sie Fragen zu unserem Kunden-Service haben, wenden Sie sich bitte an:        {$content.MAIL_REPLY_ADDRESS}       . <br />\n            Achtung: Diese E-Mail-Adresse wurde uns von einem Kunden bekannt gegeben. Falls Sie sich nicht angemeldet haben, senden Sie bitte eine E-Mail an      {$content.MAIL_REPLY_ADDRESS}. <br />\n            <br />\n            {if $SEND_GIFT==true}     <br />\n            Als kleines Willkommensgeschenk senden wir Ihnen einen Gutschein &uuml;ber: <b>{$GIFT_AMMOUNT}</b><br />\n            <br />\n            Ihr pers&ouml;nlicher Gutschein-Code lautet <b>{$GIFT_CODE}</b>. Sie k&ouml;nnen diese Gutschrift an der Kasse w&auml;hrend des Bestellvorganges verbuchen.<br />\n            <br />\n            Um den Gutschein einzul&ouml;sen klichen Sie bitte auf <a href="{$GIFT_LINK}">[Gutschein Einl&ouml;sen]</a>.{/if}  {if $SEND_COUPON==true}  Als kleines Willkommensgeschenk senden wir Ihnen einen Kupon.<br />\n            Kuponbeschreibung: <b>{$COUPON_DESC}</b>   <br />\n            Geben Sie einfach Ihren pers&ouml;nlichen Code {$COUPON_CODE} w&auml;hrend des Bezahlvorganges ein.{/if}  </font></td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong></font> <br />\n            <br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">Sie haben soeben Ihr Kundenkonto erfolgreich erstellt. Als registrierter Kunde haben Sie folgende Vorteile in unserem Shop:</font><br />\n            <br />\n            <font size="2"><b><font face="Verdana, Arial, Helvetica, sans-serif">- Kundenwarenkorb:</font></b><font face="Verdana, Arial, Helvetica, sans-serif"> Jeder Artikel bleibt registriert bis Sie zur Kasse gehen oder die Produkte aus dem Warenkorb entfernen.<br />\n            <b>- Adressbuch:</b> Wir k&ouml;nnen jetzt die Produkte zu der von Ihnen ausgesuchten Adresse senden. Der perfekte Weg ein Geburtstagsgeschenk zu versenden.<br />\n            <b>- Vorherige Bestellungen:</b> Sie k&ouml;nnen jederzeit Ihre vorherigen Bestellungen &uuml;berpr&uuml;fen.<br />\n            <b>- Meinungen &uuml;ber Produkte:</b> Teilen Sie Ihre Meinung zu unseren Produkten mit anderen Kunden.<br />\n            </font></font><br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">Falls Sie Fragen zu unserem Kunden-Service haben, wenden Sie sich bitte an:        {$content.MAIL_REPLY_ADDRESS}       . <br />\n            Achtung: Diese E-Mail-Adresse wurde uns von einem Kunden bekannt gegeben. Falls Sie sich nicht angemeldet haben, senden Sie bitte eine E-Mail an      {$content.MAIL_REPLY_ADDRESS}. <br />\n            <br />\n            {if $SEND_GIFT==true}     <br />\n            Als kleines Willkommensgeschenk senden wir Ihnen einen Gutschein &uuml;ber: <b>{$GIFT_AMMOUNT}</b><br />\n            <br />\n            Ihr pers&ouml;nlicher Gutschein-Code lautet <b>{$GIFT_CODE}</b>. Sie k&ouml;nnen diese Gutschrift an der Kasse w&auml;hrend des Bestellvorganges verbuchen.<br />\n            <br />\n            Um den Gutschein einzul&ouml;sen klichen Sie bitte auf <a href="{$GIFT_LINK}">[Gutschein Einl&ouml;sen]</a>.{/if}  {if $SEND_COUPON==true}  Als kleines Willkommensgeschenk senden wir Ihnen einen Kupon.<br />\n            Kuponbeschreibung: <b>{$COUPON_DESC}</b>   <br />\n            Geben Sie einfach Ihren pers&ouml;nlichen Code {$COUPON_CODE} w&auml;hrend des Bezahlvorganges ein.{/if}  </font></td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nSie haben soeben Ihr Kundenkonto erfolgreich erstellt. Als registrierter Kunde haben Sie folgende Vorteile in unserem Shop:\n\n- Kundenwarenkorb: Jeder Artikel bleibt registriert bis Sie zur Kasse gehen oder die Produkte aus dem Warenkorb entfernen.\n- Adressbuch: Wir knnen jetzt die Produkte zu der von Ihnen ausgesuchten Adresse senden. Der perfekte Weg ein Geburtstagsgeschenk zu versenden.\n- Vorherige Bestellungen: Sie knnen jederzeit Ihre vorherigen Bestellungen berprfen.\n- Meinungen ber Produkte: Teilen Sie Ihre Meinung zu unseren Produkten mit anderen Kunden.\n\nFalls Sie Fragen zu unserem Kunden-Service haben, wenden Sie sich bitte an: {$content.MAIL_REPLY_ADDRESS} .\nAchtung: Diese E-Mail-Adresse wurde uns von einem Kunden bekannt gegeben. Falls Sie sich nicht angemeldet haben, senden Sie bitte eine E-Mail an {$content.MAIL_REPLY_ADDRESS}.\n\n{if $SEND_GIFT==true}\nAls kleines Willkommensgeschenk senden wir Ihnen einen Gutschein ber: {$GIFT_AMMOUNT}\n\nIhr persnlicher Gutschein-Code lautet {$GIFT_CODE}. Sie knnen diese Gutschrift an der Kasse whrend des Bestellvorganges verbuchen.\n\nUm den Gutschein einzulsen klichen Sie bitte auf [Gutschein Einlsen].{/if} {if $SEND_COUPON==true} Als kleines Willkommensgeschenk senden wir Ihnen einen Kupon.\nKuponbeschreibung: {$COUPON_DESC}\nGeben Sie einfach Ihren persnlichen Code {$COUPON_CODE} whrend des Bezahlvorganges ein.{/if}\n\n{$EMAIL_SIGNATURE_TEXT}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nSie haben soeben Ihr Kundenkonto erfolgreich erstellt. Als registrierter Kunde haben Sie folgende Vorteile in unserem Shop:\n\n- Kundenwarenkorb: Jeder Artikel bleibt registriert bis Sie zur Kasse gehen oder die Produkte aus dem Warenkorb entfernen.\n- Adressbuch: Wir knnen jetzt die Produkte zu der von Ihnen ausgesuchten Adresse senden. Der perfekte Weg ein Geburtstagsgeschenk zu versenden.\n- Vorherige Bestellungen: Sie knnen jederzeit Ihre vorherigen Bestellungen berprfen.\n- Meinungen ber Produkte: Teilen Sie Ihre Meinung zu unseren Produkten mit anderen Kunden.\n\nFalls Sie Fragen zu unserem Kunden-Service haben, wenden Sie sich bitte an: {$content.MAIL_REPLY_ADDRESS} .\nAchtung: Diese E-Mail-Adresse wurde uns von einem Kunden bekannt gegeben. Falls Sie sich nicht angemeldet haben, senden Sie bitte eine E-Mail an {$content.MAIL_REPLY_ADDRESS}.\n\n{if $SEND_GIFT==true}\nAls kleines Willkommensgeschenk senden wir Ihnen einen Gutschein ber: {$GIFT_AMMOUNT}\n\nIhr persnlicher Gutschein-Code lautet {$GIFT_CODE}. Sie knnen diese Gutschrift an der Kasse whrend des Bestellvorganges verbuchen.\n\nUm den Gutschein einzulsen klichen Sie bitte auf [Gutschein Einlsen].{/if} {if $SEND_COUPON==true} Als kleines Willkommensgeschenk senden wir Ihnen einen Kupon.\nKuponbeschreibung: {$COUPON_DESC}\nGeben Sie einfach Ihren persnlichen Code {$COUPON_CODE} whrend des Bezahlvorganges ein.{/if}\n\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(3, 3, 2, '', 'new_password_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Sie erhalten diese E-Mail, da Sie ein neues Passwort angefordert haben.<br />\n            Bitte loggen Sie sich mit folgendem Passwort und Ihrer E-Mail-Adresse bei uns ein <br />\n            und &auml;ndern Ihr Passwort in Ihrem Account, wie Sie es w&uuml;nschen.</font></p>\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Ihr neues Passwort:<br />\n                        </b>{$NEW_PASSWORD}</td>\n                    </tr>\n                </tbody>\n            </table>\n            </font>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Wir w&uuml;nschen Ihnen weiterhin viel Spa&szlig; mit unserem Angebot!        </font></p>\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">      </font></td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Sie erhalten diese E-Mail, da Sie ein neues Passwort angefordert haben.<br />\n            Bitte loggen Sie sich mit folgendem Passwort und Ihrer E-Mail-Adresse bei uns ein <br />\n            und &auml;ndern Ihr Passwort in Ihrem Account, wie Sie es w&uuml;nschen.</font></p>\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Ihr neues Passwort:<br />\n                        </b>{$NEW_PASSWORD}</td>\n                    </tr>\n                </tbody>\n            </table>\n            </font>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Wir w&uuml;nschen Ihnen weiterhin viel Spa&szlig; mit unserem Angebot!        </font></p>\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">      </font></td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nSie erhalten diese E-Mail, da Sie ein neues Passwort angefordert haben.\nBitte loggen Sie sich mit folgendem Passwort und Ihrer E-Mail-Adresse bei uns ein\nund ndern Ihr Passwort in Ihrem Account, wie Sie es wnschen.\n      \nIhr neues Passwort: {$NEW_PASSWORD}\n\nWir wnschen Ihnen weiterhin viel Spa mit unserem Angebot!\n\n{$EMAIL_SIGNATURE_TEXT}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nSie erhalten diese E-Mail, da Sie ein neues Passwort angefordert haben.\nBitte loggen Sie sich mit folgendem Passwort und Ihrer E-Mail-Adresse bei uns ein\nund ndern Ihr Passwort in Ihrem Account, wie Sie es wnschen.\n      \nIhr neues Passwort: {$NEW_PASSWORD}\n\nWir wnschen Ihnen weiterhin viel Spa mit unserem Angebot!\n\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(4, 4, 2, '', 'newsletter_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>vielen Dank f&uuml;r die Anmeldung.</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Sie erhalten diese E-Mail, weil Sie unseren Newsletter empfangen m&ouml;chten. Bitte klicken Sie auf den Aktivierungslink, damit Ihre E-Mail-Adresse f&uuml;r den Newsletterempfang freigeschaltet wird. Sollten Sie sich nicht in unseren Newsletter eingetragen haben bzw. den Empfang des Newsletters nicht w&uuml;nschen, bitten wir Sie gar nichts zu tun. Ihre E-Mail-Adresse wird dann bei der n&auml;chsten Aktualisierung der Datenbank automatisch gel&ouml;scht.</font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br />\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Ihr Aktivierungslink:<br />\n                        </b><a href="{$LINK}">{$LINK}</a></td>\n                    </tr>\n                </tbody>\n            </table>\n            </font></p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>vielen Dank f&uuml;r die Anmeldung.</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Sie erhalten diese E-Mail, weil Sie unseren Newsletter empfangen m&ouml;chten. Bitte klicken Sie auf den Aktivierungslink, damit Ihre E-Mail-Adresse f&uuml;r den Newsletterempfang freigeschaltet wird. Sollten Sie sich nicht in unseren Newsletter eingetragen haben bzw. den Empfang des Newsletters nicht w&uuml;nschen, bitten wir Sie gar nichts zu tun. Ihre E-Mail-Adresse wird dann bei der n&auml;chsten Aktualisierung der Datenbank automatisch gel&ouml;scht.</font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><br />\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Ihr Aktivierungslink:<br />\n                        </b><a href="{$LINK}">{$LINK}</a></td>\n                    </tr>\n                </tbody>\n            </table>\n            </font></p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nvielen Dank fr die Anmeldung.\nSie erhalten diese E-Mail, weil Sie unseren Newsletter empfangen mchten. Bitte klicken Sie auf den Aktivierungslink, damit Ihre E-Mail-Adresse fr den Newsletterempfang freigeschaltet wird. Sollten Sie sich nicht in unseren Newsletter eingetragen haben bzw. den Empfang des Newsletters nicht wnschen, bitten wir Sie gar nichts zu tun. Ihre E-Mail-Adresse wird dann bei der nchsten Aktualisierung der Datenbank automatisch gelscht.\n\n\nIhr Aktivierungslink:\n{$LINK}\n\n{$EMAIL_SIGNATURE_TEXT}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nvielen Dank fr die Anmeldung.\nSie erhalten diese E-Mail, weil Sie unseren Newsletter empfangen mchten. Bitte klicken Sie auf den Aktivierungslink, damit Ihre E-Mail-Adresse fr den Newsletterempfang freigeschaltet wird. Sollten Sie sich nicht in unseren Newsletter eingetragen haben bzw. den Empfang des Newsletters nicht wnschen, bitten wir Sie gar nichts zu tun. Ihre E-Mail-Adresse wird dann bei der nchsten Aktualisierung der Datenbank automatisch gelscht.\n\n\nIhr Aktivierungslink:\n{$LINK}\n\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(5, 5, 2, '', 'order_mail', '{load_language_text section="create_account"}\n<table border="0" width="100%">\n    <tbody>\n        <tr>\n            <td>\n            <table cellspacing="0" cellpadding="0" border="0" width="100%">\n                <tbody>\n                    <tr valign="top">\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{php}echo nl2br(STORE_NAME_ADDRESS){/php}</font>\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_customer}</font></p>\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{#text_tel#} {$PHONE}<br />\n                        {if $customer_vat}{#text_ustid#} {$customer_vat}{/if} <br />\n                        <br />\n                        {if $PAYMENT_METHOD} <strong>Zahlungsmethode: </strong>{$PAYMENT_METHOD}{/if}<br />\n                        <strong>Bestellung Nr:</strong> {$oID}<br />\n                        <strong>Bestelldatum:</strong> {$DATE}<br />\n                        {if $csID}<strong>Kundennummer:</strong> {$csID}{/if} </font></p>\n                        </td>\n                        {if $gm_logo_mail}\n                        <td>{$gm_logo_mail}</td>\n                        {/if}\n                    </tr>\n                </tbody>\n            </table>\n            <br />\n            <table border="0" width="100%" style="border-top: 1px solid; border-bottom: 1px solid;">\n                <tbody>\n                    <tr bgcolor="#f1f1f1">\n                        <td width="50%">\n                        <p><font size="1"><strong><font face="Verdana, Arial, Helvetica, sans-serif">Lieferadresse <br />\n                        </font></strong></font></p>\n                        </td>\n                        <td>\n                        <p><font size="1"><strong><font face="Verdana, Arial, Helvetica, sans-serif">Rechnungsadresse <br />\n                        </font></strong></font></p>\n                        </td>\n                    </tr>\n                    <tr>\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_shipping}</font></td>\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_payment}</font></td>\n                    </tr>\n                </tbody>\n            </table>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},<br />\n            <br />\n            vielen Dank f&uuml;r Ihre Bestellung in unserem Online-Shop!</font> <font face="Verdana, Arial, Helvetica, sans-serif" size="1"><br />\n            <br />\n            {if $PAYMENT_MODUL==''moneyorder''}<br />\n            Unsere Bankverbindung: <br />\n            {php} echo nl2br(MODULE_PAYMENT_MONEYORDER_PAYTO); {/php}<br />\n            {else}<br />\n            </font><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$PAYMENT_INFO_HTML}</font><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><br />\n            {/if}</font><br />\n            {if $COMMENTS}<br />\n            <strong><font face="Verdana, Arial, Helvetica, sans-serif" size="1">Ihre Anmerkungen:</font></strong><br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$COMMENTS}</font><br />\n            {/if} <br />\n            &nbsp;</p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<table cellspacing="0" cellpadding="0" border="0" width="100%" style="border-bottom: 1px solid;">\n    <tbody>\n        <tr>\n            <td><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Ihre bestellten Produkte nochmals zur Kontrolle: </font></strong></td>\n        </tr>\n        <tr>\n            <td>\n            <table cellspacing="0" cellpadding="3" border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td width="10%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="center"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Anzahl</font></strong></div>\n                        </td>\n                        <td width="50%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Artikel</font></strong></td>\n                        <td width="15%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Artikel-Nr. </font></strong></td>\n                        <td width="12%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Einzelpreis</font></strong></div>\n                        </td>\n                        <td width="13%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1"><strong>Gesamtpreis</strong> </font></div>\n                        </td>\n                    </tr>\n                </tbody>\n            </table>\n            <font size="1">{foreach name=aussen item=order_values from=$order_data} </font>\n            <table cellspacing="0" cellpadding="3" border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td width="10%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="center"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if}</font></div>\n                       </td>\n                        <td width="50%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_NAME}</font></strong><em><br />\n                        <font face="Arial, Verdana, Helvetica, sans-serif" size="1">\n							{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES}\n								{$prop_item_array.properties_name}: {$prop_item_array.values_name}<br/>\n							{/foreach}\n							{$order_values.PRODUCTS_ATTRIBUTES}\n						</font></em></td>\n                        <td width="15%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_MODEL}<br />\n                        <em>{$order_values.PRODUCTS_ATTRIBUTES_MODEL}</em></font></td>\n                        <td width="12%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_SINGLE_PRICE}</font></div>\n                        </td>\n                        <td width="13%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_PRICE}</font></div>\n                        </td>\n                    </tr>\n                </tbody>\n            </table>\n            <font face="Arial, Verdana, Helvetica, sans-serif" size="2">{/foreach} </font></td>\n        </tr>\n    </tbody>\n</table>\n<p><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{foreach name=aussen item=order_total_values from=$order_total} </font></p>\n<div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_total_values.TITLE}{$order_total_values.TEXT}</font></div>\n<p><font size="1">{/foreach}</font></p>\n<br />\n<br />\n{$TS_RATING}\n<br />\n<br />\n{$JANOLAW_INFO_HTML}\n<br />\n<br />\n{$WITHDRAWAL_HTML}\n<br />\n<br />\n{$AGB_HTML}\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '{load_language_text section="create_account"}\n<table border="0" width="100%">\n    <tbody>\n        <tr>\n            <td>\n            <table cellspacing="0" cellpadding="0" border="0" width="100%">\n                <tbody>\n                    <tr valign="top">\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{php}echo nl2br(STORE_NAME_ADDRESS){/php}</font>\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_customer}</font></p>\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{#text_tel#} {$PHONE}<br />\n                        {if $customer_vat}{#text_ustid#} {$customer_vat}{/if} <br />\n                        <br />\n                        {if $PAYMENT_METHOD} <strong>Zahlungsmethode: </strong>{$PAYMENT_METHOD}{/if}<br />\n                        <strong>Bestellung Nr:</strong> {$oID}<br />\n                        <strong>Bestelldatum:</strong> {$DATE}<br />\n                        {if $csID}<strong>Kundennummer:</strong> {$csID}{/if} </font></p>\n                        </td>\n                        {if $gm_logo_mail}\n                        <td>{$gm_logo_mail}</td>\n                        {/if}\n                    </tr>\n                </tbody>\n            </table>\n            <br />\n            <table border="0" width="100%" style="border-top: 1px solid; border-bottom: 1px solid;">\n                <tbody>\n                    <tr bgcolor="#f1f1f1">\n                        <td width="50%">\n                        <p><font size="1"><strong><font face="Verdana, Arial, Helvetica, sans-serif">Lieferadresse <br />\n                        </font></strong></font></p>\n                        </td>\n                        <td>\n                        <p><font size="1"><strong><font face="Verdana, Arial, Helvetica, sans-serif">Rechnungsadresse <br />\n                        </font></strong></font></p>\n                        </td>\n                    </tr>\n                    <tr>\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_shipping}</font></td>\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_payment}</font></td>\n                    </tr>\n                </tbody>\n            </table>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},<br />\n            <br />\n            vielen Dank f&uuml;r Ihre Bestellung in unserem Online-Shop!</font> <font face="Verdana, Arial, Helvetica, sans-serif" size="1"><br />\n            <br />\n            {if $PAYMENT_MODUL==''moneyorder''}<br />\n            Unsere Bankverbindung: <br />\n            {php} echo nl2br(MODULE_PAYMENT_MONEYORDER_PAYTO); {/php}<br />\n            {else}<br />\n            </font><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$PAYMENT_INFO_HTML}</font><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><br />\n            {/if}</font><br />\n            {if $COMMENTS}<br />\n            <strong><font face="Verdana, Arial, Helvetica, sans-serif" size="1">Ihre Anmerkungen:</font></strong><br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$COMMENTS}</font><br />\n            {/if} <br />\n            &nbsp;</p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<table cellspacing="0" cellpadding="0" border="0" width="100%" style="border-bottom: 1px solid;">\n    <tbody>\n        <tr>\n            <td><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Ihre bestellten Produkte nochmals zur Kontrolle: </font></strong></td>\n        </tr>\n        <tr>\n            <td>\n            <table cellspacing="0" cellpadding="3" border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td width="10%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="center"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Anzahl</font></strong></div>\n                        </td>\n                        <td width="50%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Artikel</font></strong></td>\n                        <td width="15%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Artikel-Nr. </font></strong></td>\n                        <td width="12%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Einzelpreis</font></strong></div>\n                        </td>\n                        <td width="13%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1"><strong>Gesamtpreis</strong> </font></div>\n                        </td>\n                    </tr>\n                </tbody>\n            </table>\n            <font size="1">{foreach name=aussen item=order_values from=$order_data} </font>\n            <table cellspacing="0" cellpadding="3" border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td width="10%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="center"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if}</font></div>\n                       </td>\n                        <td width="50%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_NAME}</font></strong><em><br />\n                        <font face="Arial, Verdana, Helvetica, sans-serif" size="1">\n							{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES}\n								{$prop_item_array.properties_name}: {$prop_item_array.values_name}<br/>\n							{/foreach}\n							{$order_values.PRODUCTS_ATTRIBUTES}\n						</font></em></td>\n                        <td width="15%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_MODEL}<br />\n                        <em>{$order_values.PRODUCTS_ATTRIBUTES_MODEL}</em></font></td>\n                        <td width="12%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_SINGLE_PRICE}</font></div>\n                        </td>\n                        <td width="13%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_PRICE}</font></div>\n                        </td>\n                    </tr>\n                </tbody>\n            </table>\n            <font face="Arial, Verdana, Helvetica, sans-serif" size="2">{/foreach} </font></td>\n        </tr>\n    </tbody>\n</table>\n<p><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{foreach name=aussen item=order_total_values from=$order_total} </font></p>\n<div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_total_values.TITLE}{$order_total_values.TEXT}</font></div>\n<p><font size="1">{/foreach}</font></p>\n<br />\n<br />\n{$TS_RATING}\n<br />\n<br />\n{$JANOLAW_INFO_HTML}\n<br />\n<br />\n{$WITHDRAWAL_HTML}\n<br />\n<br />\n{$AGB_HTML}\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '{$address_label_customer}\n\n{if $PAYMENT_METHOD}Zahlungsmethode: {$PAYMENT_METHOD}\n{/if}\nBestellnummer: {$oID}\nDatum: {$DATE}\n{if $csID}Kundennummer :{$csID}{/if}\n----------------------------------------------------------------------\n\n\nSehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nvielen Dank fr Ihre Bestellung in unserem Onlineshop.\n\n{if $PAYMENT_MODUL==''moneyorder''}\nUnsere Bankverbindung:\n{php} echo MODULE_PAYMENT_MONEYORDER_PAYTO; {/php}\n{else}\n{$PAYMENT_INFO_TXT}\n{/if}\n\n{if $COMMENTS}\nIhre Anmerkungen:\n{$COMMENTS}\n{/if}\n\nIhre bestellten Produkte zur Kontrolle:\n----------------------------------------------------------------------\n{foreach name=aussen item=order_values from=$order_data} \n{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if} {$order_values.PRODUCTS_NAME} {$order_values.PRODUCTS_PRICE}\n{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES}\n {$prop_item_array.properties_name}: {$prop_item_array.values_name}\n{/foreach}\n{if $order_values.PRODUCTS_ATTRIBUTES !=''''}{$order_values.PRODUCTS_ATTRIBUTES}{/if}\n\n{/foreach}\n\n{foreach name=aussen item=order_total_values from=$order_total}\n{$order_total_values.TITLE}{$order_total_values.TEXT}\n{/foreach}\n\n\n{if $address_label_payment}\nRechnungsadresse\n----------------------------------------------------------------------\n{$address_label_payment}\n{/if}\nVersandadresse \n----------------------------------------------------------------------\n{$address_label_shipping}\n\n{$JANOLAW_INFO_TEXT}\n\n\n{$WITHDRAWAL_TEXT}\n\n{$AGB_TEXT}\n\n{$EMAIL_SIGNATURE_TEXT}', '{$address_label_customer}\n\n{if $PAYMENT_METHOD}Zahlungsmethode: {$PAYMENT_METHOD}\n{/if}\nBestellnummer: {$oID}\nDatum: {$DATE}\n{if $csID}Kundennummer :{$csID}{/if}\n----------------------------------------------------------------------\n\n\nSehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nvielen Dank fr Ihre Bestellung in unserem Onlineshop.\n\n{if $PAYMENT_MODUL==''moneyorder''}\nUnsere Bankverbindung:\n{php} echo MODULE_PAYMENT_MONEYORDER_PAYTO; {/php}\n{else}\n{$PAYMENT_INFO_TXT}\n{/if}\n\n{if $COMMENTS}\nIhre Anmerkungen:\n{$COMMENTS}\n{/if}\n\nIhre bestellten Produkte zur Kontrolle:\n----------------------------------------------------------------------\n{foreach name=aussen item=order_values from=$order_data} \n{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if} {$order_values.PRODUCTS_NAME} {$order_values.PRODUCTS_PRICE}\n{foreach item=prop_item_array from=$order_values.PRODUCTS_PROPERTIES}\n {$prop_item_array.properties_name}: {$prop_item_array.values_name}\n{/foreach}\n{if $order_values.PRODUCTS_ATTRIBUTES !=''''}{$order_values.PRODUCTS_ATTRIBUTES}{/if}\n\n{/foreach}\n\n{foreach name=aussen item=order_total_values from=$order_total}\n{$order_total_values.TITLE}{$order_total_values.TEXT}\n{/foreach}\n\n\n{if $address_label_payment}\nRechnungsadresse\n----------------------------------------------------------------------\n{$address_label_payment}\n{/if}\nVersandadresse \n----------------------------------------------------------------------\n{$address_label_shipping}\n\n{$JANOLAW_INFO_TEXT}\n\n\n{$WITHDRAWAL_TEXT}\n\n{$AGB_TEXT}\n\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(6, 6, 2, '', 'password_verification_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Bitte best&auml;tigen Sie, dass Sie selber ein neues Passwort angefordert haben. Aus diesem Grund haben wir Ihnen diese E-Mail mit einem pers&ouml;nlichen Best&auml;tigungslink geschickt. Wenn Sie den Link best&auml;tigen, indem Sie ihn anklicken, wird Ihnen umgehend ein neues Passwort in einer weiteren E-Mail zur Verf&uuml;gung gestellt.<br />\n            <br />\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Ihr Best&auml;tigungslink:<br />\n                        </b><a href="{$LINK}">{$LINK}</a></td>\n                    </tr>\n                </tbody>\n            </table>\n            </font></p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Bitte best&auml;tigen Sie, dass Sie selber ein neues Passwort angefordert haben. Aus diesem Grund haben wir Ihnen diese E-Mail mit einem pers&ouml;nlichen Best&auml;tigungslink geschickt. Wenn Sie den Link best&auml;tigen, indem Sie ihn anklicken, wird Ihnen umgehend ein neues Passwort in einer weiteren E-Mail zur Verf&uuml;gung gestellt.<br />\n            <br />\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Ihr Best&auml;tigungslink:<br />\n                        </b><a href="{$LINK}">{$LINK}</a></td>\n                    </tr>\n                </tbody>\n            </table>\n            </font></p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nBitte besttigen Sie, dass Sie selber ein neues Passwort angefordert haben. \nAus diesem Grund haben wir Ihnen diese E-Mail mit einem persnlichen \nBesttigungslink geschickt. Wenn Sie den Link besttigen, indem Sie ihn \nanklicken, wird Ihnen umgehend ein neues Passwort in einer weiteren E-Mail \nzur Verfgung gestellt.\n      \nIhr Besttigungslink:\n{$LINK}\n\n{$EMAIL_SIGNATURE_TEXT}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nBitte besttigen Sie, dass Sie selber ein neues Passwort angefordert haben. \nAus diesem Grund haben wir Ihnen diese E-Mail mit einem persnlichen \nBesttigungslink geschickt. Wenn Sie den Link besttigen, indem Sie ihn \nanklicken, wird Ihnen umgehend ein neues Passwort in einer weiteren E-Mail \nzur Verfgung gestellt.\n      \nIhr Besttigungslink:\n{$LINK}\n\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(7, 7, 2, '', 'send_gift_to_friend', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n\r\n    <tbody>\r\n\r\n    {if $gm_logo_mail}\r\n       <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n		{/if}\r\n        <tr>\r\n\r\n            <td> <font size="2" face="Verdana, Arial, Helvetica, sans-serif">---------------------------------------------------------------------------------------- <br />   Herzlichen Gl&uuml;ckwunsch, Sie haben einen Gutschein &uuml;ber <b>{$AMMOUNT} </b>erhalten! <br /> ----------------------------------------------------------------------------------------<br />  <br /> Dieser Gutschein wurde Ihnen von {$FROM_NAME} mit folgender der Nachricht </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">&uuml;bermittelt</font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">:<br /> <br /> {$MESSAGE}<br /> <br /> Ihr pers&ouml;nlicher Gutschein-Code lautet <strong>{$GIFT_CODE}</strong>. Sie k&ouml;nnen diese Gutschrift w&auml;hrend des Bestellvorgangs verbuchen.<br /> <br /> Um den Gutschein einzul&ouml;sen klichen Sie bitte auf <a href="{$GIFT_LINK}">{$GIFT_LINK}</a>.<br /> <br /> Falls es mit dem obigen Link zu Probleme beim Einl&ouml;sen kommen sollte, k&ouml;nnen Sie den Betrag w&auml;hrend des Bestellvorganges verbuchen. </font></td>\r\n\r\n        </tr>\r\n\r\n    </tbody>\r\n\r\n</table>\r\n<br />\r\n<br />\r\n{$EMAIL_SIGNATURE_HTML}', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n\r\n    <tbody>\r\n\r\n    {if $gm_logo_mail}\r\n       <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n		{/if}\r\n        <tr>\r\n\r\n            <td> <font size="2" face="Verdana, Arial, Helvetica, sans-serif">---------------------------------------------------------------------------------------- <br />   Herzlichen Gl&uuml;ckwunsch, Sie haben einen Gutschein &uuml;ber <b>{$AMMOUNT} </b>erhalten! <br /> ----------------------------------------------------------------------------------------<br />  <br /> Dieser Gutschein wurde Ihnen von {$FROM_NAME} mit folgender der Nachricht </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">&uuml;bermittelt</font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">:<br /> <br /> {$MESSAGE}<br /> <br /> Ihr pers&ouml;nlicher Gutschein-Code lautet <strong>{$GIFT_CODE}</strong>. Sie k&ouml;nnen diese Gutschrift w&auml;hrend des Bestellvorgangs verbuchen.<br /> <br /> Um den Gutschein einzul&ouml;sen klichen Sie bitte auf <a href="{$GIFT_LINK}">{$GIFT_LINK}</a>.<br /> <br /> Falls es mit dem obigen Link zu Probleme beim Einl&ouml;sen kommen sollte, k&ouml;nnen Sie den Betrag w&auml;hrend des Bestellvorganges verbuchen. </font></td>\r\n\r\n        </tr>\r\n\r\n    </tbody>\r\n\r\n</table>', '----------------------------------------------------------------------------------------------\r\nHerzlichen Glckwunsch, Sie haben einen Gutschein ber {$AMMOUNT} erhalten!\r\n----------------------------------------------------------------------------------------------\r\n\r\nDieser Gutschein wurde Ihnen von {$FROM_NAME} mit folgender Nachricht bermittelt:\r\n\r\n{$MESSAGE}\r\n\r\nIhr persnlicher Gutschein-Code lautet {$GIFT_CODE}. Sie knnen diese Gutschrift whrend des Bestellvorgangs verbuchen.\r\n\r\nUm den Gutschein einzulsen klichen Sie bitte auf {$GIFT_LINK}.\r\n\r\nFalls es mit dem obigen Link zu Probleme beim Einlsen kommen sollte, knnen Sie den Betrag whrend des Bestellvorganges verbuchen.\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '----------------------------------------------------------------------------------------------\r\nHerzlichen Glckwunsch, Sie haben einen Gutschein ber {$AMMOUNT} erhalten!\r\n----------------------------------------------------------------------------------------------\r\n\r\nDieser Gutschein wurde Ihnen von {$FROM_NAME} mit folgender Nachricht bermittelt:\r\n\r\n{$MESSAGE}\r\n\r\nIhr persnlicher Gutschein-Code lautet {$GIFT_CODE}. Sie knnen diese Gutschrift whrend des Bestellvorgangs verbuchen.\r\n\r\nUm den Gutschein einzulsen klichen Sie bitte auf {$GIFT_LINK}.\r\n\r\nFalls es mit dem obigen Link zu Probleme beim Einlsen kommen sollte, knnen Sie den Betrag whrend des Bestellvorganges verbuchen.');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(8, 8, 2, 'admin/', 'change_order_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"> <strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME}, </strong><br />\n            <br />\n            Der Status Ihrer Bestellung vom {$ORDER_DATE} mit der Bestellnummer {$ORDER_NR} wurde ge&auml;ndert.<br />\n            {if $NOTIFY_COMMENTS}<br />\n            Anmerkungen und Kommentare zu Ihrer Bestellung:  {$NOTIFY_COMMENTS} <br />\n            {/if} <br />\n            Neuer Status:  <strong>{$ORDER_STATUS}</strong> <br />\n            Bei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail. </font></td>\n        </tr>\n    </tbody>\n</table>', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"> <strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME}, </strong><br />\n            <br />\n            Der Status Ihrer Bestellung vom {$ORDER_DATE} mit der Bestellnummer {$ORDER_NR} wurde ge&auml;ndert.<br />\n            {if $NOTIFY_COMMENTS}<br />\n            Anmerkungen und Kommentare zu Ihrer Bestellung:  {$NOTIFY_COMMENTS} <br />\n            {/if} <br />\n            Neuer Status:  <strong>{$ORDER_STATUS}</strong> <br />\n            Bei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail. </font></td>\n        </tr>\n    </tbody>\n</table>', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nDer Status Ihrer Bestellung vom {$ORDER_DATE} mit der Bestellnummer {$ORDER_NR} wurde gendert.\n{if $NOTIFY_COMMENTS}\n\nAnmerkungen und Kommentare zu Ihrer Bestellung: {$NOTIFY_COMMENTS}\n{/if}\n\nNeuer Status: {$ORDER_STATUS}\nBei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail.', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nDer Status Ihrer Bestellung vom {$ORDER_DATE} mit der Bestellnummer {$ORDER_NR} wurde gendert.\n{if $NOTIFY_COMMENTS}\n\nAnmerkungen und Kommentare zu Ihrer Bestellung: {$NOTIFY_COMMENTS}\n{/if}\n\nNeuer Status: {$ORDER_STATUS}\nBei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese E-Mail.');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(9, 9, 2, 'admin/', 'create_account_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME}, </strong></font><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><br />\n            <font size="2"><br />\n            es wurde ein Account f&uuml;r Sie eingerichtet. Sie k&ouml;nnen sich mit folgenden Daten in unseren Shop einloggen. <br />\n            <br />\n            {if $COMMENTS} Anmerkungen: {$COMMENTS} <br />\n            {/if}         <br />\n            <br />\n            Ihre Logindaten f&uuml;r unseren Shop:<br />\n            <br />\n            E-Mail:  {$EMAIL} <br />\n            Ihr Passwort:  {$PASSWORD}          </font></font></td>\n        </tr>\n    </tbody>\n</table>', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME}, </strong></font><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><br />\n            <font size="2"><br />\n            es wurde ein Account f&uuml;r Sie eingerichtet. Sie k&ouml;nnen sich mit folgenden Daten in unseren Shop einloggen. <br />\n            <br />\n            {if $COMMENTS} Anmerkungen: {$COMMENTS} <br />\n            {/if}         <br />\n            <br />\n            Ihre Logindaten f&uuml;r unseren Shop:<br />\n            <br />\n            E-Mail:  {$EMAIL} <br />\n            Ihr Passwort:  {$PASSWORD}          </font></font></td>\n        </tr>\n    </tbody>\n</table>', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nes wurde ein Account fr Sie eingerichtet. Sie knnen sich mit folgenden Daten in unseren Shop einloggen.\n\n{if $COMMENTS}Anmerkungen: {$COMMENTS}{/if}\n\nIhre Logindaten fr unseren Shop:\n\nE-Mail: {$EMAIL}\n\nIhr Passwort: {$PASSWORD}', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nes wurde ein Account fr Sie eingerichtet. Sie knnen sich mit folgenden Daten in unseren Shop einloggen.\n\n{if $COMMENTS}Anmerkungen: {$COMMENTS}{/if}\n\nIhre Logindaten fr unseren Shop:\n\nE-Mail: {$EMAIL}\n\nIhr Passwort: {$PASSWORD}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(10, 10, 2, 'admin/', 'gift_accepted', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">  </font><font face="Verdana, Arial, Helvetica, sans-serif" size="2">       <strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong></font> <br />\n            <br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">Sie haben k&uuml;rzlich in unserem Online-Shop einen Gutschein bestellt, welcher aus Sicherheitsgr&uuml;nden nicht sofort freigeschaltet wurde. Dieses Guthaben steht Ihnen nun zur Verf&uuml;gung. Sie k&ouml;nnen Ihren Gutschein verbuchen und per E-Mail versenden. Der von Ihnen bestellte Gutschein hat einen Wert von       {$AMMOUNT}.       </font></td>\n        </tr>\n    </tbody>\n</table>', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">  </font><font face="Verdana, Arial, Helvetica, sans-serif" size="2">       <strong>Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},</strong></font> <br />\n            <br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">Sie haben k&uuml;rzlich in unserem Online-Shop einen Gutschein bestellt, welcher aus Sicherheitsgr&uuml;nden nicht sofort freigeschaltet wurde. Dieses Guthaben steht Ihnen nun zur Verf&uuml;gung. Sie k&ouml;nnen Ihren Gutschein verbuchen und per E-Mail versenden. Der von Ihnen bestellte Gutschein hat einen Wert von       {$AMMOUNT}.       </font></td>\n        </tr>\n    </tbody>\n</table>', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nSie haben krzlich in unserem Online-Shop einen Gutschein bestellt, welcher aus Sicherheitsgrnden nicht sofort freigeschaltet wurde.\nDieses Guthaben steht Ihnen nun zur Verfgung. Sie knnen Ihren Gutschein verbuchen und per E-Mail versenden. Der von Ihnen bestellte Gutschein hat einen Wert von {$AMMOUNT}.', 'Sehr {if $GENDER == ''m''}geehrter Herr {elseif $GENDER == ''f''}geehrte Frau {else}geehrte(r) {/if}{$NAME},\n\nSie haben krzlich in unserem Online-Shop einen Gutschein bestellt, welcher aus Sicherheitsgrnden nicht sofort freigeschaltet wurde.\nDieses Guthaben steht Ihnen nun zur Verfgung. Sie knnen Ihren Gutschein verbuchen und per E-Mail versenden. Der von Ihnen bestellte Gutschein hat einen Wert von {$AMMOUNT}.');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(11, 11, 2, 'admin/', 'send_coupon', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n    <tbody>\r\n        <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n        <tr>\r\n            <td><font size="1" face="Verdana, Arial, Helvetica, sans-serif">        </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">       {$MESSAGE}       <br />       <br /> Sie k&ouml;nnen den Gutschein bei Ihrer Bestellung einl&ouml;sen. Geben Sie daf&uuml;r Ihre Gutschein-Nummer in das Feld Gutscheine ein. <br /> <br /> Ihre Gutschein-Nummer lautet: <strong> {$COUPON_ID} </strong><br /> <br /> Heben Sie Ihre Gutschein-Nummer gut auf, nur so k&ouml;nnen Sie von diesem Angebot profitieren, wenn Sie uns das n&auml;chste Mal unter <a href="{$WEBSITE}">{$WEBSITE}</a> besuchen. </font></td>\r\n        </tr>\r\n    </tbody>\r\n</table>', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n    <tbody>\r\n        <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n        <tr>\r\n            <td><font size="1" face="Verdana, Arial, Helvetica, sans-serif">        </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">       {$MESSAGE}       <br />       <br /> Sie k&ouml;nnen den Gutschein bei Ihrer Bestellung einl&ouml;sen. Geben Sie daf&uuml;r Ihre Gutschein-Nummer in das Feld Gutscheine ein. <br /> <br /> Ihre Gutschein-Nummer lautet: <strong> {$COUPON_ID} </strong><br /> <br /> Heben Sie Ihre Gutschein-Nummer gut auf, nur so k&ouml;nnen Sie von diesem Angebot profitieren, wenn Sie uns das n&auml;chste Mal unter <a href="{$WEBSITE}">{$WEBSITE}</a> besuchen. </font></td>\r\n        </tr>\r\n    </tbody>\r\n</table>', '{$MESSAGE}\r\n\r\nSie knnen den Gutschein bei Ihrer Bestellung einlsen. Geben Sie dafr Ihre Gutschein-Nummer in das Feld Gutscheine ein.\r\n\r\nIhre Gutschein-Nummer lautet: {$COUPON_ID}\r\n\r\nHeben Sie Ihre Gutschein-Nummer gut auf, nur so knnen Sie von diesem Angebot profitieren, wenn Sie uns das nchste Mal unter {$WEBSITE} besuchen.', '{$MESSAGE}\r\n\r\nSie knnen den Gutschein bei Ihrer Bestellung einlsen. Geben Sie dafr Ihre Gutschein-Nummer in das Feld Gutscheine ein.\r\n\r\nIhre Gutschein-Nummer lautet: {$COUPON_ID}\r\n\r\nHeben Sie Ihre Gutschein-Nummer gut auf, nur so knnen Sie von diesem Angebot profitieren, wenn Sie uns das nchste Mal unter {$WEBSITE} besuchen.');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(12, 12, 2, 'admin/', 'send_gift', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n\r\n    <tbody>\r\n\r\n	   {if $gm_logo_mail}\r\n       <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n		{/if}\r\n        <tr>\r\n\r\n            <td><font size="1" face="Verdana, Arial, Helvetica, sans-serif">        </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">       {$MESSAGE}       <br />       <br /> Sie k&ouml;nnen den Gutschein bei Ihrer Bestellung einl&ouml;sen. Geben Sie daf&uuml;r Ihre Gutschein-Nummer in das Feld Gutscheine ein. <br /> <br /> Ihre Gutschein-Nummer lautet: <strong> {$COUPON_ID} </strong><br /> <br /> Heben Sie Ihre Gutschein-Nummer gut auf, nur so k&ouml;nnen Sie von diesem Angebot profitieren, wenn Sie uns das n&auml;chste Mal unter <a href="{$WEBSITE}">{$WEBSITE}</a> besuchen. </font></td>\r\n\r\n        </tr>\r\n\r\n    </tbody>\r\n\r\n</table>', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n\r\n    <tbody>\r\n\r\n	   {if $gm_logo_mail}\r\n       <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n		{/if}\r\n        <tr>\r\n\r\n            <td><font size="1" face="Verdana, Arial, Helvetica, sans-serif">        </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">       {$MESSAGE}       <br />       <br /> Sie k&ouml;nnen den Gutschein bei Ihrer Bestellung einl&ouml;sen. Geben Sie daf&uuml;r Ihre Gutschein-Nummer in das Feld Gutscheine ein. <br /> <br /> Ihre Gutschein-Nummer lautet: <strong> {$COUPON_ID} </strong><br /> <br /> Heben Sie Ihre Gutschein-Nummer gut auf, nur so k&ouml;nnen Sie von diesem Angebot profitieren, wenn Sie uns das n&auml;chste Mal unter <a href="{$WEBSITE}">{$WEBSITE}</a> besuchen. </font></td>\r\n\r\n        </tr>\r\n\r\n    </tbody>\r\n\r\n</table>', '{$MESSAGE}\r\n\r\nGutscheinwert: {$AMMOUNT}\r\n\r\nUm Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren persnlichen Gutschein-Code. \r\n\r\nIhr Gutschein-Code lautet: {$GIFT_ID} \r\n{$GIFT_LINK}\r\n\r\nFalls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, besuchen Sie unsere Webseite {$WEBSITE} und geben den Gutschein-Code bitte manuell ein.', '{$MESSAGE}\r\n\r\nGutscheinwert: {$AMMOUNT}\r\n\r\nUm Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren persnlichen Gutschein-Code. \r\n\r\nIhr Gutschein-Code lautet: {$GIFT_ID} \r\n{$GIFT_LINK}\r\n\r\nFalls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, besuchen Sie unsere Webseite {$WEBSITE} und geben den Gutschein-Code bitte manuell ein.');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(13, 1, 1, '', 'change_password_mail', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n    <tbody>\r\n        <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right"><img alt="" src="{$logo_path}logo.gif" /></div>\r\n            </td>\r\n        </tr>\r\n        <tr>\r\n            <td>\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><strong>Dear customer,</strong></font> </p>\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Your password was successfully changed.<br />         <br />   Your new login data:</font>       </p>\r\n            <table width="100%" border="0" bgcolor="#f1f1f1">\r\n                <tbody>\r\n                    <tr>\r\n                        <td> <font size="1" face="Verdana, Arial, Helvetica, sans-serif"><strong>Your mail :</strong>                     {$EMAIL}             <br />             <strong>Your new password :</strong>            {$PASSWORD}         </font> </td>\r\n                    </tr>\r\n                </tbody>\r\n            </table>\r\n            </td>\r\n        </tr>\r\n    </tbody>\r\n</table>\r\n<br />\r\n<br />\r\n{$EMAIL_SIGNATURE_HTML}', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n    <tbody>\r\n        <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right"><img alt="" src="{$logo_path}logo.gif" /></div>\r\n            </td>\r\n        </tr>\r\n        <tr>\r\n            <td>\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><strong>Dear customer,</strong></font> </p>\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Your password was successfully changed.<br />         <br />   Your new login data:</font>       </p>\r\n            <table width="100%" border="0" bgcolor="#f1f1f1">\r\n                <tbody>\r\n                    <tr>\r\n                        <td> <font size="1" face="Verdana, Arial, Helvetica, sans-serif"><strong>Your mail :</strong>                     {$EMAIL}             <br />             <strong>Your new password :</strong>            {$PASSWORD}         </font> </td>\r\n                    </tr>\r\n                </tbody>\r\n            </table>\r\n            </td>\r\n        </tr>\r\n    </tbody>\r\n</table>', 'Dear customer,\r\n\r\nYour password was successfully changed.\r\n\r\nYour new login data:\r\n      \r\nemail: {$EMAIL}\r\nPassword: {$PASSWORD}\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', 'Dear customer,\r\n\r\nYour password was successfully changed.\r\n\r\nYour new login data:\r\n      \r\nemail: {$EMAIL}\r\nPassword: {$PASSWORD}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(14, 2, 1, '', 'create_account_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</strong></font> <br />\n            <br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">You successfully created your Customer Account, now you got following featues in our shop.</font><br />\n            <br />\n            <font size="2"><b><font face="Verdana, Arial, Helvetica, sans-serif">- Customer shopping cart:</font></b><font face="Verdana, Arial, Helvetica, sans-serif"> Every item remains registered until you go to the cash box, or the products are deleted from the shopping cart.<br />\n            <b>- Addressbook</b>: Now we can send the products to the postal address selected by you. The perfect way to get a birthday present.<br />\n            <b>- Previous orders:</b> You can check  your previous orders at any time.<br />\n            <b>- Opinions about products:</b> Tell zour oppinion about our products to other customers</font></font></p>\n            <p><br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">If you have questions to our customer-service, contact us directly:          {$content.MAIL_REPLY_ADDRESS}         . <br />\n            Caution: This eMail-address was announced to us by a customer. If you did not announce yourself, please send an eMail to       {$content.MAIL_REPLY_ADDRESS}. <br />\n            <br />\n            {if $SEND_GIFT==true}       <br />\n            As part of our welcome to new customers, we have sent you an e-Gift Voucher worth: <b>{$GIFT_AMMOUNT}</b><br />\n            <br />\n            The redeem code for the e-Gift Voucher is <b>{$GIFT_CODE}</b>, you can enter the redeem code when checking out while making a purchase.<br />\n            <br />\n            To use your e-Gift voucher, klick on Following link <a href="{$GIFT_LINK}">[redeem Voucher]</a>. {/if} {if $SEND_COUPON==true} Congratulations, to make your first visit to our online shop a more rewarding experience we are sending you an e-Discount Coupon.<br />\n            Below are details of the Discount Coupon created just for you<br />\n            <br />\n            Description: <b>{$COUPON_DESC}</b> <br />\n            <br />\n            To use the coupon enter the redeem code which is {$COUPON_CODE} during checkout while making a purchase {/if} </font></p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</strong></font> <br />\n            <br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">You successfully created your Customer Account, now you got following featues in our shop.</font><br />\n            <br />\n            <font size="2"><b><font face="Verdana, Arial, Helvetica, sans-serif">- Customer shopping cart:</font></b><font face="Verdana, Arial, Helvetica, sans-serif"> Every item remains registered until you go to the cash box, or the products are deleted from the shopping cart.<br />\n            <b>- Addressbook</b>: Now we can send the products to the postal address selected by you. The perfect way to get a birthday present.<br />\n            <b>- Previous orders:</b> You can check  your previous orders at any time.<br />\n            <b>- Opinions about products:</b> Tell zour oppinion about our products to other customers</font></font></p>\n            <p><br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">If you have questions to our customer-service, contact us directly:          {$content.MAIL_REPLY_ADDRESS}         . <br />\n            Caution: This eMail-address was announced to us by a customer. If you did not announce yourself, please send an eMail to       {$content.MAIL_REPLY_ADDRESS}. <br />\n            <br />\n            {if $SEND_GIFT==true}       <br />\n            As part of our welcome to new customers, we have sent you an e-Gift Voucher worth: <b>{$GIFT_AMMOUNT}</b><br />\n            <br />\n            The redeem code for the e-Gift Voucher is <b>{$GIFT_CODE}</b>, you can enter the redeem code when checking out while making a purchase.<br />\n            <br />\n            To use your e-Gift voucher, klick on Following link <a href="{$GIFT_LINK}">[redeem Voucher]</a>. {/if} {if $SEND_COUPON==true} Congratulations, to make your first visit to our online shop a more rewarding experience we are sending you an e-Discount Coupon.<br />\n            Below are details of the Discount Coupon created just for you<br />\n            <br />\n            Description: <b>{$COUPON_DESC}</b> <br />\n            <br />\n            To use the coupon enter the redeem code which is {$COUPON_CODE} during checkout while making a purchase {/if} </font></p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nYou successfully created your Customer Account, now you got following featues in our shop.\n\n- Customer shopping cart: Every item remains registered until you go to the cash box, or the products are deleted from the shopping cart.\n- Addressbook: Now we can send the products to the postal address selected by you. The perfect way to get a birthday present.\n- Previous orders: You can check  your previous orders at any time.\n- Opinions about products: Tell zour oppinion about our products to other customers\n\nIf you have questions to our customer-service, contact us directly:{$content.MAIL_REPLY_ADDRESS}\n\nCaution: This eMail-address was announced to us by a customer. If you did not announce yourself, please send an eMail to: {$content.MAIL_REPLY_ADDRESS}\n\n{if $SEND_GIFT==true}\n\nAs part of our welcome to new customers, we have sent you an e-Gift Voucher worth: {$GIFT_AMMOUNT}\n\nThe redeem code for the e-Gift Voucher is {$GIFT_CODE}, you can enter the redeem code when checking out while making a purchase.\n\nTo use your e-Gift voucher, klick on Following link {$GIFT_LINK}. \n{/if} \n\n{if $SEND_COUPON==true} \nCongratulations, to make your first visit to our online shop a more rewarding experience we are sending you an e-Discount Coupon.\nBelow are details of the Discount Coupon created just for you.\n\nDescription: {$COUPON_DESC}\n\nTo use the coupon enter the redeem code which is {$COUPON_CODE} during checkout while making a purchase \n{/if}\n\n{$EMAIL_SIGNATURE_TEXT}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nYou successfully created your Customer Account, now you got following featues in our shop.\n\n- Customer shopping cart: Every item remains registered until you go to the cash box, or the products are deleted from the shopping cart.\n- Addressbook: Now we can send the products to the postal address selected by you. The perfect way to get a birthday present.\n- Previous orders: You can check  your previous orders at any time.\n- Opinions about products: Tell zour oppinion about our products to other customers\n\nIf you have questions to our customer-service, contact us directly:{$content.MAIL_REPLY_ADDRESS}\n\nCaution: This eMail-address was announced to us by a customer. If you did not announce yourself, please send an eMail to: {$content.MAIL_REPLY_ADDRESS}\n\n{if $SEND_GIFT==true}\n\nAs part of our welcome to new customers, we have sent you an e-Gift Voucher worth: {$GIFT_AMMOUNT}\n\nThe redeem code for the e-Gift Voucher is {$GIFT_CODE}, you can enter the redeem code when checking out while making a purchase.\n\nTo use your e-Gift voucher, klick on Following link {$GIFT_LINK}. \n{/if} \n\n{if $SEND_COUPON==true} \nCongratulations, to make your first visit to our online shop a more rewarding experience we are sending you an e-Discount Coupon.\nBelow are details of the Discount Coupon created just for you.\n\nDescription: {$COUPON_DESC}\n\nTo use the coupon enter the redeem code which is {$COUPON_CODE} during checkout while making a purchase \n{/if}\n\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(15, 3, 1, '', 'new_password_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">You receive this mail, because you required a new password. <br />\n            Please log in with the following password and your email address <br />\n            and change your password like you wish.</font></p>\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Your new password:<br />\n                        </b>{$NEW_PASSWORD}</td>\n                    </tr>\n                </tbody>\n            </table>\n            </font>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">We wish you further much fun with our offer!</font></p>\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">      </font></td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">You receive this mail, because you required a new password. <br />\n            Please log in with the following password and your email address <br />\n            and change your password like you wish.</font></p>\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Your new password:<br />\n                        </b>{$NEW_PASSWORD}</td>\n                    </tr>\n                </tbody>\n            </table>\n            </font>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">We wish you further much fun with our offer!</font></p>\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">      </font></td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nYou receive this mail, because you required a new password. \nPlease log in with the following password and your email address \nand change your password like you wish.\n\nYour new password:      \n{$NEW_PASSWORD}\n\nWe wish you further much fun with our offer!\n\n{$EMAIL_SIGNATURE_TEXT}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nYou receive this mail, because you required a new password. \nPlease log in with the following password and your email address \nand change your password like you wish.\n\nYour new password:      \n{$NEW_PASSWORD}\n\nWe wish you further much fun with our offer!\n\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(16, 4, 1, '', 'newsletter_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>thank you for your subscription.</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">You receive this mail, because you want to receive our newsletter. <br />\n            Please you click on the activation link to activate this service. If you should <br />\n            not have registered yourselves in newsletter and/or the receipt of the newsletters <br />\n            is not wanted, we wish you to do nothing. Your address is then deleted automatically <br />\n            with the next actualization of the data base.\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Your activation-link:<br />\n                        </b><a href="{$LINK}">{$LINK}</a></td>\n                    </tr>\n                </tbody>\n            </table>\n            </font></p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>thank you for your subscription.</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">You receive this mail, because you want to receive our newsletter. <br />\n            Please you click on the activation link to activate this service. If you should <br />\n            not have registered yourselves in newsletter and/or the receipt of the newsletters <br />\n            is not wanted, we wish you to do nothing. Your address is then deleted automatically <br />\n            with the next actualization of the data base.\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Your activation-link:<br />\n                        </b><a href="{$LINK}">{$LINK}</a></td>\n                    </tr>\n                </tbody>\n            </table>\n            </font></p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nthank you for your subscription.\n\nYou receive this mail, because you want to receive our newsletter. \nPlease you click on the activation link to activate this service. If you should \nnot have registered yourselves in newsletter and/or the receipt of the newsletters \nis not wanted, we wish you to do nothing. Your address is then deleted automatically \nwith the next actualization of the data base.\n      \nYour activation-link:\n{$LINK}\n\n{$EMAIL_SIGNATURE_TEXT}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nthank you for your subscription.\n\nYou receive this mail, because you want to receive our newsletter. \nPlease you click on the activation link to activate this service. If you should \nnot have registered yourselves in newsletter and/or the receipt of the newsletters \nis not wanted, we wish you to do nothing. Your address is then deleted automatically \nwith the next actualization of the data base.\n      \nYour activation-link:\n{$LINK}\n\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(17, 5, 1, '', 'order_mail', '{config_load file="english/lang_english.conf" section="create_account"}\n<table border="0" width="100%">\n    <tbody>\n        <tr>\n            <td>\n            <table cellspacing="0" cellpadding="0" border="0" width="100%">\n                <tbody>\n                    <tr valign="top">\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{php}echo nl2br(STORE_NAME_ADDRESS){/php}</font>\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_customer}</font></p>\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{#text_tel#} {$PHONE}<br />\n                        {if $customer_vat}{#text_ustid#} {$customer_vat}{/if} <br />\n                        <br />\n                        {if $PAYMENT_METHOD} <strong>Paymentmethod: </strong>{$PAYMENT_METHOD}{/if}<br />\n                        <strong>Order No:</strong> {$oID}<br />\n                        <strong>Order date:</strong> {$DATE}<br />\n                        {if $csID}<strong>Customer ID:</strong> {$csID}{/if} </font></p>\n                        </td>\n                        {if $gm_logo_mail}\n                        <td>{$gm_logo_mail}</td>\n                        {/if}\n                    </tr>\n                </tbody>\n            </table>\n            <br />\n            <table border="0" width="100%" style="border-top: 1px solid; border-bottom: 1px solid;">\n                <tbody>\n                    <tr bgcolor="#f1f1f1">\n                        <td width="50%">\n                        <p><font size="1"><strong><font face="Verdana, Arial, Helvetica, sans-serif">Shipping address<br />\n                        </font></strong></font></p>\n                        </td>\n                        <td>\n                        <p><font size="1"><strong><font face="Verdana, Arial, Helvetica, sans-serif">Payment address<br />\n                        </font></strong></font></p>\n                        </td>\n                    </tr>\n                    <tr>\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_shipping}</font></td>\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_payment}</font></td>\n                    </tr>\n                </tbody>\n            </table>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},<br />\n            <br />\n            thank you for your order in our onlineshop!<br />\n            <br />\n            {if $PAYMENT_MODUL==''moneyorder''}<br />\n			Our bank details: <br />\n			{php} echo nl2br(MODULE_PAYMENT_MONEYORDER_PAYTO); {/php}<br />\n			{else}<br />\n			</font><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$PAYMENT_INFO_HTML}</font><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><br />\n            {/if}</font><br />\n            {if $COMMENTS}<br />\n            <strong><font face="Verdana, Arial, Helvetica, sans-serif" size="1">Your comments:</font></strong><br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$COMMENTS}</font><br />\n            {/if} </p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<table cellspacing="0" cellpadding="0" border="0" width="100%" style="border-bottom: 1px solid;">\n    <tbody>\n        <tr>\n            <td><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">You ordered the following products: </font></strong></td>\n        </tr>\n        <tr>\n            <td>\n            <table cellspacing="0" cellpadding="3" border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td width="10%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="center"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">pcs. </font></strong></div>\n                        </td>\n                        <td width="50%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Article</font></strong></td>\n                        <td width="15%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Article-No. </font></strong></td>\n                        <td width="12%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Single price</font></strong></div>\n                        </td>\n                        <td width="13%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1"><strong>Total price</strong> </font></div>\n                        </td>\n                    </tr>\n                </tbody>\n            </table>\n            <font size="1">{foreach name=aussen item=order_values from=$order_data} </font>\n            <table cellspacing="0" cellpadding="3" border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td width="10%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="center"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if}</font></div>\n                        </td>\n                        <td width="50%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_NAME}</font></strong><em><br />\n                        <font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_ATTRIBUTES}</font></em></td>\n                        <td width="15%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_MODEL}<br />\n                        <em>{$order_values.PRODUCTS_ATTRIBUTES_MODEL}</em></font></td>\n                        <td width="12%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_SINGLE_PRICE}</font></div>\n                        </td>\n                        <td width="13%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_PRICE}</font></div>\n                        </td>\n                    </tr>\n                </tbody>\n            </table>\n            <font face="Arial, Verdana, Helvetica, sans-serif" size="2">{/foreach} </font></td>\n        </tr>\n    </tbody>\n</table>\n<p><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{foreach name=aussen item=order_total_values from=$order_total} </font></p>\n<div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_total_values.TITLE}{$order_total_values.TEXT}</font></div>\n<p><font size="1">{/foreach}</font></p><br />\n<br />\n{$TS_RATING}\n<br />\n<br />\n{$WITHDRAWAL_HTML}\n<br />\n<br />\n{$AGB_HTML}\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '{config_load file="english/lang_english.conf" section="create_account"}\n<table border="0" width="100%">\n    <tbody>\n        <tr>\n            <td>\n            <table cellspacing="0" cellpadding="0" border="0" width="100%">\n                <tbody>\n                    <tr valign="top">\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{php}echo nl2br(STORE_NAME_ADDRESS){/php}</font>\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_customer}</font></p>\n                        <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{#text_tel#} {$PHONE}<br />\n                        {if $customer_vat}{#text_ustid#} {$customer_vat}{/if} <br />\n                        <br />\n                        {if $PAYMENT_METHOD} <strong>Paymentmethod: </strong>{$PAYMENT_METHOD}{/if}<br />\n                        <strong>Order No:</strong> {$oID}<br />\n                        <strong>Order date:</strong> {$DATE}<br />\n                        {if $csID}<strong>Customer ID:</strong> {$csID}{/if} </font></p>\n                        </td>\n                        {if $gm_logo_mail}\n                        <td>{$gm_logo_mail}</td>\n                        {/if}\n                    </tr>\n                </tbody>\n            </table>\n            <br />\n            <table border="0" width="100%" style="border-top: 1px solid; border-bottom: 1px solid;">\n                <tbody>\n                    <tr bgcolor="#f1f1f1">\n                        <td width="50%">\n                        <p><font size="1"><strong><font face="Verdana, Arial, Helvetica, sans-serif">Shipping address<br />\n                        </font></strong></font></p>\n                        </td>\n                        <td>\n                        <p><font size="1"><strong><font face="Verdana, Arial, Helvetica, sans-serif">Payment address<br />\n                        </font></strong></font></p>\n                        </td>\n                    </tr>\n                    <tr>\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_shipping}</font></td>\n                        <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$address_label_payment}</font></td>\n                    </tr>\n                </tbody>\n            </table>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="1">Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},<br />\n            <br />\n            thank you for your order in our onlineshop!<br />\n            <br />\n            {if $PAYMENT_MODUL==''moneyorder''}<br />\n			Our bank details: <br />\n			{php} echo nl2br(MODULE_PAYMENT_MONEYORDER_PAYTO); {/php}<br />\n			{else}<br />\n			</font><font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$PAYMENT_INFO_HTML}</font><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><br />\n            {/if}</font><br />\n            {if $COMMENTS}<br />\n            <strong><font face="Verdana, Arial, Helvetica, sans-serif" size="1">Your comments:</font></strong><br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="1">{$COMMENTS}</font><br />\n            {/if} </p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<table cellspacing="0" cellpadding="0" border="0" width="100%" style="border-bottom: 1px solid;">\n    <tbody>\n        <tr>\n            <td><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">You ordered the following products: </font></strong></td>\n        </tr>\n        <tr>\n            <td>\n            <table cellspacing="0" cellpadding="3" border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td width="10%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="center"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">pcs. </font></strong></div>\n                        </td>\n                        <td width="50%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Article</font></strong></td>\n                        <td width="15%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Article-No. </font></strong></td>\n                        <td width="12%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">Single price</font></strong></div>\n                        </td>\n                        <td width="13%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1"><strong>Total price</strong> </font></div>\n                        </td>\n                    </tr>\n                </tbody>\n            </table>\n            <font size="1">{foreach name=aussen item=order_values from=$order_data} </font>\n            <table cellspacing="0" cellpadding="3" border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td width="10%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="center"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if}</font></div>\n                        </td>\n                        <td width="50%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><strong><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_NAME}</font></strong><em><br />\n                        <font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_ATTRIBUTES}</font></em></td>\n                        <td width="15%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_MODEL}<br />\n                        <em>{$order_values.PRODUCTS_ATTRIBUTES_MODEL}</em></font></td>\n                        <td width="12%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_SINGLE_PRICE}</font></div>\n                        </td>\n                        <td width="13%" style="border-color: rgb(255, 255, 255); border-right: 2px solid rgb(255, 255, 255); border-bottom: 2px solid rgb(255, 255, 255);">\n                        <div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_values.PRODUCTS_PRICE}</font></div>\n                        </td>\n                    </tr>\n                </tbody>\n            </table>\n            <font face="Arial, Verdana, Helvetica, sans-serif" size="2">{/foreach} </font></td>\n        </tr>\n    </tbody>\n</table>\n<p><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{foreach name=aussen item=order_total_values from=$order_total} </font></p>\n<div align="right"><font face="Arial, Verdana, Helvetica, sans-serif" size="1">{$order_total_values.TITLE}{$order_total_values.TEXT}</font></div>\n<p><font size="1">{/foreach}</font></p><br />\n<br />\n{$TS_RATING}\n<br />\n<br />\n{$WITHDRAWAL_HTML}\n<br />\n<br />\n{$AGB_HTML}\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '{$address_label_customer}\n\n{if $PAYMENT_METHOD}Payment method: {$PAYMENT_METHOD}\n{/if}\nOrder No.: {$oID}\nDate: {$DATE}\n{if $csID}Customer ID :{$csID}{/if}\n----------------------------------------------------------------------\n\n\nDear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nthank you for your order in our onlineshop.\n\n{if $PAYMENT_MODUL==''moneyorder''}\nOur bank details:\n{php} echo MODULE_PAYMENT_MONEYORDER_PAYTO; {/php}\n{else}\n{$PAYMENT_INFO_TXT}\n{/if}\n\n{if $COMMENTS}\nYour Comments:\n{$COMMENTS}\n{/if}\n\nYou ordered the following products:\n----------------------------------------------------------------------\n{foreach name=aussen item=order_values from=$order_data} \n{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if} {$order_values.PRODUCTS_NAME} {$order_values.PRODUCTS_PRICE}\n{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}Shipping time: {$order_values.PRODUCTS_SHIPPING_TIME}<br />{/if}\n{if $order_values.PRODUCTS_ATTRIBUTES !=''''}{$order_values.PRODUCTS_ATTRIBUTES}{/if}\n\n{/foreach}\n\n{foreach name=aussen item=order_total_values from=$order_total}\n{$order_total_values.TITLE}{$order_total_values.TEXT}\n{/foreach}\n\n\n{if $address_label_payment}\nPayment address\n----------------------------------------------------------------------\n{$address_label_payment}\n{/if}\nShipping address \n----------------------------------------------------------------------\n{$address_label_shipping}\n\n\n\n{$WITHDRAWAL_TEXT}\n\n{$AGB_TEXT}\n\n{$EMAIL_SIGNATURE_TEXT}', '{$address_label_customer}\n\n{if $PAYMENT_METHOD}Payment method: {$PAYMENT_METHOD}\n{/if}\nOrder No.: {$oID}\nDate: {$DATE}\n{if $csID}Customer ID :{$csID}{/if}\n----------------------------------------------------------------------\n\n\nDear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nthank you for your order in our onlineshop.\n\n{if $PAYMENT_MODUL==''moneyorder''}\nOur bank details:\n{php} echo MODULE_PAYMENT_MONEYORDER_PAYTO; {/php}\n{else}\n{$PAYMENT_INFO_TXT}\n{/if}\n\n{if $COMMENTS}\nYour Comments:\n{$COMMENTS}\n{/if}\n\nYou ordered the following products:\n----------------------------------------------------------------------\n{foreach name=aussen item=order_values from=$order_data} \n{$order_values.PRODUCTS_QTY} {if $order_values.UNIT}{$order_values.UNIT}{else}x{/if} {$order_values.PRODUCTS_NAME} {$order_values.PRODUCTS_PRICE}\n{if $order_values.PRODUCTS_SHIPPING_TIME neq ''''}Shipping time: {$order_values.PRODUCTS_SHIPPING_TIME}<br />{/if}\n{if $order_values.PRODUCTS_ATTRIBUTES !=''''}{$order_values.PRODUCTS_ATTRIBUTES}{/if}\n\n{/foreach}\n\n{foreach name=aussen item=order_total_values from=$order_total}\n{$order_total_values.TITLE}{$order_total_values.TEXT}\n{/foreach}\n\n\n{if $address_label_payment}\nPayment address\n----------------------------------------------------------------------\n{$address_label_payment}\n{/if}\nShipping address \n----------------------------------------------------------------------\n{$address_label_shipping}\n\n\n\n{$WITHDRAWAL_TEXT}\n\n{$AGB_TEXT}\n\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(18, 6, 1, '', 'password_verification_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Please confirm, that you personally required a new password. <br />\n            For this reason we sent this email with a personal confirmation-link.          If you confirm the link, by clicking it, immediately a new password is sent to you in a further email at the disposal.\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Your confirmation-link:<br />\n                        </b><a href="{$LINK}">{$LINK}</a></td>\n                    </tr>\n                </tbody>\n            </table>\n            </font></p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</b></font></p>\n            <p><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Please confirm, that you personally required a new password. <br />\n            For this reason we sent this email with a personal confirmation-link.          If you confirm the link, by clicking it, immediately a new password is sent to you in a further email at the disposal.\n            <table border="0" bgcolor="#f1f1f1" width="100%">\n                <tbody>\n                    <tr>\n                        <td><b>Your confirmation-link:<br />\n                        </b><a href="{$LINK}">{$LINK}</a></td>\n                    </tr>\n                </tbody>\n            </table>\n            </font></p>\n            </td>\n        </tr>\n    </tbody>\n</table>\n<br />\n<br />\n{$EMAIL_SIGNATURE_HTML}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nPlease confirm, that you personally required a new password. \nFor this reason we sent this email with a personal confirmation-link. If you confirm the link, by clicking it, immediately a new password \nis sent to you in a further email at the disposal.\n      \nYour confirmation-link:\n{$LINK}\n\n{$EMAIL_SIGNATURE_TEXT}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nPlease confirm, that you personally required a new password. \nFor this reason we sent this email with a personal confirmation-link. If you confirm the link, by clicking it, immediately a new password \nis sent to you in a further email at the disposal.\n      \nYour confirmation-link:\n{$LINK}\n\n{$EMAIL_SIGNATURE_TEXT}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(19, 7, 1, '', 'send_gift_to_friend', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n\r\n    <tbody>\r\n\r\n    {if $gm_logo_mail}\r\n       <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n		{/if}\r\n        <tr>\r\n\r\n            <td>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">----------------------------------------------------------------------------------------          <br />         Gratulation, you received a gift voucher over: <b>{$AMMOUNT}</b><br />         ----------------------------------------------------------------------------------------<br />         <br />         This gift voucher is from: {$FROM_NAME}.</font></p>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><br />Message: <br />         <br />         {$MESSAGE}<br />         <br />         Your personal gift voucher code is: <strong>{$GIFT_CODE}</strong>. You          can redeem this gift voucher during your order in our store,</font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">or with a click on the following link <a href="{$GIFT_LINK}">{$GIFT_LINK}</a>.          <br />         </font></p>\r\n\r\n            </td>\r\n\r\n        </tr>\r\n\r\n    </tbody>\r\n\r\n</table>\r\n<br />\r\n<br />\r\n{$EMAIL_SIGNATURE_HTML}', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n\r\n    <tbody>\r\n\r\n    {if $gm_logo_mail}\r\n       <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n		{/if}\r\n        <tr>\r\n\r\n            <td>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">----------------------------------------------------------------------------------------          <br />         Gratulation, you received a gift voucher over: <b>{$AMMOUNT}</b><br />         ----------------------------------------------------------------------------------------<br />         <br />         This gift voucher is from: {$FROM_NAME}.</font></p>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><br />Message: <br />         <br />         {$MESSAGE}<br />         <br />         Your personal gift voucher code is: <strong>{$GIFT_CODE}</strong>. You          can redeem this gift voucher during your order in our store,</font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">or with a click on the following link <a href="{$GIFT_LINK}">{$GIFT_LINK}</a>.          <br />         </font></p>\r\n\r\n            </td>\r\n\r\n        </tr>\r\n\r\n    </tbody>\r\n\r\n</table>', '---------------------------------------------------------------------------------------- \r\nGratulation, you received a gift voucher over: {$AMMOUNT}\r\n----------------------------------------------------------------------------------------\r\n\r\nThis gift voucher is from: {$FROM_NAME}\r\n\r\nMessage: \r\n\r\n{$MESSAGE}\r\n\r\nYour personal gift voucher code is: {$GIFT_CODE}. \r\nYou can redeem this gift voucher during your order in our store or with a click on the following link:\r\n{$GIFT_LINK}\r\n\r\n\r\n{$EMAIL_SIGNATURE_TEXT}', '---------------------------------------------------------------------------------------- \r\nGratulation, you received a gift voucher over: {$AMMOUNT}\r\n----------------------------------------------------------------------------------------\r\n\r\nThis gift voucher is from: {$FROM_NAME}\r\n\r\nMessage: \r\n\r\n{$MESSAGE}\r\n\r\nYour personal gift voucher code is: {$GIFT_CODE}. \r\nYou can redeem this gift voucher during your order in our store or with a click on the following link:\r\n{$GIFT_LINK}\r\n');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(20, 8, 1, 'admin/', 'change_order_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\n            <br />\n            The status of your order </font><font face="Verdana, Arial, Helvetica, sans-serif" size="2">{$ORDER_NR} from </font><font face="Verdana, Arial, Helvetica, sans-serif" size="2">{$ORDER_DATE} </font><font face="Verdana, Arial, Helvetica, sans-serif" size="2">changed.<br />\n            {if $NOTIFY_COMMENTS}<br />\n            Comments:  {$NOTIFY_COMMENTS} <br />\n            {/if} <br />\n            New status:  <b>{$ORDER_STATUS}</b> <br />\n            For questions, feel free to anwser to this mail. </font></td>\n        </tr>\n    </tbody>\n</table>', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong><br />\n            <br />\n            The status of your order </font><font face="Verdana, Arial, Helvetica, sans-serif" size="2">{$ORDER_NR} from </font><font face="Verdana, Arial, Helvetica, sans-serif" size="2">{$ORDER_DATE} </font><font face="Verdana, Arial, Helvetica, sans-serif" size="2">changed.<br />\n            {if $NOTIFY_COMMENTS}<br />\n            Comments:  {$NOTIFY_COMMENTS} <br />\n            {/if} <br />\n            New status:  <b>{$ORDER_STATUS}</b> <br />\n            For questions, feel free to anwser to this mail. </font></td>\n        </tr>\n    </tbody>\n</table>', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nThe status of your order {$ORDER_NR} from {$ORDER_DATE} changed.\n\n{if $NOTIFY_COMMENTS}\nComments: {$NOTIFY_COMMENTS}\n\n{/if}\nNew status: {$ORDER_STATUS}\nFor questions, feel free to anwser to this mail.', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nThe status of your order {$ORDER_NR} from {$ORDER_DATE} changed.\n\n{if $NOTIFY_COMMENTS}\nComments: {$NOTIFY_COMMENTS}\n\n{/if}\nNew status: {$ORDER_STATUS}\nFor questions, feel free to anwser to this mail.');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(21, 9, 1, 'admin/', 'create_account_mail', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong></font><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><br />\n            <font size="2"><br />\n            We created an account for you. <br />\n            <br />\n            </font><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><font size="2">         {if $COMMENTS}Comments: {$COMMENTS} <br />\n            {/if}         </font></font><font size="2"><br />\n            <br />\n            Login with following account/password:<br />\n            <br />\n            mail:  {$EMAIL} <br />\n            password:  {$PASSWORD}          </font></font></td>\n        </tr>\n    </tbody>\n</table>', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME}, </strong></font><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><br />\n            <font size="2"><br />\n            We created an account for you. <br />\n            <br />\n            </font><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><font size="2">         {if $COMMENTS}Comments: {$COMMENTS} <br />\n            {/if}         </font></font><font size="2"><br />\n            <br />\n            Login with following account/password:<br />\n            <br />\n            mail:  {$EMAIL} <br />\n            password:  {$PASSWORD}          </font></font></td>\n        </tr>\n    </tbody>\n</table>', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nWe created an account for you.\n\n{if $COMMENTS}Comments:{$COMMENTS}{/if}\n\nLogin with following account/password:\n\nmail: {$EMAIL}\npassword: {$PASSWORD}', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nWe created an account for you.\n\n{if $COMMENTS}Comments:{$COMMENTS}{/if}\n\nLogin with following account/password:\n\nmail: {$EMAIL}\npassword: {$PASSWORD}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(22, 10, 1, 'admin/', 'gift_accepted', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">  </font><font face="Verdana, Arial, Helvetica, sans-serif" size="2">       <strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</strong></font> <br />\n            <br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">You have recently ordered a coupon in our online shop, which was not activated immediately for safety reasons. This credit is now available for you. You can book your coupon and send it by e-mail. The ordered coupon have a value of {$AMMOUNT}.       </font></td>\n        </tr>\n    </tbody>\n</table>', '<table cellspacing="0" cellpadding="4" border="0" align="center" width="100%">\n    <tbody>\n        {if $gm_logo_mail}\n        <tr>\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\n            <div align="right">{$gm_logo_mail}</div>\n            </td>\n        </tr>\n        {/if}\n        <tr>\n            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="1">  </font><font face="Verdana, Arial, Helvetica, sans-serif" size="2">       <strong>Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},</strong></font> <br />\n            <br />\n            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">You have recently ordered a coupon in our online shop, which was not activated immediately for safety reasons. This credit is now available for you. You can book your coupon and send it by e-mail. The ordered coupon have a value of {$AMMOUNT}.       </font></td>\n        </tr>\n    </tbody>\n</table>', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nYou have recently ordered a coupon in our online shop, which was not activated immediately for safety reasons.\nThis credit is now available for you. You can book your coupon and send it by e-mail. The ordered coupon have a value of {$AMMOUNT}.', 'Dear {if $GENDER == ''m''}Mr {elseif $GENDER == ''f''}Miss/Ms/Mrs {/if}{$NAME},\n\nYou have recently ordered a coupon in our online shop, which was not activated immediately for safety reasons.\nThis credit is now available for you. You can book your coupon and send it by e-mail. The ordered coupon have a value of {$AMMOUNT}.');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(23, 11, 1, 'admin/', 'send_coupon', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n\r\n    <tbody>\r\n\r\n	   {if $gm_logo_mail}\r\n       <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n		{/if}\r\n        <tr>\r\n\r\n            <td><font size="1" face="Verdana, Arial, Helvetica, sans-serif">        </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">       {$MESSAGE}       <br />       <br /> Sie k&ouml;nnen den Gutschein bei Ihrer Bestellung einl&ouml;sen. Geben Sie daf&uuml;r Ihre Gutschein-Nummer in das Feld Gutscheine ein. <br /> <br /> Ihre Gutschein-Nummer lautet: <strong> {$COUPON_ID} </strong><br /> <br /> Heben Sie Ihre Gutschein-Nummer gut auf, nur so k&ouml;nnen Sie von diesem Angebot profitieren, wenn Sie uns das n&auml;chste Mal unter <a href="{$WEBSITE}">{$WEBSITE}</a> besuchen. </font></td>\r\n\r\n        </tr>\r\n\r\n    </tbody>\r\n\r\n</table>', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n\r\n    <tbody>\r\n\r\n	   {if $gm_logo_mail}\r\n       <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n		{/if}\r\n        <tr>\r\n\r\n            <td><font size="1" face="Verdana, Arial, Helvetica, sans-serif">        </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">       {$MESSAGE}       <br />       <br /> Sie k&ouml;nnen den Gutschein bei Ihrer Bestellung einl&ouml;sen. Geben Sie daf&uuml;r Ihre Gutschein-Nummer in das Feld Gutscheine ein. <br /> <br /> Ihre Gutschein-Nummer lautet: <strong> {$COUPON_ID} </strong><br /> <br /> Heben Sie Ihre Gutschein-Nummer gut auf, nur so k&ouml;nnen Sie von diesem Angebot profitieren, wenn Sie uns das n&auml;chste Mal unter <a href="{$WEBSITE}">{$WEBSITE}</a> besuchen. </font></td>\r\n\r\n        </tr>\r\n\r\n    </tbody>\r\n\r\n</table>', '{$MESSAGE}\r\n\r\nSie knnen den Gutschein bei Ihrer Bestellung einlsen. Geben Sie dafr Ihre Gutschein-Nummer in das Feld Gutscheine ein.\r\n\r\nIhre Gutschein-Nummer lautet: {$COUPON_ID}\r\n\r\nHeben Sie Ihre Gutschein-Nummer gut auf, nur so knnen Sie von diesem Angebot profitieren, wenn Sie uns das nchste Mal unter {$WEBSITE} besuchen.', '{$MESSAGE}\r\n\r\nSie knnen den Gutschein bei Ihrer Bestellung einlsen. Geben Sie dafr Ihre Gutschein-Nummer in das Feld Gutscheine ein.\r\n\r\nIhre Gutschein-Nummer lautet: {$COUPON_ID}\r\n\r\nHeben Sie Ihre Gutschein-Nummer gut auf, nur so knnen Sie von diesem Angebot profitieren, wenn Sie uns das nchste Mal unter {$WEBSITE} besuchen.');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(24, 12, 1, 'admin/', 'send_gift', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n\r\n    <tbody>\r\n\r\n	   {if $gm_logo_mail}\r\n       <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n		{/if}\r\n        <tr>\r\n\r\n            <td>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">{$MESSAGE}       </font></p>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Gutscheinwert: {$AMMOUNT}</font></p>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Um Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren pers&ouml;nlichen Gutschein-Code. Ihr Gutschein-Code lautet: {$GIFT_ID}</font></p>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"> <a href="{$GIFT_LINK}">{$GIFT_LINK}</a> </font></p>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Falls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">besuchen Sie unsere Webseite <a href="{$WEBSITE}">{$WEBSITE}</a> und geben den Gutschein-Code bitte manuell ein. </font></p>\r\n\r\n            </td>\r\n\r\n        </tr>\r\n\r\n    </tbody>\r\n\r\n</table>\r\n\r\n<p> </p>', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n\r\n    <tbody>\r\n\r\n	   {if $gm_logo_mail}\r\n       <tr>\r\n            <td style="border-color: rgb(204, 204, 204); border-bottom: 1px solid rgb(204, 204, 204);">\r\n            <div align="right">{$gm_logo_mail}</div>\r\n            </td>\r\n        </tr>\r\n		{/if}\r\n        <tr>\r\n\r\n            <td>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">{$MESSAGE}       </font></p>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Gutscheinwert: {$AMMOUNT}</font></p>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Um Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren pers&ouml;nlichen Gutschein-Code. Ihr Gutschein-Code lautet: {$GIFT_ID}</font></p>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif"> <a href="{$GIFT_LINK}">{$GIFT_LINK}</a> </font></p>\r\n\r\n            <p><font size="2" face="Verdana, Arial, Helvetica, sans-serif">Falls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">besuchen Sie unsere Webseite <a href="{$WEBSITE}">{$WEBSITE}</a> und geben den Gutschein-Code bitte manuell ein. </font></p>\r\n\r\n            </td>\r\n\r\n        </tr>\r\n\r\n    </tbody>\r\n\r\n</table>\r\n\r\n<p> </p>', '{$MESSAGE}\r\n\r\nGutscheinwert: {$AMMOUNT}\r\n\r\nUm Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren persnlichen Gutschein-Code. \r\n\r\nIhr Gutschein-Code lautet: {$GIFT_ID} \r\n{$GIFT_LINK}\r\n\r\nFalls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, besuchen Sie unsere Webseite {$WEBSITE} und geben den Gutschein-Code bitte manuell ein.', '{$MESSAGE}\r\n\r\nGutscheinwert: {$AMMOUNT}\r\n\r\nUm Ihren Gutschein zu verbuchen, klicken Sie auf den unten stehenden Link. Bitte notieren Sie sich zur Sicherheit Ihren persnlichen Gutschein-Code. \r\n\r\nIhr Gutschein-Code lautet: {$GIFT_ID} \r\n{$GIFT_LINK}\r\n\r\nFalls es wider Erwarten zu Problemen beim Verbuchen kommen sollte, besuchen Sie unsere Webseite {$WEBSITE} und geben den Gutschein-Code bitte manuell ein.');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(25, 13, 2, 'admin/', 'delete_account_mail', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n    <tbody>\r\n        <tr>\r\n            <td><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><strong>Sehr geehrter Admin, </strong><br />       <br />der Kunde </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">{$CUSTOMER} m&ouml;chte sein Konto l&ouml;schen</font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">.<br />        {if $NOTIFY_COMMENTS}<br /><br /> Anmerkungen:<br />  {$NOTIFY_COMMENTS} <br />{/if} </font></td>\r\n        </tr>\r\n    </tbody>\r\n</table>', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n    <tbody>\r\n        <tr>\r\n            <td><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><strong>Sehr geehrter Admin, </strong><br />       <br />der Kunde </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">{$CUSTOMER} m&ouml;chte sein Konto l&ouml;schen</font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">.<br />        {if $NOTIFY_COMMENTS}<br /><br /> Anmerkungen:<br />  {$NOTIFY_COMMENTS} <br />{/if} </font></td>\r\n        </tr>\r\n    </tbody>\r\n</table>', 'Sehr geehrter Admin,\r\n\r\nder Kunde {$CUSTOMER} mchte sein Konto lschen.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nAnmerkungen:\r\n{$NOTIFY_COMMENTS}\r\n{/if}', 'Sehr geehrter Admin,\r\n\r\nder Kunde {$CUSTOMER} mchte sein Konto lschen.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nAnmerkungen:\r\n{$NOTIFY_COMMENTS}\r\n{/if}');
INSERT INTO `gm_emails` (`gm_emails_id`, `gm_email_id`, `languages_id`, `folder`, `filename`, `backup_original_html`, `backup_user_html`, `backup_original_txt`, `backup_user_txt`) VALUES(26, 13, 1, 'admin/', 'delete_account_mail', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n    <tbody>\r\n        <tr>\r\n            <td><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><strong>Dear admin, </strong><br />       <br />the customer </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">{$CUSTOMER} would like to delete his account</font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">.<br />        {if $NOTIFY_COMMENTS}<br /><br /> Comments:<br />  {$NOTIFY_COMMENTS} <br />{/if} </font></td>\r\n        </tr>\r\n    </tbody>\r\n</table>', '<table width="100%" cellspacing="0" cellpadding="4" border="0" align="center">\r\n    <tbody>\r\n        <tr>\r\n            <td><font size="2" face="Verdana, Arial, Helvetica, sans-serif"><strong>Dear admin, </strong><br />       <br />the customer </font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">{$CUSTOMER} would like to delete his account</font><font size="2" face="Verdana, Arial, Helvetica, sans-serif">.<br />        {if $NOTIFY_COMMENTS}<br /><br /> Comments:<br />  {$NOTIFY_COMMENTS} <br />{/if} </font></td>\r\n        </tr>\r\n    </tbody>\r\n</table>', 'Dear admin,\r\n\r\nthe customer {$CUSTOMER} would like to delete his account.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nComments:\r\n{$NOTIFY_COMMENTS}\r\n{/if}', 'Dear admin,\r\n\r\nthe customer {$CUSTOMER} would like to delete his account.\r\n{if $NOTIFY_COMMENTS}\r\n\r\nComments:\r\n{$NOTIFY_COMMENTS}\r\n{/if}');


INSERT INTO `gm_gmotion` (`gm_gmotion_id`, `products_id`, `image_nr`, `position_from`, `position_to`, `zoom_from`, `zoom_to`, `duration`, `sort_order`) VALUES(1, 1, 0, '4% 98%', '93% 11%', 1.0, 1.0, 10, 1);
INSERT INTO `gm_gmotion` (`gm_gmotion_id`, `products_id`, `image_nr`, `position_from`, `position_to`, `zoom_from`, `zoom_to`, `duration`, `sort_order`) VALUES(2, 1, 1, '21% 30%', '63% 67%', 1.0, 1.0, 10, 2);
INSERT INTO `gm_gmotion` (`gm_gmotion_id`, `products_id`, `image_nr`, `position_from`, `position_to`, `zoom_from`, `zoom_to`, `duration`, `sort_order`) VALUES(3, 1, 2, '73% 12%', '34% 92%', 1.0, 1.0, 10, 3);
INSERT INTO `gm_gmotion` (`gm_gmotion_id`, `products_id`, `image_nr`, `position_from`, `position_to`, `zoom_from`, `zoom_to`, `duration`, `sort_order`) VALUES(4, 1, 3, '6% 73%', '92% 34%', 1.0, 1.0, 10, 4);


INSERT INTO `gm_gmotion_products` (`gm_gmotion_products_id`, `products_id`) VALUES(1, 1);


INSERT INTO `gm_guestbook_customers_status` (`gm_guestbook_customers_status_id`, `customers_status_id`) VALUES(1, 0);
INSERT INTO `gm_guestbook_customers_status` (`gm_guestbook_customers_status_id`, `customers_status_id`) VALUES(2, 1);
INSERT INTO `gm_guestbook_customers_status` (`gm_guestbook_customers_status_id`, `customers_status_id`) VALUES(3, 2);
INSERT INTO `gm_guestbook_customers_status` (`gm_guestbook_customers_status_id`, `customers_status_id`) VALUES(4, 3);


INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(8, 5, 1, 2, 'Artikelbild');
INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(7, 5, 1, 1, 'product image');
INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(11, 7, 1, 1, 'product image');
INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(10, 6, 1, 2, 'Artikelbild');
INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(9, 6, 1, 1, 'product image');
INSERT INTO `gm_prd_img_alt` (`img_alt_id`, `image_id`, `products_id`, `language_id`, `gm_alt_text`) VALUES(12, 7, 1, 2, 'Artikelbild');

 
INSERT INTO `google_export_availability` (`google_export_availability_id`, `availability`) VALUES(1, 'auf lager');
INSERT INTO `google_export_availability` (`google_export_availability_id`, `availability`) VALUES(2, 'bestellbar');
INSERT INTO `google_export_availability` (`google_export_availability_id`, `availability`) VALUES(3, 'nicht auf lager');
INSERT INTO `google_export_availability` (`google_export_availability_id`, `availability`) VALUES(4, 'vorbestellt');


INSERT INTO `languages` (`languages_id`, `name`, `code`, `image`, `directory`, `sort_order`, `language_charset`) VALUES(1, 'English', 'en', 'icon.gif', 'english', 2, 'iso-8859-15');
INSERT INTO `languages` (`languages_id`, `name`, `code`, `image`, `directory`, `sort_order`, `language_charset`) VALUES(2, 'Deutsch', 'de', 'icon.gif', 'german', 1, 'iso-8859-15');


INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(1, 1, 'Pending');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(2, 1, 'Processing');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(2, 2, 'In Bearbeitung');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(3, 1, 'Delivered');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(3, 2, 'Versendet');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(99, 1, 'Canceled');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(99, 2, 'Storniert');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(1, 2, 'Offen');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(149, 2, 'Rechnung erstellt');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(149, 1, 'Invoice created');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(160, 1, 'ipayment temporary');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(160, 2, 'ipayment temporaer');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(161, 1, 'ipayment paid');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(161, 2, 'ipayment bezahlt');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(162, 1, 'ipayment error');
INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES(162, 2, 'ipayment Fehler');


INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(2, 'ALB');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(3, 'ALG');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(4, 'AME');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(5, 'AND');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(6, 'AGL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(7, 'ANG');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(9, 'ANT');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(10, 'ARG');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(11, 'ARM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(12, 'ARU');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(13, 'AUS');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(14, 'AUT');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(15, 'AZE');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(16, 'BMS');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(17, 'BAH');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(18, 'BAN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(19, 'BAR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(20, 'BLR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(21, 'BGM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(22, 'BEL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(23, 'BEN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(24, 'BER');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(26, 'BOL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(27, 'BOS');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(28, 'BOT');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(30, 'BRA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(32, 'BRU');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(33, 'BUL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(34, 'BKF');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(35, 'BUR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(36, 'CAM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(37, 'CMR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(38, 'CAN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(39, 'CAP');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(40, 'CAY');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(41, 'CEN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(42, 'CHA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(43, 'CHL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(44, 'CHN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(47, 'COL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(49, 'CON');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(51, 'COS');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(52, 'COT');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(53, 'CRO');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(54, 'CUB');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(55, 'CYP');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(56, 'CZE');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(57, 'DEN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(58, 'DJI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(59, 'DOM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(60, 'DRP');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(62, 'ECU');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(64, 'EL_');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(65, 'EQU');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(66, 'ERI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(67, 'EST');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(68, 'ETH');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(70, 'FAR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(71, 'FIJ');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(72, 'FIN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(73, 'FRA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(75, 'FRE');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(78, 'GAB');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(79, 'GAM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(80, 'GEO');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(81, 'GER');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(82, 'GHA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(83, 'GIB');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(84, 'GRC');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(85, 'GRL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(87, 'GDL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(88, 'GUM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(89, 'GUA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(90, 'GUI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(91, 'GBS');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(92, 'GUY');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(93, 'HAI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(95, 'HON');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(96, 'HKG');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(97, 'HUN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(98, 'ICE');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(99, 'IND');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(101, 'IRN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(102, 'IRA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(103, 'IRE');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(104, 'ISR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(105, 'ITA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(106, 'JAM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(107, 'JAP');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(108, 'JOR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(109, 'KAZ');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(110, 'KEN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(112, 'SKO');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(113, 'KOR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(114, 'KUW');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(115, 'KYR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(116, 'LAO');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(117, 'LAT');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(141, 'MCO');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(119, 'LES');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(120, 'LIB');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(121, 'LBY');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(122, 'LIE');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(123, 'LIT');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(124, 'LUX');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(125, 'MAC');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(126, 'F.Y');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(127, 'MAD');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(128, 'MLW');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(129, 'MLS');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(130, 'MAL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(131, 'MLI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(132, 'MLT');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(134, 'MAR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(135, 'MRT');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(136, 'MAU');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(138, 'MEX');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(140, 'MOL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(142, 'MON');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(143, 'MTT');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(144, 'MOR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(145, 'MOZ');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(76, 'PYF');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(147, 'NAM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(149, 'NEP');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(150, 'NED');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(151, 'NET');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(152, 'CDN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(153, 'NEW');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(154, 'NIC');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(155, 'NIG');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(69, 'FLK');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(160, 'NWY');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(161, 'OMA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(162, 'PAK');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(164, 'PAN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(165, 'PAP');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(166, 'PAR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(167, 'PER');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(168, 'PHI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(170, 'POL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(171, 'POR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(172, 'PUE');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(173, 'QAT');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(175, 'ROM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(176, 'RUS');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(177, 'RWA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(178, 'SKN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(179, 'SLU');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(180, 'ST.');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(181, 'WES');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(182, 'SAN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(183, 'SAO');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(184, 'SAU');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(185, 'SEN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(186, 'SEY');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(187, 'SIE');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(188, 'SIN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(189, 'SLO');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(190, 'SLV');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(191, 'SOL');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(192, 'SOM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(193, 'SOU');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(195, 'SPA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(196, 'SRI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(199, 'SUD');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(200, 'SUR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(202, 'SWA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(203, 'SWE');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(204, 'SWI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(205, 'SYR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(206, 'TWN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(207, 'TAJ');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(208, 'TAN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(209, 'THA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(210, 'TOG');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(212, 'TON');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(213, 'TRI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(214, 'TUN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(215, 'TUR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(216, 'TKM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(217, 'TCI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(219, 'UGA');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(231, 'BRI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(221, 'UAE');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(222, 'GBR');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(223, 'UNI');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(225, 'URU');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(226, 'UZB');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(227, 'VAN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(229, 'VEN');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(230, 'VIE');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(232, 'US_');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(235, 'YEM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(236, 'YUG');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(238, 'ZAM');
INSERT INTO `payment_moneybookers_countries` (`osc_cID`, `mb_cID`) VALUES(239, 'ZIM');


INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('AUD', 'Australian Dollar');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('BGN', 'Bulgarian Lev');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('CAD', 'Canadian Dollar');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('CHF', 'Swiss Franc');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('CZK', 'Czech Koruna');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('DKK', 'Danish Krone');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('EEK', 'Estonian Koruna');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('EUR', 'Euro');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('GBP', 'Pound Sterling');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('HKD', 'Hong Kong Dollar');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('HUF', 'Forint');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('ILS', 'Shekel');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('ISK', 'Iceland Krona');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('JPY', 'Yen');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('KRW', 'South-Korean Won');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('LVL', 'Latvian Lat');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('MYR', 'Malaysian Ringgit');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('NOK', 'Norwegian Krone');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('NZD', 'New Zealand Dollar');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('PLN', 'Zloty');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('SEK', 'Swedish Krona');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('SGD', 'Singapore Dollar');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('SKK', 'Slovak Koruna');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('THB', 'Baht');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('TWD', 'New Taiwan Dollar');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('USD', 'US Dollar');
INSERT INTO `payment_moneybookers_currencies` (`mb_currID`, `mb_currName`) VALUES('ZAR', 'South-African Rand');


INSERT INTO `products` (`products_id`, `products_ean`, `products_quantity`, `products_shippingtime`, `products_model`, `group_permission_0`, `group_permission_1`, `group_permission_2`, `group_permission_3`, `products_sort`, `products_image`, `products_price`, `products_discount_allowed`, `products_date_added`, `products_last_modified`, `products_date_available`, `products_weight`, `products_status`, `products_tax_class_id`, `product_template`, `options_template`, `manufacturers_id`, `products_ordered`, `products_fsk18`, `products_vpe`, `products_vpe_status`, `products_vpe_value`, `products_startpage`, `products_startpage_sort`, `group_ids`, `nc_ultra_shipping_costs`, `gm_show_date_added`, `gm_show_price_offer`, `gm_show_weight`, `gm_price_status`, `gm_min_order`, `gm_graduated_qty`, `gm_options_template`, `gm_priority`, `gm_changefreq`, `gm_show_qty_info`, `gm_sitemap_entry`, `products_image_w`, `products_image_h`, `gm_show_image`) VALUES(1, '', 998.0000, 1, 'ABC123', 0, 0, 0, 0, 0, 'artikelbild.jpg', 16.7983, 0.00, '2008-08-08 17:19:46', '2011-03-16 16:01:51', NULL, 0.0000, 1, 1, 'standard.html', 'product_options_dropdown.html', 0, 1.0000, 0, 0, 0, 0.0000, 0, 0, '', 0.00, 0, 1, 0, 0, 1.0000, 1.0000, 'product_options_dropdown.html', '0.5', 'daily', 1, 1, 130, 130, 1);


INSERT INTO `products_attributes` (`products_attributes_id`, `products_id`, `options_id`, `options_values_id`, `options_values_price`, `price_prefix`, `attributes_model`, `attributes_stock`, `options_values_weight`, `weight_prefix`, `sortorder`) VALUES(26, 1, 2, 4, 1.6807, '+', '', 199.0000, 0.0000, '+', 3);
INSERT INTO `products_attributes` (`products_attributes_id`, `products_id`, `options_id`, `options_values_id`, `options_values_price`, `price_prefix`, `attributes_model`, `attributes_stock`, `options_values_weight`, `weight_prefix`, `sortorder`) VALUES(25, 1, 2, 5, 0.0000, '+', '', 200.0000, 0.0000, '+', 2);
INSERT INTO `products_attributes` (`products_attributes_id`, `products_id`, `options_id`, `options_values_id`, `options_values_price`, `price_prefix`, `attributes_model`, `attributes_stock`, `options_values_weight`, `weight_prefix`, `sortorder`) VALUES(24, 1, 2, 6, 0.0000, '+', '', 181.0000, 0.0000, '+', 1);
INSERT INTO `products_attributes` (`products_attributes_id`, `products_id`, `options_id`, `options_values_id`, `options_values_price`, `price_prefix`, `attributes_model`, `attributes_stock`, `options_values_weight`, `weight_prefix`, `sortorder`) VALUES(23, 1, 1, 1, 4.2017, '+', '', 199.0000, 0.0000, '+', 3);
INSERT INTO `products_attributes` (`products_attributes_id`, `products_id`, `options_id`, `options_values_id`, `options_values_price`, `price_prefix`, `attributes_model`, `attributes_stock`, `options_values_weight`, `weight_prefix`, `sortorder`) VALUES(22, 1, 1, 2, 0.0000, '+', '', 200.0000, 0.0000, '+', 2);
INSERT INTO `products_attributes` (`products_attributes_id`, `products_id`, `options_id`, `options_values_id`, `options_values_price`, `price_prefix`, `attributes_model`, `attributes_stock`, `options_values_weight`, `weight_prefix`, `sortorder`) VALUES(21, 1, 1, 3, 0.0000, '+', '', 181.0000, 0.0000, '+', 1);


INSERT INTO `products_description` (`products_id`, `language_id`, `products_name`, `products_description`, `products_short_description`, `products_keywords`, `products_meta_title`, `products_meta_description`, `products_meta_keywords`, `products_url`, `products_viewed`, `gm_alt_text`, `gm_url_keywords`) VALUES(1, 1, 'test article', '<p>test article description</p>', '<p>test article short description</p>', '', '', '', '', '', 0, 'product image', 'test-article');
INSERT INTO `products_description` (`products_id`, `language_id`, `products_name`, `products_description`, `products_short_description`, `products_keywords`, `products_meta_title`, `products_meta_description`, `products_meta_keywords`, `products_url`, `products_viewed`, `gm_alt_text`, `gm_url_keywords`) VALUES(1, 2, 'Testartikel', '<p>[TAB:Seite 1] Testartikel Beschreibung Seite 1 [TAB:Seite 2] Testartikel Beschreibung Seite 2 [TAB:Seite 3] Testartikel Beschreibung Seite 3</p>', '<p>Testartikel Kurzbeschreibung</p>', '', '', '', '', '', 32, 'Artikelbild', 'Testartikel');


INSERT INTO `products_images` (`image_id`, `products_id`, `image_nr`, `image_name`, `gm_show_image`) VALUES(7, 1, 3, 'artikelbild_1_3.jpg', 1);
INSERT INTO `products_images` (`image_id`, `products_id`, `image_nr`, `image_name`, `gm_show_image`) VALUES(6, 1, 2, 'artikelbild_1_2.jpg', 1);
INSERT INTO `products_images` (`image_id`, `products_id`, `image_nr`, `image_name`, `gm_show_image`) VALUES(5, 1, 1, 'artikelbild_1_1.jpg', 1);

 
INSERT INTO `products_options` (`products_options_id`, `language_id`, `products_options_name`) VALUES(1, 1, 'size');
INSERT INTO `products_options` (`products_options_id`, `language_id`, `products_options_name`) VALUES(1, 2, 'Gre');
INSERT INTO `products_options` (`products_options_id`, `language_id`, `products_options_name`) VALUES(2, 1, 'color');
INSERT INTO `products_options` (`products_options_id`, `language_id`, `products_options_name`) VALUES(2, 2, 'Farbe');
INSERT INTO `products_options` (`products_options_id`, `language_id`, `products_options_name`) VALUES(3, 2, 'downloads');
INSERT INTO `products_options` (`products_options_id`, `language_id`, `products_options_name`) VALUES(3, 1, 'downloads');


INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(1, 1, 'S', '');
INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(1, 2, 'S', '');
INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(2, 1, 'M', '');
INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(2, 2, 'M', '');
INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(3, 1, 'L', '');
INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(3, 2, 'L', '');
INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(4, 1, 'black', '');
INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(4, 2, 'schwarz', '');
INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(5, 1, 'red', '');
INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(5, 2, 'rot', '');
INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(6, 1, 'gold', '');
INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`, `gm_filename`) VALUES(6, 2, 'gold', '');


INSERT INTO `products_options_values_to_products_options` (`products_options_values_to_products_options_id`, `products_options_id`, `products_options_values_id`) VALUES(1, 1, 1);
INSERT INTO `products_options_values_to_products_options` (`products_options_values_to_products_options_id`, `products_options_id`, `products_options_values_id`) VALUES(2, 1, 2);
INSERT INTO `products_options_values_to_products_options` (`products_options_values_to_products_options_id`, `products_options_id`, `products_options_values_id`) VALUES(3, 1, 3);
INSERT INTO `products_options_values_to_products_options` (`products_options_values_to_products_options_id`, `products_options_id`, `products_options_values_id`) VALUES(4, 2, 4);
INSERT INTO `products_options_values_to_products_options` (`products_options_values_to_products_options_id`, `products_options_id`, `products_options_values_id`) VALUES(5, 2, 5);
INSERT INTO `products_options_values_to_products_options` (`products_options_values_to_products_options_id`, `products_options_id`, `products_options_values_id`) VALUES(6, 2, 6);


INSERT INTO `products_to_categories` (`products_id`, `categories_id`) VALUES(1, 1);


INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(1, 1, 'ca. 3-4 days', 'green.png', 4, 999999);
INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(1, 2, 'ca. 3-4 Tage', 'green.png', 4, 999999);
INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(2, 1, '1 Week', 'orange.png', 7, 0);
INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(2, 2, 'ca. 1 Woche', 'orange.png', 7, 0);
INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(3, 1, '2 Weeks', 'red.png', 14, 0);
INSERT INTO `shipping_status` (`shipping_status_id`, `language_id`, `shipping_status_name`, `shipping_status_image`, `number_of_days`, `shipping_quantity`) VALUES(3, 2, 'ca. 2 Wochen', 'red.png', 14, 0);


INSERT INTO `shipping_status_to_google_availability` (`shipping_status_id`, `google_export_availability_id`) VALUES(1, 1);
INSERT INTO `shipping_status_to_google_availability` (`shipping_status_id`, `google_export_availability_id`) VALUES(2, 2);
INSERT INTO `shipping_status_to_google_availability` (`shipping_status_id`, `google_export_availability_id`) VALUES(3, 3);


INSERT INTO `specials` (`specials_id`, `products_id`, `specials_quantity`, `specials_new_products_price`, `specials_date_added`, `specials_last_modified`, `expires_date`, `date_status_change`, `status`) VALUES(1, 1, 1857.0000, 12.6050, '2008-08-12 15:40:47', '2008-08-14 19:06:03', '0000-00-00 00:00:00', NULL, 1);


INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(1, 223, 'AL', 'Alabama');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(2, 223, 'AK', 'Alaska');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(3, 223, 'AS', 'American Samoa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(4, 223, 'AZ', 'Arizona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(5, 223, 'AR', 'Arkansas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(6, 223, 'AF', 'Armed Forces Africa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(7, 223, 'AA', 'Armed Forces Americas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(8, 223, 'AC', 'Armed Forces Canada');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(9, 223, 'AE', 'Armed Forces Europe');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(10, 223, 'AM', 'Armed Forces Middle East');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(11, 223, 'AP', 'Armed Forces Pacific');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(12, 223, 'CA', 'California');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(13, 223, 'CO', 'Colorado');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(14, 223, 'CT', 'Connecticut');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(15, 223, 'DE', 'Delaware');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(16, 223, 'DC', 'District of Columbia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(17, 223, 'FM', 'Federated States Of Micronesia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(18, 223, 'FL', 'Florida');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(19, 223, 'GA', 'Georgia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(20, 223, 'GU', 'Guam');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(21, 223, 'HI', 'Hawaii');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(22, 223, 'ID', 'Idaho');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(23, 223, 'IL', 'Illinois');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(24, 223, 'IN', 'Indiana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(25, 223, 'IA', 'Iowa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(26, 223, 'KS', 'Kansas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(27, 223, 'KY', 'Kentucky');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(28, 223, 'LA', 'Louisiana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(29, 223, 'ME', 'Maine');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(30, 223, 'MH', 'Marshall Islands');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(31, 223, 'MD', 'Maryland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(32, 223, 'MA', 'Massachusetts');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(33, 223, 'MI', 'Michigan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(34, 223, 'MN', 'Minnesota');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(35, 223, 'MS', 'Mississippi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(36, 223, 'MO', 'Missouri');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(37, 223, 'MT', 'Montana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(38, 223, 'NE', 'Nebraska');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(39, 223, 'NV', 'Nevada');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(40, 223, 'NH', 'New Hampshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(41, 223, 'NJ', 'New Jersey');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(42, 223, 'NM', 'New Mexico');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(43, 223, 'NY', 'New York');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(44, 223, 'NC', 'North Carolina');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(45, 223, 'ND', 'North Dakota');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(46, 223, 'MP', 'Northern Mariana Islands');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(47, 223, 'OH', 'Ohio');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(48, 223, 'OK', 'Oklahoma');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(49, 223, 'OR', 'Oregon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(50, 223, 'PW', 'Palau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(51, 223, 'PA', 'Pennsylvania');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(52, 223, 'PR', 'Puerto Rico');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(53, 223, 'RI', 'Rhode Island');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(54, 223, 'SC', 'South Carolina');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(55, 223, 'SD', 'South Dakota');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(56, 223, 'TN', 'Tennessee');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(57, 223, 'TX', 'Texas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(58, 223, 'UT', 'Utah');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(59, 223, 'VT', 'Vermont');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(60, 223, 'VI', 'Virgin Islands');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(61, 223, 'VA', 'Virginia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(62, 223, 'WA', 'Washington');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(63, 223, 'WV', 'West Virginia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(64, 223, 'WI', 'Wisconsin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(65, 223, 'WY', 'Wyoming');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(66, 38, 'AB', 'Alberta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(67, 38, 'BC', 'British Columbia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(68, 38, 'MB', 'Manitoba');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(69, 38, 'NF', 'Newfoundland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(70, 38, 'NB', 'New Brunswick');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(71, 38, 'NS', 'Nova Scotia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(72, 38, 'NT', 'Northwest Territories');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(73, 38, 'NU', 'Nunavut');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(74, 38, 'ON', 'Ontario');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(75, 38, 'PE', 'Prince Edward Island');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(76, 38, 'QC', 'Quebec');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(77, 38, 'SK', 'Saskatchewan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(78, 38, 'YT', 'Yukon Territory');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(79, 81, 'NDS', 'Niedersachsen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(80, 81, 'BAW', 'Baden-Wrttemberg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(81, 81, 'BAY', 'Bayern');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(82, 81, 'BER', 'Berlin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(83, 81, 'BRG', 'Brandenburg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(84, 81, 'BRE', 'Bremen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(85, 81, 'HAM', 'Hamburg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(86, 81, 'HES', 'Hessen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(87, 81, 'MEC', 'Mecklenburg-Vorpommern');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(88, 81, 'NRW', 'Nordrhein-Westfalen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(89, 81, 'RHE', 'Rheinland-Pfalz');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(90, 81, 'SAR', 'Saarland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(91, 81, 'SAS', 'Sachsen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(92, 81, 'SAC', 'Sachsen-Anhalt');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(93, 81, 'SCN', 'Schleswig-Holstein');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(94, 81, 'THE', 'Thringen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(95, 14, 'WI', 'Wien');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(96, 14, 'NO', 'Niedersterreich');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(97, 14, 'OO', 'Obersterreich');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(98, 14, 'SB', 'Salzburg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(99, 14, 'KN', 'Krnten');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(100, 14, 'ST', 'Steiermark');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(101, 14, 'TI', 'Tirol');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(102, 14, 'BL', 'Burgenland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(103, 14, 'VB', 'Vorarlberg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(104, 204, 'AG', 'Aargau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(105, 204, 'AI', 'Appenzell Innerrhoden');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(106, 204, 'AR', 'Appenzell Ausserrhoden');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(107, 204, 'BE', 'Bern');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(108, 204, 'BL', 'Basel-Landschaft');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(109, 204, 'BS', 'Basel-Stadt');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(110, 204, 'FR', 'Freiburg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(111, 204, 'GE', 'Genf');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(112, 204, 'GL', 'Glarus');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(113, 204, 'JU', 'Graubnden');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(114, 204, 'JU', 'Jura');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(115, 204, 'LU', 'Luzern');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(116, 204, 'NE', 'Neuenburg');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(117, 204, 'NW', 'Nidwalden');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(118, 204, 'OW', 'Obwalden');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(119, 204, 'SG', 'St. Gallen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(120, 204, 'SH', 'Schaffhausen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(121, 204, 'SO', 'Solothurn');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(122, 204, 'SZ', 'Schwyz');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(123, 204, 'TG', 'Thurgau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(124, 204, 'TI', 'Tessin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(125, 204, 'UR', 'Uri');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(126, 204, 'VD', 'Waadt');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(127, 204, 'VS', 'Wallis');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(128, 204, 'ZG', 'Zug');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(129, 204, 'ZH', 'Zrich');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(130, 195, 'A Corua', 'A Corua');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(131, 195, 'Alava', 'Alava');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(132, 195, 'Albacete', 'Albacete');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(133, 195, 'Alicante', 'Alicante');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(134, 195, 'Almeria', 'Almeria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(135, 195, 'Asturias', 'Asturias');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(136, 195, 'Avila', 'Avila');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(137, 195, 'Badajoz', 'Badajoz');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(138, 195, 'Baleares', 'Baleares');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(139, 195, 'Barcelona', 'Barcelona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(140, 195, 'Burgos', 'Burgos');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(141, 195, 'Caceres', 'Caceres');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(142, 195, 'Cadiz', 'Cadiz');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(143, 195, 'Cantabria', 'Cantabria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(144, 195, 'Castellon', 'Castellon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(145, 195, 'Ceuta', 'Ceuta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(146, 195, 'Ciudad Real', 'Ciudad Real');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(147, 195, 'Cordoba', 'Cordoba');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(148, 195, 'Cuenca', 'Cuenca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(149, 195, 'Girona', 'Girona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(150, 195, 'Granada', 'Granada');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(151, 195, 'Guadalajara', 'Guadalajara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(152, 195, 'Guipuzcoa', 'Guipuzcoa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(153, 195, 'Huelva', 'Huelva');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(154, 195, 'Huesca', 'Huesca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(155, 195, 'Jaen', 'Jaen');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(156, 195, 'La Rioja', 'La Rioja');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(157, 195, 'Las Palmas', 'Las Palmas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(158, 195, 'Leon', 'Leon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(159, 195, 'Lleida', 'Lleida');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(160, 195, 'Lugo', 'Lugo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(161, 195, 'Madrid', 'Madrid');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(162, 195, 'Malaga', 'Malaga');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(163, 195, 'Melilla', 'Melilla');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(164, 195, 'Murcia', 'Murcia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(165, 195, 'Navarra', 'Navarra');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(166, 195, 'Ourense', 'Ourense');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(167, 195, 'Palencia', 'Palencia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(168, 195, 'Pontevedra', 'Pontevedra');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(169, 195, 'Salamanca', 'Salamanca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(170, 195, 'Santa Cruz de Tenerife', 'Santa Cruz de Tenerife');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(171, 195, 'Segovia', 'Segovia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(172, 195, 'Sevilla', 'Sevilla');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(173, 195, 'Soria', 'Soria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(174, 195, 'Tarragona', 'Tarragona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(175, 195, 'Teruel', 'Teruel');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(176, 195, 'Toledo', 'Toledo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(177, 195, 'Valencia', 'Valencia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(178, 195, 'Valladolid', 'Valladolid');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(179, 195, 'Vizcaya', 'Vizcaya');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(180, 195, 'Zamora', 'Zamora');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(181, 195, 'Zaragoza', 'Zaragoza');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(182, 13, 'NSW', 'New South Wales');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(183, 13, 'VIC', 'Victoria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(184, 13, 'QLD', 'Queensland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(185, 13, 'NT', 'Northern Territory');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(186, 13, 'WA', 'Western Australia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(187, 13, 'SA', 'South Australia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(188, 13, 'TAS', 'Tasmania');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(189, 13, 'ACT', 'Australian Capital Territory');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(190, 153, 'Northland', 'Northland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(191, 153, 'Auckland', 'Auckland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(192, 153, 'Waikato', 'Waikato');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(193, 153, 'Bay of Plenty', 'Bay of Plenty');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(194, 153, 'Gisborne', 'Gisborne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(195, 153, 'Hawkes Bay', 'Hawkes Bay');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(196, 153, 'Taranaki', 'Taranaki');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(197, 153, 'Manawatu-Wanganui', 'Manawatu-Wanganui');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(198, 153, 'Wellington', 'Wellington');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(199, 153, 'West Coast', 'West Coast');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(200, 153, 'Canterbury', 'Canterbury');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(201, 153, 'Otago', 'Otago');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(202, 153, 'Southland', 'Southland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(203, 153, 'Tasman', 'Tasman');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(204, 153, 'Nelson', 'Nelson');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(205, 153, 'Marlborough', 'Marlborough');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(206, 30, 'SP', 'So Paulo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(207, 30, 'RJ', 'Rio de Janeiro');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(208, 30, 'PE', 'Pernanbuco');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(209, 30, 'BA', 'Bahia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(210, 30, 'AM', 'Amazonas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(211, 30, 'MG', 'Minas Gerais');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(212, 30, 'ES', 'Espirito Santo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(213, 30, 'RS', 'Rio Grande do Sul');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(214, 30, 'PR', 'Paran');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(215, 30, 'SC', 'Santa Catarina');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(216, 30, 'RG', 'Rio Grande do Norte');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(217, 30, 'MS', 'Mato Grosso do Sul');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(218, 30, 'MT', 'Mato Grosso');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(219, 30, 'GO', 'Goias');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(220, 30, 'TO', 'Tocantins');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(221, 30, 'DF', 'Distrito Federal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(222, 30, 'RO', 'Rondonia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(223, 30, 'AC', 'Acre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(224, 30, 'AP', 'Amapa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(225, 30, 'RO', 'Roraima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(226, 30, 'AL', 'Alagoas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(227, 30, 'CE', 'Cear');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(228, 30, 'MA', 'Maranho');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(229, 30, 'PA', 'Par');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(230, 30, 'PB', 'Paraba');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(231, 30, 'PI', 'Piau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(232, 30, 'SE', 'Sergipe');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(233, 43, 'I', 'I Regin de Tarapac');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(234, 43, 'II', 'II Regin de Antofagasta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(235, 43, 'III', 'III Regin de Atacama');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(236, 43, 'IV', 'IV Regin de Coquimbo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(237, 43, 'V', 'V Regin de Valaparaso');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(238, 43, 'RM', 'Regin Metropolitana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(239, 43, 'VI', 'VI Regin de L. B. Ohiggins');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(240, 43, 'VII', 'VII Regin del Maule');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(241, 43, 'VIII', 'VIII Regin del Bo Bo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(242, 43, 'IX', 'IX Regin de la Araucana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(243, 43, 'X', 'X Regin de los Lagos');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(244, 43, 'XI', 'XI Regin de Aysn');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(245, 43, 'XII', 'XII Regin de Magallanes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(246, 47, 'AMA', 'Amazonas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(247, 47, 'ANT', 'Antioquia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(248, 47, 'ARA', 'Arauca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(249, 47, 'ATL', 'Atlantico');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(250, 47, 'BOL', 'Bolivar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(251, 47, 'BOY', 'Boyaca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(252, 47, 'CAL', 'Caldas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(253, 47, 'CAQ', 'Caqueta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(254, 47, 'CAS', 'Casanare');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(255, 47, 'CAU', 'Cauca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(256, 47, 'CES', 'Cesar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(257, 47, 'CHO', 'Choco');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(258, 47, 'COR', 'Cordoba');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(259, 47, 'CUN', 'Cundinamarca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(260, 47, 'HUI', 'Huila');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(261, 47, 'GUA', 'Guainia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(262, 47, 'GUA', 'Guajira');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(263, 47, 'GUV', 'Guaviare');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(264, 47, 'MAG', 'Magdalena');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(265, 47, 'MET', 'Meta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(266, 47, 'NAR', 'Narino');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(267, 47, 'NDS', 'Norte de Santander');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(268, 47, 'PUT', 'Putumayo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(269, 47, 'QUI', 'Quindio');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(270, 47, 'RIS', 'Risaralda');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(271, 47, 'SAI', 'San Andres Islas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(272, 47, 'SAN', 'Santander');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(273, 47, 'SUC', 'Sucre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(274, 47, 'TOL', 'Tolima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(275, 47, 'VAL', 'Valle');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(276, 47, 'VAU', 'Vaupes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(277, 47, 'VIC', 'Vichada');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(278, 73, 'Et', 'Etranger');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(279, 73, '01', 'Ain');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(280, 73, '02', 'Aisne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(281, 73, '03', 'Allier');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(282, 73, '04', 'Alpes de Haute Provence');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(283, 73, '05', 'Hautes-Alpes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(284, 73, '06', 'Alpes Maritimes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(285, 73, '07', 'Ardche');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(286, 73, '08', 'Ardennes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(287, 73, '09', 'Arige');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(288, 73, '10', 'Aube');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(289, 73, '11', 'Aude');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(290, 73, '12', 'Aveyron');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(291, 73, '13', 'Bouches-du-Rhne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(292, 73, '14', 'Calvados');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(293, 73, '15', 'Cantal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(294, 73, '16', 'Charente');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(295, 73, '17', 'Charente Maritime');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(296, 73, '18', 'Cher');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(297, 73, '19', 'Corrze');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(298, 73, '2A', 'Corse du Sud');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(299, 73, '2B', 'Haute Corse');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(300, 73, '21', 'Cte d''Azur');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(301, 73, '22', 'Ctes d''Armor');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(302, 73, '23', 'Creuse');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(303, 73, '24', 'Dordogne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(304, 73, '25', 'Doubs');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(305, 73, '26', 'Drme');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(306, 73, '27', 'Eure');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(307, 73, '28', 'Eure et Loir');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(308, 73, '29', 'Finistre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(309, 73, '30', 'Gard');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(310, 73, '31', 'Haute Garonne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(311, 73, '32', 'Gers');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(312, 73, '33', 'Gironde');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(313, 73, '34', 'Hrault');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(314, 73, '35', 'Ille et Vilaine');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(315, 73, '36', 'Indre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(316, 73, '37', 'Indre et Loire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(317, 73, '38', 'Isre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(318, 73, '39', 'Jura');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(319, 73, '40', 'Landes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(320, 73, '41', 'Loir et Cher');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(321, 73, '42', 'Loire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(322, 73, '43', 'Haute Loire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(323, 73, '44', 'Loire Atlantique');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(324, 73, '45', 'Loiret');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(325, 73, '46', 'Lot');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(326, 73, '47', 'Lot et Garonne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(327, 73, '48', 'Lozre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(328, 73, '49', 'Maine et Loire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(329, 73, '50', 'Manche');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(330, 73, '51', 'Marne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(331, 73, '52', 'Haute Marne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(332, 73, '53', 'Mayenne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(333, 73, '54', 'Meurthe et Moselle');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(334, 73, '55', 'Meuse');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(335, 73, '56', 'Morbihan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(336, 73, '57', 'Moselle');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(337, 73, '58', 'Nivre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(338, 73, '59', 'Nord');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(339, 73, '60', 'Oise');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(340, 73, '61', 'Orne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(341, 73, '62', 'Pas de Calais');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(342, 73, '63', 'Puy-de-Dme');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(343, 73, '64', 'Pyrnes-Atlantiques');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(344, 73, '65', 'Hautes-Pyrnes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(345, 73, '66', 'Pyrnes-Orientales');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(346, 73, '67', 'Bas Rhin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(347, 73, '68', 'Haut Rhin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(348, 73, '69', 'Rhne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(349, 73, '70', 'Haute-Sane');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(350, 73, '71', 'Sane-et-Loire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(351, 73, '72', 'Sarthe');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(352, 73, '73', 'Savoie');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(353, 73, '74', 'Haute Savoie');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(354, 73, '75', 'Paris');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(355, 73, '76', 'Seine Maritime');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(356, 73, '77', 'Seine et Marne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(357, 73, '78', 'Yvelines');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(358, 73, '79', 'Deux-Svres');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(359, 73, '80', 'Somme');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(360, 73, '81', 'Tarn');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(361, 73, '82', 'Tarn et Garonne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(362, 73, '83', 'Var');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(363, 73, '84', 'Vaucluse');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(364, 73, '85', 'Vende');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(365, 73, '86', 'Vienne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(366, 73, '87', 'Haute Vienne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(367, 73, '88', 'Vosges');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(368, 73, '89', 'Yonne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(369, 73, '90', 'Territoire de Belfort');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(370, 73, '91', 'Essonne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(371, 73, '92', 'Hauts de Seine');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(372, 73, '93', 'Seine St-Denis');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(373, 73, '94', 'Val de Marne');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(374, 73, '95', 'Val d''Oise');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(375, 73, '971 (DOM)', 'Guadeloupe');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(376, 73, '972 (DOM)', 'Martinique');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(377, 73, '973 (DOM)', 'Guyane');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(378, 73, '974 (DOM)', 'Saint Denis');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(379, 73, '975 (DOM)', 'St-Pierre de Miquelon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(380, 73, '976 (TOM)', 'Mayotte');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(381, 73, '984 (TOM)', 'Terres australes et Antartiques');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(382, 73, '985 (TOM)', 'Nouvelle-Caldonie');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(383, 73, '986 (TOM)', 'Wallis et Futuna');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(384, 73, '987 (TOM)', 'Polynsie franaise');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(385, 99, 'DL', 'Delhi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(386, 99, 'MH', 'Maharashtra');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(387, 99, 'TN', 'Tamil Nadu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(388, 99, 'KL', 'Kerala');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(389, 99, 'AP', 'Andhra Pradesh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(390, 99, 'KA', 'Karnataka');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(391, 99, 'GA', 'Goa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(392, 99, 'MP', 'Madhya Pradesh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(393, 99, 'PY', 'Pondicherry');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(394, 99, 'GJ', 'Gujarat');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(395, 99, 'OR', 'Orrisa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(396, 99, 'CA', 'Chhatisgarh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(397, 99, 'JH', 'Jharkhand');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(398, 99, 'BR', 'Bihar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(399, 99, 'WB', 'West Bengal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(400, 99, 'UP', 'Uttar Pradesh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(401, 99, 'RJ', 'Rajasthan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(402, 99, 'PB', 'Punjab');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(403, 99, 'HR', 'Haryana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(404, 99, 'CH', 'Chandigarh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(405, 99, 'JK', 'Jammu & Kashmir');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(406, 99, 'HP', 'Himachal Pradesh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(407, 99, 'UA', 'Uttaranchal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(408, 99, 'LK', 'Lakshadweep');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(409, 99, 'AN', 'Andaman & Nicobar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(410, 99, 'MG', 'Meghalaya');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(411, 99, 'AS', 'Assam');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(412, 99, 'DR', 'Dadra & Nagar Haveli');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(413, 99, 'DN', 'Daman & Diu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(414, 99, 'SK', 'Sikkim');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(415, 99, 'TR', 'Tripura');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(416, 99, 'MZ', 'Mizoram');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(417, 99, 'MN', 'Manipur');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(418, 99, 'NL', 'Nagaland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(419, 99, 'AR', 'Arunachal Pradesh');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(420, 105, 'AG', 'Agrigento');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(421, 105, 'AL', 'Alessandria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(422, 105, 'AN', 'Ancona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(423, 105, 'AO', 'Aosta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(424, 105, 'AR', 'Arezzo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(425, 105, 'AP', 'Ascoli Piceno');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(426, 105, 'AT', 'Asti');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(427, 105, 'AV', 'Avellino');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(428, 105, 'BA', 'Bari');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(429, 105, 'BL', 'Belluno');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(430, 105, 'BN', 'Benevento');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(431, 105, 'BG', 'Bergamo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(432, 105, 'BI', 'Biella');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(433, 105, 'BO', 'Bologna');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(434, 105, 'BZ', 'Bolzano');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(435, 105, 'BS', 'Brescia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(436, 105, 'BR', 'Brindisi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(437, 105, 'CA', 'Cagliari');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(438, 105, 'CL', 'Caltanissetta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(439, 105, 'CB', 'Campobasso');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(440, 105, 'CE', 'Caserta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(441, 105, 'CT', 'Catania');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(442, 105, 'CZ', 'Catanzaro');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(443, 105, 'CH', 'Chieti');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(444, 105, 'CO', 'Como');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(445, 105, 'CS', 'Cosenza');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(446, 105, 'CR', 'Cremona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(447, 105, 'KR', 'Crotone');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(448, 105, 'CN', 'Cuneo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(449, 105, 'EN', 'Enna');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(450, 105, 'FE', 'Ferrara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(451, 105, 'FI', 'Firenze');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(452, 105, 'FG', 'Foggia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(453, 105, 'FO', 'Forl');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(454, 105, 'FR', 'Frosinone');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(455, 105, 'GE', 'Genova');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(456, 105, 'GO', 'Gorizia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(457, 105, 'GR', 'Grosseto');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(458, 105, 'IM', 'Imperia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(459, 105, 'IS', 'Isernia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(460, 105, 'AQ', 'Aquila');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(461, 105, 'SP', 'La Spezia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(462, 105, 'LT', 'Latina');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(463, 105, 'LE', 'Lecce');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(464, 105, 'LC', 'Lecco');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(465, 105, 'LI', 'Livorno');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(466, 105, 'LO', 'Lodi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(467, 105, 'LU', 'Lucca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(468, 105, 'MC', 'Macerata');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(469, 105, 'MN', 'Mantova');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(470, 105, 'MS', 'Massa-Carrara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(471, 105, 'MT', 'Matera');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(472, 105, 'ME', 'Messina');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(473, 105, 'MI', 'Milano');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(474, 105, 'MO', 'Modena');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(475, 105, 'NA', 'Napoli');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(476, 105, 'NO', 'Novara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(477, 105, 'NU', 'Nuoro');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(478, 105, 'OR', 'Oristano');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(479, 105, 'PD', 'Padova');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(480, 105, 'PA', 'Palermo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(481, 105, 'PR', 'Parma');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(482, 105, 'PG', 'Perugia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(483, 105, 'PV', 'Pavia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(484, 105, 'PS', 'Pesaro e Urbino');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(485, 105, 'PE', 'Pescara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(486, 105, 'PC', 'Piacenza');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(487, 105, 'PI', 'Pisa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(488, 105, 'PT', 'Pistoia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(489, 105, 'PN', 'Pordenone');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(490, 105, 'PZ', 'Potenza');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(491, 105, 'PO', 'Prato');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(492, 105, 'RG', 'Ragusa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(493, 105, 'RA', 'Ravenna');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(494, 105, 'RC', 'Reggio di Calabria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(495, 105, 'RE', 'Reggio Emilia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(496, 105, 'RI', 'Rieti');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(497, 105, 'RN', 'Rimini');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(498, 105, 'RM', 'Roma');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(499, 105, 'RO', 'Rovigo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(500, 105, 'SA', 'Salerno');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(501, 105, 'SS', 'Sassari');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(502, 105, 'SV', 'Savona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(503, 105, 'SI', 'Siena');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(504, 105, 'SR', 'Siracusa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(505, 105, 'SO', 'Sondrio');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(506, 105, 'TA', 'Taranto');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(507, 105, 'TE', 'Teramo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(508, 105, 'TR', 'Terni');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(509, 105, 'TO', 'Torino');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(510, 105, 'TP', 'Trapani');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(511, 105, 'TN', 'Trento');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(512, 105, 'TV', 'Treviso');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(513, 105, 'TS', 'Trieste');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(514, 105, 'UD', 'Udine');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(515, 105, 'VA', 'Varese');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(516, 105, 'VE', 'Venezia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(517, 105, 'VB', 'Verbania');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(518, 105, 'VC', 'Vercelli');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(519, 105, 'VR', 'Verona');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(520, 105, 'VV', 'Vibo Valentia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(521, 105, 'VI', 'Vicenza');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(522, 105, 'VT', 'Viterbo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(523, 107, 'Niigata', 'Niigata');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(524, 107, 'Toyama', 'Toyama');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(525, 107, 'Ishikawa', 'Ishikawa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(526, 107, 'Fukui', 'Fukui');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(527, 107, 'Yamanashi', 'Yamanashi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(528, 107, 'Nagano', 'Nagano');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(529, 107, 'Gifu', 'Gifu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(530, 107, 'Shizuoka', 'Shizuoka');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(531, 107, 'Aichi', 'Aichi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(532, 107, 'Mie', 'Mie');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(533, 107, 'Shiga', 'Shiga');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(534, 107, 'Kyoto', 'Kyoto');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(535, 107, 'Osaka', 'Osaka');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(536, 107, 'Hyogo', 'Hyogo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(537, 107, 'Nara', 'Nara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(538, 107, 'Wakayama', 'Wakayama');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(539, 107, 'Tottori', 'Tottori');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(540, 107, 'Shimane', 'Shimane');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(541, 107, 'Okayama', 'Okayama');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(542, 107, 'Hiroshima', 'Hiroshima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(543, 107, 'Yamaguchi', 'Yamaguchi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(544, 107, 'Tokushima', 'Tokushima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(545, 107, 'Kagawa', 'Kagawa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(546, 107, 'Ehime', 'Ehime');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(547, 107, 'Kochi', 'Kochi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(548, 107, 'Fukuoka', 'Fukuoka');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(549, 107, 'Saga', 'Saga');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(550, 107, 'Nagasaki', 'Nagasaki');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(551, 107, 'Kumamoto', 'Kumamoto');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(552, 107, 'Oita', 'Oita');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(553, 107, 'Miyazaki', 'Miyazaki');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(554, 107, 'Kagoshima', 'Kagoshima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(555, 129, 'JOH', 'Johor');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(556, 129, 'KDH', 'Kedah');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(557, 129, 'KEL', 'Kelantan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(558, 129, 'KL', 'Kuala Lumpur');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(559, 129, 'MEL', 'Melaka');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(560, 129, 'NS', 'Negeri Sembilan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(561, 129, 'PAH', 'Pahang');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(562, 129, 'PRK', 'Perak');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(563, 129, 'PER', 'Perlis');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(564, 129, 'PP', 'Pulau Pinang');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(565, 129, 'SAB', 'Sabah');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(566, 129, 'SWK', 'Sarawak');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(567, 129, 'SEL', 'Selangor');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(568, 129, 'TER', 'Terengganu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(569, 129, 'LAB', 'W.P.Labuan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(570, 138, 'AGS', 'Aguascalientes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(571, 138, 'BC', 'Baja California');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(572, 138, 'BCS', 'Baja California Sur');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(573, 138, 'CAM', 'Campeche');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(574, 138, 'COA', 'Coahuila');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(575, 138, 'COL', 'Colima');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(576, 138, 'CHI', 'Chiapas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(577, 138, 'CHIH', 'Chihuahua');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(578, 138, 'DF', 'Distrito Federal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(579, 138, 'DGO', 'Durango');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(580, 138, 'MEX', 'Estado de Mexico');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(581, 138, 'GTO', 'Guanajuato');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(582, 138, 'GRO', 'Guerrero');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(583, 138, 'HGO', 'Hidalgo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(584, 138, 'JAL', 'Jalisco');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(585, 138, 'MCH', 'Michoacan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(586, 138, 'MOR', 'Morelos');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(587, 138, 'NAY', 'Nayarit');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(588, 138, 'NL', 'Nuevo Leon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(589, 138, 'OAX', 'Oaxaca');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(590, 138, 'PUE', 'Puebla');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(591, 138, 'QRO', 'Queretaro');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(592, 138, 'QR', 'Quintana Roo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(593, 138, 'SLP', 'San Luis Potosi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(594, 138, 'SIN', 'Sinaloa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(595, 138, 'SON', 'Sonora');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(596, 138, 'TAB', 'Tabasco');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(597, 138, 'TMPS', 'Tamaulipas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(598, 138, 'TLAX', 'Tlaxcala');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(599, 138, 'VER', 'Veracruz');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(600, 138, 'YUC', 'Yucatan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(601, 138, 'ZAC', 'Zacatecas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(602, 160, 'OSL', 'Oslo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(603, 160, 'AKE', 'Akershus');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(604, 160, 'AUA', 'Aust-Agder');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(605, 160, 'BUS', 'Buskerud');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(606, 160, 'FIN', 'Finnmark');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(607, 160, 'HED', 'Hedmark');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(608, 160, 'HOR', 'Hordaland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(609, 160, 'MOR', 'Mre og Romsdal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(610, 160, 'NOR', 'Nordland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(611, 160, 'NTR', 'Nord-Trndelag');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(612, 160, 'OPP', 'Oppland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(613, 160, 'ROG', 'Rogaland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(614, 160, 'SOF', 'Sogn og Fjordane');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(615, 160, 'STR', 'Sr-Trndelag');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(616, 160, 'TEL', 'Telemark');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(617, 160, 'TRO', 'Troms');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(618, 160, 'VEA', 'Vest-Agder');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(619, 160, 'OST', 'stfold');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(620, 160, 'SVA', 'Svalbard');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(621, 99, 'KHI', 'Karachi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(622, 99, 'LH', 'Lahore');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(623, 99, 'ISB', 'Islamabad');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(624, 99, 'QUE', 'Quetta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(625, 99, 'PSH', 'Peshawar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(626, 99, 'GUJ', 'Gujrat');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(627, 99, 'SAH', 'Sahiwal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(628, 99, 'FSB', 'Faisalabad');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(629, 99, 'RIP', 'Rawal Pindi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(630, 175, 'AB', 'Alba');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(631, 175, 'AR', 'Arad');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(632, 175, 'AG', 'Arges');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(633, 175, 'BC', 'Bacau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(634, 175, 'BH', 'Bihor');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(635, 175, 'BN', 'Bistrita-Nasaud');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(636, 175, 'BT', 'Botosani');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(637, 175, 'BV', 'Brasov');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(638, 175, 'BR', 'Braila');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(639, 175, 'B', 'Bucuresti');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(640, 175, 'BZ', 'Buzau');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(641, 175, 'CS', 'Caras-Severin');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(642, 175, 'CL', 'Calarasi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(643, 175, 'CJ', 'Cluj');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(644, 175, 'CT', 'Constanta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(645, 175, 'CV', 'Covasna');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(646, 175, 'DB', 'Dimbovita');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(647, 175, 'DJ', 'Dolj');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(648, 175, 'GL', 'Galati');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(649, 175, 'GR', 'Giurgiu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(650, 175, 'GJ', 'Gorj');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(651, 175, 'HR', 'Harghita');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(652, 175, 'HD', 'Hunedoara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(653, 175, 'IL', 'Ialomita');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(654, 175, 'IS', 'Iasi');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(655, 175, 'IF', 'Ilfov');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(656, 175, 'MM', 'Maramures');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(657, 175, 'MH', 'Mehedint');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(658, 175, 'MS', 'Mures');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(659, 175, 'NT', 'Neamt');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(660, 175, 'OT', 'Olt');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(661, 175, 'PH', 'Prahova');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(662, 175, 'SM', 'Satu-Mare');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(663, 175, 'SJ', 'Salaj');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(664, 175, 'SB', 'Sibiu');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(665, 175, 'SV', 'Suceava');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(666, 175, 'TR', 'Teleorman');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(667, 175, 'TM', 'Timis');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(668, 175, 'TL', 'Tulcea');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(669, 175, 'VS', 'Vaslui');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(670, 175, 'VL', 'Valcea');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(671, 175, 'VN', 'Vrancea');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(672, 193, 'WP', 'Western Cape');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(673, 193, 'GP', 'Gauteng');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(674, 193, 'KZN', 'Kwazulu-Natal');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(675, 193, 'NC', 'Northern-Cape');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(676, 193, 'EC', 'Eastern-Cape');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(677, 193, 'MP', 'Mpumalanga');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(678, 193, 'NW', 'North-West');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(679, 193, 'FS', 'Free State');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(680, 193, 'NP', 'Northern Province');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(681, 215, 'ADANA', 'ADANA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(682, 215, 'ADIYAMAN', 'ADIYAMAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(683, 215, 'AFYON', 'AFYON');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(684, 215, 'AGRI', 'AGRI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(685, 215, 'AMASYA', 'AMASYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(686, 215, 'ANKARA', 'ANKARA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(687, 215, 'ANTALYA', 'ANTALYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(688, 215, 'ARTVIN', 'ARTVIN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(689, 215, 'AYDIN', 'AYDIN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(690, 215, 'BALIKESIR', 'BALIKESIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(691, 215, 'BILECIK', 'BILECIK');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(692, 215, 'BINGL', 'BINGL');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(693, 215, 'BITLIS', 'BITLIS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(694, 215, 'BOLU', 'BOLU');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(695, 215, 'BURDUR', 'BURDUR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(696, 215, 'BURSA', 'BURSA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(697, 215, 'ANAKKALE', 'ANAKKALE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(698, 215, 'ANKIRI', 'ANKIRI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(699, 215, 'ORUM', 'ORUM');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(700, 215, 'DENIZLI', 'DENIZLI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(701, 215, 'DIYARBAKIR', 'DIYARBAKIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(702, 215, 'EDIRNE', 'EDIRNE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(703, 215, 'ELAZIG', 'ELAZIG');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(704, 215, 'ERZINCAN', 'ERZINCAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(705, 215, 'ERZURUM', 'ERZURUM');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(706, 215, 'ESKISEHIR', 'ESKISEHIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(707, 215, 'GAZIANTEP', 'GAZIANTEP');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(708, 215, 'GIRESUN', 'GIRESUN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(709, 215, 'GMSHANE', 'GMSHANE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(710, 215, 'HAKKARI', 'HAKKARI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(711, 215, 'HATAY', 'HATAY');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(712, 215, 'ISPARTA', 'ISPARTA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(713, 215, 'IEL', 'IEL');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(714, 215, 'ISTANBUL', 'ISTANBUL');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(715, 215, 'IZMIR', 'IZMIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(716, 215, 'KARS', 'KARS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(717, 215, 'KASTAMONU', 'KASTAMONU');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(718, 215, 'KAYSERI', 'KAYSERI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(719, 215, 'KIRKLARELI', 'KIRKLARELI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(720, 215, 'KIRSEHIR', 'KIRSEHIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(721, 215, 'KOCAELI', 'KOCAELI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(722, 215, 'KONYA', 'KONYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(723, 215, 'KTAHYA', 'KTAHYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(724, 215, 'MALATYA', 'MALATYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(725, 215, 'MANISA', 'MANISA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(726, 215, 'KAHRAMANMARAS', 'KAHRAMANMARAS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(727, 215, 'MARDIN', 'MARDIN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(728, 215, 'MUGLA', 'MUGLA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(729, 215, 'MUS', 'MUS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(730, 215, 'NEVSEHIR', 'NEVSEHIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(731, 215, 'NIGDE', 'NIGDE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(732, 215, 'ORDU', 'ORDU');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(733, 215, 'RIZE', 'RIZE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(734, 215, 'SAKARYA', 'SAKARYA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(735, 215, 'SAMSUN', 'SAMSUN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(736, 215, 'SIIRT', 'SIIRT');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(737, 215, 'SINOP', 'SINOP');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(738, 215, 'SIVAS', 'SIVAS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(739, 215, 'TEKIRDAG', 'TEKIRDAG');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(740, 215, 'TOKAT', 'TOKAT');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(741, 215, 'TRABZON', 'TRABZON');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(742, 215, 'TUNCELI', 'TUNCELI');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(743, 215, 'SANLIURFA', 'SANLIURFA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(744, 215, 'USAK', 'USAK');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(745, 215, 'VAN', 'VAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(746, 215, 'YOZGAT', 'YOZGAT');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(747, 215, 'ZONGULDAK', 'ZONGULDAK');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(748, 215, 'AKSARAY', 'AKSARAY');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(749, 215, 'BAYBURT', 'BAYBURT');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(750, 215, 'KARAMAN', 'KARAMAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(751, 215, 'KIRIKKALE', 'KIRIKKALE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(752, 215, 'BATMAN', 'BATMAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(753, 215, 'SIRNAK', 'SIRNAK');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(754, 215, 'BARTIN', 'BARTIN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(755, 215, 'ARDAHAN', 'ARDAHAN');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(756, 215, 'IGDIR', 'IGDIR');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(757, 215, 'YALOVA', 'YALOVA');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(758, 215, 'KARABK', 'KARABK');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(759, 215, 'KILIS', 'KILIS');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(760, 215, 'OSMANIYE', 'OSMANIYE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(761, 215, 'DZCE', 'DZCE');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(762, 229, 'AM', 'Amazonas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(763, 229, 'AN', 'Anzotegui');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(764, 229, 'AR', 'Aragua');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(765, 229, 'AP', 'Apure');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(766, 229, 'BA', 'Barinas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(767, 229, 'BO', 'Bolvar');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(768, 229, 'CA', 'Carabobo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(769, 229, 'CO', 'Cojedes');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(770, 229, 'DA', 'Delta Amacuro');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(771, 229, 'DC', 'Distrito Capital');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(772, 229, 'FA', 'Falcn');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(773, 229, 'GA', 'Gurico');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(774, 229, 'GU', 'Guayana');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(775, 229, 'LA', 'Lara');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(776, 229, 'ME', 'Mrida');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(777, 229, 'MI', 'Miranda');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(778, 229, 'MO', 'Monagas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(779, 229, 'NE', 'Nueva Esparta');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(780, 229, 'PO', 'Portuguesa');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(781, 229, 'SU', 'Sucre');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(782, 229, 'TA', 'Tchira');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(783, 229, 'TU', 'Trujillo');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(784, 229, 'VA', 'Vargas');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(785, 229, 'YA', 'Yaracuy');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(786, 229, 'ZU', 'Zulia');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(787, 222, 'AVON', 'Avon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(788, 222, 'BEDS', 'Bedfordshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(789, 222, 'BERK', 'Berkshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(790, 222, 'BIRM', 'Birmingham');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(791, 222, 'BORD', 'Borders');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(792, 222, 'BUCK', 'Buckinghamshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(793, 222, 'CAMB', 'Cambridgeshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(794, 222, 'CENT', 'Central');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(795, 222, 'CHES', 'Cheshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(796, 222, 'CLEV', 'Cleveland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(797, 222, 'CLWY', 'Clwyd');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(798, 222, 'CORN', 'Cornwall');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(799, 222, 'CUMB', 'Cumbria');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(800, 222, 'DERB', 'Derbyshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(801, 222, 'DEVO', 'Devon');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(802, 222, 'DORS', 'Dorset');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(803, 222, 'DUMF', 'Dumfries & Galloway');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(804, 222, 'DURH', 'Durham');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(805, 222, 'DYFE', 'Dyfed');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(806, 222, 'ESUS', 'East Sussex');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(807, 222, 'ESSE', 'Essex');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(808, 222, 'FIFE', 'Fife');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(809, 222, 'GLAM', 'Glamorgan');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(810, 222, 'GLOU', 'Gloucestershire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(811, 222, 'GRAM', 'Grampian');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(812, 222, 'GWEN', 'Gwent');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(813, 222, 'GWYN', 'Gwynedd');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(814, 222, 'HAMP', 'Hampshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(815, 222, 'HERE', 'Hereford & Worcester');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(816, 222, 'HERT', 'Hertfordshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(817, 222, 'HUMB', 'Humberside');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(818, 222, 'KENT', 'Kent');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(819, 222, 'LANC', 'Lancashire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(820, 222, 'LEIC', 'Leicestershire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(821, 222, 'LINC', 'Lincolnshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(822, 222, 'LOND', 'London');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(823, 222, 'LOTH', 'Lothian');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(824, 222, 'MANC', 'Manchester');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(825, 222, 'MERS', 'Merseyside');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(826, 222, 'NORF', 'Norfolk');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(827, 222, 'NYOR', 'North Yorkshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(828, 222, 'NWHI', 'North west Highlands');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(829, 222, 'NHAM', 'Northamptonshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(830, 222, 'NUMB', 'Northumberland');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(831, 222, 'NOTT', 'Nottinghamshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(832, 222, 'OXFO', 'Oxfordshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(833, 222, 'POWY', 'Powys');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(834, 222, 'SHRO', 'Shropshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(835, 222, 'SOME', 'Somerset');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(836, 222, 'SYOR', 'South Yorkshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(837, 222, 'STAF', 'Staffordshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(838, 222, 'STRA', 'Strathclyde');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(839, 222, 'SUFF', 'Suffolk');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(840, 222, 'SURR', 'Surrey');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(841, 222, 'WSUS', 'West Sussex');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(842, 222, 'TAYS', 'Tayside');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(843, 222, 'TYWE', 'Tyne & Wear');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(844, 222, 'WARW', 'Warwickshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(845, 222, 'WISL', 'West Isles');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(846, 222, 'WYOR', 'West Yorkshire');
INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES(847, 222, 'WILT', 'Wiltshire');

INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('person.active', '1');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('company.active', '1');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('sandbox', '1');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('applicationLicence', 'ff24b9634bb8e0b24a15a7cbbddc5fe6');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('clientLicence', '');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('clientId', '');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('recheckSuspect', '30');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('buergel.score', '2.3');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('paymentModules', 'invoice,banktransfer');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('orderTotal', '100');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('allowPaymentWithNoResult', '0');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('daysUntilClaimStart', '20');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('orderStatusIdMarked', '1');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('displayClaimsCount', '5');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('overdueFees', '5.00');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('lastStatusUpdate', '1207030153');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('statusUpdateInterval', '3');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('daysFromLastReminder', '10');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('defaultType', '1');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('requestType', 'always');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('requestOnModules', 'invoice,banktransfer');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('paymentErrorText', 'Leider ist die ausgewhlte Zahlart zur Zeit nicht verfgbar. Bitte whlen Sie eine andere Zahlart aus.');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('minAmountForRequest', '0');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('maxAmountForRequest', '0');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('allowPaymentUnderMinAmount', '0');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('allowPaymentOverMaxAmount', '0');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('defaultPersonScore', 'MF_Score_BuergelClient');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('defaultCompanyScore', 'MF_Score_AccumioClient');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('accumio.score', '2');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('accumio.minSimilarity', '80');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('version', '0.3.2');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('applicationId', '317');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('registrationKey', '');
INSERT INTO `mf_config` (`config_key`, `config_value`) VALUES('serviceLicenceKey', '9c889dd2408ca44b1cd9e12ba40333fa');